﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Windows.Forms.DataVisualization.Charting;
using System.Drawing.Imaging;
using System.Runtime.InteropServices;
using System.Diagnostics;


namespace APO_BB_DK_v012013
{   
    class ArytmetykaObrazu
    {
     private double W1; 
                
        public ArytmetykaObrazu(Bitmap bmp)
        {
            int perimeter = 0;
            int area = 0;
            int size = bmp.Width * bmp.Height;
            double areaNorm = 0.0;
            int[] r0 = new int[] { 0, 0 };
            long m00 = 0;
            long m10 = 0;
            long m01 = 0;
            long m11 = 0;

            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    int rpixel = bmp.GetPixel(x, y).R;
                    if (rpixel > 0)
                    {
                        area++;
                        m00 += bmp.GetPixel(x, y).R;
                        m10 += x * bmp.GetPixel(x, y).R;
                        m01 += y * bmp.GetPixel(x, y).R;
                        m11 += x * y * bmp.GetPixel(x, y).R;

                        for (int i = -1; i < 2; i++)
                        {
                            for (int j = -1; j < 2; j++)
                            {
                                if (ImageHelper.isPixelValid(x + i, y + j, bmp.Width, bmp.Height))
                                {
                                    int sasiad = bmp.GetPixel(x + i, y + j).R;
                                    if (sasiad == 0)
                                    {
                                        perimeter++;
                                        r0[0] += x;
                                        r0[1] += y;
                                        goto next;
                                    }
                                }
                            }
                        }
                    }
                next: ;
                }
            }

            if (perimeter > 0)
            {
                r0[0] = r0[0] / perimeter;
                r0[1] = r0[1] / perimeter;
            }
            areaNorm = (double)area / (double)size;
            double W1 = 2.0 * Math.Sqrt((double)area / Math.PI);
            double W2 = (double)perimeter / Math.PI;
            double W3 = (double)perimeter / (2.0 * Math.Sqrt((double)area * Math.PI));
            double W9 = (2.0 * Math.Sqrt((double)area * Math.PI)) / (double)perimeter;
            int minX = -1;
            int maxX = -1;
            int minY = -1;
            int maxY = -1;
            bool isSet = false;
            long sumaOdl = 0;
            long M10 = 0;
            long M01 = 0;
            long M11 = 0;

            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    int rpixel = bmp.GetPixel(x, y).R;
                    if (rpixel > 0)
                    {
                        if (!isSet)
                        {
                            isSet = true;
                            if (minX == -1) minX = x;
                            if (maxX == -1) maxX = x;
                            if (minY == -1) minY = y;
                            if (maxY == -1) maxY = y;
                        }
                        if (x < minX) minX = x;
                        if (x > maxX) maxX = x;
                        if (y < minY) minY = y;
                        if (y > maxY) maxY = y;

                        M10 += (x - r0[0]) * bmp.GetPixel(x, y).R;
                        M01 += (y - r0[1]) * bmp.GetPixel(x, y).R;
                        M11 += (x - r0[0]) * (y - r0[1]) * bmp.GetPixel(x, y).R;
                        sumaOdl += (long)Math.Pow(Math.Sqrt(Math.Pow(x - r0[0], 2) + Math.Pow(y - r0[1], 2)), 2);
                    }
                }
            }
            int gabarytX = maxX - minX;
            int gabarytY = maxY - minY;
            int gabaryt;
            if (gabarytX > gabarytY) gabaryt = gabarytX;
            else gabaryt = gabarytY;
            double W8 = (double)gabaryt / (double)perimeter;
            double W4 = (double)area / Math.Sqrt(2 * Math.PI * sumaOdl);

            #region  MessageBox
            MessageBox.Show(" CECHY OBIEKTU BINARNEGO\n"+
                           "\n Liczba pikseli w obrazie: " + size +
                            "\n Liczba pikseli tła: " + (size - area) +
                            "\n Powierzchnia: " + area +
                            "\n Objetość pikseli: " + perimeter +
                            "\n Środek masy: " + r0[0] + ", " + r0[1] + "\n"+
                            "\n Współczynniki Kształtu (W)\n"+ 
                            "\n W1 - średnica koła o powierzchni równej powierzchni badanego obiektu"+                          
                            "\n W2 - średnica koła o długości obwodu równej długości obwodu badanego obiektu"+
                            "\n W3 - Współczynnik Malinowskiej"+
                            "\n W4 - Współczynnik Blaira-Blissa - większa wrażliwość na zmiany kształtu"+
                            "\n W5 - Współczynnik Danielssona" + 
                            "\n W6  - Współczynnik Haralicka"+ 
                            "\n W7 - Współczynnik Lp1" +
                            "\n W8 - Współczynnik Lp2" +
                            "\n W9 - Współczynnik Mz (Malinowskiej uproszczony)\n"+
                            "\n\n Współczynniki Kształtu (W)\n" + 
                            "\n W1 = " + W1 + 
                            "\n W2 = " + W2 +
                            "\n W3 = " + W3 +
                            "\n W4 = " + W4 +
                            "\n W8 = " + W8 +
                            "\n W9 = " + W9 + "\n"+
                            "\n\n Momenty geometryczne (m)\n"+
                            "\n  m(0, 0) = " + m00 +
                            "\n  m(0, 1) = " + m01 +
                            "\n  m(1, 0) = " + m10 +
                            "\n  m(1, 1) = " + m11 + "\n"+
                            "\n\n Momenty centralne (M)\n" +
                            "\n  M(1, 0): " + M10 +
                            "\n  M(0, 1): " + M01 +
                            "\n  M(1, 1): " + M11,
                            "Analaliza obrazu");
            #endregion
        }

        public string ArytmetykaObrazuT()
        {
            return "Wyniki" + W1.ToString() + " ";
        }

        public class ImageHelper
        {
            public static bool isPixelValid(int x, int y, int width, int height)
            {
                if (x >= 0 && y >= 0 && x < width && y < height)
                    return true;
                return false;
            }

        }
    }
}
