﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Windows.Forms.DataVisualization.Charting;
using System.Drawing.Imaging;
using BitmapProcessing;
using System.Reflection;
using APO_BB_DK_v012013.Operacje;


namespace APO_BB_DK_v012013
{
    public partial class ObrazJPNew : Form
    {
      //  private Image zrodloOPJ;
      //  private OperatorOPJ processingOPJ;
      //  private FunkcjeHSV fHSV;
        private TrackBar suwak1;
        private OpenFileDialog open;
        public PictureBox pictureHistogramOPJ;
        public PictureBox pictureWtornyOPJ;
        public PictureBox picturePierwotnyOPJ;
        public Bitmap bitmap;
    //    private Bitmap src_thumbnail;

        private Bitmap originalBitmap = null;
        private Bitmap previewBitmap = null;
        private Bitmap resultBitmap = null;
   //     Bitmap bmpHSV;

        //
     //   private int _id = -1;
        private int[] histogram_values = new int[256];
        private int[] histogram_hsv_values = new int[256];
        private int[,] histogram_kolory_values;

        private int[] histogram_values2 = new int[256];
        private int[] histogram_hsv_values2 = new int[256];
        private int[,] histogram_kolory_values2;

        public bool HSV
        {
            get { return _HSV; }
            set { _HSV = value; this.labelJPJv_RGB.Text = "Obraz (HSV)"; this.HistogramRGB.Visible = false; button_blue.Visible = false; button_green.Visible = false; buttpn_red.Visible = false; labelJPJv_RGB.Visible = false; button_wszystkie.Visible = false; button1.Visible = false; button3.Visible = false; labelJPJv_RGB.Visible = true; label2.Text = "1.0"; }
        }
        private bool _HSV = false;
        public Bitmap get_image
        {
            get { return new Bitmap(this.pictureWtornyOPJ.Image); }
            set { }
        }
        public Bitmap get_histogram
        {
            get
            {
                if (this.HistogramGrey.Image == null)
                    return null;
                return new Bitmap(HistogramGrey.Image);
            }
            set { }
        }
        public Bitmap get_histogram_kolory
        {
            get
            {
                if (this.HistogramRGB.Image == null)
                    return null;
                return new Bitmap(this.HistogramRGB.Image);
            }
            set { }
        }

        private void EnableDoubleBuffered(DataGridView dgv, bool setting)
        {
            Type dgvType = dgv.GetType();
            PropertyInfo pi = dgvType.GetProperty("DoubleBuffered", BindingFlags.Instance | BindingFlags.NonPublic);
            pi.SetValue(dgv, setting, null);
        }

        //RYSOWANIE HISTOGRAMÓW ----------------------------------------------------------
        private Bitmap generuj_histogram(int k)
        {
            Bitmap obrazek_bitmapa = new Bitmap(this.pictureWtornyOPJ.Image);
            Bitmap histogram = null;
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(obrazek_bitmapa);

            if (HSV)
            {
                int histogram_max = 0;
                double h, s, v;
                fobrazek_bitmapa.LockImage();
                for (int x = 0; x < obrazek_bitmapa.Width; x++)
                {
                    for (int y = 0; y < obrazek_bitmapa.Height; y++)
                    {
                        hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y), out h, out s, out v);
                        int temp_v = (int)(v * 255.0f);
                        histogram_hsv_values[temp_v]++;
                        if (histogram_hsv_values[temp_v] > histogram_max)
                            histogram_max = histogram_hsv_values[temp_v];
                    }
                }
                fobrazek_bitmapa.UnlockImage();
                double skala = (512.0f / (double)histogram_max) * ((double)pasek_skali.Value / 10.0f);
                histogram = new Bitmap(1024, 513);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_hsv_values[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Black);
                        }
                    }
                }

                fhistogram.UnlockImage();
            }
            else
            {
                int[] histogram_values_tmp;
                histogram_values_tmp = new int[256];
                int histogram_max = 0;
                fobrazek_bitmapa.LockImage();
                //Zliczanie wartości histogramu
                for (int x = 0; x < obrazek_bitmapa.Width; x++)
                {
                    for (int y = 0; y < obrazek_bitmapa.Height; y++)
                    {
                        if (k == 0 || k > 2)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R]++;
                            histogram_values[fobrazek_bitmapa.GetPixel(x, y).R]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R];
                        }
                        if (k == 1)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G];
                        }
                        if (k == 2)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B];
                        }
                        if (k == 3)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B];
                        }

                    }
                }
                fobrazek_bitmapa.UnlockImage();
                float skala = (512.0f / (float)histogram_max) * ((float)pasek_skali.Value / 10.0f);
                histogram = new Bitmap(1024, 513);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                Color slupki = Color.Black;
                if (k == 0)
                    slupki = Color.Red;
                if (k == 1)
                    slupki = Color.Green;
                if (k == 2)
                    slupki = Color.Blue;
                Color tlo = Color.White;
                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_values_tmp[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), slupki);
                        }
                        else
                        {
                            //fhistogram.SetPixel(4*x1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+2, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+3, (int)(256 - y1), tlo);
                        }
                    }
                }
                fhistogram.UnlockImage();
            }
            return histogram;
        }

        private Bitmap generuj_histogram2(int k)
        {
            Bitmap bmp = new Bitmap(this.picturePierwotnyOPJ.Image);
            Bitmap histogram = null;
            BitmapProcessing.FastBitmap fbmp = new BitmapProcessing.FastBitmap(bmp);

            if (HSV)
            {
                int histogram_max = 0;
                double h, s, v;
                fbmp.LockImage();
                for (int x = 0; x < bmp.Width; x++)
                {
                    for (int y = 0; y < bmp.Height; y++)
                    {
                        hsv.ColorToHSV(fbmp.GetPixel(x, y), out h, out s, out v);
                        int temp_v = (int)(v * 255.0f);
                        histogram_hsv_values2[temp_v]++;
                        if (histogram_hsv_values2[temp_v] > histogram_max)
                            histogram_max = histogram_hsv_values2[temp_v];
                    }
                }
                fbmp.UnlockImage();
                double skala = (512.0f / (double)histogram_max) * ((double)pasek_skali.Value / 10.0f);
                histogram = new Bitmap(1024, 513);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_hsv_values2[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Black);
                        }
                    }
                }

                fhistogram.UnlockImage();
            }
            else
            {
                int[] histogram_values_tmp;
                histogram_values_tmp = new int[256];
                int histogram_max = 0;
                fbmp.LockImage();
                //Zliczanie wartości histogramu
                for (int x = 0; x < bmp.Width; x++)
                {
                    for (int y = 0; y < bmp.Height; y++)
                    {
                        if (k == 0 || k > 2)
                        {
                            histogram_values_tmp[fbmp.GetPixel(x, y).R]++;
                            histogram_values2[fbmp.GetPixel(x, y).R]++;
                            if (histogram_values_tmp[fbmp.GetPixel(x, y).R] > histogram_max)
                                histogram_max = histogram_values_tmp[fbmp.GetPixel(x, y).R];
                        }
                        if (k == 1)
                        {
                            histogram_values_tmp[fbmp.GetPixel(x, y).G]++;
                            if (histogram_values_tmp[fbmp.GetPixel(x, y).G] > histogram_max)
                                histogram_max = histogram_values_tmp[fbmp.GetPixel(x, y).G];
                        }
                        if (k == 2)
                        {
                            histogram_values_tmp[fbmp.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fbmp.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fbmp.GetPixel(x, y).B];
                        }
                        if (k == 3)
                        {
                            histogram_values_tmp[fbmp.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fbmp.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fbmp.GetPixel(x, y).B];
                        }

                    }
                }
                fbmp.UnlockImage();
                float skala = (512.0f / (float)histogram_max) * ((float)pasek_skali.Value / 10.0f);
                histogram = new Bitmap(1024, 513);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                Color slupki = Color.Black;
                if (k == 0)
                    slupki = Color.Red;
                if (k == 1)
                    slupki = Color.Green;
                if (k == 2)
                    slupki = Color.Blue;
                Color tlo = Color.White;
                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_values_tmp[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), slupki);
                        }
                        else
                        {
                            //fhistogram.SetPixel(4*x1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+2, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+3, (int)(256 - y1), tlo);
                        }
                    }
                }
                fhistogram.UnlockImage();
            }
            return histogram;
        }

        private Bitmap generuj_histogram_kolory2(int k)
        {
            Bitmap bmp = new Bitmap(this.picturePierwotnyOPJ.Image);
            if (histogram_kolory_values2 == null)
                histogram_kolory_values2 = new int[256, 3];
            int histogram_max = 0;
            BitmapProcessing.FastBitmap fbmp = new BitmapProcessing.FastBitmap(bmp);
            fbmp.LockImage();
            //Zliczanie wartości histogramu
            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    histogram_kolory_values2[fbmp.GetPixel(x, y).R, 0]++;
                    if (histogram_kolory_values2[fbmp.GetPixel(x, y).R, 0] > histogram_max)
                        histogram_max = histogram_kolory_values2[fbmp.GetPixel(x, y).R, 0];
                }
            }
            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    histogram_kolory_values2[fbmp.GetPixel(x, y).G, 1]++;
                    if (histogram_kolory_values2[fbmp.GetPixel(x, y).G, 1] > histogram_max)
                        histogram_max = histogram_kolory_values2[fbmp.GetPixel(x, y).G, 1];
                }
            }
            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    histogram_kolory_values2[fbmp.GetPixel(x, y).B, 2]++;
                    if (histogram_kolory_values2[fbmp.GetPixel(x, y).B, 2] > histogram_max)
                        histogram_max = histogram_kolory_values2[fbmp.GetPixel(x, y).B, 2];
                }
            }
            fbmp.UnlockImage();
            float skala = (512.0f / (float)histogram_max);
            Bitmap histogram = new Bitmap(1024, 513);
            BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
            fhistogram.LockImage();
            for (int x1 = 0; x1 < 256; x1++)
            {
                int tmpr = (int)(histogram_kolory_values2[x1, 0] * skala);
                int tmpg = (int)(histogram_kolory_values2[x1, 1] * skala);
                int tmpb = (int)(histogram_kolory_values2[x1, 2] * skala);
                //0,1,2 nie 3
                if (k < 3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpr)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Red);
                        }
                    }
                }
                //0,1,3 nie 2
                if (k < 2 || k == 3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpg)
                        {
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Green);
                        }
                    }
                }
                //0,2,3 nie 1
                if (k == 0 || k > 1)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpb)
                        {
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Blue);
                        }
                    }
                }
            }
            fhistogram.UnlockImage();
            return histogram;
        }

        private Bitmap generuj_histogram_kolory(int k)
        {
            Bitmap obrazek_bitmapa = new Bitmap(this.pictureWtornyOPJ.Image);
            if (histogram_kolory_values == null)
                histogram_kolory_values = new int[256, 3];
            int histogram_max = 0;
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(obrazek_bitmapa);
            fobrazek_bitmapa.LockImage();
            //Zliczanie wartości histogramu
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0];
                }
            }
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1];
                }
            }
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2];
                }
            }
            fobrazek_bitmapa.UnlockImage();
            float skala = (512.0f / (float)histogram_max);
            Bitmap histogram = new Bitmap(1024, 513);
            BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
            fhistogram.LockImage();
            for (int x1 = 0; x1 < 256; x1++)
            {
                int tmpr = (int)(histogram_kolory_values[x1, 0] * skala);
                int tmpg = (int)(histogram_kolory_values[x1, 1] * skala);
                int tmpb = (int)(histogram_kolory_values[x1, 2] * skala);
                //0,1,2 nie 3
                if (k < 3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpr)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Red);
                        }
                    }
                }
                //0,1,3 nie 2
                if (k < 2 || k == 3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpg)
                        {
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Green);
                        }
                    }
                }
                //0,2,3 nie 1
                if (k == 0 || k > 1)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpb)
                        {
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Blue);
                        }
                    }
                }
            }
            fhistogram.UnlockImage();
            return histogram;
        }


        //


        public ObrazJPNew()
        {
            InitializeComponent();
            //processingOPJ = new OperatorOPJ();
            open = new OpenFileDialog();
            suwak1 = new System.Windows.Forms.TrackBar();
            comboBoxFGG.Items.Add("Operacje jednopunktowe");
            comboBoxFGG.SelectedIndex = 0;
            this.groupV1.Visible = false;
           // this.groupV2.Visible = false;
            this.trackBarOPJ.Visible = true;
        }
        
        //OTWIERANIE OBRAZ Z PLIKU
        private void buttonObrazPierwotnyOPJ_Click(object sender, EventArgs e)
        {
           OpenFileDialog ofd = new OpenFileDialog();
           ofd.Title = "Select the source Image";
           ofd.Filter = "Image Files(*.BMP;*.JPG;*.PNG)|*.BMP;*.JPG;*.PNG|All files (*.*)|*.*";

            if (ofd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                StreamReader streamReader = new StreamReader(ofd.FileName);
                originalBitmap = (Bitmap)Bitmap.FromStream(streamReader.BaseStream);
                streamReader.Close();
                previewBitmap = originalBitmap.CopyToSquareCanvas(this.picturePierwotnyOPJ.Width);
                this.picturePierwotnyOPJ.Image = previewBitmap;
                this.pictureObrazFL1.Image = originalBitmap;
              }
        }


        private void buttonKolor_Click(object sender, EventArgs e)
        {
            FunkcjeJednoarg fn = new FunkcjeJednoarg();
            comboBoxFGG.Items.Clear();
            comboBoxFGG.Items.Add("Operacje jednopunktowe");
            comboBoxFGG.SelectedIndex = 0;
        
            if (this.radioSzary.Checked)
            {
                comboBoxFGG.Items.Add("Negacja");
                comboBoxFGG.Items.Add("Kontrast");
                comboBoxFGG.Items.Add("Jasność");
                comboBoxFGG.Items.Add("Korekcja Gamma");
                comboBoxFGG.Items.Add("Progowanie");
                comboBoxFGG.Items.Add("Rozciąganie");            
                comboBoxFGG.Items.Add("Redukcja poziomów jasności");
                comboBoxFGG.Items.Add("Uniwersalna Operacja Jednopunktowa");
                comboBoxFGG.Items.Add("Sepia");
                comboBoxFGG.Items.Add("Transparentny");
                comboBoxFGG.SelectedIndex = 0;

                this.label1.Text = "Obraz wynikowy w odcieniach szarości";
                Bitmap bmpGrey = new Bitmap(this.pictureObrazFL1.Image);
                bmpGrey = fn.Skalaszarosci(bmpGrey);
                this.pictureObrazFL2.Image = bmpGrey;
                picturePierwotnyOPJ.Image = bmpGrey;
                pictureWtornyOPJ.Image = bmpGrey;      
                previewBitmap = bmpGrey.CopyToSquareCanvas(this.picturePierwotnyOPJ.Width);
                this.pictureWtornyOPJ.Image = previewBitmap;
                tabOJ.Visible = true;
                tabOJ.TabPages.Clear();
                /*
                tabOJ.TabPages.Add(this.tabJPKontrastS);
                tabOJ.TabPages.Add(this.tabJPJasnoscS);
                tabOJ.TabPages.Add(this.tabJPKorekcjaGammaS);
                tabOJ.TabPages.Add(this.tabJPProgowanieS);
                tabOJ.TabPages.Add(this.tabJPRozciaganieS);
                tabOJ.TabPages.Add(this.tabJPRedukcjaPoziomowS);
                tabOJ.TabPages.Add(this.tabJPuopS);
               */
            }

            if (this.radioKolorHVS.Checked)
            {
                comboBoxFGG.Items.Add("Negacja HSV");
                comboBoxFGG.Items.Add("Kontrast HSV");
                comboBoxFGG.Items.Add("Jasność HSV");
                comboBoxFGG.Items.Add("Rozciąganie HSV");
                comboBoxFGG.Items.Add("Progowanie HSV");
                comboBoxFGG.Items.Add("Korekcja Gamma HSV");
                comboBoxFGG.Items.Add("Odcienie HSV");
                comboBoxFGG.Items.Add("Redukcja poziomów jasności HSV");
                comboBoxFGG.Items.Add("Uniwersalna Operacja Jednopunktowa HSV");
                comboBoxFGG.Items.Add("Sepia HSV");
                comboBoxFGG.Items.Add("Transparentny HSV");
                comboBoxFGG.SelectedIndex = 0;
                
                this.label1.Text = "Obraz wtórny kolorowy HVS";
                Bitmap bmpHVS = new Bitmap(this.pictureObrazFL1.Image);
                picturePierwotnyOPJ.Image = bmpHVS;
                pictureWtornyOPJ.Image = bmpHVS;
                previewBitmap = bmpHVS.CopyToSquareCanvas(this.picturePierwotnyOPJ.Width);
                this.pictureWtornyOPJ.Image = previewBitmap;
                tabOJ.Visible = true;
                tabOJ.TabPages.Clear();
                /*
                tabOJ.TabPages.Add(this.tabJPKontrastHSV);
                tabOJ.TabPages.Add(this.tabJPJasnoscHSV);
                tabOJ.TabPages.Add(this.tabJPKorekcjaGammaHSV);
                tabOJ.TabPages.Add(this.tabJPProgowanieHSV);
                tabOJ.TabPages.Add(this.tabJPRozciaganieHSV);
                tabOJ.TabPages.Add(this.tabJPRedukcjaPoziomowHSV);
                tabOJ.TabPages.Add(this.tabJPuopHSV);
                 */
            }

            if (this.radioKolorRGB.Checked)
            {
                comboBoxFGG.Items.Add("Negacja RGB");
                comboBoxFGG.Items.Add("Kontrast RGB");
                comboBoxFGG.Items.Add("Jasność RGB");
                comboBoxFGG.Items.Add("Rozciąganie RGB");
                comboBoxFGG.Items.Add("Progowanie RGB");
                comboBoxFGG.Items.Add("Korekcja Gamma RGB");
                comboBoxFGG.Items.Add("Odcienie RGB");
                comboBoxFGG.Items.Add("Redukcja poziomów jasności RGB");
                comboBoxFGG.Items.Add("Uniwersalna Operacja Jednopunktowa RGB");
                comboBoxFGG.Items.Add("Sepia RGB");
                comboBoxFGG.Items.Add("Transparentny RGB");
                comboBoxFGG.SelectedIndex = 0;

                this.label1.Text = "Obraz wtórny kolorowy RGB";
                  Bitmap bmpRGB = new Bitmap(this.pictureObrazFL1.Image);
                picturePierwotnyOPJ.Image = bmpRGB;
                pictureWtornyOPJ.Image = bmpRGB;
                previewBitmap = bmpRGB.CopyToSquareCanvas(this.picturePierwotnyOPJ.Width);
                this.pictureWtornyOPJ.Image = previewBitmap;
                tabOJ.Visible = true;
                tabOJ.TabPages.Clear();
                /*
                tabOJ.TabPages.Add(this.tabJPKontrastRGB);
                tabOJ.TabPages.Add(this.tabJPJasnoscRGB);
                tabOJ.TabPages.Add(this.tabJPKorekcjaGammaRGB);
                tabOJ.TabPages.Add(this.tabJPProgowanieRGB);
                tabOJ.TabPages.Add(this.tabJPRozciaganieRGB);
                tabOJ.TabPages.Add(this.tabJPRedukcjaPoziomowRGB);
                tabOJ.TabPages.Add(this.tabJPuopRGB);
                 */
            }
        }

        private void buttonHistogramOPJ_Click(object sender, EventArgs e)
        {
            Bitmap bmpG = (Bitmap)this.pictureWtornyOPJ.Image;
            Bitmap hs = new HistogramRysuj(bmpG).draw();
            this.pictureHistogramOPJ.Image = hs;
            this.pictureHistogramOPJ.Visible = true; 
            
            /*
            this.pictureHistogramOPJ.Visible = true;
            Bitmap bmpHistogOPJ = (Bitmap)pictureWtornyOPJ.Image;
            this.processingOPJ.setImage(new Bitmap(this.pictureWtornyOPJ.Image));
            this.processingOPJ.calcHisto(this);
            this.Invalidate();
            */
        }


        //JASNOŚĆ
        private void trackBarJasnosc(object sender, EventArgs e)
        {
            //Przygotuj tablice LUT i pokaz ja na wykresie
            wykres.Series[0].Points.Clear();
            byte[] LUT = new byte[256];
            int b = this.trackBarOPJ.Value;
            wykres.Titles[0].Text = "Tablica LUT, b = " + b;
            for (int i = 0; i < 256; i++)
            {
                if ((b + i) > 255)
                {
                    LUT[i] = 255;
                }
                else if ((b + i) < 0)
                {
                    LUT[i] = 0;
                }
                else
                {
                    LUT[i] = (byte)(b + i);
                }
                wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
            }

            //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
            if (this.picturePierwotnyOPJ.Image == null)
            {
                return;
            }
            Bitmap bitmap = (Bitmap)this.picturePierwotnyOPJ.Image.Clone();
            this.pictureWtornyOPJ.Image = bitmap;
            //Pobierz wartosc wszystkich punktow obrazu
            BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
            byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
            System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);
            //Zmien jasnosc kazdego punktu zgodnie z tablica LUT
            for (int i = 0; i < pixelValues.Length; i++)
            {
                pixelValues[i] = LUT[pixelValues[i]];
            }
            //Ustaw wartosc wszystkich punktow obrazu
            System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
            bitmap.UnlockBits(bmpData);
        }

        //Korekcja Gamma
        private void trackBarGamma(object sender, EventArgs e)
        {
            //Przygotuj tablice LUT i pokaz ja na wykresie
            wykres.Series[0].Points.Clear();
            byte[] LUT = new byte[256];
            double gamma = this.trackBarOPJ.Value / 100.0;
            wykres.Titles[0].Text = "Tablica LUT, gamma = " + gamma;
            for (int i = 0; i < 256; i++)
            {
                if ((255 * Math.Pow(i / 255.0, 1 / gamma)) > 255)
                {
                    LUT[i] = 255;
                }
                else
                {
                    LUT[i] = (byte)(255 * Math.Pow(i / 255.0, 1 / gamma));
                }
                wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
            }
            //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
            if (picturePierwotnyOPJ.Image == null)
            {
                return;
            }
            Bitmap bitmap = (Bitmap)this.picturePierwotnyOPJ.Image.Clone();
            this.pictureWtornyOPJ.Image = bitmap;
            //Pobierz wartosc wszystkich punktow obrazu
            BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
            byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
            System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);
            for (int i = 0; i < pixelValues.Length; i++)
            {
                pixelValues[i] = LUT[pixelValues[i]];
            }
            System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
            bitmap.UnlockBits(bmpData);
        }

        //KONTRAST
        //C# Advanced Tutorial 
        private void trackBarKontrast(object sender, EventArgs e)
        {
            //Przygotuj tablice LUT i pokaz ja na wykresie
            wykres.Series[0].Points.Clear();
            byte[] LUT = new byte[256];
            double a;
            if (this.trackBarOPJ.Value <= 0)
            {
                a = 1.0 + (trackBarOPJ.Value / 256.0);
            }
            else
            {
                a = 256.0 / Math.Pow(2, Math.Log(257 - trackBarOPJ.Value, 2));
            }
            wykres.Titles[0].Text = "Tablica LUT, a = " + a;
            for (int i = 0; i < 256; i++)
            {
                if ((a * (i - 127) + 127) > 255)
                {
                    LUT[i] = 255;
                }
                else if ((a * (i - 127) + 127) < 0)
                {
                    LUT[i] = 0;
                }
                else
                {
                    LUT[i] = (byte)(a * (i - 127) + 127);
                }
                wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
            }
            //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
            if (this.picturePierwotnyOPJ == null)
            {
                return;
            }
            //Kopiuj obrazek zrodlowy        
            Bitmap bitmap = (Bitmap)this.picturePierwotnyOPJ.Image.Clone();
            //    Bitmap bitmap1 = (Bitmap)this.picturePierwotnySzary.Image.Clone();
            this.pictureWtornyOPJ.Image = bitmap;
            //Pobierz wartosc wszystkich punktow obrazu
            BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
            byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
            System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);
            //Zmien kontrast kazdego punktu zgodnie z tablica LUT
            for (int i = 0; i < pixelValues.Length; i++)
            {
                pixelValues[i] = LUT[pixelValues[i]];
            }
            //Ustaw wartosc wszystkich punktow obrazu
            System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
            bitmap.UnlockBits(bmpData);
        }

        //BINERYZACJA
        private void trackBarBineryzacja(object sender, EventArgs e)
        {
            //Przygotuj tablice LUT i pokaz ja na wykresie
            wykres.Series[0].Points.Clear();
            byte[] LUT = new byte[256];
            int b = this.trackBarOPJ.Value;
            //  int b = this.trackBar1.Value;
            wykres.Titles[0].Text = "Tablica LUT, b = " + b;
            for (int i = 0; i < 256; i++)
            {
                if ((b + i) > 255)
                {
                    LUT[i] = 255;
                }
                else if ((b + i) < 0)
                {
                    LUT[i] = 0;
                }
                else
                {
                    LUT[i] = (byte)(b + i);
                }
                wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
            }
            //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
            if (this.picturePierwotnyOPJ.Image == null)
            {
                return;
            }
            Bitmap bitmap = (Bitmap)this.picturePierwotnyOPJ.Image.Clone();
            this.pictureWtornyOPJ.Image = bitmap;
            //Pobierz wartosc wszystkich punktow obrazu
            BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
            byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
            System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);
            //Korekcja gamma dla kazdego punktu zgodnie z tablica LUT
            for (int i = 0; i < pixelValues.Length; i++)
            {
                pixelValues[i] = LUT[pixelValues[i]];
            }
            //Ustaw wartosc wszystkich punktow obrazu
            System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
            bitmap.UnlockBits(bmpData);
        }

       
        private void trackBarOPJ_Scroll(object sender, EventArgs e)
        {
            label_value.Text = trackBarOPJ.Value.ToString();         
          //  this.pictureWtornyOPJ.Refresh();
            ApplyFilter(true);
          }

        private void ApplyFilter(bool preview)
        {
            if (previewBitmap == null || comboBoxFGG.SelectedIndex == -1)
            {
                return;
            }

            Bitmap selectedSource = null;
            Bitmap bitmapResult = null;

            if (preview == true)
            {
                selectedSource = previewBitmap;
            }
            else
            {
                selectedSource = originalBitmap;
            }

            if (selectedSource != null)
            {
                if (comboBoxFGG.SelectedItem.ToString() == "None")
                {
                    bitmapResult = selectedSource;
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Negacja")
                {
                    label1.Text = "Obraz wynikowy - Negacja";
                    tabOJ.TabPages.Clear();
                    bitmapResult = selectedSource.NegacjaRGB();
                                  
                   //     this.groupBoxTablicaLUT.Visible = false;                                       
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Negacja RGB")
                {
                    label1.Text = "Obraz wynikowy - Negacja RGB";
                    tabOJ.TabPages.Clear();
                    bitmapResult = selectedSource.NegacjaRGB();

                //    this.groupBoxTablicaLUT.Visible = false;                                   
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Negacja HSV")
                {
                    label1.Text = "Obraz wynikowy - Negacja HSV";
                    tabOJ.TabPages.Clear();
                    bitmapResult = selectedSource.NegacjaHSV();

                 //   this.groupBoxTablicaLUT.Visible = false;                                   
                }


                else if (comboBoxFGG.SelectedItem.ToString() == "Kontrast")
                {
                    label1.Text = "Obraz wynikowy - Kontrast";
                    tabOJ.TabPages.Clear();
                    tabOJ.TabPages.Add(tabJPKontrastS);
                    bitmapResult = selectedSource.Contrast(trackJPK_S.Value);

                    //-------------------------------------------                    
                    // this.groupBoxTablicaLUT.Visible = true;
                    // this.trackKS.ValueChanged += new System.EventHandler(this.trackBarKontrast);
                    // bitmapResult = selectedSource.Contrast(trackBarOPJ.Value);                 
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Kontrast RGB")
                {
                    label1.Text = "Obraz wynikowy - Kontrast RGB";
                    tabOJ.TabPages.Clear();
                    tabOJ.TabPages.Add(tabJPKontrastRGB);
                    bitmapResult = selectedSource.Contrast(trackJPK_RGB.Value);

                    //-------------------------------------------                                 
                    //   this.groupBoxTablicaLUT.Visible = true;
                    //   this.trackKS_RGB.ValueChanged += new System.EventHandler(this.trackBarKontrast);                            
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Kontrast HSV")
                {                    
                    label1.Text = "Obraz wynikowy - Kontrast HSV";
                    tabOJ.TabPages.Clear();
                    tabOJ.TabPages.Add(tabJPKontrastHSV);
                    bitmapResult = selectedSource.KontrastHSV(trackJPK_HSV_v.Value);

                    //-------------------------------------------                               
                    //   this.groupBoxTablicaLUT.Visible = true;  
                    //   this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarKontrast);
                    //   pictureWtornyOPJ.Refresh();                  
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Jasność")
                {
                    label1.Text = "Obraz wynikowy - Jasność";
                    tabOJ.TabPages.Clear();
                    tabOJ.TabPages.Add(tabJPJasnoscS);
                    bitmapResult = selectedSource.Jasnosc(trackJPJ_S.Value);

                    //-------------------------------------------
                    //    this.groupBoxTablicaLUT.Visible = true;
                    //    this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarJasnosc);                   
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Jasność RGB")
                {
                    label1.Text = "Obraz wynikowy - Jasność RGB";
                    tabOJ.TabPages.Clear();
                    tabOJ.TabPages.Add(tabJPJasnoscRGB);
                    bitmapResult = selectedSource.Jasnosc(trackJPJ_RGB.Value);

                    //-------------------------------------------
                    //   this.groupBoxTablicaLUT.Visible = true;
                    //   this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarJasnosc);
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Jasność HSV")
                {
                    label1.Text = "Obraz wynikowy - Jasność HSV";
                    tabOJ.TabPages.Clear();
                    tabOJ.TabPages.Add(tabJPJasnoscHSV);
                    bitmapResult = selectedSource.JasnoscHSV(trackJPJv1_HSV.Value);
                    
                    //-------------------------------------------------
                   // this.groupBoxTablicaLUT.Visible = true;
                  //  this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarJasnosc);
                    
                }

               /*
                else if (comboBoxFGG.SelectedItem.ToString() == "Bineryzacja")
                {
                    this.groupV1.Visible = true;
                 //   this.groupV2.Visible = false;
                    this.groupBoxTablicaLUT.Visible = true;
                    this.label1.Text = "Obraz wynikowy - Bineryzacja";
                    this.trackBarOPJ.Maximum = 255;
                    this.trackBarOPJ.Minimum = 0;
                    this.label2.Text = "0";
                    this.label3.Text = "255";
                    this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarBineryzacja);
                    Bitmap bmpHSV;
                    bmpHSV = (Bitmap)this.pictureWtornyOPJ.Image;
                    bmpHSV = FunkcjeJednoarg.Bineryzacja(bmpHSV, this.trackBarOPJ.Value);
                    pictureWtornyOPJ.Refresh();
                    bitmapResult = bmpHSV;  
                }
                */

                else if (comboBoxFGG.SelectedItem.ToString() == "Progowanie")
                {
                    label1.Text = "Obraz wynikowy - Progowanie";
                    tabOJ.TabPages.Clear();
                    tabOJ.TabPages.Add(tabJPProgowanieS); 
                    bitmapResult = selectedSource.JasnoscHSV(trackJPP_S.Value);
                    
                    //--------------------------------------------------------------
                    // this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarBineryzacja);
                    // Bitmap bmpHSV;
                    // bmpHSV = (Bitmap)this.pictureWtornyOPJ.Image;
                    // bmpHSV = FunkcjeJednoarg.ProgowanieRGB(bmpHSV, this.trackBarOPJ.Value);
                    //  pictureWtornyOPJ.Refresh();
                    // bitmapResult = bmpHSV; 
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Progowanie RGB")
                {
                    label1.Text = "Obraz wynikowy - Progowanie RGB";
                    tabOJ.TabPages.Clear();
                    tabOJ.TabPages.Add(tabJPProgowanieRGB);
                    bitmapResult = selectedSource.JasnoscHSV(trackJPP_RGB.Value);
                    
                    //-----------------------------------------------------------------------------
                    // this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarBineryzacja);
                   //  Bitmap bmpHSV;
                   //  bmpHSV = (Bitmap)this.picturePierwotnyOPJ.Image;
                   // bmpHSV = FunkcjeJednoarg.ProgowanieRGB(bmpHSV, this.trackBarOPJ.Value);
                   // bmpHSV1 = (Bitmap)pictureWtornyOPJ.Image;
                   //   pictureWtornyOPJ.Refresh();
                   //  bitmapResult = bmpHSV;
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Progowanie HSV")
                {
                    label1.Text = "Obraz wynikowy - Progowanie HSV ";
                    tabOJ.TabPages.Clear();
                    tabOJ.TabPages.Add(tabJPProgowanieHSV);
                    bitmapResult = selectedSource.JasnoscHSV(trackJPP_HSV.Value);
                    
                    //---------------------------------------------------------------------
                    // this.trackBarOPJ.Maximum = 100000;
                    // this.trackBarOPJ.Minimum = 0;
                    //  this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarBineryzacja);                             
                    // Bitmap bmpHSV;
                    // bmpHSV = (Bitmap)this.pictureWtornyOPJ.Image;
                    // bmpHSV = FunkcjeHSV.ProgowanieHSV2(bmpHSV, this.trackBarOPJ.Value);
                    // pictureWtornyOPJ.Refresh();
                    // bitmapResult = bmpHSV;
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Rozciąganie")
                {
                   label1.Text = "Obraz wynikowy - Rozciąganie";
                   tabOJ.TabPages.Clear();
                   tabOJ.TabPages.Add(tabJPRozciaganieS);
                  // bitmapResult = selectedSource.JasnoscHSV(.Value);
                    
                    //---------------------------------------------------------------------------
                    // tabOJ.TabPages.Add(this.tabJPRozciaganie);
                    // Bitmap bmpRP;
                    // bmpRP = (Bitmap)this.pictureWtornyOPJ.Image;
                    // bmpRP = FunkcjeJednoarg.RozciagnieRGB(bmpRP, this.trackBarOPJ.Value, this.trackBarV2.Value);
                    // this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarBineryzacja);
                    // pictureWtornyOPJ.Refresh();
                    // bitmapResult = bmpRP;
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Rozciąganie RGB")
                {
                    label1.Text = "Obraz wynikowy - Rozciąganie";
                    tabOJ.TabPages.Clear();
                    tabOJ.TabPages.Add(tabJPRozciaganieRGB);
                    // bitmapResult = selectedSource.JasnoscHSV(.Value);
                    
                    //---------------------------------------------------------------------------------------
                    // Bitmap bmpRP;
                    // bmpRP = (Bitmap)this.pictureWtornyOPJ.Image;
                    // bmpRP = FunkcjeJednoarg.RozciagnieRGB(bmpRP, this.trackBarOPJ.Value, this.trackBarV2.Value);
                    // this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarBineryzacja);
                    // pictureWtornyOPJ.Refresh();
                    // bitmapResult = bmpRP;
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Rozciąganie HSV")
                {
                    label1.Text = "Obraz wynikowy - Rozciąganie HSV";
                    tabOJ.TabPages.Clear();
                    tabOJ.TabPages.Add(tabJPRozciaganieHSV);
                    // bitmapResult = selectedSource.JasnoscHSV(.Value);
                    
                    //------------------------------------------------------------------
                    // Bitmap bmpRP;
                    // bmpRP = (Bitmap)this.pictureWtornyOPJ.Image;
                    // bmpRP = FunkcjeJednoarg.RozciagnieRGB(bmpRP, this.trackBarOPJ.Value, this.trackBarV2.Value);
                    // this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarBineryzacja);
                    // pictureWtornyOPJ.Refresh();
                    // bitmapResult = bmpRP;
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Korekcja Gamma")
                {
                    label1.Text = "Obraz wynikowy - Korekcja Gamma";
                    tabOJ.TabPages.Clear();
                    tabOJ.TabPages.Add(tabJPKorekcjaGammaS);
                    // bitmapResult = selectedSource.JasnoscHSV(.Value);
                                       
                    //-------------------------------------------------------------------
                    // this.trackBarOPJ.Minimum = 1;
                    // this.trackBarOPJ.Maximum = 400;
                    // this.trackBarOPJ.Value = 200;          
                   // this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarGamma);
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Korekcja Gamma RGB")
                {
                    label1.Text = "Obraz wynikowy - Korekcja Gamma RGB";
                    tabOJ.TabPages.Clear();
                    tabOJ.TabPages.Add(tabJPKorekcjaGammaRGB);
                    // bitmapResult = selectedSource.JasnoscHSV(.Value);
                    
                    //-------------------------------------------------------------------------
                    // this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarGamma);
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Korekcja Gamma HSV")
                {
                    label1.Text = "Obraz wynikowy - Korekcja Gamma HSV";
                    tabOJ.TabPages.Clear();
                    tabOJ.TabPages.Add(tabJPKorekcjaGammaHSV);
                    // bitmapResult = selectedSource.JasnoscHSV(.Value);                            
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Odcienie RGB")
                {
                    label1.Text = "Obraz wynikowy - Odcienie RGB";
                    tabOJ.TabPages.Clear();
                    tabOJ.TabPages.Add(tabJPRedukcjaPoziomowRGB);
                    // bitmapResult = selectedSource.JasnoscHSV(.Value);
                    
                    //-------------------------------------------------------
                    // float blue = trackBarOPJ.Value / 100.0f;
                    // float green = trackBarV2.Value / 100.0f;
                    // float red = trackBarV3.Value / 100.0f;
                    // this.trackBarOPJ.Minimum = 0;
                    // this.trackBarOPJ.Maximum = 100;
                    //  this.trackBarV2.Minimum = 0;
                    //  this.trackBarV2.Maximum = 100;
                    //  this.trackBarV3.Minimum = 0;
                    //  this.trackBarV3.Maximum = 100;
                    //  bitmapResult = selectedSource.OdcienieRGB(blue, green, red);
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Redukcja poziomów jasności")
                {
                    label1.Text = "Obraz wynikowy - Redukcja poziomów jasności";
                    tabOJ.TabPages.Clear();
                    tabOJ.TabPages.Add(tabJPRedukcjaPoziomowS);
                                        
                    //----------------------------------------------
                    //  this.trackBarOPJ.Maximum = 255;
                    //  this.trackBarOPJ.Minimum = 0;                   
                    //  Bitmap bmpRP;
                    //  bmpRP = (Bitmap)this.pictureWtornyOPJ.Image;
                    //  bmpRP = FunkcjeJednoarg.Bineryzacja(bmpRP, this.trackBarOPJ.Value);
                    //  this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarBineryzacja);
                    //  pictureWtornyOPJ.Refresh();
                    //  bitmapResult = bmpRP;
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Redukcja poziomów jasności RGB")
                {
                    label1.Text = "Obraz wynikowy - Redukcja poziomów jasności RGB";
                    tabOJ.TabPages.Clear();
                    tabOJ.TabPages.Add(tabJPRedukcjaPoziomowRGB);
                    // bitmapResult = selectedSource.JasnoscHSV(.Value);
                    
                    //-------------------------------------------------------------
                    //  Bitmap bmpRP;
                    //  bmpRP = (Bitmap)this.pictureWtornyOPJ.Image;
                    //  bmpRP = FunkcjeJednoarg.Bineryzacja(bmpRP, this.trackBarOPJ.Value);
                    //  this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarBineryzacja);
                    //  pictureWtornyOPJ.Refresh();
                    //  bitmapResult = bmpRP;
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Redukcja poziomów jasności HSV")
                {
                    label1.Text = "Obraz wynikowy - Redukcja poziomów jasności HSV";
                    tabOJ.TabPages.Clear();
                    tabOJ.TabPages.Add(tabJPRedukcjaPoziomowHSV);
                    // bitmapResult = selectedSource.JasnoscHSV(.Value);
                    
                    //--------------------------------------------------------------------------
                    //  this.trackBarOPJ.Maximum = 10000;
                    //  this.trackBarOPJ.Minimum = 0;                
                    //  Bitmap bmpRP;
                    //  bmpRP..SetPixel(x, y, hsv.ColorFromHSV(h,s,));                    
                    //  bmpRP = (Bitmap)this.pictureWtornyOPJ.Image;
                    //  bmpRP = FunkcjeHSV.PoziomySzarosciHSV2(bmpRP, this.trackBarOPJ.Value);               
                    //  this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarBineryzacja);
                    //  pictureWtornyOPJ.Refresh();
                    //  bitmapResult = bmpRP;
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Sepia")
                {
                   label1.Text = "Obraz wynikowy - Sepia";
                   tabOJ.TabPages.Clear();
                   bitmapResult = selectedSource.CopyAsSepiaTone();
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Sepia RGB")
                {
                    label1.Text = "Obraz wynikowy - Sepia RGB";
                    tabOJ.TabPages.Clear();
                    bitmapResult = selectedSource.CopyAsSepiaTone();
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Sepia HSV")
                {
                    label1.Text = "Obraz wynikowy - Sepia HSV";
                    tabOJ.TabPages.Clear();
                    bitmapResult = selectedSource.CopyAsSepiaTone();                 
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Transparentny")
                {
                    label1.Text = "Obraz wynikowy - Transparentny";
                    tabOJ.TabPages.Clear();
                     bitmapResult = selectedSource.CopyWithTransparency();
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Transparentny RGB")
                {
                    label1.Text = "Obraz wynikowy - Transparentny RGB";
                    tabOJ.TabPages.Clear();
                    bitmapResult = selectedSource.CopyWithTransparency();
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Transparentny HSV")
                {
                    label1.Text = "Obraz wynikowy - Transparentny HSV ";
                    tabOJ.TabPages.Clear();
                    bitmapResult = selectedSource.CopyWithTransparency();
                }
             }

            if (bitmapResult != null)
            {
                if (preview == true)
                {
                    this.pictureWtornyOPJ.Image = bitmapResult;
                }
                else
                {
                    resultBitmap = bitmapResult;
                }
            }

        }

        private void comboBoxFGG_SelectedIndexChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void button1_Click(object sender, EventArgs e)
        {
             // this.picturePierwotnyOPJ.Image = previewBitmap;
       //     this.pictureWtornyOPJ.Image = bitmapResult;

            this.pictureWtornyOPJ.Image = resultBitmap;
            ApplyFilter(false);
            if (resultBitmap != null)
            {
                SaveFileDialog sfd = new SaveFileDialog();
                sfd.Title = "Specify a file name and file path";
                sfd.Filter = "Png Images(*.png)|*.png|Jpeg Images(*.jpg)|*.jpg";
                sfd.Filter += "|Bitmap Images(*.bmp)|*.bmp";

                if (sfd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                {
                    string fileExtension = Path.GetExtension(sfd.FileName).ToUpper();
                    ImageFormat imgFormat = ImageFormat.Png;

                    if (fileExtension == "BMP")
                    {
                        imgFormat = ImageFormat.Bmp;
                    }
                    else if (fileExtension == "JPG")
                    {
                        imgFormat = ImageFormat.Jpeg;
                    }

                    StreamWriter streamWriter = new StreamWriter(sfd.FileName, false);
                    resultBitmap.Save(streamWriter.BaseStream, imgFormat);
                    streamWriter.Flush();
                    streamWriter.Close();

                    resultBitmap = null;
                }

            }
        }

        private void trackBarV2_Scroll(object sender, EventArgs e)
        {
            this.labelJPJmax_RGB.Text = trackBarOPJ.Value.ToString();
            ApplyFilter(true);
        }

        private void buttonWidok_Click(object sender, EventArgs e)
        {
            this.picturePierwotnyOPJ.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureWtornyOPJ.SizeMode = PictureBoxSizeMode.StretchImage;

            if (this.radioNaturalny.Checked)
            {
                this.picturePierwotnyOPJ.SizeMode = PictureBoxSizeMode.Normal;
                this.pictureWtornyOPJ.SizeMode = PictureBoxSizeMode.Normal;
            }

            if (this.radioAutoSize.Checked)
            {
                this.picturePierwotnyOPJ.SizeMode = PictureBoxSizeMode.CenterImage;
                this.pictureWtornyOPJ.SizeMode = PictureBoxSizeMode.CenterImage;
            }
            if (this.radioDopasowany.Checked)
            {
                this.picturePierwotnyOPJ.SizeMode = PictureBoxSizeMode.StretchImage;
                this.pictureWtornyOPJ.SizeMode = PictureBoxSizeMode.StretchImage;
            }
            this.picturePierwotnyOPJ.Refresh();
            this.pictureWtornyOPJ.Refresh();
        }

        private void ColourComponentValueChangedEventHandler(object sender, EventArgs e)
        {
            label3.Text = this.trackBarOPJ.Value.ToString();
      //      labelJPJmin_RGB.Text = this.trackBarV2.Value.ToString();
            label9.Text = this.trackBarV3.Value.ToString();

            ApplyFilter(true);
        }

        private void trackBarV3_Scroll(object sender, EventArgs e)
        {
            label7.Text = trackBarOPJ.Value.ToString();
            ApplyFilter(true);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            //this.TabWynikowy.Visible = true;
            if (this.radioSzary.Checked)
            {
                this.generuj_histogram(0);
              //  this.groupHistogram.Visible = true;
            }
            if (this.radioKolorRGB.Checked)
            {
                this.HistogramRGB.Image = generuj_histogram_kolory(0);
                this.labelJPJv_RGB.Text = "rgb";
            }
            if (this.radioKolorHVS.Checked)
            { 
            
            }         
            EnableDoubleBuffered(this.dataGridTablica, true);
            int cols_width = 40;         
            Bitmap bmpTab = (Bitmap)this.pictureWtornyOPJ.Image;

            if (dataGridTablica.Columns.Count != bmpTab.Width || dataGridTablica.Rows.Count != bmpTab.Height)
            {
                dataGridTablica.Rows.Clear();
                dataGridTablica.Columns.Clear();
                dataGridTablica.RowHeadersWidth = 60;
                for (int x = 0; x < bmpTab.Width; x++)
                {
                    dataGridTablica.Columns.Add(null, x.ToString());
                    dataGridTablica.Columns[x].Width = cols_width;
                    dataGridTablica.Columns[x].FillWeight = 0.0000001f;
                }
                dataGridTablica.Rows.Add(bmpTab.Height);
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    dataGridTablica.Rows[y].HeaderCell.Value = y.ToString();
                }
            }

            for (int x = 0; x < bmpTab.Width; x++)
            {
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    dataGridTablica[x, y].Value = bmpTab.GetPixel(x, y).R;
                }
            } 
        }

        private void pasek_skali_Scroll(object sender, EventArgs e)
        {
            wartosc_skali.Text = ((double)pasek_skali.Value / 10.0f).ToString();
            this.HistogramGrey.Image = generuj_histogram(4);
        }

        private void buttpn_red_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(0);
        }

        private void button_green_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(1);
        }

        private void button_blue_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(2);
        }

        private void button_wszystkie_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(0);
        }

        private void button8_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(1);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(2);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(3);
        }

        private void pasek_skali2_Scroll(object sender, EventArgs e)
        {
            wartosc_skali2.Text = ((double)pasek_skali2.Value / 10.0f).ToString();
            this.HistogramGrey2.Image = generuj_histogram2(4);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            //this.TabPierwotny.Visible = true; 
            if (this.radioSzary.Checked)
            {
            //    Bitmap b = (Bitmap)this.picturePierwotny2.Image;
                this.generuj_histogram2(0);
            }
            if (this.radioKolorRGB.Checked)
            {
                this.HistogramRGB2.Image = generuj_histogram_kolory2(0);
                this.labelJPJv_RGB.Text = "rgb"; 
            }
            if (this.radioKolorHVS.Checked)
            { 
            
            }
            EnableDoubleBuffered(this.TablicaLiczb2, true);
            int cols_width = 40;         
            Bitmap bmpTab = (Bitmap)this.picturePierwotnyOPJ.Image;

            if (TablicaLiczb2.Columns.Count != bmpTab.Width || TablicaLiczb2.Rows.Count != bmpTab.Height)
            {
                TablicaLiczb2.Rows.Clear();
                TablicaLiczb2.Columns.Clear();
                TablicaLiczb2.RowHeadersWidth = 60;
                for (int x = 0; x < bmpTab.Width; x++)
                {
                    TablicaLiczb2.Columns.Add(null, x.ToString());
                    TablicaLiczb2.Columns[x].Width = cols_width;
                    TablicaLiczb2.Columns[x].FillWeight = 0.0000001f;
                }
                TablicaLiczb2.Rows.Add(bmpTab.Height);
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    TablicaLiczb2.Rows[y].HeaderCell.Value = y.ToString();
                }
            }

            for (int x = 0; x < bmpTab.Width; x++)
            {
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    TablicaLiczb2[x, y].Value = bmpTab.GetPixel(x, y).R;
                }
            } 
        }

        private void button6_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram2(0);
        }

        private void button12_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram2(1);
        }

        private void button11_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram2(2);
        }

        private void button10_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram_kolory2(0);
        }

        private void button9_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram_kolory2(1);
        }

        private void button14_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram_kolory2(2);
        }

        private void button13_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram_kolory2(3);
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {           
            ApplyFilter(true);
            this.labelJPKv_S.Text = this.trackJPK_S.Value.ToString();   
        }

        private void trackBar2_Scroll(object sender, EventArgs e)
        {

            ApplyFilter(true);
           this.labelJPK_HSV_v.Text = this.trackJPK_HSV_v.Value.ToString();  
        }

        private void trackKS_RGB_Scroll(object sender, EventArgs e)
        {
          ApplyFilter(true);
          this.labelJPKv_RGB.Text = this.trackJPK_RGB.Value.ToString(); 
        }

        private void groupBox2_Enter(object sender, EventArgs e)
        {

        }

        private void groupBox7_Enter(object sender, EventArgs e)
        {

        }

        private void label73_Click(object sender, EventArgs e)
        {

        }

        private void label44_Click(object sender, EventArgs e)
        {

        }

        private void trackJPJ_S_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelJPJv_S.Text = this.trackJPJ_S.Value.ToString(); 
        }

        private void trackJPJ_RGB_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelJPJv_RGB.Text = this.trackJPJ_RGB.Value.ToString();
        }

        private void trackJPKG_S_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelJPKGv_S.Text = this.trackJPKG_S.Value.ToString();
        }

        private void trackJPKG_RGB_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelJPKGv_RGB.Text = this.trackJPKG_RGB.Value.ToString();
        }

        private void trackJPP_S_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelJPPv_S.Text = this.trackJPP_S.Value.ToString();
        }

        private void trackJPP_RGB_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelJPPv_RGB.Text = this.trackJPP_RGB.Value.ToString();
        }

        private void trackJPP_HSV_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelJPPv_HSV.Text = this.trackJPP_HSV.Value.ToString();
        }

        private void trackJPRv1_S_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelJPRv1_S.Text = this.trackJPRv1_S.Value.ToString();
        }

        private void trackJPRv2_S_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelJPRv2_S.Text = this.trackJPRv2_S.Value.ToString();
        }

        private void trackJPRv1_RGB_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelJPRv1_RGB.Text = this.trackJPRv1_RGB.Value.ToString();
        }

        private void trackJPRv2_RGB_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelJPRv2_RGB.Text = this.trackJPRv2_RGB.Value.ToString();
        }

        private void trackJPRv1_HSV_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelJPRv1_HSV.Text = this.trackJPRv1_HSV.Value.ToString();
        }

        private void trackJPRv2_HSV_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelJPRv2_HSV.Text = this.trackJPRv2_HSV.Value.ToString();
        }

        private void trackJPRP_S_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelJPRPv_S.Text = this.trackJPRP_S.Value.ToString();
        }

        private void trackJPRPv1_RGB_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelJPRPv1_RGB.Text = this.trackJPRPv1_RGB.Value.ToString();
        }

        private void trackJPRPv2_RGB_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelJPRPv2_RGB.Text = this.trackJPRPv2_RGB.Value.ToString();
        }

        private void trackJPRPv3_RGB_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelJPRPv3_RGB.Text = this.trackJPRPv3_RGB.Value.ToString();
        }

        private void trackJPRPv1_HSV_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelJPRPv1_HSV.Text = this.trackJPRPv1_HSV.Value.ToString();
        }

        private void trackJPRPv2_HSV_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelJPRPv2_HSV.Text = this.trackJPRPv2_HSV.Value.ToString();
        }

        private void trackJPRPv3_HSV_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelJPRPv3_HSV.Text = this.trackJPRPv3_HSV.Value.ToString();
        }

        private void trackJPUOP_S_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelJPUOJv_S.Text = this.trackJPUOP_S.Value.ToString();
        }

        private void trackJPUOP_RGB_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelJPUOJv_RGB.Text = this.trackJPUOP_RGB.Value.ToString();
        }

        private void trackJPUOP_HSV_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelJPUOJv_HSV.Text = this.trackJPUOP_HSV.Value.ToString();
        }
   

    }
}