﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Drawing;

namespace APO_BB_DK_v012013
{
    class FiltracjaLiniowa
    {
        private static int safety_check(int val)
        {
            if (val > 255)
                return 255;
            else if (val < 0)
                return 0;
            return val;
        }
        private static double safety_check_hsv(double val)
        {
            if (val > 1)
                return 1;
            else if (val < 0)
                return 0;
            return val;
        }

               
        public Bitmap filtracja_liniowa(Bitmap src, int[] vals, int dzielnik, int metoda)
        {
            if (vals == null)
                return src;
          //  if (vals.Length != 9)
          //      return src;

            Bitmap result = new Bitmap(src);
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(src);
            BitmapProcessing.FastBitmap fresult = new BitmapProcessing.FastBitmap(result);
            fobrazek_bitmapa.LockImage();
            fresult.LockImage();
            int sum_vals = dzielnik;

            if (sum_vals == 0)
                sum_vals = 1;

            if (metoda == 1)
            {
                int rmax = 0, gmax = 0, bmax = 0, rmin = 0, gmin = 0, bmin = 0;
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {
                        //RED
                        int[] r = new int[vals.Length];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            r[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).R;
                        if (y > 0)
                            r[1] = fobrazek_bitmapa.GetPixel(x, y - 1).R;
                        if (y > 0 && x < src.Width - 1)
                            r[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).R;
                        if (x > 0)
                            r[3] = fobrazek_bitmapa.GetPixel(x - 1, y).R;
                        r[4] = fobrazek_bitmapa.GetPixel(x, y).R;
                        if (x < src.Width - 1)
                            r[5] = fobrazek_bitmapa.GetPixel(x + 1, y).R;
                        if (x > 0 && y < src.Height - 1)
                            r[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).R;
                        if (y < src.Height - 1)
                            r[7] = fobrazek_bitmapa.GetPixel(x, y + 1).R;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            r[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).R;
                        int red = 0;
                        for (int z = 0; z < vals.Length; z++)
                        {
                            red = red + vals[z] * r[z];
                        }
                        red = red / sum_vals;
                        if (red > rmax) rmax = red;
                        if (red < rmin) rmin = red;
                        //GREEN
                        int[] g = new int[vals.Length];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            g[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).G;
                        if (y > 0)
                            g[1] = fobrazek_bitmapa.GetPixel(x, y - 1).G;
                        if (y > 0 && x < src.Width - 1)
                            g[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).G;
                        if (x > 0)
                            g[3] = fobrazek_bitmapa.GetPixel(x - 1, y).G;
                        g[4] = fobrazek_bitmapa.GetPixel(x, y).G;
                        if (x < src.Width - 1)
                            g[5] = fobrazek_bitmapa.GetPixel(x + 1, y).G;
                        if (x > 0 && y < src.Height - 1)
                            g[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).G;
                        if (y < src.Height - 1)
                            g[7] = fobrazek_bitmapa.GetPixel(x, y + 1).G;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            g[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).G;
                        int green = 0;
                        for (int z = 0; z < vals.Length; z++)
                        {
                            green = green + vals[z] * g[z];
                        }
                        green = green / sum_vals;
                        if (green > gmax) gmax = green;
                        if (green < gmin) gmin = green;
                        //BLUE
                        int[] b = new int[vals.Length];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            b[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).B;
                        if (y > 0)
                            b[1] = fobrazek_bitmapa.GetPixel(x, y - 1).B;
                        if (y > 0 && x < src.Width - 1)
                            b[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).B;
                        if (x > 0)
                            b[3] = fobrazek_bitmapa.GetPixel(x - 1, y).B;
                        b[4] = fobrazek_bitmapa.GetPixel(x, y).B;
                        if (x < src.Width - 1)
                            b[5] = fobrazek_bitmapa.GetPixel(x + 1, y).B;
                        if (x > 0 && y < src.Height - 1)
                            b[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).B;
                        if (y < src.Height - 1)
                            b[7] = fobrazek_bitmapa.GetPixel(x, y + 1).B;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            b[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).B;
                        int blue = 0;
                        for (int z = 0; z < vals.Length; z++)
                        {
                            blue = blue + vals[z] * b[z];
                        }
                        blue = blue / sum_vals;
                        if (blue > bmax) bmax = blue;
                        if (blue < bmin) bmin = blue;
                    }
                }
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {
                        //RED
                        int[] r = new int[vals.Length];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            r[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).R;
                        if (y > 0)
                            r[1] = fobrazek_bitmapa.GetPixel(x, y - 1).R;
                        if (y > 0 && x < src.Width - 1)
                            r[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).R;
                        if (x > 0)
                            r[3] = fobrazek_bitmapa.GetPixel(x - 1, y).R;
                        r[4] = fobrazek_bitmapa.GetPixel(x, y).R;
                        if (x < src.Width - 1)
                            r[5] = fobrazek_bitmapa.GetPixel(x + 1, y).R;
                        if (x > 0 && y < src.Height - 1)
                            r[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).R;
                        if (y < src.Height - 1)
                            r[7] = fobrazek_bitmapa.GetPixel(x, y + 1).R;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            r[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).R;
                        int red = 0;
                        for (int z = 0; z < vals.Length; z++)
                        {
                            red = red + vals[z] * r[z];
                        }
                        red = red / sum_vals;
                        red = (int)((((double)red - (double)rmin) / ((double)rmax - (double)rmin)) * 256);
                        //GREEN
                        int[] g = new int[vals.Length];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            g[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).G;
                        if (y > 0)
                            g[1] = fobrazek_bitmapa.GetPixel(x, y - 1).G;
                        if (y > 0 && x < src.Width - 1)
                            g[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).G;
                        if (x > 0)
                            g[3] = fobrazek_bitmapa.GetPixel(x - 1, y).G;
                        g[4] = fobrazek_bitmapa.GetPixel(x, y).G;
                        if (x < src.Width - 1)
                            g[5] = fobrazek_bitmapa.GetPixel(x + 1, y).G;
                        if (x > 0 && y < src.Height - 1)
                            g[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).G;
                        if (y < src.Height - 1)
                            g[7] = fobrazek_bitmapa.GetPixel(x, y + 1).G;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            g[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).G;
                        int green = 0;
                        for (int z = 0; z < vals.Length; z++)
                        {
                            green = green + vals[z] * g[z];
                        }
                        green = green / sum_vals;
                        green = (int)((((double)green - (double)gmin) / ((double)gmax - (double)gmin)) * 256);
                        //BLUE
                        int[] b = new int[vals.Length];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            b[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).B;
                        if (y > 0)
                            b[1] = fobrazek_bitmapa.GetPixel(x, y - 1).B;
                        if (y > 0 && x < src.Width - 1)
                            b[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).B;
                        if (x > 0)
                            b[3] = fobrazek_bitmapa.GetPixel(x - 1, y).B;
                        b[4] = fobrazek_bitmapa.GetPixel(x, y).B;
                        if (x < src.Width - 1)
                            b[5] = fobrazek_bitmapa.GetPixel(x + 1, y).B;
                        if (x > 0 && y < src.Height - 1)
                            b[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).B;
                        if (y < src.Height - 1)
                            b[7] = fobrazek_bitmapa.GetPixel(x, y + 1).B;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            b[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).B;
                        int blue = 0;
                        for (int z = 0; z < vals.Length; z++)
                        {
                            blue = blue + vals[z] * b[z];
                        }
                        blue = blue / sum_vals;
                        blue = (int)((((double)blue - (double)bmin) / ((double)bmax - (double)bmin)) * 256);
                        fresult.SetPixel(x, y, Color.FromArgb(safety_check(red), safety_check(green), safety_check(blue)));
                    }
                }
            }
            else
            {
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {
                        //RED
                        int[] r = new int[ vals.Length];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            r[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).R;
                        if (y > 0)
                            r[1] = fobrazek_bitmapa.GetPixel(x, y - 1).R;
                        if (y > 0 && x < src.Width - 1)
                            r[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).R;
                        if (x > 0)
                            r[3] = fobrazek_bitmapa.GetPixel(x - 1, y).R;
                        r[4] = fobrazek_bitmapa.GetPixel(x, y).R;
                        if (x < src.Width - 1)
                            r[5] = fobrazek_bitmapa.GetPixel(x + 1, y).R;
                        if (x > 0 && y < src.Height - 1)
                            r[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).R;
                        if (y < src.Height - 1)
                            r[7] = fobrazek_bitmapa.GetPixel(x, y + 1).R;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            r[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).R;
                        int red = 0;
                        for (int z = 0; z < vals.Length; z++)
                        {
                            red = red + vals[z] * r[z];
                        }
                        red = red / sum_vals;
                        //GREEN
                        int[] g = new int[vals.Length];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            g[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).G;
                        if (y > 0)
                            g[1] = fobrazek_bitmapa.GetPixel(x, y - 1).G;
                        if (y > 0 && x < src.Width - 1)
                            g[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).G;
                        if (x > 0)
                            g[3] = fobrazek_bitmapa.GetPixel(x - 1, y).G;
                        g[4] = fobrazek_bitmapa.GetPixel(x, y).G;
                        if (x < src.Width - 1)
                            g[5] = fobrazek_bitmapa.GetPixel(x + 1, y).G;
                        if (x > 0 && y < src.Height - 1)
                            g[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).G;
                        if (y < src.Height - 1)
                            g[7] = fobrazek_bitmapa.GetPixel(x, y + 1).G;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            g[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).G;
                        int green = 0;
                        for (int z = 0; z < vals.Length; z++)
                        {
                            green = green + vals[z] * g[z];
                        }
                        green = green / sum_vals;
                        //BLUE
                        int[] b = new int[vals.Length];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            b[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).B;
                        if (y > 0)
                            b[1] = fobrazek_bitmapa.GetPixel(x, y - 1).B;
                        if (y > 0 && x < src.Width - 1)
                            b[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).B;
                        if (x > 0)
                            b[3] = fobrazek_bitmapa.GetPixel(x - 1, y).B;
                        b[4] = fobrazek_bitmapa.GetPixel(x, y).B;
                        if (x < src.Width - 1)
                            b[5] = fobrazek_bitmapa.GetPixel(x + 1, y).B;
                        if (x > 0 && y < src.Height - 1)
                            b[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).B;
                        if (y < src.Height - 1)
                            b[7] = fobrazek_bitmapa.GetPixel(x, y + 1).B;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            b[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).B;
                        int blue = 0;
                        for (int z = 0; z < vals.Length; z++)
                        {
                            blue = blue + vals[z] * b[z];
                        }
                        blue = blue / sum_vals;
                        if (metoda == 2)
                        {
                            if (red > 0)
                            {
                                red = 255;
                            }
                            else if (red < 0)
                            {
                                red = 0;
                            }
                            else
                            {
                                red = 127;
                            }
                            if (green > 0)
                            {
                                green = 255;
                            }
                            else if (green < 0)
                            {
                                green = 0;
                            }
                            else
                            {
                                green = 127;
                            }
                            if (blue > 0)
                            {
                                blue = 255;
                            }
                            else if (blue < 0)
                            {
                                blue = 0;
                            }
                            else
                            {
                                blue = 127;
                            }

                        }

                        fresult.SetPixel(x, y, Color.FromArgb(safety_check(red), safety_check(green), safety_check(blue)));
                    }
                }
            }
            fresult.UnlockImage();
            fobrazek_bitmapa.UnlockImage();
            return result;
        }


       //-------------------------------------------------------------------------------------------------------------

        public static void BarKontrast(byte[ ] tab,  double b)
        {
            //Przygotuj tablice LUT i pokaz ja na wykresie
         //   wykres.Series[0].Points.Clear();

            byte[] LUT = new byte[256];
            double a;
            if (b <= 0)
            {
                a = 1.0 + (b / 256.0);
            }
            else
            {
                a = 256.0 / Math.Pow(2, Math.Log(257 - b, 2));
            }
          //  return a;
          //  wykres.Titles[0].Text = "Tablica LUT, a = " + a;
            for (int i = 0; i < 256; i++)
            {
                if ((a * (i - 127) + 127) > 255)
                {
                    LUT[i] = 255;
                }
                else if ((a * (i - 127) + 127) < 0)
                {
                    LUT[i] = 0;
                }
                else
                {
                    LUT[i] = (byte)(a * (i - 127) + 127);
                }
               
              //  wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
            }
        }
            /*
            //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
            byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
            for (int i = 0; i < pixelValues.Length; i++)
            {
                pixelValues[i] = LUT[pixelValues[i]];
            }
                 
            //Kopiuj obrazek zrodlowy        
            Bitmap bitmap = (Bitmap)this.picturePierwotnyOPJ.Image.Clone();
            //    Bitmap bitmap1 = (Bitmap)this.picturePierwotnySzary.Image.Clone();
            this.pictureWtornyOPJ.Image = bitmap;
            //Pobierz wartosc wszystkich punktow obrazu
            BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
            byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
            System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);
            //Zmien kontrast kazdego punktu zgodnie z tablica LUT
            for (int i = 0; i < pixelValues.Length; i++)
            {
                pixelValues[i] = LUT[pixelValues[i]];
            }
            //Ustaw wartosc wszystkich punktow obrazu
            System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
            bitmap.UnlockBits(bmpData);
             */
        

    }
}