﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace APO_BB_DK_v012013
{
    public enum FiltryWygladzajaceTyp
    {
        Usredniajacy,
        Kwadratowy,
        Kolowy,
        Piramidalny,
        Stozkowy,
        Gauss_3x3,
        Gauss_5x5_1,
        Gauss_5x5_2,
        Gauss_5x5_3,
        Gauss_7x7,
        LP_1,
        LP_2,
        LP_3,
        Wlasna_maska
    }
    
    public class FiltryWygladzajace
    {
        public double x1, x2, x3, x4, x5, x6, x7, x8, x9;


        public static double Suma(double[,] matrix)
        {
            double suma;
            suma = 0.0;
            for (int x = 0; x < matrix.GetLength(0); x++)
                for (int y = 0; y < matrix.GetLength(1); y++)
                {
                    suma += matrix[x,y];
                }
                return suma;      
        }



        public static double[,] Usredniajacy
        {
            get {
                   return new double[,] { { 1, 1, 1 }, 
                                          { 1, 1, 1 }, 
                                          { 1, 1, 1 }, };
                }
        }

        public static double[,] Kwadratowy
        {
            get
            {
                return new double[,] { { 1, 1, 1, 1, 1 }, 
                                       { 1, 1, 1, 1, 1 }, 
                                       { 1, 1, 1, 1, 1 }, 
                                       { 1, 1, 1, 1, 1 }, 
                                       { 1, 1, 1, 1, 1 }, };
            }
        }

        public static double[,] Kolowy
        {
            get
            {
                return new double[,] { { 0, 1, 1, 1, 0 }, 
                                       { 1, 1, 1, 1, 1 }, 
                                       { 1, 1, 1, 1, 1 }, 
                                       { 1, 1, 1, 1, 1 }, 
                                       { 0, 1, 1, 1, 0 }, };
            }
        }

        public static double[,] Piramidalny
        {
            get
            {
                return new double[,] { { 1, 2, 3, 2, 1 }, 
                                       { 2, 4, 6, 4, 2 }, 
                                       { 3, 6, 9, 6, 3 }, 
                                       { 2, 4, 6, 4, 2 }, 
                                       { 1, 2, 3, 2, 1 }, };
            }
        }

        public static double[,] Stozkowy
        {
            get
            {
                return new double[,] { { 0, 0, 1, 0, 0 }, 
                                       { 0, 2, 2, 2, 0 }, 
                                       { 1, 2, 5, 2, 1 }, 
                                       { 0, 2, 2, 2, 0 }, 
                                       { 0, 0, 1, 0, 0 }, }; 
            }
        }

        public static double[,] Gauss_3x3
        {
            get
            {
                return new double[,] { { 1, 2, 1 }, 
                                       { 2, 4, 2 }, 
                                       { 1, 2, 1 }, };
            }
        }


        public static double[,] Gauss_5x5_1
        {
            get
            {
                return new double[,] { { 1, 1, 2, 1, 1 }, 
                                       { 1, 2, 4, 2, 1 }, 
                                       { 2, 4, 8, 4, 2 }, 
                                       { 1, 2, 4, 2, 1 }, 
                                       { 1, 1, 2, 1, 1 }, };
            }
        }

        public static double[,] Gauss_5x5_2
        {
            get
            {
                return new double[,] { { 0, 1, 2, 1, 0 }, 
                                       { 1, 4, 8, 4, 1 }, 
                                       { 2, 8, 16, 8, 2 }, 
                                       { 1, 4, 8, 4, 1 }, 
                                       { 0, 1, 2, 1, 0 },};
            }
        }

        public static double[,] Gauss_5x5_3
        {
            get
            {
                return new double[,] { { 1, 4, 7, 4, 1 }, 
                                       { 4, 16, 26, 16, 4 }, 
                                       { 7, 26, 41, 26, 7 }, 
                                       { 4, 16, 26, 16, 4 }, 
                                       { 1, 4, 7, 4, 1 },};
            }
        }

        public static double[,] Gauss_5x5_4
        {
            get
            {
                return new 
                    
                    double[,] {{ 2,  4,  5,  4, 2  }, 
                               { 4,  9, 12,  9, 4  }, 
                               { 5, 12, 15, 12, 5  },
                               { 4,  9, 12,  9, 4  },
                               { 2,  4,  5,  4, 2  },};
            }
        }

        public static double[,] Gauss_5x5_5
        {
            get
            {
                return new

                    double[,] { {  1,   4,  6,  4,  1  }, 
                              {  4,  16, 24, 16,  4  }, 
                              {  6,  24, 36, 24,  6  },
                              {  4,  16, 24, 16,  4  },
                              {  1,   4,  6,  4,  1  }, };
            }
        }




        public static double[,] Gauss_7x7
        {
            get
            {
                return new double[,] { { 1, 1, 2, 2, 2, 1, 1 }, 
                                       { 1, 2, 2, 4, 2, 2, 1 }, 
                                       { 2, 2, 4, 8, 4, 2, 2 }, 
                                       { 2, 4, 8, 16, 8, 4, 2 }, 
                                       { 2, 2, 4, 8, 4, 2, 2 }, 
                                       { 1, 2, 2, 4, 2, 2, 1 }, 
                                       { 1, 1, 2, 2, 2, 1, 1 }, }; 
            }
        }

        public static double[,] LP_1
        {
            get
            {
                return new double[,] { { 1, 1, 1 }, 
                                       { 1, 2, 1 }, 
                                       { 1, 1, 1 }, };
            }
        }

        public static double[,] LP_2
        {
            get
            {
                return new double[,] { { 1, 1, 1 }, 
                                       { 1, 4, 1 }, 
                                       { 1, 1, 1 }, };
            }
        }

        public static double[,] LP_3
        {
            get
            {
                return new double[,] { { 1, 1 , 1 }, 
                                       { 1, 12, 1 }, 
                                       { 1, 1 , 1 }, };
            }
        }

        public  double[,] Wlasna_maska
         {      
            get
            {
                return new double[,] { { x1, x2, x3 }, 
                                       { x4, x5, x6 }, 
                                       { x7, x8, x9 }, };    
            }
        }
    }
}
