﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Windows.Forms.DataVisualization.Charting;
using System.Drawing.Imaging;
using System.IO;


namespace APO_BB_DK_v012013
{
    public partial class Obraz2 : Form
    {
        private Image zrodlo;
        private Image zrodlo2;
        private System.Windows.Forms.TrackBar suwak1;
        private Bitmap bmpOrg;
        private Bitmap bmpMod;
     
     //   private Bitmap blendBitmap1 = null;
    //    private Bitmap blendBitmap2 = null;
    //    private Bitmap resultBitmap = null;

        public System.Windows.Forms.PictureBox pictureWynik1;
        public System.Windows.Forms.Panel panelPierowtny;
        public System.Windows.Forms.Panel panelWynikowy;
        public System.Windows.Forms.PictureBox pictureHistPierwotny;
        public System.Windows.Forms.PictureBox pictureHistWynikowy;

        public Obraz2()
        {
            zrodlo = null;
            zrodlo2 = null;
         //   processing = new Operator();

            suwak1 = new System.Windows.Forms.TrackBar();
        
            InitializeComponent();
            trackBar1_ValueChanged(null, null);
            trackBar2_ValueChanged(null, null);
            trackBar3_ValueChanged(null, null);
            suwak_ValueChanged(null, null);

       //     processing = new Operator();

       }

           private void wczytaj_Click(object sender, EventArgs e)
        {
            OpenFileDialog open = new OpenFileDialog();
            open.Filter = "Image Files(*.jpg; *.jpeg; *.gif; *.bmp)|*.jpg; *.jpeg; *.gif; *.bmp";
            if (open.ShowDialog() == DialogResult.OK)
            {
                this.pictureBox1.Image = new Bitmap(open.FileName);
                zrodlo = new Bitmap(open.OpenFile());

                zrodlo2 = new Bitmap(open.OpenFile());
                //     this.pictureBox3.Image = new Bitmap(open.OpenFile());        
            }
        }

    
        private void trackBar1_ValueChanged(object sender, EventArgs e)
        {
            //Przygotuj tablice LUT i pokaz ja na wykresie
            wykres.Series[0].Points.Clear();
            byte[] LUT = new byte[256];
            double a;
            if (suwak.Value <= 0)
            {
                a = 1.0 + (suwak.Value / 256.0);
            }
            else
            {
                a = 256.0 / Math.Pow(2, Math.Log(257 - suwak.Value, 2));
            }
            wykres.Titles[0].Text = "Tablica LUT, a = " + a;
            for (int i = 0; i < 256; i++)
            {
                if ((a * (i - 127) + 127) > 255)
                {
                    LUT[i] = 255;
                }
                else if ((a * (i - 127) + 127) < 0)
                {
                    LUT[i] = 0;
                }
                else
                {
                    LUT[i] = (byte)(a * (i - 127) + 127);
                }
                wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
            }

            //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
            if (zrodlo == null)
            {
                return;
            }

            //Kopiuj obrazek zrodlowy
            //       Bitmap bitmap = (Bitmap)zrodlo.Clone();                

            Bitmap bitmap = (Bitmap)pictureBox2.Image.Clone();
            this.pictureWynik1.Image = bitmap;



            //Pobierz wartosc wszystkich punktow obrazu
            BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
            byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
            System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);

            //Zmien kontrast kazdego punktu zgodnie z tablica LUT
            for (int i = 0; i < pixelValues.Length; i++)
            {
                pixelValues[i] = LUT[pixelValues[i]];
            }

            //Ustaw wartosc wszystkich punktow obrazu
            System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
            bitmap.UnlockBits(bmpData);
        }


        private void button3_Click(object sender, EventArgs e)
        {
            FunkcjeJednoarg fn = new FunkcjeJednoarg();
            Bitmap bmp1 = new Bitmap(pictureBox1.Image);

            if (this.radioButton2.Checked)
            {
                this.label2.Text = "Obraz pierwotny w odcieniach szarości";
                bmp1 = fn.Skalaszarosci(bmp1);
                pictureBox2.Image = bmp1;
                this.pictureWynik1.Image = bmp1;
            }
            else
            {
                this.label2.Text = "Obraz pierwotny kolorowy";
                Bitmap bmp2 = new Bitmap(pictureBox1.Image);
                pictureBox2.Image = bmp2;
                this.pictureWynik1.Image = bmp2;
            }
        }


        /////////////////
        //JASNOŚĆ
        private void trackBar2_ValueChanged(object sender, EventArgs e)
        {
            //Przygotuj tablice LUT i pokaz ja na wykresie
            wykres.Series[0].Points.Clear();
            byte[] LUT = new byte[256];
            int b = suwak.Value;
            //  int b = this.trackBar1.Value;
            wykres.Titles[0].Text = "Tablica LUT, b = " + b;
            for (int i = 0; i < 256; i++)
            {
                if ((b + i) > 255)
                {
                    LUT[i] = 255;
                }
                else if ((b + i) < 0)
                {
                    LUT[i] = 0;
                }
                else
                {
                    LUT[i] = (byte)(b + i);
                }
                wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
            }

            //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
            if (zrodlo == null)
            {
                return;
            }

            //Kopiuj obrazek zrodlowy
            //  Bitmap bitmap = (Bitmap)zrodlo.Clone();
            // this.pictureBox3.Image = bitmap;

            Bitmap bitmap = (Bitmap)pictureBox2.Image.Clone();
            this.pictureWynik1.Image = bitmap;

            //Pobierz wartosc wszystkich punktow obrazu
            BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
            byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
            System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);

            //Zmien jasnosc kazdego punktu zgodnie z tablica LUT
            for (int i = 0; i < pixelValues.Length; i++)
            {
                pixelValues[i] = LUT[pixelValues[i]];
            }

            //Ustaw wartosc wszystkich punktow obrazu
            System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
            bitmap.UnlockBits(bmpData);
        }


        //////////////
        //BINERYZACJA
        private void trackBar3_ValueChanged(object sender, EventArgs e)
        {
            //Przygotuj tablice LUT i pokaz ja na wykresie
            wykres.Series[0].Points.Clear();
            byte[] LUT = new byte[256];
            int b = suwak.Value;
            //  int b = this.trackBar1.Value;
            wykres.Titles[0].Text = "Tablica LUT, b = " + b;
            for (int i = 0; i < 256; i++)
            {
                if ((b + i) > 255)
                {
                    LUT[i] = 255;
                }
                else if ((b + i) < 0)
                {
                    LUT[i] = 0;
                }
                else
                {
                    LUT[i] = (byte)(b + i);
                }
                wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
            }

            //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
            if (pictureBox2.Image == null)
            {
                return;
            }


            Bitmap bitmap = (Bitmap)pictureBox2.Image.Clone();
            pictureWynik1.Image = bitmap;

            //Pobierz wartosc wszystkich punktow obrazu
            BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
            byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
            System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);

            //Korekcja gamma dla kazdego punktu zgodnie z tablica LUT
            for (int i = 0; i < pixelValues.Length; i++)
            {
                pixelValues[i] = LUT[pixelValues[i]];
            }

            //Ustaw wartosc wszystkich punktow obrazu
            System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
            bitmap.UnlockBits(bmpData);

        }

        /////////////////////


        private void groupBox5_Enter(object sender, EventArgs e)
        {

        }

        private void suwak_ValueChanged(object sender, EventArgs e)
        {
            FunkcjeJednoarg fn = new FunkcjeJednoarg();
            Bitmap bmp2 = (Bitmap)pictureBox1.Image;
            Bitmap bmp1 = (Bitmap)pictureBox2.Image;
            this.pictureWynik1.Image = bmp1;

        }

        private void suwak_Scroll(object sender, EventArgs e)
        {

            wartosc.Text = suwak.Value.ToString();
        }


        private void button5_Click(object sender, EventArgs e)
        {
            if (this.radioNegacja.Checked)
            {
                this.label5.Text = "Obraz wynikowy - Negacja";
                this.groupBox6.Visible = false;
                this.groupBox7.Visible = false;

                this.pictureWynik1.Image = this.pictureBox2.Image;
                //      this.suwak.ValueChanged += new System.EventHandler(this.trackBar5_ValueChanged);

                FunkcjeJednoarg fn = new FunkcjeJednoarg();
                Bitmap bmpN = (Bitmap)pictureBox2.Image.Clone();
                bmpN = fn.Negacja(bmpN);
                this.pictureWynik1.Image = bmpN;

                // Bitmap bitmap = IndexImage.Clone(new Rectangle(0, 0, IndexImage.Width, IndexImage.Height), System.Drawing.Imaging.PixelFormat.Format32bppArgb);       
            }


            if (this.radioKontrast.Checked)
            {
                this.groupBox6.Visible = true;
                this.groupBox7.Visible = false;
                this.label5.Text = "Obraz wynikowy - Kontrast";
                this.label1.Text = "Kontrast";
                suwak.Minimum = -255;
                suwak.Maximum = 255;
                this.pictureWynik1.Image = this.pictureBox2.Image;
                this.suwak.ValueChanged += new System.EventHandler(this.trackBar1_ValueChanged);
            }


            if (this.radioKorekcjaGamma.Checked)
            {
                this.groupBox6.Visible = true;
                this.groupBox7.Visible = false;
                this.label5.Text = "Obraz wynikowy - Korekcja Gamma";
                this.label1.Text = "Korekcja Gamma";
                suwak.Minimum = 1;
                suwak.Maximum = 400;
                //    suwak.TickFrequency = 10;
                suwak.Value = 200;
                this.pictureWynik1.Image = this.pictureBox2.Image;
                this.suwak.ValueChanged += new System.EventHandler(this.trackBar4_ValueChanged);

            }


            if (this.radioRozciaganie.Checked)
            {
                this.label5.Text = "Obraz wynikowy - Rozciąganie";
                this.label1.Text = "Rozciąganie";
                this.groupBox7.Visible = true;
                this.groupBox6.Visible = false;
                suwak2.Minimum = 0;
                suwak2.Maximum = 255 - 1;
                suwak3.Minimum = 0;
                suwak3.Maximum = 255 - 1;
                wartosc2.Text = suwak2.Value.ToString();
                wartosc3.Text = suwak3.Value.ToString();
                this.pictureWynik1.Image = this.pictureBox2.Image;

                Bitmap bmp;
                bmp = (Bitmap)pictureBox2.Image;
                this.pictureWynik1.Image = bmp;
                FunkcjeJednoarg fn = new FunkcjeJednoarg();
                Bitmap bmpR = (Bitmap)pictureBox2.Image.Clone();

                bmpR = fn.Rozciagnie(bmpR, suwak2.Value, suwak3.Value);
             
                this.pictureWynik1.Image = bmpR;
            }


            if (this.radioJasnosc.Checked)
            {
                this.groupBox6.Visible = true;
                this.groupBox7.Visible = false;
                this.label5.Text = "Obraz wynikowy - Jasność";
                this.label1.Text = "Jasność";
                suwak.Minimum = -255;
                suwak.Maximum = 255;
                this.suwak.ValueChanged += new System.EventHandler(this.trackBar2_ValueChanged);
            }

            if (this.radioBineryzacja.Checked)
            {
                this.groupBox6.Visible = true;
                this.groupBox7.Visible = false;
                this.label5.Text = "Obraz wynikowy - Bineryzacja";
                this.label1.Text = "Bineryzacja";

                suwak.Minimum = 0;
                suwak.Maximum = 255;

                this.suwak.ValueChanged += new System.EventHandler(this.trackBar3_ValueChanged);

             }
        }


        private void suwak_MouseUp(object sender, MouseEventArgs e)
        {
            this.groupBox6.Visible = true;
            wartosc.Text = suwak.Value.ToString();
        }


        private void trackBar_MouseUp(object sender, MouseEventArgs e)
        {
            FunkcjeJednoarg fn = new FunkcjeJednoarg();
            bmpMod = (Bitmap)bmpOrg.Clone();
            if (suwak3.Value < suwak2.Value)
                suwak3.Value = suwak2.Value + 1;
            this.pictureWynik1.Refresh();

            bmpMod = fn.Rozciagnie(bmpMod, suwak2.Value, suwak3.Value);
        }



        private void suwak_Scroll_1(object sender, EventArgs e)
        {
            int war = suwak.Value;
            this.wartosc.Text = (String)war.ToString();


        }

     
        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            int value = suwak2.Value;
            Color color;
            Bitmap bmp, bmp2;
            bmp = (Bitmap)pictureWynik1.Image;

            label1.Text = value.ToString();
            for (int i = 0; i < bmp.Size.Width; ++i)
            {
                for (int j = 0; j < bmp.Size.Height; ++j)
                {
                    color = bmp.GetPixel(i, j);

                    Color col1 = Color.FromArgb(color.A, Math.Max(0, Math.Min(255, color.R + value)), Math.Max(0, Math.Min(255, color.G + value)), Math.Max(0, Math.Min(255, color.B + value)));
                    bmp2 = (Bitmap)pictureWynik1.Image;
                    bmp2.SetPixel(i, j, col1);
                }
            }
            //    this.pictureBox3.Image = bmp2;
        }

        private void suwak2_Scroll(object sender, EventArgs e)
        {
            int war = suwak2.Value;
            this.wartosc2.Text = (String)war.ToString();


            FunkcjeJednoarg fn = new FunkcjeJednoarg();


            bmpOrg = (Bitmap)pictureBox2.Image;
            this.pictureWynik1.Image = bmpOrg;

            bmpMod = (Bitmap)bmpOrg.Clone();
            if (suwak3.Value < suwak2.Value)
                suwak3.Value = suwak2.Value + 1;
            this.pictureWynik1.Refresh();

            bmpMod = fn.Rozciagnie(bmpMod, suwak2.Value, suwak3.Value);
        }

        private void suwak3_Scroll(object sender, EventArgs e)
        {
            int war = suwak3.Value;
            this.wartosc3.Text = (String)war.ToString();

            FunkcjeJednoarg fn = new FunkcjeJednoarg();
            bmpMod = (Bitmap)bmpOrg.Clone();
            if (suwak3.Value < suwak2.Value)
                suwak3.Value = suwak2.Value + 1;
            this.pictureWynik1.Refresh();

            bmpMod = fn.Rozciagnie(bmpMod, suwak2.Value, suwak3.Value);
        }


        private void trackBar4_ValueChanged(object sender, EventArgs e)
        {
            //Przygotuj tablice LUT i pokaz ja na wykresie
            wykres.Series[0].Points.Clear();
            byte[] LUT = new byte[256];
            double gamma = suwak.Value / 100.0;
            wykres.Titles[0].Text = "Tablica LUT, gamma = " + gamma;
            for (int i = 0; i < 256; i++)
            {
                if ((255 * Math.Pow(i / 255.0, 1 / gamma)) > 255)
                {
                    LUT[i] = 255;
                }
                else
                {
                    LUT[i] = (byte)(255 * Math.Pow(i / 255.0, 1 / gamma));
                }
                wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
            }

            //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
            if (pictureBox2.Image == null)
            {
                return;
            }

            //Kopiuj obrazek zrodlowy

            Bitmap bitmap = (Bitmap)pictureBox2.Image.Clone();
            pictureWynik1.Image = bitmap;

            //Pobierz wartosc wszystkich punktow obrazu
            BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
            byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
            System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);

            //Korekcja gamma dla kazdego punktu zgodnie z tablica LUT
            for (int i = 0; i < pixelValues.Length; i++)
            {
                pixelValues[i] = LUT[pixelValues[i]];
            }

            //Ustaw wartosc wszystkich punktow obrazu
            System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
            bitmap.UnlockBits(bmpData);
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            this.groupHistogram.Visible = true;
             Bitmap bmpH1 = (Bitmap)pictureBox2.Image;
            Bitmap bmpH2 = (Bitmap)pictureWynik1.Image;
        //    this.processing.setImage(new Bitmap(this.pictureWynik1.Image));

          //  Wykres wyk = new Wykres(bmpH1);
          //  this.pictureHistPierwotny.Image. = Wykres();
            //   HistogramWyrownywanie.Wyrownanie(bmp4, HistogramWyrownywanie.MetodyWyrownywania.Wlasna);


          //  this.processing.calcHisto(this);
         //   this.pictureBox1.Image = this.processing.getImage();
        //    this.processing.setImage(new Bitmap(bmpH1));

     //       this.processing.calcHisto(this);
      //     this.pictureWynik1.Image = this.processing.getImage();
         //   this.processing.setImage(new Bitmap(bmpH2));

            this.Invalidate();

       
            //  this.processing.calcHisto(this);
        //   this.pictureBox2.Image = this.processing.getImage();

            //    this.pictureBox4.Image = (bmp);
        }


        private void button2_Click(object sender, EventArgs e)
        {
            this.groupJednopunk.Visible = true;
            this.groupBox2.Visible = true;
         }

        private void button6_Click(object sender, EventArgs e)
        {
            if (this.radioSrednich.Checked)
            {
                this.label5.Text = "Obraz wynikowy - Wyrównywanie histogramu - metoda średnich";
                HistogramWyrownywanie hw = new HistogramWyrownywanie();
                Bitmap bmp1 = (Bitmap)pictureBox2.Image;
                pictureWynik1.Image = HistogramWyrownywanie.Wyrownanie(bmp1, HistogramWyrownywanie.MetodyWyrownywania.Srednich);
            }

            if (this.radioLosowa.Checked)
            {
                this.label5.Text = "Obraz wynikowy - Wyrównywanie histogramu - metoda losowych ";
                HistogramWyrownywanie hw = new HistogramWyrownywanie();
                Bitmap bmp2 = (Bitmap)pictureBox2.Image;
                pictureWynik1.Image = HistogramWyrownywanie.Wyrownanie(bmp2, HistogramWyrownywanie.MetodyWyrownywania.Losowych);
            }

            if (this.radioSasiedztwa.Checked)
            {
                this.label5.Text = "Obraz wynikowy - Wyrównywanie histogramu - metoda sąsiedztwa ";
                HistogramWyrownywanie hw = new HistogramWyrownywanie();
                Bitmap bmp3 = (Bitmap)pictureBox2.Image;
                pictureWynik1.Image = HistogramWyrownywanie.Wyrownanie(bmp3, HistogramWyrownywanie.MetodyWyrownywania.Sasiedztwa);
            }

            if (this.radioWlasna1.Checked)
            {

                this.label5.Text = "Obraz wynikowy - Wyrównywanie histogramu - metoda własna 1 ";
                HistogramWyrownywanie hw = new HistogramWyrownywanie();
                Bitmap bmp4 = (Bitmap)pictureBox2.Image;
                pictureWynik1.Image = HistogramWyrownywanie.Wyrownanie(bmp4, HistogramWyrownywanie.MetodyWyrownywania.Wlasna);
            }

            if (this.radiowlasna2.Checked)
            {

                this.label5.Text = "Obraz wynikowy - Wyrównywanie histogramu - metoda własna 2 ";
                HistogramWyrownywanie hw = new HistogramWyrownywanie();
                Bitmap bmp5 = (Bitmap)pictureBox2.Image;
                pictureWynik1.Image = HistogramWyrownywanie.Wyrownanie(bmp5, HistogramWyrownywanie.MetodyWyrownywania.Wlasna);
            }


        }

              
        
          
    }
}
 