﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Drawing;
using System.Drawing.Imaging;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Windows.Forms.DataVisualization.Charting;

namespace APO_BB_DK_v012013
{
    class FunkcjeHSV
    {
     //   private Bitmap workingBitmap = null;
   //     private int width = 0;
   //     private BitmapData bitmapData = null;
        //    private Byte* pBase = null;
     
         
        //Rozciąganie HSV
        public static Bitmap PoziomySzarosciHSV(Bitmap bmp, int war1, int war2)
        {
            //Bitmap obrazek_bitmapa = new Bitmap(src_thumbnail);
            //BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(obrazek_bitmapa);
            //    fobrazek_bitmapa.LockImage();

            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    double h, s, v;
                    hsv.ColorToHSV(bmp.GetPixel(x, y), out h, out s, out v);
                    double wartosc = v;
                    if (wartosc < ((double)war1) / 255)
                    {
                        bmp.SetPixel(x, y, hsv.ColorFromHSV(h, s, 0));
                    }
                    else if (wartosc > ((double)war2) / 255)
                    {
                        bmp.SetPixel(x, y, hsv.ColorFromHSV(h, s, 1));
                    }
                    else
                    {
                        double tmp = wartosc;
                        if (war1 != war2)
                        {
                            tmp = (((wartosc - ((double)war1 / 255.0f)))) / (((float)(war2 - war1)) / 255.0f);
                        }
                        bmp.SetPixel(x, y, hsv.ColorFromHSV(h, s, tmp));
                    }
                }
            }
            return bmp;
        }



        public static Bitmap PoziomySzarosciHSV2(Bitmap bmp, int war1)
        {
            BitmapProcessing.FastBitmap bmp1 = new BitmapProcessing.FastBitmap(bmp);
            bmp1.LockImage();
            int new_height = bmp.Height;
            int new_width = bmp.Width;
            while (new_height > 350 || new_width > 350)
            {
                new_height = (int)(new_height / 1.05f);
                new_width = (int)(new_width / 1.05f);
            } 
            
            float krok;
            float krok1;
            krok1 = (float)war1 / 100000.0f;
            krok = 255 / krok1;
          
            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    double h, s, v;
                    hsv.ColorToHSV(bmp1.GetPixel(x, y), out h, out s, out v);
                    double wartosc_piksela = v;

                    int przedzial = (int) (wartosc_piksela / krok);

                    if (przedzial == war1 || przedzial == war1 - 1)
                    {
                        bmp1.SetPixel(x, y, hsv.ColorFromHSV(h,s,1.0f));
                    }
                    else if (przedzial == 0)
                    {
                        bmp1.SetPixel(x, y, hsv.ColorFromHSV(h,s,0));
                    }
                    else
                    {
                        double tmp = (((float)przedzial) * krok + krok / 2);
                        if (tmp > 1) tmp = 1;
                        bmp1.SetPixel(x, y, hsv.ColorFromHSV(h,s,tmp));
                    }
                }
            }
            bmp1.UnlockImage(); 
            return bmp;
        }

         //label_value.Text = prog.ToString();
        //    preview.Image = functions.progowanie_hsv(new Bitmap(src_thumbnail), prog);

        //PROGOWANIE DLA OBRAZU HSV
        public static Bitmap ProgowanieHSV2(Bitmap bmp, double prog)
        {
            BitmapProcessing.FastBitmap bmp1 = new BitmapProcessing.FastBitmap(bmp);
            bmp1.LockImage();
            int new_height = bmp.Height;
            int new_width = bmp.Width;
            while (new_height > 300 || new_width > 300)
            {
                new_height = (int)(new_height / 1.05f);
                new_width = (int)(new_width / 1.05f);
            }
            prog = prog / 100000.0f;
            
            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    double h, s, v;
                    hsv.ColorToHSV(bmp1.GetPixel(x, y), out h, out s, out v);

                    if (v > prog)
                    {
                        bmp1.SetPixel(x, y, hsv.ColorFromHSV(h, s, 0));
                    }
                    else
                    {
                        bmp1.SetPixel(x, y, hsv.ColorFromHSV(h, s, 1));
                    }
                }
            }
            bmp1.UnlockImage();
            return bmp;
        }


        //Progowanie obrazu HSV
        public static Bitmap ProgowanieHSV(Bitmap bmp, int war1)
        {
          //  float krok = 255 / war1;

            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    double h, s, v;
                    hsv.ColorToHSV(bmp.GetPixel(x, y), out h, out s, out v);
                  //  double wartosc_piksela = v;
                 //   int przedzial = (int)(wartosc_piksela / krok);
                    
                    if (bmp.GetPixel(x, y).R > war1)
                    {
                        bmp.SetPixel(x, y, hsv.ColorFromHSV(h, s, 1.0f));
                     //   bmp.SetPixel(x, y, Color.FromArgb(255, 255, 255));
                    }
                    else
                    {
                        bmp.SetPixel(x, y, hsv.ColorFromHSV(h, s, 0));
                       // bmp.SetPixel(x, y, Color.FromArgb(0, 0, 0));
                    }
                }
            }
            return bmp;
        }


        /*
        private static int safety_check(int val)
        {
            if (val > 255)
                return 255;
            else if (val < 0)
                return 0;
            return val;
        }
        private static double safety_check_hsv(double val)
        {
            if (val > 1)
                return 1;
            else if (val < 0)
                return 0;
            return val;
        }

         public static void ColorToHSV(Color color, out double hue, out double saturation, out double value)
        {
            int max = Math.Max(color.R, Math.Max(color.G, color.B));
            int min = Math.Min(color.R, Math.Min(color.G, color.B));

            hue = color.GetHue();
            saturation = (max == 0) ? 0 : 1d - (1d * min / max);
            value = max / 255d;
        }

        public static Color ColorFromHSV(double hue, double saturation, double value)
        {
            int hi = Convert.ToInt32(Math.Floor(hue / 60)) % 6;
            double f = hue / 60 - Math.Floor(hue / 60);

            value = value * 255;
            int v = Convert.ToInt32(value);
            int p = Convert.ToInt32(value * (1 - saturation));
            int q = Convert.ToInt32(value * (1 - f * saturation));
            int t = Convert.ToInt32(value * (1 - (1 - f) * saturation));

            if (hi == 0)
                return Color.FromArgb(255, v, t, p);
            else if (hi == 1)
                return Color.FromArgb(255, q, v, p);
            else if (hi == 2)
                return Color.FromArgb(255, p, v, t);
            else if (hi == 3)
                return Color.FromArgb(255, p, q, v);
            else if (hi == 4)
                return Color.FromArgb(255, t, p, v);
            else
                return Color.FromArgb(255, v, p, q);
        }

        private struct PixelData
        {
            public byte blue;
            public byte green;
            public byte red;
            public byte alpha;

            public override string ToString()
            {
                return "(" + alpha.ToString() + ", " + red.ToString() + ", " + green.ToString() + ", " + blue.ToString() + ")";
            }
        }
         */





        public static void RGBtoHSV(Color rghColor, out double hue, out double saturation, out double value)
        { 
        double r = rghColor.R / 255.0;
        double g = rghColor.G / 255.0;
        double b = rghColor.B / 255.0;

        double min = Math.Min(Math.Min(r, g), b);
        double max = Math.Max(Math.Max(r, g), b);
        
        double v = max;
        double delta = max - min;
        double h = 0;
        double s = 0;

        if (max == 0 || delta == 0)
        {
            s = h = 0;
        }
        else
        {
            s = delta / max;
            if (r == max)
            {
                h = (g * b) / delta;
            }
            else if (g == max)
            {
                h = 2 + (b * r) / delta;
            }
            else
            {
                h = 4 + (r * g) / delta;
            }
        }
            h *= 60;
            if (h < 0)
            {
                h += 360.0;
            }
            hue = (int)h;
            saturation = (int)(s * 100.0);
            value = (int)(v * 100.0);        
        }







    /*
        unsafe public Color GetPixel1(int x, int y)
        {
                 
           private PixelData* pixelData = null;
        
            pixelData = (PixelData*)(pBase + y * width + x * sizeof(PixelData));
            return Color.FromArgb(pixelData->alpha, pixelData->red, pixelData->green, pixelData->blue);
             
        }
     */
        public Bitmap ObrazHSV(Bitmap src)
        {
            Bitmap bmpHSV = new Bitmap(src);
            BitmapData data = bmpHSV.LockBits(new System.Drawing.Rectangle(0, 0, bmpHSV.Width, bmpHSV.Height), ImageLockMode.ReadWrite, PixelFormat.Format32bppArgb);

            unsafe
            {
                byte* pBase = (byte*)data.Scan0.ToPointer();

                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {
                        double h, s, v;
                      //  hsv.ColorToHSV(src.GetPixel(x, y), out h, out s, out v);
                      //  bmpHSV.SetPixel(x, y, hsv.ColorFromHSV(h, s, v));
                       
                        RGBtoHSV(src.GetPixel(x, y), out h, out s, out v);
                        src.SetPixel(x, y, Color.FromArgb(Convert.ToByte(h), Convert.ToByte(s), Convert.ToByte(v)));
                    }
                }
                bmpHSV.UnlockBits(data);
                return src;
            }
        }
        //   return Color.FromArgb(Convert.ToByte(255), Convert.ToByte(r), Convert.ToByte(g), Convert.ToByte(b));
    
        public Bitmap JasnoscHSV(Bitmap src, int val)
        {
            Bitmap bmpHSV = new Bitmap(src);
            BitmapData data = bmpHSV.LockBits(new System.Drawing.Rectangle(0, 0, bmpHSV.Width, bmpHSV.Height), ImageLockMode.ReadWrite, PixelFormat.Format32bppArgb);

            unsafe
            {
                byte* pBase = (byte*)data.Scan0.ToPointer();

                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {
                        double h, s, v;
                        hsv.ColorToHSV(src.GetPixel(x, y), out h, out s, out v);
                        v = v + ((double)val / 255);
                        if (v < 0) v = 0.0f;
                        if (v > 1) v = 1.0f;
                      
                        src.SetPixel(x, y, hsv.ColorFromHSV(h, s, v));
                    }
                }
                bmpHSV.UnlockBits(data);
                return src;
            }
        }

        public Bitmap NegacjaHSV(Bitmap src)
        {
            Bitmap bmpHSV = new Bitmap(src);
            BitmapData data = bmpHSV.LockBits(new System.Drawing.Rectangle(0, 0, bmpHSV.Width, bmpHSV.Height), ImageLockMode.ReadWrite, PixelFormat.Format32bppArgb);

            unsafe
            {
             byte* pBase = (byte*)data.Scan0.ToPointer();
 
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {
                        double h, s, v;
                        hsv.ColorToHSV(src.GetPixel(x, y), out h, out s, out v);
                        v = 1.0f - v;
                        src.SetPixel(x, y, hsv.ColorFromHSV(h, s, v));
                    }
                }

              bmpHSV.UnlockBits(data);
              return src;
          }
      }

        public Bitmap KontrastHSV(Bitmap src, int val)
        {
            Bitmap bmpHSV = new Bitmap(src);
            BitmapData data = bmpHSV.LockBits(new System.Drawing.Rectangle(0, 0, bmpHSV.Width, bmpHSV.Height), ImageLockMode.ReadWrite, PixelFormat.Format32bppArgb);

           
            double multi = (100.0 + (double)val) / 100.0;
          //  double lmax = (double)(bmpHSV.Levels - 1);
            
            unsafe
            {
                byte* pBase = (byte*)data.Scan0.ToPointer();
                
                for (int x = 0; x < src.Width; x++)
                {
                  for (int y = 0; y < src.Height; y++)
                  {
                     double h, s, v;
                     hsv.ColorToHSV(src.GetPixel(x, y), out h, out s, out v);

                     v = v + ((double)val / 255) - 0.5;
                     v = v * multi + 0.5;
                   //  v = (byte)Math.Max(0, Math.Min(255, (int)(v * 255.0)));
                  //   val = (int)(v*255.0);
                     if (v < 0) v = 0.0f;
                     if (v > 255) v = 1.0f;
                   
                                      
                     src.SetPixel(x, y, hsv.ColorFromHSV(h, s, v));                    
                   }
                }
                bmpHSV.UnlockBits(data);
                return src;
            }
        }


        public Bitmap and_hsv(Bitmap A, Bitmap B)
        {
            int min_width = Math.Min(A.Width, B.Width);
            int min_height = Math.Min(A.Height, B.Height);

            Bitmap C = new Bitmap(min_width, min_height);
            BitmapProcessing.FastBitmap fa = new BitmapProcessing.FastBitmap(A);
            BitmapProcessing.FastBitmap fb = new BitmapProcessing.FastBitmap(B);
            BitmapProcessing.FastBitmap fc = new BitmapProcessing.FastBitmap(C);
            fa.LockImage();
            fb.LockImage();
            fc.LockImage();

            for (int x = 0; x < C.Width; x++)
            {
                for (int y = 0; y < C.Height; y++)
                {
                    double h, s, v;
                    hsv.ColorToHSV(fa.GetPixel(x, y), out h, out s, out v);
                    fc.SetPixel(x, y, hsv.ColorFromHSV(h, s, v));
                }
            }

            fa.UnlockImage();
            fb.UnlockImage();
            fc.UnlockImage();
            return C;
        }
        /*
        public static Bitmap regulacja_kontrastem(Bitmap src, int val)
        {
            double multi = (100 + val) / 100;
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(src);
            fobrazek_bitmapa.LockImage();

            for (int x = 0; x < src.Width; x++)
            {
                for (int y = 0; y < src.Height; y++)
                {
                    double tmp = (fobrazek_bitmapa.GetPixel(x, y).R / 255) - 0.5;
                    tmp = tmp * multi + 0.5;

                    //fobrazek_bitmapa.SetPixel(x, y, Color.FromArgb(tmp,tmp,tmp));

                }
            }
            fobrazek_bitmapa.UnlockImage();
            return src;
        }
        public static Bitmap lut(Bitmap src, int[] vals)
        {
            if (vals == null)
                return src;
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(src);
            fobrazek_bitmapa.LockImage();

            for (int x = 0; x < src.Width; x++)
            {
                for (int y = 0; y < src.Height; y++)
                {

                    fobrazek_bitmapa.SetPixel(x, y, Color.FromArgb(vals[fobrazek_bitmapa.GetPixel(x, y).R], vals[fobrazek_bitmapa.GetPixel(x, y).G], vals[fobrazek_bitmapa.GetPixel(x, y).B]));
                }
            }
            fobrazek_bitmapa.UnlockImage();
            return src;
        }
        public static Bitmap filtracja_liniowa(Bitmap src, int[] vals, int dzielnik, int metoda)
        {
            if (vals == null)
                return src;
            if (vals.Length != 9)
                return src;

            Bitmap result = new Bitmap(src);
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(src);
            BitmapProcessing.FastBitmap fresult = new BitmapProcessing.FastBitmap(result);
            fobrazek_bitmapa.LockImage();
            fresult.LockImage();
            int sum_vals = dzielnik;

            if (sum_vals == 0)
                sum_vals = 1;

            if (metoda == 1)
            {
                int rmax = 0, gmax = 0, bmax = 0, rmin = 0, gmin = 0, bmin = 0;
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {
                        //RED
                        int[] r = new int[9];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            r[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).R;
                        if (y > 0)
                            r[1] = fobrazek_bitmapa.GetPixel(x, y - 1).R;
                        if (y > 0 && x < src.Width - 1)
                            r[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).R;
                        if (x > 0)
                            r[3] = fobrazek_bitmapa.GetPixel(x - 1, y).R;
                        r[4] = fobrazek_bitmapa.GetPixel(x, y).R;
                        if (x < src.Width - 1)
                            r[5] = fobrazek_bitmapa.GetPixel(x + 1, y).R;
                        if (x > 0 && y < src.Height - 1)
                            r[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).R;
                        if (y < src.Height - 1)
                            r[7] = fobrazek_bitmapa.GetPixel(x, y + 1).R;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            r[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).R;
                        int red = 0;
                        for (int z = 0; z < 9; z++)
                        {
                            red = red + vals[z] * r[z];
                        }
                        red = red / sum_vals;
                        if (red > rmax) rmax = red;
                        if (red < rmin) rmin = red;
                        //GREEN
                        int[] g = new int[9];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            g[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).G;
                        if (y > 0)
                            g[1] = fobrazek_bitmapa.GetPixel(x, y - 1).G;
                        if (y > 0 && x < src.Width - 1)
                            g[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).G;
                        if (x > 0)
                            g[3] = fobrazek_bitmapa.GetPixel(x - 1, y).G;
                        g[4] = fobrazek_bitmapa.GetPixel(x, y).G;
                        if (x < src.Width - 1)
                            g[5] = fobrazek_bitmapa.GetPixel(x + 1, y).G;
                        if (x > 0 && y < src.Height - 1)
                            g[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).G;
                        if (y < src.Height - 1)
                            g[7] = fobrazek_bitmapa.GetPixel(x, y + 1).G;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            g[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).G;
                        int green = 0;
                        for (int z = 0; z < 9; z++)
                        {
                            green = green + vals[z] * g[z];
                        }
                        green = green / sum_vals;
                        if (green > gmax) gmax = green;
                        if (green < gmin) gmin = green;
                        //BLUE
                        int[] b = new int[9];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            b[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).B;
                        if (y > 0)
                            b[1] = fobrazek_bitmapa.GetPixel(x, y - 1).B;
                        if (y > 0 && x < src.Width - 1)
                            b[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).B;
                        if (x > 0)
                            b[3] = fobrazek_bitmapa.GetPixel(x - 1, y).B;
                        b[4] = fobrazek_bitmapa.GetPixel(x, y).B;
                        if (x < src.Width - 1)
                            b[5] = fobrazek_bitmapa.GetPixel(x + 1, y).B;
                        if (x > 0 && y < src.Height - 1)
                            b[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).B;
                        if (y < src.Height - 1)
                            b[7] = fobrazek_bitmapa.GetPixel(x, y + 1).B;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            b[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).B;
                        int blue = 0;
                        for (int z = 0; z < 9; z++)
                        {
                            blue = blue + vals[z] * b[z];
                        }
                        blue = blue / sum_vals;
                        if (blue > bmax) bmax = blue;
                        if (blue < bmin) bmin = blue;
                    }
                }
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {
                        //RED
                        int[] r = new int[9];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            r[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).R;
                        if (y > 0)
                            r[1] = fobrazek_bitmapa.GetPixel(x, y - 1).R;
                        if (y > 0 && x < src.Width - 1)
                            r[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).R;
                        if (x > 0)
                            r[3] = fobrazek_bitmapa.GetPixel(x - 1, y).R;
                        r[4] = fobrazek_bitmapa.GetPixel(x, y).R;
                        if (x < src.Width - 1)
                            r[5] = fobrazek_bitmapa.GetPixel(x + 1, y).R;
                        if (x > 0 && y < src.Height - 1)
                            r[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).R;
                        if (y < src.Height - 1)
                            r[7] = fobrazek_bitmapa.GetPixel(x, y + 1).R;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            r[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).R;
                        int red = 0;
                        for (int z = 0; z < 9; z++)
                        {
                            red = red + vals[z] * r[z];
                        }
                        red = red / sum_vals;
                        red = (int)((((double)red - (double)rmin) / ((double)rmax - (double)rmin)) * 256);
                        //GREEN
                        int[] g = new int[9];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            g[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).G;
                        if (y > 0)
                            g[1] = fobrazek_bitmapa.GetPixel(x, y - 1).G;
                        if (y > 0 && x < src.Width - 1)
                            g[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).G;
                        if (x > 0)
                            g[3] = fobrazek_bitmapa.GetPixel(x - 1, y).G;
                        g[4] = fobrazek_bitmapa.GetPixel(x, y).G;
                        if (x < src.Width - 1)
                            g[5] = fobrazek_bitmapa.GetPixel(x + 1, y).G;
                        if (x > 0 && y < src.Height - 1)
                            g[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).G;
                        if (y < src.Height - 1)
                            g[7] = fobrazek_bitmapa.GetPixel(x, y + 1).G;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            g[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).G;
                        int green = 0;
                        for (int z = 0; z < 9; z++)
                        {
                            green = green + vals[z] * g[z];
                        }
                        green = green / sum_vals;
                        green = (int)((((double)green - (double)gmin) / ((double)gmax - (double)gmin)) * 256);
                        //BLUE
                        int[] b = new int[9];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            b[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).B;
                        if (y > 0)
                            b[1] = fobrazek_bitmapa.GetPixel(x, y - 1).B;
                        if (y > 0 && x < src.Width - 1)
                            b[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).B;
                        if (x > 0)
                            b[3] = fobrazek_bitmapa.GetPixel(x - 1, y).B;
                        b[4] = fobrazek_bitmapa.GetPixel(x, y).B;
                        if (x < src.Width - 1)
                            b[5] = fobrazek_bitmapa.GetPixel(x + 1, y).B;
                        if (x > 0 && y < src.Height - 1)
                            b[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).B;
                        if (y < src.Height - 1)
                            b[7] = fobrazek_bitmapa.GetPixel(x, y + 1).B;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            b[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).B;
                        int blue = 0;
                        for (int z = 0; z < 9; z++)
                        {
                            blue = blue + vals[z] * b[z];
                        }
                        blue = blue / sum_vals;
                        blue = (int)((((double)blue - (double)bmin) / ((double)bmax - (double)bmin)) * 256);
                        fresult.SetPixel(x, y, Color.FromArgb(safety_check(red), safety_check(green), safety_check(blue)));
                    }
                }
            }
            else
            {
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {
                        //RED
                        int[] r = new int[9];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            r[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).R;
                        if (y > 0)
                            r[1] = fobrazek_bitmapa.GetPixel(x, y - 1).R;
                        if (y > 0 && x < src.Width - 1)
                            r[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).R;
                        if (x > 0)
                            r[3] = fobrazek_bitmapa.GetPixel(x - 1, y).R;
                        r[4] = fobrazek_bitmapa.GetPixel(x, y).R;
                        if (x < src.Width - 1)
                            r[5] = fobrazek_bitmapa.GetPixel(x + 1, y).R;
                        if (x > 0 && y < src.Height - 1)
                            r[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).R;
                        if (y < src.Height - 1)
                            r[7] = fobrazek_bitmapa.GetPixel(x, y + 1).R;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            r[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).R;
                        int red = 0;
                        for (int z = 0; z < 9; z++)
                        {
                            red = red + vals[z] * r[z];
                        }
                        red = red / sum_vals;
                        //GREEN
                        int[] g = new int[9];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            g[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).G;
                        if (y > 0)
                            g[1] = fobrazek_bitmapa.GetPixel(x, y - 1).G;
                        if (y > 0 && x < src.Width - 1)
                            g[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).G;
                        if (x > 0)
                            g[3] = fobrazek_bitmapa.GetPixel(x - 1, y).G;
                        g[4] = fobrazek_bitmapa.GetPixel(x, y).G;
                        if (x < src.Width - 1)
                            g[5] = fobrazek_bitmapa.GetPixel(x + 1, y).G;
                        if (x > 0 && y < src.Height - 1)
                            g[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).G;
                        if (y < src.Height - 1)
                            g[7] = fobrazek_bitmapa.GetPixel(x, y + 1).G;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            g[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).G;
                        int green = 0;
                        for (int z = 0; z < 9; z++)
                        {
                            green = green + vals[z] * g[z];
                        }
                        green = green / sum_vals;
                        //BLUE
                        int[] b = new int[9];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            b[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).B;
                        if (y > 0)
                            b[1] = fobrazek_bitmapa.GetPixel(x, y - 1).B;
                        if (y > 0 && x < src.Width - 1)
                            b[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).B;
                        if (x > 0)
                            b[3] = fobrazek_bitmapa.GetPixel(x - 1, y).B;
                        b[4] = fobrazek_bitmapa.GetPixel(x, y).B;
                        if (x < src.Width - 1)
                            b[5] = fobrazek_bitmapa.GetPixel(x + 1, y).B;
                        if (x > 0 && y < src.Height - 1)
                            b[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).B;
                        if (y < src.Height - 1)
                            b[7] = fobrazek_bitmapa.GetPixel(x, y + 1).B;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            b[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).B;
                        int blue = 0;
                        for (int z = 0; z < 9; z++)
                        {
                            blue = blue + vals[z] * b[z];
                        }
                        blue = blue / sum_vals;
                        if (metoda == 2)
                        {
                            if (red > 0)
                            {
                                red = 255;
                            }
                            else if (red < 0)
                            {
                                red = 0;
                            }
                            else
                            {
                                red = 127;
                            }
                            if (green > 0)
                            {
                                green = 255;
                            }
                            else if (green < 0)
                            {
                                green = 0;
                            }
                            else
                            {
                                green = 127;
                            }
                            if (blue > 0)
                            {
                                blue = 255;
                            }
                            else if (blue < 0)
                            {
                                blue = 0;
                            }
                            else
                            {
                                blue = 127;
                            }

                        }

                        fresult.SetPixel(x, y, Color.FromArgb(safety_check(red), safety_check(green), safety_check(blue)));
                    }
                }
            }
            fresult.UnlockImage();
            fobrazek_bitmapa.UnlockImage();
            return result;
        }
        public static Bitmap filtracja_liniowa_hsv(Bitmap src, int[] vals, int dzielnik, int metoda)
        {
            if (vals == null)
                return src;
            if (vals.Length != 9)
                return src;

            Bitmap result = new Bitmap(src);
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(src);
            BitmapProcessing.FastBitmap fresult = new BitmapProcessing.FastBitmap(result);
            fobrazek_bitmapa.LockImage();
            fresult.LockImage();
            int sum_vals = dzielnik;

            if (sum_vals == 0)
                sum_vals = 1;
            #region metoda1
            if (metoda == 1)
            {
                double vmax = 0, vmin = 0;
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {
                        double[] h = new double[9];
                        double[] s = new double[9];
                        double[] v = new double[9];

                        for (int z = 0; z < v.Length; z++) { v[z] = 0; }
                        if (x > 0 && y > 0)
                        {
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x - 1, y - 1), out h[0], out s[0], out v[0]);
                        }
                        if (y > 0)
                        {
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y - 1), out h[1], out s[1], out v[1]);
                        }
                        if (y > 0 && x < src.Width - 1)
                        {
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x + 1, y - 1), out h[2], out s[2], out v[2]);
                        }
                        if (x > 0)
                        {
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x - 1, y), out h[3], out s[3], out v[3]);
                        }
                        ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y), out h[4], out s[4], out v[4]);
                        if (x < src.Width - 1)
                        {
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x + 1, y), out h[5], out s[5], out v[5]);
                        }
                        if (x > 0 && y < src.Height - 1)
                        {
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x - 1, y + 1), out h[6], out s[6], out v[6]);
                        }
                        if (y < src.Height - 1)
                        {
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y + 1), out h[7], out s[7], out v[7]);
                        }
                        if (y < src.Height - 1 && x < src.Width - 1)
                        {
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x + 1, y + 1), out h[8], out s[8], out v[8]);
                        }
                        double val = 0;
                        for (int z = 0; z < 9; z++)
                        {
                            val = val + ((double)vals[z]) * v[z];
                        }
                        val = val / sum_vals;
                        if (val > vmax) vmax = val;
                        if (val < vmin) vmin = val;

                    }
                }
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {
                        double[] h = new double[9];
                        double[] s = new double[9];
                        double[] v = new double[9];

                        for (int z = 0; z < v.Length; z++) { v[z] = 0; }
                        if (x > 0 && y > 0)
                        {
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x - 1, y - 1), out h[0], out s[0], out v[0]);
                        }
                        if (y > 0)
                        {
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y - 1), out h[1], out s[1], out v[1]);
                        }
                        if (y > 0 && x < src.Width - 1)
                        {
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x + 1, y - 1), out h[2], out s[2], out v[2]);
                        }
                        if (x > 0)
                        {
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x - 1, y), out h[3], out s[3], out v[3]);
                        }
                        ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y), out h[4], out s[4], out v[4]);
                        if (x < src.Width - 1)
                        {
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x + 1, y), out h[5], out s[5], out v[5]);
                        }
                        if (x > 0 && y < src.Height - 1)
                        {
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x - 1, y + 1), out h[6], out s[6], out v[6]);
                        }
                        if (y < src.Height - 1)
                        {
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y + 1), out h[7], out s[7], out v[7]);
                        }
                        if (y < src.Height - 1 && x < src.Width - 1)
                        {
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x + 1, y + 1), out h[8], out s[8], out v[8]);
                        }
                        double val = 0;
                        for (int z = 0; z < 9; z++)
                        {
                            val = val + ((double)vals[z]) * v[z];
                        }
                        val = val / sum_vals;

                        val = ((((double)val - (double)vmin) / ((double)vmax - (double)vmin)));

                        fresult.SetPixel(x, y, ObrazHSV.ColorFromHSV(h[4], s[4], safety_check_hsv(val)));
                    }
                }
            }
            #endregion
            else
            {
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {
                        double[] h = new double[9];
                        double[] s = new double[9];
                        double[] v = new double[9];

                        for (int z = 0; z < v.Length; z++) { v[z] = 0; }
                        if (x > 0 && y > 0)
                        {
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x - 1, y - 1), out h[0], out s[0], out v[0]);
                        }
                        if (y > 0)
                        {
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y - 1), out h[1], out s[1], out v[1]);
                        }
                        if (y > 0 && x < src.Width - 1)
                        {
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x + 1, y - 1), out h[2], out s[2], out v[2]);
                        }
                        if (x > 0)
                        {
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x - 1, y), out h[3], out s[3], out v[3]);
                        }
                        ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y), out h[4], out s[4], out v[4]);
                        if (x < src.Width - 1)
                        {
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x + 1, y), out h[5], out s[5], out v[5]);
                        }
                        if (x > 0 && y < src.Height - 1)
                        {
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x - 1, y + 1), out h[6], out s[6], out v[6]);
                        }
                        if (y < src.Height - 1)
                        {
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y + 1), out h[7], out s[7], out v[7]);
                        }
                        if (y < src.Height - 1 && x < src.Width - 1)
                        {
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x + 1, y + 1), out h[8], out s[8], out v[8]);
                        }
                        double val = 0;
                        for (int z = 0; z < 9; z++)
                        {
                            val = val + ((double)vals[z]) * v[z];
                        }
                        val = val / sum_vals;


                        if (metoda == 2)
                        {
                            if (val > 0)
                            {
                                val = 1;
                            }
                            else if (val < 0)
                            {
                                val = 0;
                            }
                            else
                            {
                                val = 0.5f;
                            }


                        }

                        fresult.SetPixel(x, y, ObrazHSV.ColorFromHSV(h[4], s[4], safety_check_hsv(val)));
                    }
                }
            }
            fresult.UnlockImage();
            fobrazek_bitmapa.UnlockImage();
            return result;
        }
        

        public static Bitmap and_hsv(Bitmap A, Bitmap B)
        {
            int min_width = Math.Min(A.Width, B.Width);
            int min_height = Math.Min(A.Height, B.Height);

            Bitmap C = new Bitmap(min_width, min_height);
            BitmapProcessing.FastBitmap fa = new BitmapProcessing.FastBitmap(A);
            BitmapProcessing.FastBitmap fb = new BitmapProcessing.FastBitmap(B);
            BitmapProcessing.FastBitmap fc = new BitmapProcessing.FastBitmap(C);
            fa.LockImage();
            fb.LockImage();
            fc.LockImage();

            for (int x = 0; x < C.Width; x++)
            {
                for (int y = 0; y < C.Height; y++)
                {
                    double h, s, v;
                    ObrazHSV.ColorToHSV(fa.GetPixel(x, y), out h, out s, out v);
                    fc.SetPixel(x, y, ObrazHSV.ColorFromHSV(h, s, v));
                }
            }

            fa.UnlockImage();
            fb.UnlockImage();
            fc.UnlockImage();
            return C;
        }

        public static Bitmap progowanie_hsv(Bitmap src, double prog)
        {
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(src);
            fobrazek_bitmapa.LockImage();


            for (int x = 0; x < src.Width; x++)
            {
                for (int y = 0; y < src.Height; y++)
                {
                    double h, s, v;
                    ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y), out h, out s, out v);

                    if (v > prog)
                    {
                        fobrazek_bitmapa.SetPixel(x, y, ObrazHSV.ColorFromHSV(h, s, 0));
                    }
                    else
                    {
                        fobrazek_bitmapa.SetPixel(x, y, ObrazHSV.ColorFromHSV(h, s, 1));
                    }
                }
            }


            fobrazek_bitmapa.UnlockImage();
            return src;
        }

       
        public static Bitmap filtracja_medianowa_hsv(Bitmap src, int w, int h)
        {
            if (w < 3) w = 3;
            if (h < 3) h = 3;
            if (h % 2 == 0) h = 3;
            if (w % 2 == 0) w = 3;
            double[] sasiadujace = new double[w * h];
            Bitmap result = new Bitmap(src);
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(src);
            BitmapProcessing.FastBitmap fresult = new BitmapProcessing.FastBitmap(result);
            fobrazek_bitmapa.LockImage();
            fresult.LockImage();
            for (int x = 0; x < src.Width; x++)
            {
                for (int y = 0; y < src.Height; y++)
                {
                    int i = 0;
                    double hue, sat, v;
                    for (int x1 = -w / 2; x1 <= w / 2; x1++)
                    {
                        for (int y1 = -h / 2; y1 <= h / 2; y1++)
                        {
                            if (x + x1 >= 0 && y + y1 >= 0 && x + x1 < src.Width && y + y1 < src.Height)
                            {
                                ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x + x1, y + y1), out hue, out sat, out v);
                                sasiadujace[i++] = v;
                            }
                        }
                    }
                    Array.Sort(sasiadujace, 0, i);
                    ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y), out hue, out sat, out v);
                    if (i % 2 == 1)
                    {
                        fresult.SetPixel(x, y, ObrazHSV.ColorFromHSV(hue, sat, safety_check_hsv(sasiadujace[i / 2])));
                    }
                    else
                    {
                        double val = safety_check_hsv((sasiadujace[i / 2] + sasiadujace[i / 2 + 1]) / 2);
                        fresult.SetPixel(x, y, ObrazHSV.ColorFromHSV(hue, sat, val));
                    }
                }
            }

            fresult.UnlockImage();
            fobrazek_bitmapa.UnlockImage();
            return result;
        }
     
        public static Bitmap wygladzanie_logiczne_hsv(Bitmap src, int opcja)
        {
            Bitmap result = new Bitmap(src);
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(src);
            BitmapProcessing.FastBitmap fresult = new BitmapProcessing.FastBitmap(result);
            fobrazek_bitmapa.LockImage();
            fresult.LockImage();
            //Pionowo
            if (opcja == 1)
            {
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {

                        if (y > 0 && y < src.Height - 1)
                        {
                            double h, s, v1, v2;
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y - 1), out h, out s, out v1);
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y + 1), out h, out s, out v2);

                            if (v1 == v2)
                            {
                                fresult.SetPixel(x, y, ObrazHSV.ColorFromHSV(h, s, v1));
                            }

                        }
                    }
                }
            }
            //Poziomo
            else if (opcja == 2)
            {
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {

                        if (x > 0 && x < src.Width - 1)
                        {
                            double h, s, v1, v2;
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x - 1, y), out h, out s, out v1);
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x + 1, y), out h, out s, out v2);

                            if (v1 == v2)
                            {
                                fresult.SetPixel(x, y, ObrazHSV.ColorFromHSV(h, s, v1));
                            }

                        }
                    }
                }
            }
            else if (opcja == 3)
            {
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {

                        if (x > 0 && x < src.Width - 1 && y > 0 && y < src.Height - 1)
                        {
                            double h, s, v1, v2, v3, v4;
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x - 1, y), out h, out s, out v1);
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x + 1, y), out h, out s, out v2);
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y - 1), out h, out s, out v3);
                            ObrazHSV.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y + 1), out h, out s, out v4);

                            if (v1 == v2 && v3 == v4 && v2 == v4)
                            {
                                fresult.SetPixel(x, y, ObrazHSV.ColorFromHSV(h, s, v1));
                            }

                        }
                    }
                }
            }

            fresult.UnlockImage();
            fobrazek_bitmapa.UnlockImage();
            return result;
        }
       
        
    }
}

    */
    }
}