﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Drawing;
using System.Drawing.Imaging;

namespace APO_BB_DK_v012013
{
    class FunkcjeJednoarg
    {
        private static int safety_check(int val)
        {
            if (val > 255)
                return 255;
            else if (val < 0)
                return 0;
            return val;
        }

        private static double safety_check_hsv(double val)
        {
            if (val > 1)
                return 1;
            else if (val < 0)
                return 0;
            return val;
        }
        
  
        public Bitmap JasnoscRGB (Bitmap bmp, int val)
        {
        //    BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(src);
        //    fobrazek_bitmapa.LockImage();

            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    int red = safety_check(bmp.GetPixel(x, y).R + val);
                    int green = safety_check(bmp.GetPixel(x, y).G + val);
                    int blue = safety_check(bmp.GetPixel(x, y).B + val);

                    bmp.SetPixel(x, y, Color.FromArgb(red, green, blue));

                }
            }
          //  bmp.UnlockImage();
            return bmp;
        }
        
        //---------------------------------------------
        public static Bitmap Bineryzacja(Bitmap bmp, int wartosc)
        { 
            for (int x = 0; x < bmp.Width; x++)
                for (int y = 0; y < bmp.Height; y++)
                {
                    Color px = bmp.GetPixel(x, y);
                    if ((int)((px.R * 0.3) + (px.G * 0.59) + (px.B * 0.11)) <= wartosc)
                    {
                        Color ob = Color.FromArgb(px.A, 0, 0, 0);
                        bmp.SetPixel(x, y, ob);
                    }
                    else
                    {
                        Color ob = Color.FromArgb(px.A, 255, 255, 255);
                        bmp.SetPixel(x, y, ob);                    
                    }
                }
                return bmp;
        }
        //
        public static void Binarize(Bitmap bmp, int low, int high)
        {
            byte[] upo = new byte[256];
            for (int i = 0; i < 256; ++i)
            {
                if (i < low)
                    upo[i] = 0;
                else if (i >= high)
                    upo[i] = 0;
                else upo[i] = 255;
            }
           // ApplyUPO(bmp, upo);
        }

        public static void Binarize2(Bitmap bmp, int low, int high)
        {
            byte[] upo = new byte[256];
            for (int i = 0; i < 256; ++i)
            {
                if (i < low)
                    upo[i] = 0;
                else if (i >= high)
                    upo[i] = 0;
                else upo[i] = (byte)i;
            }
            //ApplyUPO(bmp, upo);
        }

        public static void Posterize(Bitmap bmp, int value)
        {
            byte[] upo = new byte[256];
            float param1 = 255.0f / (value - 1);
            float param2 = 256.0f / (value);
            for (int i = 0; i < 256; ++i)
            {
                upo[i] = (byte)((byte)(i / param2) * param1);
            }
            //ApplyUPO(bmp, upo);
        }

        public static void Rozciagnij(Bitmap bmp, int low, int high)
        {
            byte[] upo = new byte[256];
            if ((high - low) <= 0)
            {
                for (int i = 0; i < 256; ++i)
                {
                    upo[i] = 255;
                }
            }
            float parameter = 255.0f / (high - low);
            for (int i = 0; i < 256; ++i)
            {
                if (i < low)
                    upo[i] = 0;
                else if (i >= high)
                    upo[i] = 0;
                else
                    upo[i] = (byte)((i - low) * parameter);
            }
         //   ApplyUPO(bmp, upo);
        }


        //

        public Bitmap Skalaszarosci(Bitmap bmp)
        {
            for (int x = 0; x < bmp.Width; x++)
                for (int y = 0; y < bmp.Height; y++)
                {
                    Color col;
                    col = bmp.GetPixel(x, y);
                    int grays1 = (int)((col.R * 0.3) + (col.G * 0.59) + (col.B * 0.11));
                    Color col2 = Color.FromArgb(col.A, grays1, grays1, grays1);
                    bmp.SetPixel(x, y, col2);

                    //  grays.SetPixel(i, j, Color.FromArgb((col.R + col.G + col.B) / 3, (col.R + col.G + col.B) / 3, (col.R + col.G + col.B) / 3));
                }


            return bmp;
        }

        /*
        //ROZCIĄGANIE
        public Bitmap Rozciaganie(Bitmap bmp, int p1, int p2)
        {
            for (int x = 0; x < bmp.Width; x++)
                for (int y = 0; y < bmp.Height; y++)

                    Color col2 = bmp.GetPixel(x, y);
                    if (bmp.GetPixel(x, y) > p1 && bmp.GetPixel(x, y) <= p2)
                        bmp.GetPixel(x, y) = (byte)((bmp.GetPixel(x, y) - p1) * ((bmp.Levels - 1) / (p2 - p1)));
                    else bmp.GetPixel(x, y) = 0;
            return bmp;
        }
        */

        public Bitmap Negacja(Bitmap bmp)
        {
            int negR, negG, negB;

            for (int x = 0; x <  bmp.Width; x++)
                for (int y = 0; y < bmp.Height; y++)
                {
                    Color col = bmp.GetPixel(x, y);
                    negR = 255 - col.R;
                    negG = 255 - col.G;
                    negB = 255 - col.B;

                    Color col1 = Color.FromArgb(col.A, negR, negG, negB);
                    bmp.SetPixel(x, y, col1);
                }
            return bmp;
        }

        //Rozciąganie obraz binarnych i obrazów RGB
        public static Bitmap ProgowanieRGB(Bitmap bmp, int war1)
        {
            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    if (bmp.GetPixel(x, y).R > war1)
                    {
                        bmp.SetPixel(x, y, Color.FromArgb(255, 255, 255));
                    }
                    else
                    {
                        bmp.SetPixel(x, y, Color.FromArgb(0, 0, 0));
                    }
                }
            }
            return bmp;
        }



        public Bitmap Rozciagnie(Bitmap bmp, int war1, int war2)
        {
          for (int x = 0; x < bmp.Width; x++)
              for (int y = 0; y < bmp.Height; y++)
              {
                 Color px = bmp.GetPixel(x, y);
                  int tab1, tab2;
                  tab1 = (int)((px.R * 0.3) + (px.G * 0.59) + (px.B * 0.11));
                  if (tab1 > war1 && tab1 <= war2)
                  {
                    tab2 = (tab1 - war1) * 255 / (war2-war1);

                    bmp.SetPixel(x, y, Color.FromArgb(0, 0, 0));
          
                 //     Color ob = Color.FromArgb(px.A, 0, 0, 0);
                 //     bmp.SetPixel(x, y, ob);
                   }     
                   else
                      bmp.SetPixel(x, y, Color.FromArgb(255, 255, 255));
                }
            return bmp;
        }

        //Rozciąganie RGB
         public static Bitmap RozciagnieRGB(Bitmap bmp, int war1, int war2)
         {
           // Bitmap obrazek_bitmapa = new Bitmap(src_thumbnail);
           // BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(obrazek_bitmapa);
          //  fobrazek_bitmapa.LockImage();
            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    int wartosc = bmp.GetPixel(x, y).R;
                    if (wartosc < war1)
                    {
                        bmp.SetPixel(x, y, Color.FromArgb(0, 0, 0));
                    }
                    else if (wartosc > war2)
                    {
                        bmp.SetPixel(x, y, Color.FromArgb(255, 255, 255));
                    }
                    else
                    {
                        int tmp = wartosc;
                        if (war2 != war1)
                        {
                            tmp = (int)(((float)(255 * (wartosc - war1))) / ((float)(war2 - war1)));
                        }
                        bmp.SetPixel(x, y, Color.FromArgb(tmp, tmp, tmp));
                    }
                }
            }
            return bmp;
        }


        //Poziomy  szarości w RGB i binarnym obrazie
        public static Bitmap PoziomySzarosci(Bitmap bmp, int war1)
        {
      //      label_value.Text = value.Value.ToString();
            float krok = 255 / war1;
         //  Bitmap bmp1 = new Bitmap(bmp);
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(bmp);
         //   fobrazek_bitmapa.LockImage();

            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    int wartosc_piksela = bmp.GetPixel(x, y).R;

                    int przedzial = (int)(wartosc_piksela / war1);

                    if (przedzial == war1 || przedzial == war1 - 1)
                    {
                        bmp.SetPixel(x, y, Color.FromArgb(255, 255, 255));
                    }
                    else if (przedzial == 0)
                    {
                        bmp.SetPixel(x, y, Color.FromArgb(0, 0, 0));
                    }
                    else
                    {
                        int tmp = (int)(((float)przedzial) * krok + krok / 2);
                        bmp.SetPixel(x, y, Color.FromArgb(tmp, tmp, tmp));
                    }
                }
            }
            return bmp;
        }

        
   }
    
}
