﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace APO_BB_DK_v012013
{
    //public static class ColorCalculator
    public static class FunkcjeWieloarg
    {
        public enum FunkcjeWieloargumentoweTyp
        {        
            Dodawanie,                  
            OdejmowanieLewe,           
            OdejmowaniePrawe,         
            Roznica,             
            Mnozenie,
            Srednia,    
            Minimum,                  
            Maksimum,                   
            OdchylenieStd,
            AND,
            OR,
            XOR,
            XNOR
         }

        public static byte Calculate(byte obraz1, byte obraz2, FunkcjeWieloargumentoweTyp calculationType)
        {
            byte resultValue = 0;
            int intResult = 0;
          
            if (calculationType == FunkcjeWieloargumentoweTyp.Dodawanie)
            {
                intResult = obraz1 + obraz2;
            }
            else if (calculationType == FunkcjeWieloargumentoweTyp.Srednia)
            {
                intResult = (obraz1 + obraz2) / 2;
            }
            else if (calculationType == FunkcjeWieloargumentoweTyp.OdejmowanieLewe)
            {
                intResult = obraz1 - obraz2;
            }
            else if (calculationType == FunkcjeWieloargumentoweTyp.OdejmowaniePrawe)
            {
                intResult = obraz2 - obraz1;
            }
            else if (calculationType == FunkcjeWieloargumentoweTyp.Roznica)
            {
                intResult = Math.Abs(obraz1 - obraz2);
            }
            else if (calculationType == FunkcjeWieloargumentoweTyp.Mnozenie)
            {
                intResult = (int)((obraz1 / 255.0 * obraz2 / 255.0) * 255.0);
            }
            else if (calculationType == FunkcjeWieloargumentoweTyp.Minimum)
            {
                intResult = (obraz1 < obraz2 ? obraz1 : obraz2);
            }
            else if (calculationType == FunkcjeWieloargumentoweTyp.Maksimum)
            {
                intResult = (obraz1 > obraz2 ? obraz1 : obraz2);
            }
            else if (calculationType == FunkcjeWieloargumentoweTyp.OdchylenieStd)
            {
                intResult = (int)(Math.Sqrt(obraz1 * obraz1 + obraz2 * obraz2) / Math.Sqrt(2.0));
            }
           
            else if (calculationType == FunkcjeWieloargumentoweTyp.AND)
            {
                intResult = (int)(obraz1 & obraz2);
            }
            else if (calculationType == FunkcjeWieloargumentoweTyp.OR)
            {
                
                intResult = (int)(obraz1 | obraz2);
            }
            else if (calculationType == FunkcjeWieloargumentoweTyp.XOR)
            {
                
               byte A = ( byte )( 255 - obraz1 );
			   byte B = ( byte )( 255 - obraz2 );

               intResult = (int)((obraz1 & B) | (A & obraz2));
            }
            else if (calculationType == FunkcjeWieloargumentoweTyp.XNOR)
            {
                byte A = (byte)(255 - obraz1);
                byte B = (byte)(255 - obraz2);
                intResult = (int)(255 - ((obraz1 & B) | (A & obraz2)));   
            
            }

            if (intResult < 0)
            { 
                resultValue = 0; 
            }
            else if (intResult > 255)
            {
                resultValue = 255; 
            }
            else
            { 
                resultValue = (byte)intResult; 
            }

            return resultValue;
        }

    }
}