﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Windows.Forms.DataVisualization.Charting;
using System.Drawing.Imaging;
using BitmapProcessing;
using System.Reflection;
using APO_BB_DK_v012013.Operacje;

namespace APO_BB_DK_v012013
{
    public partial class Histogram : Form
    {
   //     private OperatorHist processingH;
        public PictureBox picturePierwotny2;
        public PictureBox pictureWynikHist;

        private Bitmap originalBitmap = null;
        private Bitmap previewBitmap = null;
        private Bitmap resultBitmap = null;
        private int linia_sx = -1, linia_sy = -1;
      
        //
   //     private int _id = -1;
        private int[] histogram_values = new int[256];
        private int[] histogram_hsv_values = new int[256];
        private int[,] histogram_kolory_values;

        private int[] histogram_values2 = new int[256];
        private int[] histogram_hsv_values2 = new int[256];
        private int[,] histogram_kolory_values2;

        public bool HSV
        {
            get { return _HSV; }
            set { _HSV = value; this.label5.Text = "Obraz (HSV)"; this.HistogramRGB.Visible = false; button_blue.Visible = false; button_green.Visible = false; buttpn_red.Visible = false; label5.Visible = false; button_wszystkie.Visible = false; button1.Visible = false; button3.Visible = false; label5.Visible = true; label2.Text = "1.0"; }
        }
        private bool _HSV = false;
        public Bitmap get_image
        {
            get { return new Bitmap(this.pictureWynikHist.Image); }
            set { }
        }
        public Bitmap get_histogram
        {
            get { if (this.HistogramGrey.Image == null)
                    return null;
                return new Bitmap(HistogramGrey.Image); }
            set { }
        }
        public Bitmap get_histogram_kolory
        {
            get { if (this.HistogramRGB.Image == null)
                    return null;
                return new Bitmap(this.HistogramRGB.Image); }
            set { }
        }


               
        public Histogram()
        {
            InitializeComponent();
          //  processingH = new OperatorHist();       
            this.groupBox1.Visible = false;
            this.groupBox3.Visible = false;
        }

        private void button1_Click(object sender, EventArgs e)
        {
           OpenFileDialog ofd = new OpenFileDialog();
           ofd.Title = "Select the source Image";
           ofd.Filter = "Image Files(*.BMP;*.JPG;*.PNG)|*.BMP;*.JPG;*.PNG|All files (*.*)|*.*";

            if (ofd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                StreamReader streamReader = new StreamReader(ofd.FileName);
                originalBitmap = (Bitmap)Bitmap.FromStream(streamReader.BaseStream);
                streamReader.Close();
                previewBitmap = originalBitmap.CopyToSquareCanvas(this.picturePierwotny2.Width);
                this.picturePierwotny2.Image = previewBitmap;
                this.pictureObrazFL1.Image = originalBitmap;
              }
        }


        private void ApplyFilter(bool preview)
        {
            if (previewBitmap == null || comboBoxFGG.SelectedIndex == -1)
            { return; }

            Bitmap selectedSource = null;
            Bitmap bitmapResult = null;

            if (preview == true)
            { selectedSource = previewBitmap; }
            else
            { selectedSource = originalBitmap; }

            if (selectedSource != null)
            {
                if (comboBoxFGG.SelectedItem.ToString() == "None")
                {
                    bitmapResult = selectedSource;
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Histogram metoda średnich")
                {
                    this.label5.Text = "Obraz wynikowy - Wyrównywanie histogramu - metoda średnich";
                    Bitmap bmpR = (Bitmap)this.pictureWynikHist.Image;
                    histogram_wyrownanie(1);
                    bitmapResult = bmpR; 
                    /*
                       HistogramWyrownywanie hw = new HistogramWyrownywanie();
                       Bitmap bmpR = (Bitmap)this.pictureWynikHist.Image;
                       bmpR = HistogramWyrownywanie.Wyrownanie(bmpR, HistogramWyrownywanie.MetodyWyrownywania.Srednich);
                        bitmapResult = bmpR;
                     /// pictureWynikHist.Image = HistogramWyrownywanie.Wyrownanie(bmp1, HistogramWyrownywanie.MetodyWyrownywania.Srednich);
                      */    
                }
                  else if (comboBoxFGG.SelectedItem.ToString() == "Histogram metoda losowych")
                {
                    this.label5.Text = "Obraz wynikowy - Wyrównywanie histogramu - metoda  losowych"; 
                    Bitmap bmpR1 = (Bitmap)this.pictureWynikHist.Image;
                    histogram_wyrownanie(2);
                    bitmapResult = bmpR1;            
                }
                  else if (comboBoxFGG.SelectedItem.ToString() == "Histogram metoda sąsiedztwa")
                {
                    this.label5.Text = "Obraz wynikowy - Wyrównywanie histogramu - metoda  sąsiedztwa"; 
                    Bitmap bmpR3 = (Bitmap)this.pictureWynikHist.Image;
                    histogram_wyrownanie(3);
                    bitmapResult = bmpR3;            
                }
                  else if (comboBoxFGG.SelectedItem.ToString() == "Histogram metoda własna 1")
                {
                    this.label5.Text = "Obraz wynikowy - Wyrównywanie histogramu - metoda  własna 1";
                    Bitmap bmpR4 = (Bitmap)this.pictureWynikHist.Image;
                    histogram_wyrownanie(4);
                    bitmapResult = bmpR4;               
                }
                  else if (comboBoxFGG.SelectedItem.ToString() == "Histogram metoda własna 2")
                {
                    this.label5.Text = "Obraz wynikowy - Wyrównywanie histogramu - metoda  własna 2";
                    Bitmap bmpR5 = (Bitmap)this.pictureWynikHist.Image;
                    histogram_wyrownanie(4);
                    bitmapResult = bmpR5;             
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Histogram metoda średnich obraz HSV")
                {
                    this.label5.Text = "Obraz wynikowy - Wyrównywanie histogramu - metoda  średnich HSV";
                    Bitmap bmpR = (Bitmap)this.pictureWynikHist.Image;
                    histogram_wyrownanie(1);
                    bitmapResult = bmpR; 
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Histogram metoda losowych obraz HSV")
                {
                   this.label5.Text = "Obraz wynikowy - Wyrównywanie histogramu - metoda  sąsiedztwa HSV";
                    Bitmap bmpR1 = (Bitmap)this.pictureWynikHist.Image;
                    histogram_wyrownanie(2);
                    bitmapResult = bmpR1; 
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Histogram metoda sąsiedztwa obraz HSV")
                {
                    this.label5.Text = "Obraz wynikowy - Wyrównywanie histogramu - metoda  sąsiedztwa HSV";
                    Bitmap bmpR3 = (Bitmap)this.pictureWynikHist.Image;
                    histogram_wyrownanie(3);
                    bitmapResult = bmpR3; 
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Histogram metoda własna 1 obraz HSV")
                {
                    this.label5.Text = "Obraz wynikowy - Wyrównywanie histogramu - metoda  własna 1 HSV";
                    Bitmap bmpR3 = (Bitmap)this.pictureWynikHist.Image;
                    histogram_wyrownanie(4);
                    bitmapResult = bmpR3; 
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Histogram metoda własna 2 obraz HSV")
                {
                    this.label5.Text = "Obraz wynikowy - Wyrównywanie histogramu - metoda  własna 2 HSV"; 
                    Bitmap bmpR3 = (Bitmap)this.pictureWynikHist.Image;
                    histogram_wyrownanie(4);
                    bitmapResult = bmpR3; 
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Histogram metoda średnich obraz RGB")
                {
                    this.label5.Text = "Obraz wynikowy - Wyrównywanie histogramu - metoda  średnich RGB"; 
                    Bitmap bmpR = (Bitmap)this.pictureWynikHist.Image;
                    histogram_wyrownanie(1);
                    bitmapResult = bmpR; 
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Histogram metoda losowych obraz RGB")
                {
                    this.label5.Text = "Obraz wynikowy - Wyrównywanie histogramu - metoda  losowych RGB"; 
                    Bitmap bmpR1 = (Bitmap)this.pictureWynikHist.Image;
                    histogram_wyrownanie(2);
                    bitmapResult = bmpR1; 
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Histogram metoda sąsiedztwa obraz RGB")
                {
                    this.label5.Text = "Obraz wynikowy - Wyrównywanie histogramu - metoda  sąsiedztwa RGB"; 
                    Bitmap bmpR3 = (Bitmap)this.pictureWynikHist.Image;
                    histogram_wyrownanie(3);
                    bitmapResult = bmpR3; 
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Histogram metoda własna 1 obraz RGB")
                {
                    this.label5.Text = "Obraz wynikowy - Wyrównywanie histogramu - metoda  własna 1 RGB"; 
                    Bitmap bmpR3 = (Bitmap)this.pictureWynikHist.Image;
                    histogram_wyrownanie(4);
                    bitmapResult = bmpR3; 
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Histogram metoda własna 2 obraz RGB")
                {
                    this.label5.Text = "Obraz wynikowy - Wyrównywanie histogramu - metoda  własna 2 RGB"; 
                    Bitmap bmpR3 = (Bitmap)this.pictureWynikHist.Image;
                    histogram_wyrownanie(3);
                    bitmapResult = bmpR3; 
                }
            }

            if (bitmapResult != null)
            {
                if (preview == true)
                {  this.pictureWynikHist.Image = bitmapResult; }
                else
                {  resultBitmap = bitmapResult; }
            }
          }

       /*
        private void HistogramGrey_MouseMove(object sender, MouseEventArgs e)
        {
            this.label3.Text = e.X.ToString(); 
        }
        */

        private void buttonKolor_Click(object sender, EventArgs e)
        {
            FunkcjeJednoarg fn = new FunkcjeJednoarg();
            FunkcjeHSV fHSV = new FunkcjeHSV();
            comboBoxFGG.Items.Clear();
            comboBoxFGG.Items.Add("Metody Wyrównywania Histogramu");
            comboBoxFGG.SelectedIndex = 0;
            this.button3.Visible = true;
            this.groupBox1.Visible = true;

            if (this.radioSzary.Checked)
            {
                comboBoxFGG.Items.Add("Histogram metoda średnich");
                comboBoxFGG.Items.Add("Histogram metoda losowych");
                comboBoxFGG.Items.Add("Histogram metoda sąsiedztwa");
                comboBoxFGG.Items.Add("Histogram metoda własna 1");
                comboBoxFGG.Items.Add("Histogram metoda własna 2");
                comboBoxFGG.SelectedIndex = 0;                
                this.label5.Text = "Obraz wynikowy w odcieniach szarości";
                Bitmap bmpGrey = new Bitmap(this.picturePierwotny2.Image);
                bmpGrey = fn.Skalaszarosci(bmpGrey);
                this.pictureObrazFL2.Image = bmpGrey;
                this.picturePierwotny2.Image = bmpGrey;
                this.pictureWynikHist.Image = bmpGrey;      
                previewBitmap = bmpGrey.CopyToSquareCanvas(this.picturePierwotny2.Width);
                this.pictureWynikHist.Image = previewBitmap;
                this.groupBox1.Visible = true;
                this.groupBox3.Visible = true;
            }

            if (this.radioKolorHVS.Checked)
            {                             
                comboBoxFGG.Items.Add("Histogram metoda średnich obraz HSV");
                comboBoxFGG.Items.Add("Histogram metoda losowych obraz HSV");
                comboBoxFGG.Items.Add("Histogram metoda sąsiedztwa obraz HSV");
                comboBoxFGG.Items.Add("Histogram metoda własna 1 obraz HSV");
                comboBoxFGG.Items.Add("Histogram metoda własna 2 obraz HSV");
                comboBoxFGG.SelectedIndex = 0;
                this.label5.Text = "Obraz wtórny kolorowy HSV";
                Bitmap bmpHSV = new Bitmap(this.pictureObrazFL1.Image);
                picturePierwotny2.Image = bmpHSV;
                this.pictureWynikHist.Image = bmpHSV;
                previewBitmap = bmpHSV.CopyToSquareCanvas(this.picturePierwotny2.Width);
                this.pictureWynikHist.Image = previewBitmap;
                this.groupBox1.Visible = true;
                this.groupBox3.Visible = true;
            }

            if (this.radioKolorRGB.Checked)
            {
                comboBoxFGG.Items.Add("Histogram metoda średnich obraz RGB");
                comboBoxFGG.Items.Add("Histogram metoda losowych obraz RGB");
                comboBoxFGG.Items.Add("Histogram metoda sąsiedztwa obraz RGB");
                comboBoxFGG.Items.Add("Histogram metoda własna 1 obraz RGB");
                comboBoxFGG.Items.Add("Histogram metoda własna 2 obraz RGB");
                comboBoxFGG.SelectedIndex = 0;
                this.label5.Text = "Obraz wtórny kolorowy RGB";
                Bitmap bmpRGB = new Bitmap(this.pictureObrazFL1.Image);
                picturePierwotny2.Image = bmpRGB;
                this.pictureWynikHist.Image = bmpRGB;
                previewBitmap = bmpRGB.CopyToSquareCanvas(this.picturePierwotny2.Width);
                this.pictureWynikHist.Image = previewBitmap;
                this.groupBox1.Visible = true;
                this.groupBox3.Visible = true;
            }
        }

        //ZAPISANIE WYBRANEGO OBRAZU
        private void button4_Click(object sender, EventArgs e)
        {
            this.pictureWynikHist.Image = resultBitmap;

            ApplyFilter(false);
            if (resultBitmap != null)
            {
                SaveFileDialog sfd = new SaveFileDialog();
                sfd.Title = "Specify a file name and file path";
                sfd.Filter = "Png Images(*.png)|*.png|Jpeg Images(*.jpg)|*.jpg";
                sfd.Filter += "|Bitmap Images(*.bmp)|*.bmp";

                if (sfd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                {
                    string fileExtension = Path.GetExtension(sfd.FileName).ToUpper();
                    ImageFormat imgFormat = ImageFormat.Png;

                    if (fileExtension == "BMP")
                    {
                        imgFormat = ImageFormat.Bmp;
                    }
                    else if (fileExtension == "JPG")
                    {
                        imgFormat = ImageFormat.Jpeg;
                    }
                    StreamWriter streamWriter = new StreamWriter(sfd.FileName, false);
                    resultBitmap.Save(streamWriter.BaseStream, imgFormat);
                    streamWriter.Flush();
                    streamWriter.Close();
                    resultBitmap = null;
                }
            }      
        }

        //AKTYWACJA COMBOBOX I WYBRANEJ METODY
        private void comboBoxFGG_SelectedIndexChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        //WIDOK OBRAZU PIERWOTNEGO I WYNIKOWEGO  - ROZMIAR I WIELKOŚĆ
        private void buttonWidok_Click(object sender, EventArgs e)
        {
            this.picturePierwotny2.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureWynikHist.SizeMode = PictureBoxSizeMode.StretchImage;

            if (this.radioNaturalny.Checked)
            {
                this.picturePierwotny2.SizeMode = PictureBoxSizeMode.Normal;
                this.pictureWynikHist.SizeMode = PictureBoxSizeMode.Normal;
            }

            if (this.radioAutoSize.Checked)
            {
                this.picturePierwotny2.SizeMode = PictureBoxSizeMode.CenterImage;
                this.pictureWynikHist.SizeMode = PictureBoxSizeMode.CenterImage;
            }
            if (this.radioDopasowany.Checked)
            {
                this.picturePierwotny2.SizeMode = PictureBoxSizeMode.StretchImage;
                this.pictureWynikHist.SizeMode = PictureBoxSizeMode.StretchImage;
            }
            this.picturePierwotny2.Refresh();
            this.pictureWynikHist.Refresh();
        }

        private void EnableDoubleBuffered(DataGridView dgv, bool setting)
        {
            Type dgvType = dgv.GetType();
            PropertyInfo pi = dgvType.GetProperty("DoubleBuffered", BindingFlags.Instance | BindingFlags.NonPublic);
            pi.SetValue(dgv, setting, null);
        }

    
        private void button3_Click(object sender, EventArgs e)
        {
            if (this.radioSzary.Checked)
            {
                this.generuj_histogram(0);
              //  this.groupHistogram.Visible = true;
            }
            if (this.radioKolorRGB.Checked)
            {
                this.HistogramRGB.Image = generuj_histogram_kolory(0);
                this.label5.Text = "rgb";
            }
            if (this.radioKolorHVS.Checked)
            { 
            
            }         
            EnableDoubleBuffered(this.dataGridTablica, true);
            int cols_width = 40;         
            Bitmap bmpTab = (Bitmap)this.pictureWynikHist.Image;

            if (dataGridTablica.Columns.Count != bmpTab.Width || dataGridTablica.Rows.Count != bmpTab.Height)
            {
                dataGridTablica.Rows.Clear();
                dataGridTablica.Columns.Clear();
                dataGridTablica.RowHeadersWidth = 60;
                for (int x = 0; x < bmpTab.Width; x++)
                {
                    dataGridTablica.Columns.Add(null, x.ToString());
                    dataGridTablica.Columns[x].Width = cols_width;
                    dataGridTablica.Columns[x].FillWeight = 0.0000001f;
                }
                dataGridTablica.Rows.Add(bmpTab.Height);
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    dataGridTablica.Rows[y].HeaderCell.Value = y.ToString();
                }
            }

            for (int x = 0; x < bmpTab.Width; x++)
            {
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    dataGridTablica[x, y].Value = bmpTab.GetPixel(x, y).R;
                }
            } 
        }

         public void Profil(Color [] values,bool is_hsv)
         {
            Bitmap lin;
            int max = 1;
            if (this.radioKolorHVS.Checked)
            {
                this.tabLiniaProfit.Text = "Linia Profilu (HSV)";             
                max = 500;
                label_max.Text = "Max:\n1.0";
            }
            else
            {
                for (int i = 0; i < values.Length; i++)
                {
                    if (values[i].R > max) max = values[i].R;
                    if (values[i].G > max) max = values[i].G;
                    if (values[i].B > max) max = values[i].B;
                }
                label_max.Text = "Max:\n" + max.ToString();
            }
            lin = new Bitmap(values.Length*4+2, 4*max+1+2);
            
            label_vals.Text = "Pikseli:" + values.Length.ToString();
            FastBitmap flin = new FastBitmap(lin);
            flin.LockImage();
            //Rysowanie ramki
            for (int i = 0; i < lin.Width; i++)
            {
                flin.SetPixel(i, 0, Color.Black);
                flin.SetPixel(i, lin.Height-1, Color.Black);
            }
            for (int i = 0; i < lin.Height; i++)
            {
                flin.SetPixel(0, i, Color.Black);
                flin.SetPixel(lin.Width-1, i, Color.Black);
            }
            if (!is_hsv)
            {
                for (int i = 0; i < values.Length; i++)
                {
                    flin.SetPixel(4 * i, 4 * values[i].R, Color.Red);
                    flin.SetPixel(4 * i, 4 * values[i].G, Color.Green);
                    flin.SetPixel(4 * i, 4 * values[i].B, Color.Blue);
                    flin.SetPixel(4 * i + 1, 4 * values[i].R, Color.Red);
                    flin.SetPixel(4 * i + 1, 4 * values[i].G, Color.Green);
                    flin.SetPixel(4 * i + 1, 4 * values[i].B, Color.Blue);
                    flin.SetPixel(4 * i + 2, 4 * values[i].R, Color.Red);
                    flin.SetPixel(4 * i + 2, 4 * values[i].G, Color.Green);
                    flin.SetPixel(4 * i + 2, 4 * values[i].B, Color.Blue);
                    //flin.SetPixel(4 * i + 3, values[i].R, Color.Red);
                    //flin.SetPixel(4 * i + 3, values[i].G, Color.Green);
                    //flin.SetPixel(4 * i + 3, values[i].B, Color.Blue);
                }
                for (int i = 0; i < values.Length - 1; i++)
                {
                    int diff = Math.Abs(4 * values[i].R - 4 * values[i + 1].R);
                    int min = Math.Min(4 * values[i].R, 4 * values[i + 1].R);
                    for (int j = 0; j < diff; j++)
                    {
                        flin.SetPixel(4 * i + 3, min + j, Color.Red);
                    }
                    diff = Math.Abs(4 * values[i].G - 4 * values[i + 1].G);
                    min = Math.Min(4 * values[i].G, 4 * values[i + 1].G);
                    for (int j = 0; j < diff; j++)
                    {
                        flin.SetPixel(4 * i + 3, min + j, Color.Green);
                    }
                    diff = Math.Abs(4 * values[i].B - 4 * values[i + 1].B);
                    min = Math.Min(4 * values[i].B, 4 * values[i + 1].B);
                    for (int j = 0; j < diff; j++)
                    {
                        flin.SetPixel(4 * i + 3, min + j, Color.Blue);
                    }
                }
            }
            else
            {
                for (int i = 0; i < values.Length; i++)
                {
                    double h,s,v;
                    hsv.ColorToHSV(values[i], out h, out s, out v);
                    flin.SetPixel(4 * i, (int) (2000.0f * v), Color.Black);
                    flin.SetPixel(4 * i + 1, (int)(2000.0f * v), Color.Black);
                    flin.SetPixel(4 * i + 2, (int)(2000.0f * v), Color.Black);                  
                }
                for (int i = 0; i < values.Length - 1; i++)
                {
                    double h, s, v,v1;
                    hsv.ColorToHSV(values[i], out h, out s, out v);
                    hsv.ColorToHSV(values[i+1], out h, out s, out v1);
                    int diff = (int) (Math.Abs(v - v1)*2000.0f);
                    double min = Math.Min(v, v1);
                    for (int j = 0; j < diff; j++)
                    {
                        flin.SetPixel(4 * i + 3, (int) (min*2000.0f) + j, Color.Black);
                    }
                }
            }
            flin.UnlockImage();
            this.ProfilLine.Image = lin;
        }


        private void liniaProfiluObrazek_Click(object sender, EventArgs e)
        {
           
         }

        private void buttpn_red_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(0);
        }

        private void button_green_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(1);
        }

        private void button_blue_Click(object sender, EventArgs e)
        {
             this.HistogramRGB.Image = generuj_histogram(2);
        }

        private void button_wszystkie_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(0);
        }

        private void button8_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(1);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(2);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(3);
        }

        //
   
       private Bitmap generuj_histogram(int k)
        {
            Bitmap obrazek_bitmapa = new Bitmap(this.pictureWynikHist.Image);
            Bitmap histogram = null;
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(obrazek_bitmapa);           
           
            if (HSV)
            {
                int histogram_max=0;               
                double h, s, v;
                fobrazek_bitmapa.LockImage();
                for (int x = 0; x < obrazek_bitmapa.Width; x++)
                {
                    for (int y = 0; y < obrazek_bitmapa.Height; y++)
                    {
                        hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y), out h, out s, out v);
                        int temp_v = (int)(v * 255.0f);
                        histogram_hsv_values[temp_v]++;
                        if (histogram_hsv_values[temp_v] > histogram_max)
                            histogram_max = histogram_hsv_values[temp_v];
                    }
                }
                fobrazek_bitmapa.UnlockImage();
                double skala = (512.0f / (double)histogram_max) * ((double)pasek_skali.Value / 10.0f);
                histogram = new Bitmap(1024, 513);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_hsv_values[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Black);
                        }                       
                    }
                }

                fhistogram.UnlockImage();
            }
            else
            {
                int[] histogram_values_tmp;
                histogram_values_tmp = new int[256];
                int histogram_max = 0;
                fobrazek_bitmapa.LockImage();
                //Zliczanie wartości histogramu
                for (int x = 0; x < obrazek_bitmapa.Width; x++)
                {
                    for (int y = 0; y < obrazek_bitmapa.Height; y++)
                    {
                        if (k == 0 || k > 2)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R]++;
                            histogram_values[fobrazek_bitmapa.GetPixel(x, y).R]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R];
                        }
                        if (k == 1)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G];
                        }
                        if (k == 2)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B];
                        }
                        if (k == 3)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B];
                        }

                    }
                }
                fobrazek_bitmapa.UnlockImage();
                float skala = (512.0f / (float)histogram_max) * ((float)pasek_skali.Value / 10.0f);
                histogram = new Bitmap(1024, 513);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                Color slupki = Color.Black;
                if (k == 0)
                    slupki = Color.Red;
                if (k == 1)
                    slupki = Color.Green;
                if (k == 2)
                    slupki = Color.Blue;
                Color tlo = Color.White;
                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_values_tmp[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), slupki);
                        }
                        else
                        {
                            //fhistogram.SetPixel(4*x1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+2, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+3, (int)(256 - y1), tlo);
                        }
                    }
                }
                fhistogram.UnlockImage();
            }
            return histogram;
        }

       private Bitmap generuj_histogram2(int k)
       {
           Bitmap bmp = new Bitmap(this.picturePierwotny2.Image);
           Bitmap histogram = null;
           BitmapProcessing.FastBitmap fbmp = new BitmapProcessing.FastBitmap(bmp);

           if (HSV)
           {
               int histogram_max = 0;
               double h, s, v;
               fbmp.LockImage();
               for (int x = 0; x < bmp.Width; x++)
               {
                   for (int y = 0; y < bmp.Height; y++)
                   {
                       hsv.ColorToHSV(fbmp.GetPixel(x, y), out h, out s, out v);
                       int temp_v = (int)(v * 255.0f);
                       histogram_hsv_values2[temp_v]++;
                       if (histogram_hsv_values2[temp_v] > histogram_max)
                           histogram_max = histogram_hsv_values2[temp_v];
                   }
               }
               fbmp.UnlockImage();
               double skala = (512.0f / (double)histogram_max) * ((double)pasek_skali.Value / 10.0f);
               histogram = new Bitmap(1024, 513);
               BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
               fhistogram.LockImage();
               for (int x1 = 0; x1 < 256; x1++)
               {
                   int tmp = (int)(histogram_hsv_values2[x1] * skala);
                   for (int y1 = 0; y1 < 512; y1++)
                   {
                       if (y1 < tmp)
                       {
                           fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Black);
                           fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Black);
                           fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Black);
                       }
                   }
               }

               fhistogram.UnlockImage();
           }
           else
           {
               int[] histogram_values_tmp;
               histogram_values_tmp = new int[256];
               int histogram_max = 0;
               fbmp.LockImage();
               //Zliczanie wartości histogramu
               for (int x = 0; x < bmp.Width; x++)
               {
                   for (int y = 0; y < bmp.Height; y++)
                   {
                       if (k == 0 || k > 2)
                       {
                           histogram_values_tmp[fbmp.GetPixel(x, y).R]++;
                           histogram_values2[fbmp.GetPixel(x, y).R]++;
                           if (histogram_values_tmp[fbmp.GetPixel(x, y).R] > histogram_max)
                               histogram_max = histogram_values_tmp[fbmp.GetPixel(x, y).R];
                       }
                       if (k == 1)
                       {
                           histogram_values_tmp[fbmp.GetPixel(x, y).G]++;
                           if (histogram_values_tmp[fbmp.GetPixel(x, y).G] > histogram_max)
                               histogram_max = histogram_values_tmp[fbmp.GetPixel(x, y).G];
                       }
                       if (k == 2)
                       {
                           histogram_values_tmp[fbmp.GetPixel(x, y).B]++;
                           if (histogram_values_tmp[fbmp.GetPixel(x, y).B] > histogram_max)
                               histogram_max = histogram_values_tmp[fbmp.GetPixel(x, y).B];
                       }
                       if (k == 3)
                       {
                           histogram_values_tmp[fbmp.GetPixel(x, y).B]++;
                           if (histogram_values_tmp[fbmp.GetPixel(x, y).B] > histogram_max)
                               histogram_max = histogram_values_tmp[fbmp.GetPixel(x, y).B];
                       }

                   }
               }
               fbmp.UnlockImage();
               float skala = (512.0f / (float)histogram_max) * ((float)pasek_skali.Value / 10.0f);
               histogram = new Bitmap(1024, 513);
               BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
               Color slupki = Color.Black;
               if (k == 0)
                   slupki = Color.Red;
               if (k == 1)
                   slupki = Color.Green;
               if (k == 2)
                   slupki = Color.Blue;
               Color tlo = Color.White;
               fhistogram.LockImage();
               for (int x1 = 0; x1 < 256; x1++)
               {
                   int tmp = (int)(histogram_values_tmp[x1] * skala);
                   for (int y1 = 0; y1 < 512; y1++)
                   {
                       if (y1 < tmp)
                       {
                           fhistogram.SetPixel(4 * x1, (int)(512 - y1), slupki);
                           fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), slupki);
                           fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), slupki);
                       }
                       else
                       {
                           //fhistogram.SetPixel(4*x1, (int)(256 - y1), tlo);
                           //fhistogram.SetPixel(4 * x1+1, (int)(256 - y1), tlo);
                           //fhistogram.SetPixel(4 * x1+2, (int)(256 - y1), tlo);
                           //fhistogram.SetPixel(4 * x1+3, (int)(256 - y1), tlo);
                       }
                   }
               }
               fhistogram.UnlockImage();
           }
           return histogram;
       }

        private Bitmap generuj_histogram_kolory2(int k)
        {
            Bitmap bmp = new Bitmap(this.picturePierwotny2.Image);
            if (histogram_kolory_values2 == null)
                histogram_kolory_values2 = new int[256,3];
            int histogram_max = 0;
            BitmapProcessing.FastBitmap fbmp = new BitmapProcessing.FastBitmap(bmp);
            fbmp.LockImage();
            //Zliczanie wartości histogramu
            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    histogram_kolory_values2[fbmp.GetPixel(x, y).R, 0]++;
                    if (histogram_kolory_values2[fbmp.GetPixel(x, y).R, 0] > histogram_max)
                        histogram_max = histogram_kolory_values2[fbmp.GetPixel(x, y).R, 0];
                }
            }
            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    histogram_kolory_values2[fbmp.GetPixel(x, y).G, 1]++;
                    if (histogram_kolory_values2[fbmp.GetPixel(x, y).G, 1] > histogram_max)
                        histogram_max = histogram_kolory_values2[fbmp.GetPixel(x, y).G, 1];
                }
            }
            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    histogram_kolory_values2[fbmp.GetPixel(x, y).B, 2]++;
                    if (histogram_kolory_values2[fbmp.GetPixel(x, y).B, 2] > histogram_max)
                        histogram_max = histogram_kolory_values2[fbmp.GetPixel(x, y).B, 2];
                }
            }
            fbmp.UnlockImage();
            float skala = (512.0f / (float)histogram_max) ;
            Bitmap histogram = new Bitmap(1024, 513);
            BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
            fhistogram.LockImage();
            for (int x1 = 0; x1 < 256; x1++)
            {
                int tmpr = (int)(histogram_kolory_values2[x1,0] * skala);
                int tmpg = (int)(histogram_kolory_values2[x1,1] * skala);
                int tmpb = (int)(histogram_kolory_values2[x1,2] * skala);
                //0,1,2 nie 3
                if (k < 3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpr)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Red);
                        }
                    }
                }
                //0,1,3 nie 2
                if (k < 2 || k==3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpg)
                        {
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Green);
                        }
                    }
                }
                //0,2,3 nie 1
                if (k == 0 || k > 1)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpb)
                        {
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Blue);
                        }
                    }
                }
            }
            fhistogram.UnlockImage();
            return histogram;
        }

        private Bitmap generuj_histogram_kolory(int k)
        {
            Bitmap obrazek_bitmapa = new Bitmap(this.pictureWynikHist.Image);
            if (histogram_kolory_values == null)
                histogram_kolory_values = new int[256, 3];
            int histogram_max = 0;
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(obrazek_bitmapa);
            fobrazek_bitmapa.LockImage();
            //Zliczanie wartości histogramu
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0];
                }
            }
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1];
                }
            }
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2];
                }
            }
            fobrazek_bitmapa.UnlockImage();
            float skala = (512.0f / (float)histogram_max);
            Bitmap histogram = new Bitmap(1024, 513);
            BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
            fhistogram.LockImage();
            for (int x1 = 0; x1 < 256; x1++)
            {
                int tmpr = (int)(histogram_kolory_values[x1, 0] * skala);
                int tmpg = (int)(histogram_kolory_values[x1, 1] * skala);
                int tmpb = (int)(histogram_kolory_values[x1, 2] * skala);
                //0,1,2 nie 3
                if (k < 3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpr)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Red);
                        }
                    }
                }
                //0,1,3 nie 2
                if (k < 2 || k == 3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpg)
                        {
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Green);
                        }
                    }
                }
                //0,2,3 nie 1
                if (k == 0 || k > 1)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpb)
                        {
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Blue);
                        }
                    }
                }
            }
            fhistogram.UnlockImage();
            return histogram;
        }

        //Metody wyrównywania histogramu ---------------------------------------------------------------------------
        public void histogram_wyrownanie(int metoda)
        {
            int[] histogram_values = new int[256];
            int histogram_max = 0;
            int histogram_avg = 0;
            Bitmap obrazek_bitmapa = new Bitmap(this.pictureWynikHist.Image);
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(obrazek_bitmapa);
            fobrazek_bitmapa.LockImage();
            //Tworzenie tabeli histogramu
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_values[fobrazek_bitmapa.GetPixel(x, y).R]++;
                    if (histogram_values[fobrazek_bitmapa.GetPixel(x, y).R] > histogram_max)
                        histogram_max = histogram_values[fobrazek_bitmapa.GetPixel(x, y).R];
                }
            }
            fobrazek_bitmapa.UnlockImage();
            //Wyliczanie sredniej
            long tmp = 0;
            for (int i = 0; i < histogram_values.Length; i++)
            {
                tmp += histogram_values[i];
            }
            histogram_avg = (int)(tmp / 256);
            int[] left = new int[256];
            int[] right = new int[256];
            int[] nowy = new int[256];
            int r = 0, h_int = 0;
            for (int z = 0; z < 256; z++)
            {
                left[z] = r;
                if (left[z] == 256)
                    left[z]--;
                h_int += histogram_values[z];
                while (h_int > histogram_avg)
                {
                    h_int -= histogram_avg;
                    r++;
                }
                right[z] = r;
                if (right[z] == 256)
                    right[z]--;
                if (metoda == 1)
                {
                    //metoda1 - metoda średnich
                    nowy[z] = (left[z] + right[z]) / 2;                  
                }
                else if (metoda == 2)
                {
                    //metoda2 - metoda losowych
                    if(right[z]>=left[z])
                        nowy[z] = (right[z] - left[z]);
                }
                else if (metoda == 3)
                {
                    //metoda3 - sąsiedztwa                 
                    if (right[z] >= left[z])
                        nowy[z]  = (int)((right[z] - left[z]) / 2);
                }
                else if (metoda == 4)
                {
                    //metoda4 - własna
                    if (right[z] >= left[z])
                        nowy[z] = (int)(left[z]);
                }
            }
            fobrazek_bitmapa.LockImage();
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {                   
                        if (left[fobrazek_bitmapa.GetPixel(x, y).R] == right[fobrazek_bitmapa.GetPixel(x, y).R])
                        {
                            fobrazek_bitmapa.SetPixel(x, y, Color.FromArgb(255, left[fobrazek_bitmapa.GetPixel(x, y).R], left[fobrazek_bitmapa.GetPixel(x, y).R], left[fobrazek_bitmapa.GetPixel(x, y).R]));
                        }
                        else
                        {
                            if (metoda == 1)
                            {
                                fobrazek_bitmapa.SetPixel(x, y, Color.FromArgb(255, nowy[fobrazek_bitmapa.GetPixel(x, y).R], nowy[fobrazek_bitmapa.GetPixel(x, y).R], nowy[fobrazek_bitmapa.GetPixel(x, y).R]));
                            }
                            else if (metoda == 2)
                            {
                                Random rnd = new Random();
                                int rndnum = rnd.Next(0, nowy[fobrazek_bitmapa.GetPixel(x, y).R]) + left[fobrazek_bitmapa.GetPixel(x, y).R];
                                if (rndnum > 255)
                                    rndnum = 255;
                                fobrazek_bitmapa.SetPixel(x, y, Color.FromArgb(255, rndnum,rndnum,rndnum));
                            }
                            else if (metoda == 3)
                            {
                                int piks_avg = 0;
                                if (x > 0)
                                    piks_avg=+fobrazek_bitmapa.GetPixel(x - 1, y).R;
                                if (y > 0)
                                    piks_avg = +fobrazek_bitmapa.GetPixel(x, y-1).R;
                                if (x < obrazek_bitmapa.Width-1)
                                    piks_avg = +fobrazek_bitmapa.GetPixel(x + 1, y).R;
                                if (y < obrazek_bitmapa.Height-1)
                                    piks_avg = +fobrazek_bitmapa.GetPixel(x, y+1).R;
                                piks_avg /= 4;
                                if(piks_avg<left[fobrazek_bitmapa.GetPixel(x, y).R])
                                    piks_avg=left[fobrazek_bitmapa.GetPixel(x, y).R];
                                else if (piks_avg > right[fobrazek_bitmapa.GetPixel(x, y).R])
                                    piks_avg = right[fobrazek_bitmapa.GetPixel(x, y).R];
                                fobrazek_bitmapa.SetPixel(x, y, Color.FromArgb(255, piks_avg,piks_avg,piks_avg));
                            }
                            else if (metoda == 4)
                            {
                                int piks_avg = 0;
                                if (x > 0)
                                    piks_avg = +fobrazek_bitmapa.GetPixel(x - 1, y).R;
                                if (y > 0)
                                    piks_avg = +fobrazek_bitmapa.GetPixel(x, y - 1).R;
                                if (x < obrazek_bitmapa.Width - 1)
                                    piks_avg = +fobrazek_bitmapa.GetPixel(x + 1, y).R;
                                if (y < obrazek_bitmapa.Height - 1)
                                    piks_avg = +fobrazek_bitmapa.GetPixel(x, y + 1).R;
                                piks_avg /= 4;
                                if (piks_avg < left[fobrazek_bitmapa.GetPixel(x, y).R])
                                    piks_avg = left[fobrazek_bitmapa.GetPixel(x, y).R];
                                else if (piks_avg > right[fobrazek_bitmapa.GetPixel(x, y).R])
                                    piks_avg = right[fobrazek_bitmapa.GetPixel(x, y).R];
                                fobrazek_bitmapa.SetPixel(x, y, Color.FromArgb(255, piks_avg, piks_avg, piks_avg));                                                 
                            }
                        }
                    }                                  
            }
            fobrazek_bitmapa.UnlockImage();          
            this.pictureWynikHist.Image = obrazek_bitmapa;
            this.HistogramGrey.Image = generuj_histogram(4);
        }
        
        private void tab_histogram_Enter(object sender, EventArgs e)
        {
            this.HistogramGrey.Image = generuj_histogram(4);
            this.Width = 1060;
            this.Height = 610;
            this.Refresh();
        }
        
        private void tab_obrazek_Enter(object sender, EventArgs e)
        {
            if (this.pictureWynikHist.Image != null)
            {
                int new_height = this.pictureWynikHist.Image.Height;
                int new_width = pictureWynikHist.Image.Width;
                while (new_height > Screen.PrimaryScreen.WorkingArea.Height || new_width > Screen.PrimaryScreen.WorkingArea.Height)
                {
                    new_height = (int)(new_height / 1.1f);
                    new_width = (int)(new_width / 1.1f);
                }
                this.Height = new_height;
                this.Width = new_width;               
            }
        }


        private void HistogramGrey_MouseMove(object sender, MouseEventArgs e)
        {
            if (HSV)
            {
                wartosci_histogram.Left = e.X + 20;
                wartosci_histogram.Top = e.Y - 10;
                wartosci_histogram.Text = (((double)e.X)/1024.0f).ToString() + ", " + histogram_hsv_values[(e.X / 4)];          
            }
            else
            {
                wartosci_histogram.Left = e.X + 20;
                wartosci_histogram.Top = e.Y - 10;
                wartosci_histogram.Text = (e.X / 4).ToString() + ", " + histogram_values[(e.X / 4)];
            }
        }
         
        private void tab_histogram_kolor_Enter(object sender, EventArgs e)
        {           
            this.HistogramRGB.Image = generuj_histogram_kolory(0);
            this.Width = 1060;
            this.Height = 600;
            this.Refresh();       
        }
      
        private void tab_tablica_liczb_Enter(object sender, EventArgs e)
        {
            tablicaliczb_fill();
        }

        private void tab_linia_profilu_Enter(object sender, EventArgs e)
        {
            this.ProfilLine.Image = pictureWynikHist.Image;            
        }           
           
        private void tablicaliczb_fill()
        {
            EnableDoubleBuffered(dataGridTablica, true);
            int cols_width = 40;
            Bitmap tmp = new Bitmap(this.pictureWynikHist.Image);
            FastBitmap ftmp = new FastBitmap(tmp);
            ftmp.LockImage();
            if (HSV)
            {
                cols_width = 100;
                if (dataGridTablica.Columns.Count != pictureWynikHist.Width || dataGridTablica.Rows.Count != this.pictureWynikHist.Height)
                {
                    dataGridTablica.Rows.Clear();
                    dataGridTablica.Columns.Clear();
                    dataGridTablica.RowHeadersWidth = 60;
                    for (int x = 0; x < pictureWynikHist.Width; x++)
                    {
                        dataGridTablica.Columns.Add(null, x.ToString());
                        dataGridTablica.Columns[x].Width = cols_width;
                        dataGridTablica.Columns[x].FillWeight = 0.0000001f;
                    }
                    dataGridTablica.Rows.Add(this.pictureWynikHist.Height);
                    for (int y = 0; y < this.pictureWynikHist.Height; y++)
                    {
                        this.dataGridTablica.Rows[y].HeaderCell.Value = y.ToString();
                    }
                }
                for (int x = 0; x < pictureWynikHist.Width; x++)
                {
                    for (int y = 0; y < pictureWynikHist.Height; y++)
                    {
                        double h, s, v;
                        hsv.ColorToHSV(ftmp.GetPixel(x, y), out h, out s, out v);
                        this.dataGridTablica[x, y].Value = v;
                    }
                }
            }
            else
            {
                if (dataGridTablica.Columns.Count != pictureWynikHist.Width || dataGridTablica.Rows.Count != pictureWynikHist.Height)
                {
                    dataGridTablica.Rows.Clear();
                    dataGridTablica.Columns.Clear();
                    dataGridTablica.RowHeadersWidth = 60;
                    for (int x = 0; x < pictureWynikHist.Width; x++)
                    {
                        dataGridTablica.Columns.Add(null, x.ToString());
                        dataGridTablica.Columns[x].Width = cols_width;
                        dataGridTablica.Columns[x].FillWeight = 0.0000001f;
                    }
                    dataGridTablica.Rows.Add(pictureWynikHist.Height);
                    for (int y = 0; y < pictureWynikHist.Height; y++)
                    {
                        dataGridTablica.Rows[y].HeaderCell.Value = y.ToString();
                    }
                }
                for (int x = 0; x < pictureWynikHist.Width; x++)
                {
                    for (int y = 0; y < pictureWynikHist.Height; y++)
                    {
                        dataGridTablica[x, y].Value = ftmp.GetPixel(x, y).R.ToString();
                    }
                }
            }
            ftmp.UnlockImage();
        }
        private void tabtablicacaly_Enter(object sender, EventArgs e)
        {
            tablicaliczb_fill();
        }

        private void tabtablicacalyrgb_Enter(object sender, EventArgs e)
        {
            EnableDoubleBuffered(this.dataGridTablica, true);
            int cols_width = 40;
            Bitmap tmp = new Bitmap(pictureWynikHist.Image);
            FastBitmap ftmp = new FastBitmap(tmp);
            ftmp.LockImage();
            if (HSV)
            {
                MessageBox.Show("Tablica liczb rgb nie jest dostępna dla obrazów HSV.", "Tablica liczb rgb niedostępne", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
            {
                if (this.dataGridTablica.Columns.Count != this.pictureWynikHist.Width || dataGridTablica.Rows.Count != pictureWynikHist.Height)
                {
                    dataGridTablica.Rows.Clear();
                    dataGridTablica.Columns.Clear();
                    dataGridTablica.RowHeadersWidth = 60;
                    for (int x = 0; x < pictureWynikHist.Width; x++)
                    {
                        dataGridTablica.Columns.Add(null, x.ToString() + " R");
                        dataGridTablica.Columns[3 * x].Width = cols_width;
                        dataGridTablica.Columns[3 * x].FillWeight = 0.0000001f;
                        dataGridTablica.Columns.Add(null, x.ToString() + " G");
                        dataGridTablica.Columns[3 * x + 1].Width = cols_width;
                        dataGridTablica.Columns[3 * x + 1].FillWeight = 0.0000001f;
                        dataGridTablica.Columns.Add(null, x.ToString() + " B");
                        dataGridTablica.Columns[3 * x + 2].Width = cols_width;
                        dataGridTablica.Columns[3 * x + 2].FillWeight = 0.0000001f;
                    }
                    dataGridTablica.Rows.Add(pictureWynikHist.Height);
                    for (int y = 0; y < pictureWynikHist.Height; y++)
                    {
                        dataGridTablica.Rows[y].HeaderCell.Value = y.ToString();
                    }
                }
                for (int x = 0; x < pictureWynikHist.Width; x++)
                {
                    for (int y = 0; y < pictureWynikHist.Height; y++)
                    {
                        dataGridTablica[3 * x, y].Value = ftmp.GetPixel(x, y).R.ToString();
                        dataGridTablica[3 * x + 1, y].Value = ftmp.GetPixel(x, y).G.ToString();
                        dataGridTablica[3 * x + 2, y].Value = ftmp.GetPixel(x, y).B.ToString();
                    }
                }
            }
            ftmp.UnlockImage();
        }

        private void tabtablicawycinek_Enter(object sender, EventArgs e)
        {
            this.pictureWynikHist.Image = new Bitmap(pictureWynikHist.Image);
        }
        private int tab_sx = -1, tab_sy = -1;
        private void tablicaliczb_obraz_Click(object sender, EventArgs e)
        {
            if (tab_sx == -1 || tab_sy == -1)
            {
                tab_sx = ((MouseEventArgs)e).X;
                tab_sy = ((MouseEventArgs)e).Y;
            }
            else
            {
                int tab_kx = ((MouseEventArgs)e).X;
                int tab_ky = ((MouseEventArgs)e).Y;
                if (tab_kx < tab_sx)
                {
                    int tmp = tab_kx;
                    tab_kx = tab_sx;
                    tab_sx = tmp;
                }
                if (tab_ky < tab_sy)
                {
                    int tmp = tab_ky;
                    tab_ky = tab_sy;
                    tab_sy = tmp;
                }
                Bitmap a = (new Bitmap(this.pictureWynikHist.Image)).Clone(new Rectangle(tab_sx,tab_sy,tab_kx-tab_sx,tab_ky-tab_sy),this.pictureWynikHist.Image.PixelFormat);
                _form_tablica_liczb forma = new _form_tablica_liczb(a);
                tab_sx = -1; tab_sy = -1;
                forma.Show();
            }
        }

        private void pictureWynikHist_Click(object sender, EventArgs e)
        {
             if (linia_sx == -1 || linia_sy == -1)
            {
                linia_sx = ((MouseEventArgs)e).X;
                linia_sy = ((MouseEventArgs)e).Y;
            }
            else
            {
                Bitmap liniaProfilu = new Bitmap(this.ProfilLine.Image);
                FastBitmap flinia = new FastBitmap(liniaProfilu);
                flinia.LockImage();
                int kx=((MouseEventArgs)e).X;;
                int ky=((MouseEventArgs)e).Y;             
                Color [] values=null;              
                int wys= Math.Abs(linia_sy-ky);
                int szer=Math.Abs(kx-linia_sx);
                //
                if (szer == 0)
                {   return;  }
                if (szer >= wys)
                {
                    //rysowanie od lewej do prawej..
                    if (linia_sx > kx)
                    {
                        int tmp = ky;
                        ky = linia_sy;
                        linia_sy = tmp;
                        tmp = kx;
                        kx = linia_sx;
                        linia_sx = tmp;
                    }
                    values = new Color[szer];
                    for (int i = 0; i < szer; i++)
                    {
                        int j = (int) (((double)(ky-linia_sy))*(((double)i)/((double)szer)));
                        values[i] = flinia.GetPixel(linia_sx + i, linia_sy + j);
                        flinia.SetPixel(linia_sx + i, linia_sy+j, Color.Red);                      
                    }
                }
                else
                {
                    //rysowanie z góry na dół..
                    if (linia_sy > ky)
                    {
                        int tmp = ky;
                        ky = linia_sy;
                        linia_sy = tmp;
                        tmp = kx;
                        kx = linia_sx;
                        linia_sx = tmp;
                    }
                    values = new Color[wys];
                    for (int i = 0; i < wys; i++)
                    {
                        int j = (int)(((double)(kx-linia_sx)) * (((double)i) / ((double)wys)));
                        values[i] = flinia.GetPixel(linia_sx + j, linia_sy + i);
                        flinia.SetPixel(linia_sx + j, linia_sy + i, Color.Red);
                    }
                }
                flinia.UnlockImage();
                this.ProfilLine.Image = liniaProfilu;
                _form_linia_profilu forma = new _form_linia_profilu(values,HSV);
                forma.Show();
                linia_sx = -1; linia_sy = -1;
            }
        }

        private void pictureLinia_Click(object sender, EventArgs e)
        {
         //   int linia_sx;
         //   int linia_sy;
            if (linia_sx == -1 || linia_sy == -1)
            {
                linia_sx = ((MouseEventArgs)e).X;
                linia_sy = ((MouseEventArgs)e).Y;
            }
            else
            {
                Bitmap liniaProfilu = new Bitmap(this.pictureWynikHist.Image);
                FastBitmap flinia = new FastBitmap(liniaProfilu);
                flinia.LockImage();
                int kx = ((MouseEventArgs)e).X;
                int ky = ((MouseEventArgs)e).Y;
                Color[] values = null;
                int wys = Math.Abs(linia_sy - ky);
                int szer = Math.Abs(kx - linia_sx);
                if (szer == 0)
                { return; }
                if (szer >= wys)
                {
                    if (linia_sx > kx)     //rysowanie od lewej do prawej..
                    {
                        int tmp = ky;
                        ky = linia_sy;
                        linia_sy = tmp;
                        tmp = kx;
                        kx = linia_sx;
                        linia_sx = tmp;
                    }
                    values = new Color[szer];
                    for (int i = 0; i < szer; i++)
                    {
                        int j = (int)(((double)(ky - linia_sy)) * (((double)i) / ((double)szer)));
                        values[i] = flinia.GetPixel(linia_sx + i, linia_sy + j);
                        flinia.SetPixel(linia_sx + i, linia_sy + j, Color.Red);
                    }
                }
                else
                {
                    if (linia_sy > ky)   //rysowanie z góry na dół..
                    {
                        int tmp = ky;
                        ky = linia_sy;
                        linia_sy = tmp;
                        tmp = kx;
                        kx = linia_sx;
                        linia_sx = tmp;
                    }
                    values = new Color[wys];
                    for (int i = 0; i < wys; i++)
                    {
                        int j = (int)(((double)(kx - linia_sx)) * (((double)i) / ((double)wys)));
                        values[i] = flinia.GetPixel(linia_sx + j, linia_sy + i);
                        flinia.SetPixel(linia_sx + j, linia_sy + i, Color.Red);
                    }
                }
                flinia.UnlockImage();
                this.pictureWynikHist.Image = liniaProfilu;
                Profil(values, HSV);
                linia_sx = -1; linia_sy = -1;
            }
        }

        private void pasek_skali_Scroll_1(object sender, EventArgs e)
        {
            wartosc_skali.Text = ((double)pasek_skali.Value / 10.0f).ToString();
            this.HistogramGrey.Image = generuj_histogram(4);
        }

        private void Histogram_Load(object sender, EventArgs e)
        {

        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (this.radioSzary.Checked)
            {
            //    Bitmap b = (Bitmap)this.picturePierwotny2.Image;
                this.generuj_histogram2(0);
            }
            if (this.radioKolorRGB.Checked)
            {
                this.HistogramRGB2.Image = generuj_histogram_kolory2(0);
                this.label5.Text = "rgb"; 
            }
            if (this.radioKolorHVS.Checked)
            { 
            
            }
            EnableDoubleBuffered(this.TablicaLiczb2, true);
            int cols_width = 40;         
            Bitmap bmpTab = (Bitmap)this.picturePierwotny2.Image;

            if (TablicaLiczb2.Columns.Count != bmpTab.Width || TablicaLiczb2.Rows.Count != bmpTab.Height)
            {
                TablicaLiczb2.Rows.Clear();
                TablicaLiczb2.Columns.Clear();
                TablicaLiczb2.RowHeadersWidth = 60;
                for (int x = 0; x < bmpTab.Width; x++)
                {
                    TablicaLiczb2.Columns.Add(null, x.ToString());
                    TablicaLiczb2.Columns[x].Width = cols_width;
                    TablicaLiczb2.Columns[x].FillWeight = 0.0000001f;
                }
                TablicaLiczb2.Rows.Add(bmpTab.Height);
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    TablicaLiczb2.Rows[y].HeaderCell.Value = y.ToString();
                }
            }

            for (int x = 0; x < bmpTab.Width; x++)
            {
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    TablicaLiczb2[x, y].Value = bmpTab.GetPixel(x, y).R;
                }
            } 
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            wartosc_skali2.Text = ((double)pasek_skali2.Value / 10.0f).ToString();
            this.HistogramGrey2.Image = generuj_histogram2(4);
        }

        private void button6_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram2(0);
        }

        private void button12_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram2(1);
        }

        private void button11_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram2(2);
        }

        private void button10_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram_kolory2(0);
        }

        private void button9_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram_kolory2(1);
        }

        private void button14_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram_kolory2(2);
        }

        private void button13_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram_kolory2(3);
        }

        private void dataGridTablica_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }
        

       

      
    }
}