﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Drawing;

namespace APO_BB_DK_v012013
{  
         enum TypWyrownania : short
        {
            Metoda1,Metoda2,Metoda3
        }
    class HistogramRysuj
    {
        int[] levels;
        Bitmap bmp;

        public HistogramRysuj(Bitmap b)
        {
            bmp = b;
            levels = new int[256];
            int w = b.Width;
            int h = b.Height;
            for (int y = 0; y < h; ++y)
            {
                for (int x = 0; x < w; ++x)
                {
                    levels[b.GetPixel(x, y).G]++;
                }
            }
        }

        public Bitmap equalize(TypWyrownania t)
        {
            int[] new_levels = new int[256];
            int[] left = new int[256];
            int[] right = new int[256];

            int hav = bmp.Width * bmp.Height / 256;
            int R = 0, hint = 0;
  
            for (int Z = 0; Z < 256; ++Z)
            {
                if (levels[Z] > 0)
                {
                    int leftZ = R;
                    hint += levels[Z];
                    while (hint > hav)
                    {
                        hint -= hav;
                        ++R;
                    }
                    if (R > 255) R = 255;
                    int rightZ = R;
            
                    right[Z] = rightZ; left[Z] = leftZ;
                    switch (t)
                    {
                        case TypWyrownania.Metoda1:
                            new_levels[Z] = (leftZ + rightZ) / 2;
                            break;
                        case TypWyrownania.Metoda2:
                            new_levels[Z] = rightZ - leftZ;
                            break;
                    }

                }
            }
            Random rnd = new Random();
            Bitmap ret = new Bitmap(bmp.Width,bmp.Height);
            for (int y = 0; y < bmp.Height; ++y)
            {
                for (int x = 0; x < bmp.Width; ++x)
                {
                    int v = bmp.GetPixel(x, y).R;
                    if (left[v] == right[v])
                    {
                        if (left[v] > 255) left[v] = right[v] = 255;
                        ret.SetPixel(x, y, Color.FromArgb(left[v], left[v], left[v]));
                    }
                    else
                    {
                        int tv;
                        switch (t)
                        {
                            case TypWyrownania.Metoda1:
                                ret.SetPixel(x, y, Color.FromArgb(new_levels[v],new_levels[v],new_levels[v]));
                                break;
                            case TypWyrownania.Metoda2:
                                tv = left[v] + rnd.Next(0, new_levels[v] + 1);
                                ret.SetPixel(x,y,Color.FromArgb(tv,tv,tv));
                                break;
                            case TypWyrownania.Metoda3:
                                int [] dx = new int[]{0,0,1,-1};
                                int [] dy = new int[]{1,-1,0,0};
                                tv=0;
                                int hm=0;
                                for(int i=0;i<4;++i){
                                    int xx = x+dx[i];
                                    int yy = y+dy[i];
                                    if(xx>=0 && yy>=0 && xx < bmp.Width && yy<bmp.Height){
                                        tv += bmp.GetPixel(x,y).R;
                                        ++hm;
                                    }
                                }
                                tv /= hm;
                                if(tv>right[v]) tv = right[v];
                                if(tv<left[v]) tv=left[v];
                                ret.SetPixel(x,y,Color.FromArgb(tv,tv,tv));
                                break;
                        }
                    }
                }
            }
            return ret;
        }

        public Bitmap draw()
        {
            int maxlvl = 0;
            for (int i = 0; i < levels.Length; ++i)
            {                
                maxlvl = Math.Max(maxlvl, levels[i]);
            }
            Bitmap ret = new Bitmap(256, 256);
            Graphics g = Graphics.FromImage(ret);
            Pen p = new Pen(Color.Black);

            for (int i = 0; i < levels.Length; ++i)
            {
                g.DrawLine(p, i, 256, i, 256-levels[i] * 256 / maxlvl);
            }
            g.Dispose();
            return ret;
        }
    }
}