﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Drawing;
using System.Drawing.Imaging;
using System.Data;
using System.Windows.Forms;
using System.Diagnostics;

namespace APO_BB_DK_v012013
{
    class HistogramWyrownywanie
    {
        public enum MetodyWyrownywania
        {
            Srednich,
            Losowych,
            Sasiedztwa,
            Wlasna
        }

        public static Bitmap Wyrownanie(Bitmap bmp, MetodyWyrownywania metoda)
        {
            int zakres = 256;
            int[] H = new int[zakres];
            for (int x = 0; x < bmp.Width; x++)
                for (int y = 0; y < bmp.Height; y++)
                    H[bmp.GetPixel(x, y).R]++;

            int Hsr = 0;
            for (int i = 0; i < zakres; i++)
                Hsr += H[i];
                Hsr /= zakres;

            int R = 0;
            int Hint = 0;
            int[] lewy = new int[zakres];
            int[] prawy = new int[zakres];
            int[] _new = new int[zakres];

            for (int z = 0; z < zakres; z++)
            {
                lewy[z] = R;
                Hint += H[z];
                while (Hint > Hsr)
                {
                    Hint -= Hsr;
                    R++;
                }

                if (R > zakres - 1) R = zakres - 1;
                lewy[z] = R;

                switch (metoda)
                {
                    case MetodyWyrownywania.Srednich:
                        _new[z] = (lewy[z] + prawy[z]) / 2;
                        break;

                    case MetodyWyrownywania.Losowych:
                        _new[z] = (prawy[z] - lewy[z]);
                        break;

                //    case MetodyWyrownywania.Sasiedztwa:
                //        _new[z] = (int)((lewy[z] + prawy[z])/2);
               //         break;

                    case MetodyWyrownywania.Wlasna:
                        _new[z] = (int)(lewy[z]);
                        break;

                    default:
                        break;
                }
            }

            Random rnd = new Random();

            for (int i = 0; i < bmp.Width; ++i)
            {
                for (int j = 0; j < bmp.Height; ++j)
                {
                    byte col = 0;
                    byte pix = bmp.GetPixel(i, j).R;

                    if (lewy[pix] == prawy[pix])
                    {
                        col = (byte)lewy[pix];

                    }
                    else
                    {
                        switch (metoda)
                        {
                            case MetodyWyrownywania.Srednich:
                                col = (byte)_new[pix];
                                break;

                            case MetodyWyrownywania.Losowych:
                               // int zakres = 255;
                                if (_new[pix] < 0)
                                {
                                    int var = rnd.Next(_new[pix], 0);
                                    col = (byte)(lewy[pix] + var);
                                }
                                else
                                {
                                    int var1 = rnd.Next(0, _new[pix]);
                                    col = (byte)(lewy[pix] + var1);
                                }
                                break;

                            case MetodyWyrownywania.Sasiedztwa:
                                double sred = 0;
                                int licz = 0;
                                foreach (Point offset in new Point[] { new Point(1, 0), new Point(-1, 0), new Point(0, 1), new Point(0, -1), new Point(1, 1), new Point(-1, -1), new Point(-1, 1), new Point(1, -1) })
                                {
                                    if (i + offset.X >= 0 && i + offset.X < bmp.Width && j + offset.Y >= 0 && j + offset.Y < bmp.Height)
                                    {
                                        sred += bmp.GetPixel(i + offset.X, j + offset.Y).R;
                                        ++licz;
                                    }
                                }
                                sred /= licz;

                                if (sred > prawy[pix])
                                    col = (byte)prawy[pix];
                                else if (sred < lewy[pix])
                                    col = (byte)lewy[pix];
                                else
                                    col = (byte)((int)sred);
                                break;

                            default:
                                break;
                        }
                    }
                    Color px = bmp.GetPixel(i, j);
                    Color nc = Color.FromArgb(px.A, col, col, col);
                    bmp.SetPixel(i, j, nc);
                }
            }
            return bmp;
        }
    }
}
    
