﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace APO_BB_DK_v012013
{
     public static class Matrix
    {
        public static double[,] Laplacian3x3
        {
            get
            {
                return new double[,]  
                { { -1, -1, -1,  }, 
                  { -1,  8, -1,  }, 
                  { -1, -1, -1,  }, };
            }
        }

        public static double[,] Laplacian5x5
        {
            get
            {
                return new double[,] 
                { { -1, -1, -1, -1, -1, }, 
                  { -1, -1, -1, -1, -1, }, 
                  { -1, -1, 24, -1, -1, }, 
                  { -1, -1, -1, -1, -1, }, 
                  { -1, -1, -1, -1, -1  }, };
            }
        }

        public static double[,] LaplacianOfGaussian
        {
            get
            {
                return new double[,]  
                { {  0,   0, -1,  0,  0 }, 
                  {  0,  -1, -2, -1,  0 }, 
                  { -1,  -2, 16, -2, -1 },
                  {  0,  -1, -2, -1,  0 },
                  {  0,   0, -1,  0,  0 }, };
            }
        }

        public static double[,] Gaussian3x3
        {
            get
            {
                return new double[,]  
                { { 1, 2, 1, }, 
                  { 2, 4, 2, }, 
                  { 1, 2, 1, }, };
            }
        }

        public static double[,] Gaussian5x5Type1
        {
            get
            {
                return new double[,]  
                { { 2, 04, 05, 04, 2 }, 
                  { 4, 09, 12, 09, 4 }, 
                  { 5, 12, 15, 12, 5 },
                  { 4, 09, 12, 09, 4 },
                  { 2, 04, 05, 04, 2 }, };
            }
        }

        public static double[,] Gaussian5x5Type2
        {
            get
            {
                return new double[,] 
                { {  1,   4,  6,  4,  1 }, 
                  {  4,  16, 24, 16,  4 }, 
                  {  6,  24, 36, 24,  6 },
                  {  4,  16, 24, 16,  4 },
                  {  1,   4,  6,  4,  1 }, };
            }
        }

        public static double[,] Sobel3x3Horizontal    //pionowa
        {
            get
            {
                return new double[,] 
                { { -1,  0,  1, }, 
                  { -2,  0,  2, }, 
                  { -1,  0,  1, }, };
            }
        }

        public static double[,] Sobel3x3Vertical    //pozioma
        {
            get
            {
                return new double[,] 
                { {  1,  2,  1, }, 
                  {  0,  0,  0, }, 
                  { -1, -2, -1, }, };
            }
        }

        public static double[,] Prewitt3x3Horizontal
        {
            get
            {
                return new double[,] 
                { { -1,  0,  1, }, 
                  { -1,  0,  1, }, 
                  { -1,  0,  1, }, };
            }
        }

        public static double[,] Prewitt3x3Vertical
        {
            get
            {
                return new double[,] 
                { {  1,  1,  1, }, 
                  {  0,  0,  0, }, 
                  { -1, -1, -1, }, };
            }
        }


        public static double[,] Kirsch3x3Horizontal
        {
            get
            {
                return new double[,] 
                { {  5,  5,  5, }, 
                  { -3,  0, -3, }, 
                  { -3, -3, -3, }, };
            }
        }

        public static double[,] Kirsch3x3Vertical
        {
            get
            {
                return new double[,] 
                { {  5, -3, -3, }, 
                  {  5,  0, -3, }, 
                  {  5, -3, -3, }, };
            }
        }
//----------------------------------------------
        public static double[,] Prewitta_N
        {
            get
            {
                return new double[,]  
                { {  1,  1,  1,  }, 
                  {  1, -2,  1,  }, 
                  { -1, -1, -1,  }, };
            }
        }

        public static double[,] Prewitta_NE
        {
            get
            {
                return new double[,]  
                { {  1,  1,  1,  }, 
                  { -1, -2,  1,  }, 
                  { -1, -1, 1,  }, };
            }
        }

        public static double[,] Prewitta_E
        {
            get
            {
                return new double[,]  
                { { -1,  1,  1,  }, 
                  { -1, -2,  1,  }, 
                  { -1,  1,  1,  }, };
            }
        }

        public static double[,] Prewitta_SE
        {
            get
            {
                return new double[,]  
                { { -1, -1,  1,  }, 
                  { -1, -2,  1,  }, 
                  { -1,  1,  1,  }, };
            }
        }

        public static double[,] Prewitta_S
        {
            get
            {
                return new double[,]  
                { { -1, -1, -1,  }, 
                  {  1, -2,  1,  }, 
                  {  1,  1,  1,  }, };
            }
        }

        public static double[,] Prewitta_SW
        {
            get
            {
                return new double[,]  
                { {  1, -1, -1,  }, 
                  {  1, -2, -1,  }, 
                  {  1,  1,  1,  }, };
            }
        }

        public static double[,] Prewitta_W
        {
            get
            {
                return new double[,]  
                { {  1,  1, -1,  }, 
                  {  1, -2, -1,  }, 
                  {  1,  1, -1,  }, };
            }
        }

        public static double[,] Prewitta_NW
        {
            get
            {
                return new double[,]  
                { {  1,  1,  1,  }, 
                  {  1, -2, -1,  }, 
                  {  1, -1, -1,  }, };
            }
        }

        //--------------------
        public static double[,] Kirscha_N
        {
            get
            {
                return new double[,]  
                { {  3,  3,  3,  }, 
                  {  3,  0,  3,  }, 
                  { -5, -5, -5,  }, };
            }
        }

        public static double[,] Kirscha_NE
        {
            get
            {
                return new double[,]  
                { {  3,  3,  3,  }, 
                  { -5,  0,  3,  }, 
                  { -5, -5,  3,  }, };
            }
        }

        public static double[,] Kirscha_E
        {
            get
            {
                return new double[,]  
                { { -5,  3,  3,  }, 
                  { -5,  0,  3,  }, 
                  { -5,  3,  3,  }, };
            }
        }

        public static double[,] Kirscha_SE
        {
            get
            {
                return new double[,]  
                { { -5, -5,  3,  }, 
                  { -5,  0,  3,  }, 
                  {  3,  3,  3,  }, };
            }
        }

        public static double[,] Kirscha_S
        {
            get
            {
                return new double[,]  
                { { -5, -5, -5,  }, 
                  {  3,  0,  3,  }, 
                  {  3,  3,  3,  }, };
            }
        }

        public static double[,] Kirscha_SW
        {
            get
            {
                return new double[,]  
                { {  3, -5, -5,  }, 
                  {  3,  0, -5,  }, 
                  {  3,  3,  3,  }, };
            }
        }

        public static double[,] Kirscha_W
        {
            get
            {
                return new double[,]  
                { {  3,  3, -5,  }, 
                  {  3,  0, -5,  }, 
                  {  3,  3, -5,  }, };
            }
        }

        public static double[,] Kirscha_NW
        {
            get
            {
                return new double[,]  
                { {  3,  3,  3,  }, 
                  {  3,  0, -5,  }, 
                  {  3, -5, -5,  }, };
            }
        }
     
        //------------------
        public static double[,] Laplacian_L1
        {
            get
            {
                return new double[,]  
                { { 0, -1, 0,  }, 
                  { -1,  4, -1,  }, 
                  { 0, -1, 0,  }, };
            }
        }

        public static double[,] Laplacian_L2
        {
            get
            {
                return new double[,]  
                { { -1, -1, -1,  }, 
                  { -1,  4, -1,  }, 
                  { -1, -1, -1,  }, };
            }
        }

        public static double[,] Laplacian_L3
        {
            get
            {
                return new double[,]  
                { {  1, -2,  1,  }, 
                  { -2,  4, -2,  }, 
                  {  1, -2,  1,  }, };
            }
        }

        public static double[,] Laplacian_L4
        {
            get
            {
                return new double[,]  
                { { -1, -1, -1,  }, 
                  { -1,  9, -1,  }, 
                  { -1, -1, -1,  }, };
            }
        }

        public static double[,] Laplacian_L5
        {
            get
            {
                return new double[,]  
                { {  0, -1,  0,  }, 
                  { -1,  5, -1,  }, 
                  {  0, -1,  0,  }, };
            }
        }

        public static double[,] Laplacian_Horizontal
        {
            get
            {
                return new double[,]  
                { {  0, -1,  0,  }, 
                  {  0,  2,  0,  }, 
                  {  0, -1,  0,  }, };
            }
        }

        public static double[,] Laplacian_Vertical
        {
            get
            {
                return new double[,]  
                { {  0,  0,  0,  }, 
                  {  -1,  2, -1, }, 
                  {  0,  0,  0,  }, };
            }
        }

        public static double[,] Laplacian_Ukosny
        {
            get
            {
                return new double[,]  
                { { -1,  0, -1,  }, 
                  {  0,  4,  0,  }, 
                  { -1,  0, -1,  }, };
            }
        }

        public static double[,] Roberts_1
        {
            get
            {
                return new double[,]  
                { {  0,  0,  0,  }, 
                  {  -1, 0,  0,  }, 
                  {  0,  1,  0,  }, };
            }
        }


        public static double[,] Roberts_2  //filtry górnoprzepustowe
        {
            get
            {
                return new double[,]  
                { {  0,  0,  0,  }, 
                  {  0,  1, 0,  }, 
                  {  -1,  0,  0,  }, };
            }
        }

        public static double[,] Prewitta_1  //filtry górnoprzepustowe
        {
            get
            {
             return new double[,]  
                  { {  -1, -1,  -1,  }, 
                  {  0,  0,  0,  }, 
                  {  1, 1,  1,  }, };    
           }
        }

        public static double[,] Prewitta_2  //filtry górnoprzepustowe
        {
            get
            {
                return new double[,]  
                { {  -1,  0,  1,  }, 
                  {  -1,  0,  1,  }, 
                  {  -1,  0,  1,  }, };
            }
        }

        public static double[,] Sobela_1  //filtry górnoprzepustowe
        {
           get
            {
                return new double[,]  
                { {  1, 2,  1,  }, 
                  {  0,  0, 0,  }, 
                  {  -1, -2, -1,  }, };    
            }
        }

        public static double[,] Sobela_2  //filtry górnoprzepustowe
        {
            get
            {
                return new double[,]  
                { {  1,  0,  -1,  }, 
                  {  2,  0,  -2,  }, 
                  {  1,  0,  -1,  }, };
            }
        }


       

     
     
     }
}


