﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Drawing;
using System.Drawing.Imaging;
using System.Windows.Forms;

namespace APO_BB_DK_v012013
{

    public class OperatorHist
 	{
		private Bitmap bmp1;
		public OperatorHist()
		{
			
		}

		public void setImage( Bitmap bmp )
		{
			bmp1 = ( Bitmap )bmp.Clone( );
		}

		public Bitmap getImage( )
		{
			return ( Bitmap )bmp1.Clone( );
		}

		public void calcHisto( Histogram hist )
		{         
          //  BitmapData data = bmpimg.LockBits( new System.Drawing.Rectangle( 0 , 0 , bmpimg.Width , bmpimg.Height ), ImageLockMode.ReadWrite , PixelFormat.Format24bppRgb );
            BitmapData data = bmp1.LockBits(new System.Drawing.Rectangle(0, 0, bmp1.Width, bmp1.Height), ImageLockMode.ReadWrite, PixelFormat.Format32bppArgb);

			unsafe
			{
				byte* ptr = ( byte* )data.Scan0;

				int remain = data.Stride - data.Width * 3;

				int[ ] histogram = new int[ 256 ];
				for( int i = 0 ; i < histogram.Length ; i ++ )
					histogram[ i ] = 0;

				for( int i = 0 ; i < data.Height ; i ++ )
				{
					for( int j = 0 ; j < data.Width ; j ++ )
					{
						int mean = ptr[ 0 ] + ptr[ 1 ] + ptr[ 2 ];
						mean /= 3;

						histogram[ mean ] ++;
						ptr += 3;
					}

					ptr += remain;
				}	
			
				drawHistogram( histogram , hist);
			}
			bmp1.UnlockBits( data );  
		}

        public void equilizeHist(Histogram hist)
        {
            BitmapData data = bmp1.LockBits(new System.Drawing.Rectangle(0, 0, bmp1.Width, bmp1.Height), ImageLockMode.ReadWrite, PixelFormat.Format24bppRgb);
            unsafe
            {
                byte* ptr = (byte*)data.Scan0;

                int remain = data.Stride - data.Width * 3;

                int[] histogram = new int[256];
                for (int i = 0; i < histogram.Length; i++)
                    histogram[i] = 0;

                for (int i = 0; i < data.Height; i++)
                {
                    for (int j = 0; j < data.Width; j++)
                    {
                        int mean = ptr[0] + ptr[1] + ptr[2];
                        mean /= 3;

                        histogram[mean]++;
                        ptr += 3;
                    }

                    ptr += remain;
                }

                float[] LUT = equilize(histogram, data.Width * data.Height);
                ptr = (byte*)data.Scan0;

                for (int i = 0; i < data.Height; i++)
                {
                    for (int j = 0; j < data.Width; j++)
                    {
                        int index = ptr[0];
                        byte nValue = (byte)LUT[index];
                        if (LUT[index] > 255)
                            nValue = 255;
                        ptr[0] = ptr[1] = ptr[2] = nValue;
                        ptr += 3;
                    }

                    ptr += remain;
                }

                ptr = (byte*)data.Scan0;

                histogram = new int[256];
                for (int i = 0; i < histogram.Length; i++)
                    histogram[i] = 0;

                for (int i = 0; i < data.Height; i++)
                {
                    for (int j = 0; j < data.Width; j++)
                    {
                        int mean = ptr[0];

                        histogram[mean]++;
                        ptr += 3;
                    }

                    ptr += remain;
                }

                drawHistogram(histogram, hist);

            }

            bmp1.UnlockBits(data);
        }

        public float[] equilize(int[] histogram, long numPixel)
        {
            float[] hist = new float[256];

            hist[0] = histogram[0] * histogram.Length / numPixel;
            long prev = histogram[0];
            string str = "";
            str += (int)hist[0] + "\n";

            for (int i = 1; i < hist.Length; i++)
            {
                prev += histogram[i];
                hist[i] = prev * histogram.Length / numPixel;
                str += (int)hist[i] + "   _" + i + "\t";
            }

            //	MessageBox.Show( str );
            return hist;

        }

		public void drawHistogram( int[ ] histogram , Histogram hist )
		{	
			Bitmap bmp = new Bitmap( histogram.Length + 10 , 310 );
        //    hist.pictureHistWynikowy.Image = bmp;
         //   hist.statusStrip1.Text =
         //       histogram.HistogramTable[e.X] + " pixels with a gray level of " + e.X.ToString(); 
         //   hist.pictureHistPierwotny.Image = bmp;
    
			BitmapData data = bmp.LockBits( new System.Drawing.Rectangle( 0 , 0 , bmp.Width , bmp.Height ), ImageLockMode.ReadWrite , PixelFormat.Format24bppRgb );

			unsafe
			{
				int remain = data.Stride - data.Width * 3;
				byte* ptr = ( byte* )data.Scan0;

				for( int i = 0 ; i < data.Height ; i ++ )
				{
										
					for( int j = 0 ; j < data.Width ; j ++ )
					{
						ptr[ 0 ] = ptr[ 1 ] = ptr[ 2 ] = 150;
						ptr += 3;
					}
					ptr += remain;

				}

				int max = 0;
				for( int i = 0 ; i < histogram.Length ; i ++ )
				{
					
					if( max < histogram[ i ] )
						max = histogram[ i ];

				}

				for( int i = 0 ; i < histogram.Length ; i ++ )
				{
					ptr = ( byte* )data.Scan0;
					ptr += data.Stride * ( 305 ) + ( i + 5 ) * 3;

					int length = ( int )( 1.0 * histogram[ i ] * 300 / max );
										
					for( int j = 0 ; j < length ; j ++ )
					{
						ptr[ 0 ] = 255;
						ptr[ 1 ] = ptr[ 2 ] = 0;
						ptr -= data.Stride;
					}

				}

			}

			bmp.UnlockBits( data );		    			
		}

	}
}
