﻿/*
 * The Following Code was developed by Dewald Esterhuizen
 * View Documentation at: http://softwarebydefault.com
 * Licensed under Ms-PL 
*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace APO_BB_DK_v012013
{
    /*
    public class Usredniajacy : ConvolutionFilterBase      // FiltryWygladzajace
    {
        public override string FilterName
        {
            get { return "Usredniajacy"; }      // "SoftenFilter"
        }

        private double factor = 1.0 / 9.0;
        public override double Factor
        {
            get { return factor; }
        }

        private double bias = 0.0;
        public override double Bias
        {
            get { return bias; }
        }

        private double[,] filterMatrix =
            new double[,] { { 1, 1, 1, }, 
                            { 1, 1, 1, }, 
                            { 1, 1, 1, }, };

        public override double[,] FilterMatrix
        {
            get { return filterMatrix; }
        }
    }

    //FILTR KWADRATOWY
    public class Kwadratowy : ConvolutionFilterBase      // FiltryWygladzajace
    {
        public override string FilterName
        {
            get { return "Kwadratowy"; }      // 
        }

        private double factor = 1.0 / 25.0;   // 24.0
        public override double Factor
        {
            get { return factor; }
        }

        private double bias = 0.0;
        public override double Bias
        {
            get { return bias; }
        }

        private double[,] filterMatrix =
            new double[,] { { 1, 1, 1, 1, 1 }, 
                            { 1, 1, 1, 1, 1 }, 
                            { 1, 1, 1, 1, 1 }, 
                            { 1, 1, 1, 1, 1 }, 
                            { 1, 1, 1, 1, 1 }, };

        public override double[,] FilterMatrix
        {
            get { return filterMatrix; }
        }
    }

    // FILTR KOLOWY
    public class Kolowy : ConvolutionFilterBase      // FiltryWygladzajace
    {
        public override string FilterName
        {
            get { return "Kolowy"; }      // 
        }

        private double factor = 1.0 / 16.0;   // 24.0
        public override double Factor
        {
            get { return factor; }
        }

        private double bias = 0.0;
        public override double Bias
        {
            get { return bias; }
        }

        private double[,] filterMatrix =
            new double[,] { { 0, 1, 1, 1, 0 }, 
                            { 1, 1, 1, 1, 1 }, 
                            { 1, 1, 1, 1, 1 }, 
                            { 1, 1, 1, 1, 1 }, 
                            { 0, 1, 1, 1, 0 }, };
            
        public override double[,] FilterMatrix
        {
            get { return filterMatrix; }
        }
    }

    // FILTR PIRAMIDALNY
    public class Piramidalny : ConvolutionFilterBase      // FiltryWygladzajace
    {
        public override string FilterName
        {
            get { return "Piramidalny"; }      // 
        }

        private double factor = 1.0 / 81.0;   // 24.0
        public override double Factor
        {
            get { return factor; }
        }

        private double bias = 0.0;
        public override double Bias
        {
            get { return bias; }
        }

        private double[,] filterMatrix =
            new double[,] { { 1, 2, 3, 2, 1 }, 
                            { 2, 4, 6, 4, 2 }, 
                            { 3, 6, 9, 6, 3 }, 
                            { 2, 4, 6, 4, 2 }, 
                            { 1, 2, 3, 2, 1 }, };

        public override double[,] FilterMatrix
        {
            get { return filterMatrix; }
        }
    }
    //---------------------
    // FILTR Stozkowy
    public class Stozkowy : ConvolutionFilterBase      // FiltryWygladzajace
    {
        public override string FilterName
        {
            get { return "Stozkowy"; }      // 
        }

        private double factor = 1.0 / 80.0;   // 24.0
        public override double Factor
        {
            get { return factor; }
        }

        private double bias = 0.0;
        public override double Bias
        {
            get { return bias; }
        }

        private double[,] filterMatrix =
            new double[,] { { 0, 0, 1, 0, 0 }, 
                            { 0, 2, 2, 2, 0 }, 
                            { 1, 2, 5, 2, 1 }, 
                            { 0, 2, 2, 2, 0 }, 
                            { 0, 0, 1, 0, 0 }, }; 

        public override double[,] FilterMatrix
        {
            get { return filterMatrix; }
        }
    }

    // FILTR Gaussa3x3
    public class Gaussa3x3 : ConvolutionFilterBase      // FiltryWygladzajace
    {
        public override string FilterName
        {
            get { return "Gaussa 3x3"; }      
        }

        private double factor = 1.0 / 16.0;   // 8.0
        public override double Factor
        {
            get { return factor; }
        }

        private double bias = 0.0;
        public override double Bias
        {
            get { return bias; }
        }

        private double[,] filterMatrix =
            new double[,] { { 1, 2, 1 }, 
                            { 2, 4, 2 }, 
                            { 1, 2, 1 }, };

        public override double[,] FilterMatrix
        {
            get { return filterMatrix; }
        }
    }

    // FILTR Gaussa5x5_1
    public class Gaussa5x5_1 : ConvolutionFilterBase      // FiltryWygladzajace
    {
        public override string FilterName
        {
            get { return "Gaussa 5x5 1"; }
        }

        private double factor = 1.0 / 52.0;   // 8.0
        public override double Factor
        {
            get { return factor; }
        }

        private double bias = 0.0;
        public override double Bias
        {
            get { return bias; }
        }

        private double[,] filterMatrix =
            new double[,] { { 1, 1, 2, 1, 1 }, 
                            { 1, 2, 4, 2, 1 }, 
                            { 2, 4, 8, 4, 2 }, 
                            { 1, 2, 4, 2, 1 }, 
                            { 1, 1, 2, 1, 1 }, };

        public override double[,] FilterMatrix
        {
            get { return filterMatrix; }
        }
    }

    // FILTR Gaussa5x5_2
    public class Gaussa5x5_2 : ConvolutionFilterBase      // FiltryWygladzajace
    {
        public override string FilterName
        {
            get { return "Gaussa 5x5 2"; }
        }

        private double factor = 1.0 / 25.0;   // 8.0
        public override double Factor
        {
            get { return factor; }
        }

        private double bias = 0.0;
        public override double Bias
        {
            get { return bias; }
        }

        private double[,] filterMatrix =
            new double[,] { { 0, 1, 2, 1, 0 }, 
                            { 1, 4, 8, 4, 1 }, 
                            { 2, 8, 16, 8, 2 }, 
                            { 1, 4, 8, 4, 1 }, 
                            { 0, 1, 2, 1, 0 }, };

        public override double[,] FilterMatrix
        {
            get { return filterMatrix; }
        }
    }

    // FILTR Gaussa5x5_3
    public class Gaussa5x5_3 : ConvolutionFilterBase      // FiltryWygladzajace
    {
        public override string FilterName
        {
            get { return "Gaussa 5x5 3"; }
        }

        private double factor = 1.0 / 273.0;   // 8.0
        public override double Factor
        {
            get { return factor; }
        }

        private double bias = 0.0;
        public override double Bias
        {
            get { return bias; }
        }

        private double[,] filterMatrix =
            new double[,] { { 1, 4, 7, 4, 1 }, 
                            { 4, 16, 26, 16, 4 }, 
                            { 7, 26, 41, 26, 7 }, 
                            { 4, 16, 26, 16, 4 }, 
                            { 1, 4, 7, 4, 1 }, };

        public override double[,] FilterMatrix
        {
            get { return filterMatrix; }
        }
    }


    //-----------
       // FILTR Gaussa5x5_4
    public class Gaussa5x5_4 : ConvolutionFilterBase      // FiltryWygladzajace
    {
        public override string FilterName
        {
            get { return "Gaussa 5x5 4"; }
        }

        private double factor = 1.0 / 159.0;   // 8.0
        public override double Factor
        {
            get { return factor; }
        }

        private double bias = 0.0;
        public override double Bias
        {
            get { return bias; }
        }

        public double[,] filterMatrix =
            new double[,] {{ 2,  4,  5,  4, 2  }, 
                           { 4,  9, 12,  9, 4  }, 
                           { 5, 12, 15, 12, 5  },
                           { 4,  9, 12,  9, 4  },
                           { 2,  4,  5,  4, 2  },};

        public override double[,] FilterMatrix
        {
            get { return filterMatrix; }
        }
    }

    // FILTR Gaussa5x5_5
    public class Gaussa5x5_5 : ConvolutionFilterBase      // FiltryWygladzajace
    {
        public override string FilterName
        {
            get { return "Gaussa 5x5 5"; }
        }

        private double factor = 1.0 / 256.0;   // 8.0
        public override double Factor
        {
            get { return factor; }
        }

        private double bias = 0.0;
        public override double Bias
        {
            get { return bias; }
        }

        private double[,] filterMatrix =
            new   double[,] { {  1,   4,  6,  4,  1  }, 
                              {  4,  16, 24, 16,  4  }, 
                              {  6,  24, 36, 24,  6  },
                              {  4,  16, 24, 16,  4  },
                              {  1,   4,  6,  4,  1  }, };

        public override double[,] FilterMatrix
        {
            get { return filterMatrix; }
        }
    }




    // FILTR Gaussa7x7
    public class Gaussa7x7 : ConvolutionFilterBase      // FiltryWygladzajace
    {
        public override string FilterName
        {
            get { return "Gaussa 7x7"; }
        }

        private double factor = 1.0 / 49.0;   // 8.0
        public override double Factor
        {
            get { return factor; }
        }

        private double bias = 0.0;
        public override double Bias
        {
            get { return bias; }
        }

        private double[,] filterMatrix =
            new double[,] { { 1, 1, 2, 2, 2, 1, 1 }, 
                            { 1, 2, 2, 4, 2, 2, 1 }, 
                            { 2, 2, 4, 8, 4, 2, 2 }, 
                            { 2, 4, 8, 16, 8, 4, 2 }, 
                            { 2, 2, 4, 8, 4, 2, 2 }, 
                            { 1, 2, 2, 4, 2, 2, 1 }, 
                            { 1, 1, 2, 2, 2, 1, 1 }, }; 

        public override double[,] FilterMatrix
        {
            get { return filterMatrix; }
        }
    }

    //-------
    // FILTR LP_1
    public class LP_1 : ConvolutionFilterBase      // FiltryWygladzajace
    {
        public override string FilterName
        {
            get { return "LP 1"; }
        }

        private double factor = 1.0 /10.0;   // 8.0
        public override double Factor
        {
            get { return factor; }
        }

        private double bias = 0.0;
        public override double Bias
        {
            get { return bias; }
        }

        private double[,] filterMatrix =
            new double[,] { { 1, 1, 1 }, 
                            { 1, 2, 1 }, 
                            { 1, 1, 1 } };

        public override double[,] FilterMatrix
        {
            get { return filterMatrix; }
        }
    }

    //------
    // FILTR LP_2
    public class LP_2 : ConvolutionFilterBase      // FiltryWygladzajace
    {
        public override string FilterName
        {
            get { return "LP 2"; }
        }

        private double factor = 1.0 / 12.0;   // 8.0
        public override double Factor
        {
            get { return factor; }
        }

        private double bias = 0.0;
        public override double Bias
        {
            get { return bias; }
        }

        private double[,] filterMatrix =
            new double[,] { { 1, 1, 1 }, 
                            { 1, 4, 1 }, 
                            { 1, 1, 1 } };

        public override double[,] FilterMatrix
        {
            get { return filterMatrix; }
        }
    }

    //-------------
    // FILTR LP_3
    public class LP_3 : ConvolutionFilterBase      // FiltryWygladzajace
    {
        public override string FilterName
        {
            get { return "LP 3"; }
        }

        private double factor = 1.0 / 21.0;   // 8.0
        public override double Factor
        {
            get { return factor; }
        }

        private double bias = 0.0;
        public override double Bias
        {
            get { return bias; }
        }

        private double[,] filterMatrix =
            new double[,] { { 1, 1 , 1 }, 
                            { 1, 12, 1 }, 
                            { 1, 1 , 1 } };

        public override double[,] FilterMatrix
        {
            get { return filterMatrix; }
        }
    }

    //-------------
    //FILTR KWADRATOWY2
    public class Kwadratowy2 : ConvolutionFilterBase      // FiltryWygladzajace
    {
        public override string FilterName
        {
            get { return "Kwadratowy2"; }      // 
        }

        private double factor = 1.0 / 25.0;   // 24.0
        public override double Factor
        {
            get { return factor; }
        }

        private double bias = 5.0;
        public override double Bias
        {
            get { return bias; }
        }

        private double[,] filterMatrix =
            new double[,] { { 1, 1, 1, 1, 1 }, 
                            { 1, 1, 1, 1, 1 }, 
                            { 1, 1, 1, 1, 1 }, 
                            { 1, 1, 1, 1, 1 }, 
                            { 1, 1, 1, 1, 1 }, };

        public override double[,] FilterMatrix
        {
            get { return filterMatrix; }
        }
    }

    */
}
