﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Windows.Forms.DataVisualization.Charting;
using System.Drawing.Imaging;
//using AForge.NET;
//using AForge.Imaging.Filters.Convolution;


namespace APO_BB_DK_v012013
{
    
//public class Convolution : BaseUsingCopyPartialFilter;

    public partial class Obraz1 : Form
    {
        private Image zrodloOPJ;
     //   private OperatorOPJ processingOPJ;
        private TrackBar suwak1;
        private OpenFileDialog open;
        public PictureBox pictureHistogramOPJ;
        public PictureBox pictureWtornyOPJ;
        public PictureBox picturePierwotnyOPJ;
        public Bitmap bitmap;
        //   public ComboBox comboBoxOPJ;

        public Obraz1()
        {
            InitializeComponent();
            zrodloOPJ = null;
      //      processingOPJ = new OperatorOPJ();
            open = new OpenFileDialog();
            suwak1 = new System.Windows.Forms.TrackBar();
            //    this.groupBoxTablicaLUT.Visible = false;
            trackBarOPJ.Visible = false;

            //  trackBarGamma(null, null);
            //  trackBarJasnosc(null, null);
            //   trackBarKontrast(null, null);
            //   trackBarBineryzacja(null, null);

            comboBoxOPJ.Items.Add("Operacje jednopunktowe");
            comboBoxOPJ.Items.Add("Negacja");
            comboBoxOPJ.Items.Add("Kontrast");
            comboBoxOPJ.Items.Add("Jasność");
            comboBoxOPJ.Items.Add("Bineryzacja");
            comboBoxOPJ.Items.Add("Progowanie");
            comboBoxOPJ.Items.Add("Rozciąganie");
            comboBoxOPJ.Items.Add("Korekcja Gamma");
            comboBoxOPJ.Items.Add("Redukcja poziomów jasności");
            comboBoxOPJ.Items.Add("Sepia");
            comboBoxOPJ.Items.Add("Transparentny");
            comboBoxOPJ.SelectedIndex = 0;
        }

        private void buttonObrazPierwotnyOPJ_Click(object sender, EventArgs e)
        {
            open.Filter = "Image Files(*.jpg; *.jpeg; *.gif; *.bmp)|*.jpg; *.jpeg; *.gif; *.bmp";
            if (open.ShowDialog() == DialogResult.OK)
            {
                this.picturePierwotnyOPJ.Image = new Bitmap(open.FileName);
                zrodloOPJ = new Bitmap(open.OpenFile());
            }
        }

        private void buttonKolor_Click(object sender, EventArgs e)
        {
            FunkcjeJednoarg fn = new FunkcjeJednoarg();
            Bitmap bmp1 = new Bitmap(this.picturePierwotnyOPJ.Image);

            if (this.radioSzaryOPJ.Checked)
            {
                this.label1.Text = "Obraz wtórny w odcieniach szarości";
                bmp1 = fn.Skalaszarosci(bmp1);
                this.picturePierwotnySzary.Image = bmp1;
                pictureWtornyOPJ.Image = bmp1;
                picturePierwotnyOPJ.Image = bmp1;
                //    Bitmap bitmap1 = (Bitmap)this.picturePierwotnySzary.Image.Clone();
            }
            else
            {
                this.label1.Text = "Obraz wtórny kolorowy";
                Bitmap bmp2 = new Bitmap(this.picturePierwotnyOPJ.Image);
                pictureWtornyOPJ.Image = bmp2;

                //    Bitmap bitmap1 = (Bitmap)this.picturePierwotnyOPJ.Image.Clone();
            }
        }

        private void buttonHistogramOPJ_Click(object sender, EventArgs e)
        {
            Bitmap bmpG = (Bitmap)this.pictureWtornyOPJ.Image;
            Bitmap hs = new HistogramRysuj(bmpG).draw();
            this.pictureHistogramOPJ.Image = hs;
            this.pictureHistogramOPJ.Visible = true; 
            
            /*
            this.pictureHistogramOPJ.Visible = true;
            Bitmap bmpHistogOPJ = (Bitmap)pictureWtornyOPJ.Image;
            this.processingOPJ.setImage(new Bitmap(this.pictureWtornyOPJ.Image));
            this.processingOPJ.calcHisto(this);
            this.Invalidate();
            */
        }

        //JASNOŚĆ
        private void trackBarJasnosc(object sender, EventArgs e)
        {
            //Przygotuj tablice LUT i pokaz ja na wykresie
            wykres.Series[0].Points.Clear();
            byte[] LUT = new byte[256];
            int b = this.trackBarOPJ.Value;
            wykres.Titles[0].Text = "Tablica LUT, b = " + b;
            for (int i = 0; i < 256; i++)
            {
                if ((b + i) > 255)
                {
                    LUT[i] = 255;
                }
                else if ((b + i) < 0)
                {
                    LUT[i] = 0;
                }
                else
                {
                    LUT[i] = (byte)(b + i);
                }
                wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
            }

            //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
            if (this.picturePierwotnyOPJ.Image == null)
            {
                return;
            }
            Bitmap bitmap = (Bitmap)this.picturePierwotnyOPJ.Image.Clone();
            this.pictureWtornyOPJ.Image = bitmap;
            //Pobierz wartosc wszystkich punktow obrazu
            BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
            byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
            System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);
            //Zmien jasnosc kazdego punktu zgodnie z tablica LUT
            for (int i = 0; i < pixelValues.Length; i++)
            {
                pixelValues[i] = LUT[pixelValues[i]];
            }
            //Ustaw wartosc wszystkich punktow obrazu
            System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
            bitmap.UnlockBits(bmpData);
        }

        //Korekcja Gamma
        private void trackBarGamma(object sender, EventArgs e)
        {
            //Przygotuj tablice LUT i pokaz ja na wykresie
            wykres.Series[0].Points.Clear();
      //      wykres.ChartAreas[0].AxisX.Minimum = 0;
      //      wykres.ChartAreas[0].AxisX.Maximum = 255;
            wykres.Series[0].YValuesPerPoint = 1;


            wykres.ChartAreas[0].AxisX.Minimum = 0;
            wykres.ChartAreas[0].AxisX.Maximum = 256;
            wykres.ChartAreas[0].AxisY.Minimum = 0;
            wykres.ChartAreas[0].AxisY.Maximum= 256;
            byte[] LUT = new byte[256];
            double gamma = this.trackBarOPJ.Value / 100.0;
            wykres.Titles[0].Text = "Tablica LUT, gamma = " + gamma;
            for (int i = 0; i < 256; i++)
            {
                if ((255 * Math.Pow(i / 255.0, 1 / gamma)) > 255)
                {
                    LUT[i] = 255;
                }
                else
                {
                    LUT[i] = (byte)(255 * Math.Pow(i / 255.0, 1 / gamma));
                }
                wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
            }
            //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
            if (picturePierwotnyOPJ.Image == null)
            {
                return;
            }
            Bitmap bitmap = (Bitmap)this.picturePierwotnyOPJ.Image.Clone();
            this.pictureWtornyOPJ.Image = bitmap;
            //Pobierz wartosc wszystkich punktow obrazu
            BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
            byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
            System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);
            for (int i = 0; i < pixelValues.Length; i++)
            {
                pixelValues[i] = LUT[pixelValues[i]];
            }
            System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
            bitmap.UnlockBits(bmpData);
        }

        //KONTRAST
        private void trackBarKontrast(object sender, EventArgs e)
        {
            //Przygotuj tablice LUT i pokaz ja na wykresie
            wykres.Series[0].Points.Clear();
            byte[] LUT = new byte[256];
            double a;
            if (this.trackBarOPJ.Value <= 0)
            {
                a = 1.0 + (trackBarOPJ.Value / 256.0);
            }
            else
            {
                a = 256.0 / Math.Pow(2, Math.Log(257 - trackBarOPJ.Value, 2));
            }
            wykres.Titles[0].Text = "Tablica LUT, a = " + a;
            for (int i = 0; i < 256; i++)
            {
                if ((a * (i - 127) + 127) > 255)
                {
                    LUT[i] = 255;
                }
                else if ((a * (i - 127) + 127) < 0)
                {
                    LUT[i] = 0;
                }
                else
                {
                    LUT[i] = (byte)(a * (i - 127) + 127);
                }
                wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
            }
            //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
            if (this.picturePierwotnyOPJ == null)
            {
                return;
            }
            //Kopiuj obrazek zrodlowy        
            Bitmap bitmap = (Bitmap)this.picturePierwotnyOPJ.Image.Clone();
            //    Bitmap bitmap1 = (Bitmap)this.picturePierwotnySzary.Image.Clone();
            this.pictureWtornyOPJ.Image = bitmap;
            //Pobierz wartosc wszystkich punktow obrazu
            BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
            byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
            System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);
            //Zmien kontrast kazdego punktu zgodnie z tablica LUT
            for (int i = 0; i < pixelValues.Length; i++)
            {
                pixelValues[i] = LUT[pixelValues[i]];
            }
            //Ustaw wartosc wszystkich punktow obrazu
            System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
            bitmap.UnlockBits(bmpData);
        }

        //BINERYZACJA
        private void trackBarBineryzacja(object sender, EventArgs e)
        {
            //Przygotuj tablice LUT i pokaz ja na wykresie
            wykres.Series[0].Points.Clear();
            byte[] LUT = new byte[256];
            int b = this.trackBarOPJ.Value;
            //  int b = this.trackBar1.Value;
            wykres.Titles[0].Text = "Tablica LUT, b = " + b;
            for (int i = 0; i < 256; i++)
            {
                if ((b + i) > 255)
                {
                    LUT[i] = 255;
                }
                else if ((b + i) < 0)
                {
                    LUT[i] = 0;
                }
                else
                {
                    LUT[i] = (byte)(b + i);
                }
                wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
            }
            //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
            if (this.picturePierwotnyOPJ.Image == null)
            {
                return;
            }
            Bitmap bitmap = (Bitmap)this.picturePierwotnyOPJ.Image.Clone();
            this.pictureWtornyOPJ.Image = bitmap;
            //Pobierz wartosc wszystkich punktow obrazu
            BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
            byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
            System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);
            //Korekcja gamma dla kazdego punktu zgodnie z tablica LUT
            for (int i = 0; i < pixelValues.Length; i++)
            {
                pixelValues[i] = LUT[pixelValues[i]];
            }
            //Ustaw wartosc wszystkich punktow obrazu
            System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
            bitmap.UnlockBits(bmpData);
        }

        private void comboBoxOPJ_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (this.pictureWtornyOPJ.Image != null)
            {
                if (this.comboBoxOPJ.Text == "Negacja")
                {
                    this.trackBarOPJ.Visible = false;
                    this.groupBoxTablicaLUT.Visible = false;
                    this.label1.Text = "Obraz wynikowy - Negacja";
                    this.pictureWtornyOPJ.Image = pictureWtornyOPJ.Image.CopyAsNegative();
                }
                else if (this.comboBoxOPJ.Text == "Kontrast")
                {
                    this.trackBarOPJ.Visible = true;
                    this.groupBoxTablicaLUT.Visible = true;
                    this.label1.Text = "Obraz wynikowy - Kontrast";
                    this.trackBarOPJ.Maximum = 255;
                    this.trackBarOPJ.Minimum = -255;
                    this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarKontrast);
                }
                else if (this.comboBoxOPJ.Text == "Jasność")
                {
                    this.trackBarOPJ.Visible = true;
                    this.groupBoxTablicaLUT.Visible = true;
                    this.label1.Text = "Obraz wynikowy - Jasność";
                    this.trackBarOPJ.Maximum = 255;
                    this.trackBarOPJ.Minimum = -255;
                    this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarJasnosc);
                }
                else if (this.comboBoxOPJ.Text == "Bineryzacja")
                {
                    Bitmap bmpR;
                    this.trackBarOPJ.Visible = true;
                    this.groupBoxTablicaLUT.Visible = true;
                    this.label1.Text = "Obraz wynikowy - Bineryzacja";
                    this.trackBarOPJ.Maximum = 255;
                    this.trackBarOPJ.Minimum = 0;
                    this.trackBarOPJ.Value = 125;
                   // this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarBineryzacja);
                    FunkcjeJednoarg fn = new FunkcjeJednoarg();
                     bmpR = (Bitmap)this.pictureWtornyOPJ.Image; //.Clone();
                 //   bmpR = fn.Bineryzacja(bmpR, trackBarOPJ.Value);
                    pictureWtornyOPJ.Refresh();

                }
                else if (this.comboBoxOPJ.Text == "Progowanie")
                {
                    this.trackBarOPJ.Visible = true;
                    this.label1.Text = "Obraz wynikowy - Progowanie";
                    //     this.pictureWtornyOPJ.Image = pictureWtornyOPJ.Image.CopyAsNegative();
                }
                else if (this.comboBoxOPJ.Text == "Rozciąganie")
                {
                    this.trackBarOPJ.Visible = true;
                    this.groupBoxTablicaLUT.Visible = true;
                    this.label1.Text = "Obraz wynikowy - Rozciąganie";
                    //    this.pictureWtornyOPJ.Image = pictureWtornyOPJ.Image.CopyAsNegative();
                }
                else if (this.comboBoxOPJ.Text == "Korekcja Gamma")
                {
                    this.trackBarOPJ.Visible = true;
                    this.groupBoxTablicaLUT.Visible = true;
                    this.label1.Text = "Obraz wynikowy - Korekcja Gamma";
                    this.trackBarOPJ.Minimum = 1;
                    this.trackBarOPJ.Maximum = 400;
                    this.trackBarOPJ.Value = 200;
                    this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarGamma);
                }
                else if (this.comboBoxOPJ.Text == "Redukcja poziomów jasności")
                {
                    this.trackBarOPJ.Visible = true;
                    this.groupBoxTablicaLUT.Visible = true;
                    this.label1.Text = "Obraz wynikowy - Redukcja poziomów jasności";
                    //  this.pictureWtornyOPJ.Image = pictureWtornyOPJ.Image.CopyAsNegative();
                }

                else if (this.comboBoxOPJ.Text == "Sepia")
                {
                    this.trackBarOPJ.Visible = false;
                    this.groupBoxTablicaLUT.Visible = false;
                    this.label1.Text = "Obraz wynikowy - Sepia";
                    this.pictureWtornyOPJ.Image = pictureWtornyOPJ.Image.CopyAsSepiaTone();
                }
                else if (this.comboBoxOPJ.Text == "Transparentny")
                {
                    this.trackBarOPJ.Visible = false;
                    this.groupBoxTablicaLUT.Visible = false;
                    this.label1.Text = "Obraz wynikowy - Transparentny";
                    this.pictureWtornyOPJ.Image = pictureWtornyOPJ.Image.CopyWithTransparency();
                }
            }
        }

        private void trackBarOPJ_Scroll(object sender, EventArgs e)
        {

        }

        private void wykres_Click(object sender, EventArgs e)
        {

        }


    }
}