﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Windows.Forms.DataVisualization.Charting;
using System.Drawing.Imaging;
using APO_BB_DK_v012013.Operacje;
using BitmapProcessing;
using System.Reflection;


namespace APO_BB_DK_v012013
{
    public partial class ObrazFDL : Form
    {
        private TrackBar suwak1;
        private OpenFileDialog open;
        public PictureBox pictureFGLwynik;
        public Bitmap bitmap;
        private Bitmap originalBitmap = null;
        private Bitmap previewBitmap = null;
        private Bitmap resultBitmap = null;
    //    private int _id = -1;
        private int[] histogram_values = new int[256];
        private int[] histogram_hsv_values = new int[256];
        private int[,] histogram_kolory_values;
        public int[,] tab;
        public int rozmiar;
        public int tryb;

        
        public bool HSV
        {   get { return _HSV; }
            set { _HSV = value; this.label5.Text = "Obraz (HSV)"; this.HistogramRGB.Visible = false; button_blue.Visible = false; button_green.Visible = false; buttpn_red.Visible = false; label5.Visible = false; button_wszystkie.Visible = false; button1.Visible = false; button3.Visible = false; label5.Visible = true; label2.Text = "1.0"; }
        }
        private bool _HSV = false;
      
        public ObrazFDL()
        {
            InitializeComponent();
            open = new OpenFileDialog();
            suwak1 = new System.Windows.Forms.TrackBar();
            this.pictureFGL.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureFGLwynik.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureObrazFL1.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureObrazFL2.SizeMode = PictureBoxSizeMode.StretchImage;
            comboBoxFGL.Items.Add("Filtry Wygładzające (FD) - Liniowa");       
            comboBoxFGL.SelectedIndex = 0;        
        }
              
        private void buttonObrazFL_Click_1(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Title = "Select the source Image";
            ofd.Filter = "Image Files(*.BMP;*.JPG;*.PNG)|*.BMP;*.JPG;*.PNG|All files (*.*)|*.*";

            if (ofd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                StreamReader streamReader = new StreamReader(ofd.FileName);
                originalBitmap = (Bitmap)Bitmap.FromStream(streamReader.BaseStream);
                streamReader.Close();
                previewBitmap = originalBitmap.CopyToSquareCanvas(pictureFGL.Width);
                this.pictureFGL.Image = previewBitmap;
                this.pictureObrazFL1.Image = originalBitmap;
              }
        }           
           
        private void buttonWidok_Click(object sender, EventArgs e)
        {
            this.pictureFGL.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureFGLwynik.SizeMode = PictureBoxSizeMode.StretchImage;

            if (this.radioNaturalny.Checked)
            {           
                this.pictureFGLwynik.SizeMode = PictureBoxSizeMode.Normal;
                this.pictureFGL.SizeMode = PictureBoxSizeMode.Normal;
            }

            if (this.radioAutoSize.Checked)
            {
                this.pictureFGL.SizeMode = PictureBoxSizeMode.CenterImage;
                this.pictureFGLwynik.SizeMode = PictureBoxSizeMode.CenterImage;
            }
            if (this.radioDopasowany.Checked)
            {
                this.pictureFGL.SizeMode = PictureBoxSizeMode.StretchImage;
                this.pictureFGLwynik.SizeMode = PictureBoxSizeMode.StretchImage;
            }
            this.pictureFGL.Refresh();
            this.pictureFGLwynik.Refresh();
        }

        public void update_view(double[,] tabela, int wymiar)
        {
            int szer = wymiar;
            double[,] tablica = tabela;
            dataGridGrey.ColumnCount = szer;
            dataGridGrey.EditMode = DataGridViewEditMode.EditProgrammatically;
            dataGridGrey.RowHeadersVisible = false;
            dataGridGrey.ColumnHeadersVisible = false;
            dataGridGrey.AutoSize = true;
            dataGridGrey.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells;
            dataGridGrey.AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.AllCells;
            string[] tab = new string[szer];
            dataGridGrey.Rows.Clear();
            for (int i = 0; i < szer; i++)
            {
                for (int j = 0; j < szer; j++)
                {
                    tab[j] = tablica[i, j].ToString();
                }
                dataGridGrey.Rows.Add(tab);
            }
            dataGridGrey.Visible = true;
        }

        public void update_viewRGB(double[,] tabela, int wymiar)
        {
            int szer = wymiar;
            double[,] tablica = tabela;
            dataGridRGB.ColumnCount = szer;
            dataGridRGB.EditMode = DataGridViewEditMode.EditProgrammatically;
            dataGridRGB.RowHeadersVisible = false;
            dataGridRGB.ColumnHeadersVisible = false;
            dataGridRGB.AutoSize = true;
            dataGridRGB.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells;
            dataGridRGB.AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.AllCells;
            string[] tab = new string[szer];
            dataGridRGB.Rows.Clear();
            for (int i = 0; i < szer; i++)
            {
                for (int j = 0; j < szer; j++)
                {
                    tab[j] = tablica[i, j].ToString();
                }
                dataGridRGB.Rows.Add(tab);
            }
            dataGridRGB.Visible = true;
        }

        public void update_viewHSV(double[,] tabela, int wymiar)
        {
            int szer = wymiar;
            double[,] tablica = tabela;
            dataGridHSV.ColumnCount = szer;
            dataGridHSV.EditMode = DataGridViewEditMode.EditProgrammatically;
            dataGridHSV.RowHeadersVisible = false;
            dataGridHSV.ColumnHeadersVisible = false;
            dataGridHSV.AutoSize = true;
            dataGridHSV.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells;
            dataGridHSV.AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.AllCells;
            string[] tab = new string[szer];
            dataGridHSV.Rows.Clear();
            for (int i = 0; i < szer; i++)
            {
                for (int j = 0; j < szer; j++)
                {
                    tab[j] = tablica[i, j].ToString();
                }
                dataGridHSV.Rows.Add(tab);
            }
            dataGridHSV.Visible = true;
        }

        private void ApplyFilter(bool preview)
        {
            if (previewBitmap == null || comboBoxFGL.SelectedIndex == -1)
            {   return;   }
            Bitmap selectedSource = null;
            Bitmap bitmapResult = null;

            if (preview == true)
            {   selectedSource = previewBitmap;  }
            else
            {   selectedSource = originalBitmap;  }

            if (selectedSource != null)
            {
                if (comboBoxFGL.SelectedItem.ToString() == "None")
                {
                    bitmapResult = selectedSource;
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Uśredniający")
                {
                    this.dataGridGrey.Visible = true;                    
                    update_view(FiltryWygladzajace.Usredniajacy, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Usredniajacy.Length))));
                    Bitmap bmpFDL;
                    int z;
                    z = Convert.ToInt32(tab);
                    bmpFDL = (Bitmap)this.pictureFGLwynik.Image; //.Clone();
                //    bmpFDL = FiltracjaLiniowa.filtracja_liniowa(bmpFDL, FiltryWygladzajace.Usredniajacy, 9,z);

                  //  FiltracjaLiniowa fDL = new FiltracjaLiniowa();
               //        public void update_view(double[,] tabela, int wymiar)
               //           public static Bitmap filtracja_liniowa(Bitmap src, int[] vals, int dzielnik, int metoda)
               //     bmpFDL = functions.filtracja_liniowa(bmpFDL, values, dzielnik,-2);
        
                    bitmapResult = selectedSource.MedianFilter(3);                 
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Kwadratowy")
                {
                    this.dataGridGrey.Visible = true;
                    update_view(FiltryWygladzajace.Kwadratowy, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Kwadratowy.Length))));
                    bitmapResult = selectedSource.MedianFilter(5);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Kołowy")
                {
                    this.dataGridGrey.Visible = true;
                    update_view(FiltryWygladzajace.Kolowy, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Kolowy.Length))));
                    bitmapResult = selectedSource.MedianFilter(7);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Piramidalny")
                {
                    this.dataGridGrey.Visible = true;
                    update_view(FiltryWygladzajace.Piramidalny, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Piramidalny.Length))));
                    bitmapResult = selectedSource.MedianFilter(9);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Stożkowy")
                {
                    this.dataGridGrey.Visible = true;
                    update_view(FiltryWygladzajace.Stozkowy, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Stozkowy.Length))));
                    bitmapResult = selectedSource.MedianFilter(11);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Gauss 3x3")
                {
                    this.dataGridGrey.Visible = true;
                    update_view(FiltryWygladzajace.Gauss_3x3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Gauss_3x3.Length))));
                    bitmapResult = selectedSource.MedianFilter(13);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Gauss 5x5 G1")
                {
                    this.dataGridGrey.Visible = true;
                    update_view(FiltryWygladzajace.Gauss_5x5_1, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Gauss_5x5_1.Length))));
                    bitmapResult = selectedSource.MedianFilter(15);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Gauss 5x5 G2")
                {
                    this.dataGridGrey.Visible = true;
                    update_view(FiltryWygladzajace.Gauss_5x5_2, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Gauss_5x5_2.Length))));
                    bitmapResult = selectedSource.MedianFilter(17);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Gauss 5x5 G3")
                {
                    this.dataGridGrey.Visible = true;
                    update_view(FiltryWygladzajace.Gauss_5x5_3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Gauss_5x5_3.Length))));
                    bitmapResult = selectedSource.MedianFilter(17);
                }
                 else if (comboBoxFGL.SelectedItem.ToString() == "Gauss 7x7")
                {
                    this.dataGridGrey.Visible = true;
                    update_view(FiltryWygladzajace.Gauss_7x7, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Gauss_7x7.Length))));
                     bitmapResult = selectedSource.MedianFilter(17);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Liniowy L1")
                {
                    this.dataGridGrey.Visible = true;
                    update_view(FiltryWygladzajace.LP_1, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.LP_1.Length))));
                    bitmapResult = selectedSource.MedianFilter(17);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Liniowy L2")
                {
                    this.dataGridGrey.Visible = true;
                    update_view(FiltryWygladzajace.LP_2, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.LP_2.Length))));
                    bitmapResult = selectedSource.MedianFilter(17);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Liniowy L3")
                {
                    this.dataGridGrey.Visible = true;
                    update_view(FiltryWygladzajace.LP_3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.LP_3.Length))));

                    bitmapResult = selectedSource.MedianFilter(17);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Własna maska")
                {
                    this.dataGridW.Visible = true;
                    this.groupFiltrGrey.Visible = false;
                    this.groupFiltrWlasna.Visible = true;
                    bitmapResult = selectedSource.MedianFilter(17);
                }
                // oBRAZ RGB
                else if (comboBoxFGL.SelectedItem.ToString() == "Uśredniający RGB")
                {
                    update_viewRGB(FiltryWygladzajace.Usredniajacy, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Usredniajacy.Length))));
                    bitmapResult = selectedSource.MedianFilter(3);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Kwadratowy RGB")
                {
                    update_viewRGB(FiltryWygladzajace.Kwadratowy, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Kwadratowy.Length))));
                    bitmapResult = selectedSource.MedianFilter(5);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Kołowy RGB")
                {
                    update_viewRGB(FiltryWygladzajace.Kolowy, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Kolowy.Length))));
                    bitmapResult = selectedSource.MedianFilter(7);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Piramidalny RGB")
                {
                    update_viewRGB(FiltryWygladzajace.Piramidalny, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Piramidalny.Length))));
                    bitmapResult = selectedSource.MedianFilter(9);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Stożkowy RGB")
                {
                    update_viewRGB(FiltryWygladzajace.Stozkowy, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Stozkowy.Length))));
                    bitmapResult = selectedSource.MedianFilter(11);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Gauss 3x3 RGB")
                {
                    update_viewRGB(FiltryWygladzajace.Gauss_3x3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Gauss_3x3.Length))));
                    bitmapResult = selectedSource.MedianFilter(13);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Gauss 5x5 G1 RGB")
                {
                    update_viewRGB(FiltryWygladzajace.Gauss_5x5_1, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Gauss_5x5_1.Length))));
                    bitmapResult = selectedSource.MedianFilter(15);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Gauss 5x5 G2 RGB")
                {
                    update_viewRGB(FiltryWygladzajace.Gauss_5x5_2, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Gauss_5x5_2.Length))));
                    bitmapResult = selectedSource.MedianFilter(17);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Gauss 5x5 G3 RGB")
                {
                    update_viewRGB(FiltryWygladzajace.Gauss_5x5_3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Gauss_5x5_3.Length))));
                    bitmapResult = selectedSource.MedianFilter(17);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Gauss 7x7 RGB")
                {
                    update_viewRGB(FiltryWygladzajace.Gauss_7x7, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Gauss_7x7.Length))));
                    bitmapResult = selectedSource.MedianFilter(17);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Liniowy L1 RGB")
                {
                    update_viewRGB(FiltryWygladzajace.LP_1, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.LP_1.Length))));
                    bitmapResult = selectedSource.MedianFilter(17);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Liniowy L2 RGB")
                {
                    update_viewRGB(FiltryWygladzajace.LP_2, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.LP_2.Length))));
                    bitmapResult = selectedSource.MedianFilter(17);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Liniowy L3 RGB")
                {
                    update_viewRGB(FiltryWygladzajace.LP_3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.LP_3.Length))));
                    bitmapResult = selectedSource.MedianFilter(17);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Własna maska RGB")
                {
                    this.dataGridW.Visible = true;
                    this.groupFiltrGrey.Visible = false;
                    this.groupFiltrWlasna.Visible = true;
                    bitmapResult = selectedSource.MedianFilter(17);
                }
              
                //OBRAZ HSV
                else if (comboBoxFGL.SelectedItem.ToString() == "Uśredniający HSV")
                {
                    update_viewHSV(FiltryWygladzajace.Usredniajacy, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Usredniajacy.Length))));
                    bitmapResult = selectedSource.MedianFilter(3);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Kwadratowy HSV")
                {
                    update_viewHSV(FiltryWygladzajace.Kwadratowy, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Kwadratowy.Length))));
                    bitmapResult = selectedSource.MedianFilter(5);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Kołowy HSV")
                {
                    update_viewHSV(FiltryWygladzajace.Kolowy, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Kolowy.Length))));
                    bitmapResult = selectedSource.MedianFilter(7);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Piramidalny HSV")
                {
                    update_viewHSV(FiltryWygladzajace.Piramidalny, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Piramidalny.Length))));
                    bitmapResult = selectedSource.MedianFilter(9);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Stożkowy HSV")
                {
                    update_viewHSV(FiltryWygladzajace.Stozkowy, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Stozkowy.Length))));
                    bitmapResult = selectedSource.MedianFilter(11);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Gauss 3x3 HSV")
                {
                    update_viewHSV(FiltryWygladzajace.Gauss_3x3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Gauss_3x3.Length))));
                    bitmapResult = selectedSource.MedianFilter(13);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Gauss 5x5 G1 HSV")
                {
                    update_viewHSV(FiltryWygladzajace.Gauss_5x5_1, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Gauss_5x5_1.Length))));
                    bitmapResult = selectedSource.MedianFilter(15);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Gauss 5x5 G2 HSV")
                {
                    update_viewHSV(FiltryWygladzajace.Gauss_5x5_2, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Gauss_5x5_2.Length))));
                    bitmapResult = selectedSource.MedianFilter(17);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Gauss 5x5 G3 HSV")
                {
                    update_viewHSV(FiltryWygladzajace.Gauss_5x5_3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Gauss_5x5_3.Length))));
                    bitmapResult = selectedSource.MedianFilter(17);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Gauss 7x7 HSV")
                {
                    update_viewHSV(FiltryWygladzajace.Gauss_7x7, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.Gauss_7x7.Length))));
                    bitmapResult = selectedSource.MedianFilter(17);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Liniowy L1 HSV")
                {
                    update_viewHSV(FiltryWygladzajace.LP_1, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.LP_1.Length))));
                    bitmapResult = selectedSource.MedianFilter(17);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Liniowy L2 HSV")
                {
                    update_viewHSV(FiltryWygladzajace.LP_2, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.LP_2.Length))));
                    bitmapResult = selectedSource.MedianFilter(17);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Liniowy L3 HSV")
                {
                    update_viewHSV(FiltryWygladzajace.LP_3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(FiltryWygladzajace.LP_3.Length))));
                    bitmapResult = selectedSource.MedianFilter(17);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Własna maska HSV")
                {
                    this.dataGridW.Visible = true;
                    this.groupFiltrGrey.Visible = false;
                    this.groupFiltrWlasna.Visible = true;
                    bitmapResult = selectedSource.MedianFilter(17);
                }               
            }      

            if (bitmapResult != null)
            {
                if (preview == true)
                {
                    pictureFGLwynik.Image = bitmapResult;
                }
                else
                {
                    resultBitmap = bitmapResult;
                }
            }
        }

        private void comboBoxFL_SelectedIndexChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void buttonKolor_Click(object sender, EventArgs e)
        {
            FunkcjeJednoarg fn = new FunkcjeJednoarg();
            comboBoxFGL.Items.Clear();
            comboBoxFGL.Items.Add ("Filtry Wygładzające (FD) - Liniowa");
            comboBoxFGL.SelectedIndex = 0;
        
            if (this.radioSzary.Checked)
            {
                comboBoxFGL.Items.Add("Uśredniający");
                comboBoxFGL.Items.Add("Kwadratowy");
                comboBoxFGL.Items.Add("Kołowy");
                comboBoxFGL.Items.Add("Piramidalny");
                comboBoxFGL.Items.Add("Stożkowy");
                comboBoxFGL.Items.Add("Gauss 3x3");
                comboBoxFGL.Items.Add("Gauss 5x5 G1");
                comboBoxFGL.Items.Add("Gauss 5x5 G2");
                comboBoxFGL.Items.Add("Gauss 5x5 G3");
                comboBoxFGL.Items.Add("Gauss 7x7");
                comboBoxFGL.Items.Add("Liniowy L1");
                comboBoxFGL.Items.Add("Liniowy L2");
                comboBoxFGL.Items.Add("Liniowy L3");
                comboBoxFGL.Items.Add("Własna maska"); 
                comboBoxFGL.SelectedIndex = 0; 
              
                this.label1.Text = "Obraz wynikowy w odcieniach szarości";
                Bitmap bmpFL = new Bitmap(this.pictureObrazFL1.Image);
                this.pictureObrazFL2.Image = bmpFL;
                bmpFL = fn.Skalaszarosci(bmpFL);
                this.pictureFGLwynik.Image = bmpFL;
                this.pictureFGL.Image = bmpFL;
                this.pictureFGLwynik.Image = bmpFL.CopyToSquareCanvas(pictureFGLwynik.Width);
                this.comboBoxFGL.Visible = true;
                this.pictureFGLwynik.Visible = true;
                previewBitmap = bmpFL.CopyToSquareCanvas(this.pictureFGL.Width);
                this.pictureFGLwynik.Image = previewBitmap;
                this.groupFiltrGrey.Visible = true;
                this.groupFiltrHSV.Visible = false;
                this.groupFiltrRGB.Visible = false;
            }

            if (this.radioKolorHVS.Checked)
            {
                comboBoxFGL.Items.Add("Uśredniający HSV");
                comboBoxFGL.Items.Add("Kwadratowy HSV");
                comboBoxFGL.Items.Add("Kołowy HSV");
                comboBoxFGL.Items.Add("Piramidalny HSV");
                comboBoxFGL.Items.Add("Stożkowy HSV");
                comboBoxFGL.Items.Add("Gauss 3x3 HSV");
                comboBoxFGL.Items.Add("Gauss 5x5 G1 HSV");
                comboBoxFGL.Items.Add("Gauss 5x5 G2 HSV");
                comboBoxFGL.Items.Add("Gauss 5x5 G3 HSV");
                comboBoxFGL.Items.Add("Gauss 7x7 HSV");
                comboBoxFGL.Items.Add("Liniowy L1 HSV");
                comboBoxFGL.Items.Add("Liniowy L2 HSV");
                comboBoxFGL.Items.Add("Liniowy L3 HSV");
                comboBoxFGL.Items.Add("Własna maska HSV"); 
                comboBoxFGL.SelectedIndex = 0; 
                
                this.label1.Text = "Obraz wynikowy kolorowy HSV";
                Bitmap bmpFLkol = new Bitmap(this.pictureObrazFL1.Image);            
                this.comboBoxFGL.Visible = true;
                this.pictureFGL.Image = bmpFLkol;
                this.pictureFGLwynik.Image = bmpFLkol;
                this.pictureFGLwynik.Visible = true;
                previewBitmap = bmpFLkol.CopyToSquareCanvas(this.pictureFGL.Width);
                this.pictureFGLwynik.Image = previewBitmap;
                this.groupFiltrGrey.Visible = false;
                this.groupFiltrHSV.Visible = true;
                this.groupFiltrRGB.Visible = false;
            }

            if (this.radioKolorRGB.Checked)
            {
                comboBoxFGL.Items.Add("Uśredniający RGB");
                comboBoxFGL.Items.Add("Kwadratowy RGB");
                comboBoxFGL.Items.Add("Kołowy RGB");
                comboBoxFGL.Items.Add("Piramidalny RGB");
                comboBoxFGL.Items.Add("Stożkowy RGB");
                comboBoxFGL.Items.Add("Gauss 3x3 RGB");
                comboBoxFGL.Items.Add("Gauss 5x5 G1 RGB");
                comboBoxFGL.Items.Add("Gauss 5x5 G2 RGB");
                comboBoxFGL.Items.Add("Gauss 5x5 G3 RGB");
                comboBoxFGL.Items.Add("Gauss 7x7 RGB");
                comboBoxFGL.Items.Add("Liniowy L1 RGB");
                comboBoxFGL.Items.Add("Liniowy L2 RGB");
                comboBoxFGL.Items.Add("Liniowy L3 RBB");
                comboBoxFGL.Items.Add("Własna maska RGB");   
                comboBoxFGL.SelectedIndex = 0; 

                this.label1.Text = "Obraz wynikowy kolorowy RGB";
                Bitmap bmpFLkol = new Bitmap(this.pictureObrazFL1.Image);            
                this.comboBoxFGL.Visible = true;
                this.pictureFGL.Image = bmpFLkol;
                this.pictureFGLwynik.Image = bmpFLkol;
                this.pictureFGLwynik.Visible = true;
                previewBitmap = bmpFLkol.CopyToSquareCanvas(this.pictureFGL.Width);
                this.pictureFGLwynik.Image = previewBitmap;
                this.groupFiltrGrey.Visible = false;
                this.groupFiltrHSV.Visible = false;
                this.groupFiltrRGB.Visible = true;
            }
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
             this.pictureFGLwynik.Image = resultBitmap;
            ApplyFilter(false);
            if (resultBitmap != null)
            {
                SaveFileDialog sfd = new SaveFileDialog();
                sfd.Title = "Specify a file name and file path";
                sfd.Filter = "Png Images(*.png)|*.png|Jpeg Images(*.jpg)|*.jpg";
                sfd.Filter += "|Bitmap Images(*.bmp)|*.bmp";

                if (sfd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                {
                    string fileExtension = Path.GetExtension(sfd.FileName).ToUpper();
                    ImageFormat imgFormat = ImageFormat.Png;

                    if (fileExtension == "BMP")
                    {
                        imgFormat = ImageFormat.Bmp;
                    }
                    else if (fileExtension == "JPG")
                    {
                        imgFormat = ImageFormat.Jpeg;
                    }
                    StreamWriter streamWriter = new StreamWriter(sfd.FileName, false);
                    resultBitmap.Save(streamWriter.BaseStream, imgFormat);
                    streamWriter.Flush();
                    streamWriter.Close();
                    resultBitmap = null;
                }
            }
        }

        private void EnableDoubleBuffered(DataGridView dgv, bool setting)
        {
            Type dgvType = dgv.GetType();
            PropertyInfo pi = dgvType.GetProperty("DoubleBuffered", BindingFlags.Instance | BindingFlags.NonPublic);
            pi.SetValue(dgv, setting, null);
        }

         private Bitmap generuj_histogram(int k)
        {
            Bitmap obrazek_bitmapa = new Bitmap(this.pictureFGLwynik.Image);
            Bitmap histogram = null;
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(obrazek_bitmapa); 
           
            if (HSV)
            {
                int histogram_max=0;      
                double h, s, v;
                fobrazek_bitmapa.LockImage();
                for (int x = 0; x < obrazek_bitmapa.Width; x++)
                {
                    for (int y = 0; y < obrazek_bitmapa.Height; y++)
                    {
                        hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y), out h, out s, out v);
                        int temp_v = (int)(v * 255.0f);
                        histogram_hsv_values[temp_v]++;
                        if (histogram_hsv_values[temp_v] > histogram_max)
                            histogram_max = histogram_hsv_values[temp_v];
                    }
                }

                fobrazek_bitmapa.UnlockImage();
                double skala = (512.0f / (double)histogram_max) * ((double)pasek_skali.Value / 10.0f);
                histogram = new Bitmap(1024, 513);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_hsv_values[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Black);
                        }                       
                    }
                }

                fhistogram.UnlockImage();
            }
            else
            {
                int[] histogram_values_tmp;
                histogram_values_tmp = new int[256];
                int histogram_max = 0;
                fobrazek_bitmapa.LockImage();
                //Zliczanie wartości histogramu
                for (int x = 0; x < obrazek_bitmapa.Width; x++)
                {
                    for (int y = 0; y < obrazek_bitmapa.Height; y++)
                    {
                        if (k == 0 || k > 2)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R]++;
                            histogram_values[fobrazek_bitmapa.GetPixel(x, y).R]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R];
                        }
                        if (k == 1)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G];
                        }
                        if (k == 2)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B];
                        }
                        if (k == 3)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B];
                        }
                    }
                }
                fobrazek_bitmapa.UnlockImage();

                float skala = (512.0f / (float)histogram_max) * ((float)pasek_skali.Value / 10.0f);

               histogram = new Bitmap(1024, 513);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                Color slupki = Color.Black;
                if (k == 0)
                    slupki = Color.Red;
                if (k == 1)
                    slupki = Color.Green;
                if (k == 2)
                    slupki = Color.Blue;

                Color tlo = Color.White;

                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_values_tmp[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), slupki);
                        }
                        else
                        {
                            //fhistogram.SetPixel(4*x1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+2, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+3, (int)(256 - y1), tlo);
                        }
                    }
                }
                fhistogram.UnlockImage();
            }
            return histogram;
        }

        private Bitmap generuj_histogram_kolory(int k)
        {
            Bitmap obrazek_bitmapa = new Bitmap(this.pictureFGLwynik.Image);
            if (histogram_kolory_values == null)
                histogram_kolory_values = new int[256,3];
            int histogram_max = 0;
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(obrazek_bitmapa);
            fobrazek_bitmapa.LockImage();
            //Zliczanie wartości histogramu
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0];
                }
            }
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1];
                }
            }
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2];
                }
            }
            fobrazek_bitmapa.UnlockImage();
            float skala = (512.0f / (float)histogram_max) ;
            Bitmap histogram = new Bitmap(1024, 513);
            BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
            fhistogram.LockImage();
            for (int x1 = 0; x1 < 256; x1++)
            {
                int tmpr = (int)(histogram_kolory_values[x1,0] * skala);
                int tmpg = (int)(histogram_kolory_values[x1,1] * skala);
                int tmpb = (int)(histogram_kolory_values[x1,2] * skala);
                //0,1,2 nie 3
                if (k < 3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpr)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Red);
                        }
                    }
                }
                //0,1,3 nie 2
                if (k < 2 || k==3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpg)
                        {
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Green);
                        }
                    }
                }
                //0,2,3 nie 1
                if (k == 0 || k > 1)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpb)
                        {
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Blue);
                        }
                    }
                }
            }
            fhistogram.UnlockImage();
            return histogram;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (this.radioSzary.Checked)
            {
            //    this.tab_histogram_Enter(this.pictureWynikHist.Image);
                this.generuj_histogram(0);
              //  this.groupHistogram.Visible = true;
            }
            if (this.radioKolorRGB.Checked)
            {
                this.HistogramRGB.Image = generuj_histogram_kolory(0);
                this.label5.Text = "rgb";
            }
            if (this.radioKolorHVS.Checked)
            { 
            
            }           
            EnableDoubleBuffered(this.dataGridTablica, true);
            int cols_width = 40;         
            Bitmap bmpTab = (Bitmap)this.pictureFGLwynik.Image;

            if (dataGridTablica.Columns.Count != bmpTab.Width || dataGridTablica.Rows.Count != bmpTab.Height)
            {
                dataGridTablica.Rows.Clear();
                dataGridTablica.Columns.Clear();
                dataGridTablica.RowHeadersWidth = 60;
                for (int x = 0; x < bmpTab.Width; x++)
                {
                    dataGridTablica.Columns.Add(null, x.ToString());
                    dataGridTablica.Columns[x].Width = cols_width;
                    dataGridTablica.Columns[x].FillWeight = 0.0000001f;
                }
                dataGridTablica.Rows.Add(bmpTab.Height);
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    dataGridTablica.Rows[y].HeaderCell.Value = y.ToString();
                }
            }
            for (int x = 0; x < bmpTab.Width; x++)
            {
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    dataGridTablica[x, y].Value = bmpTab.GetPixel(x, y).R;
                }
            } 
        }

        private void pasek_skali_Scroll(object sender, EventArgs e)
        {
            wartosc_skali.Text = ((double)pasek_skali.Value / 10.0f).ToString();
            this.HistogramGrey.Image = generuj_histogram(4);
        }

        private void buttpn_red_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(0);
        }

        private void button_green_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(1);
        }

        private void button_blue_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(2);
        }

        private void button_wszystkie_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(0);
        }

        private void button8_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(1);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(2);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(3);
        }

        private void dataGridView2_CellEndEdit(object sender, DataGridViewCellEventArgs e)
        {
            dataGridW.AutoResizeColumns();
            dataGridW.AutoResizeRows();
        }

        private void dataGridView2_CellBeginEdit(object sender, DataGridViewCellCancelEventArgs e)
        {
            dataGridW.AutoResizeColumns();
            dataGridW.AutoResizeRows();
        }

        private void dataGridView1_CellEndEdit(object sender, DataGridViewCellEventArgs e)
        {
            dataGridGrey.AutoResizeColumns();
            dataGridGrey.AutoResizeRows();
        }

        private void dataGridView1_CellBeginEdit(object sender, DataGridViewCellCancelEventArgs e)
        {
            dataGridGrey.AutoResizeColumns();
            dataGridGrey.AutoResizeRows();
        }
      
        private void buttonWybierzM_Click_1(object sender, EventArgs e)
        {
            if (this.radioBrzegiIgnor.Checked)
            {
                tryb = -1;
            }
            if (this.radioBrzegiCopy.Checked)
            {
                tryb = this.trackGrey.Value;
            }
            if (this.radioBrzegSzary.Checked)
            {
          //      this.groupGrey.Visible = true;
                tryb = 0;
            }
        }

        private void trackGrey_Scroll_1(object sender, EventArgs e)
        {
            this.labelGrey.BackColor = Color.FromArgb(trackGrey.Value, trackGrey.Value, trackGrey.Value);
            textGrey.Text = trackGrey.Value.ToString();
        }

        private void textGrey_TextChanged_1(object sender, EventArgs e)
        {
            /*
            int a;
            int pom = this.trackGrey.Value;
            try
            {
                a = Convert.ToInt32(this.textGrey.Text);
            }
            catch (FormatException)
            {
                a = pom;
            }
            if (a < 0)
                a = 0;
            else if (a > 255)
                a = 255;

            this.textGrey.Text = a.ToString();
            this.labelGrey.BackColor = Color.FromArgb(a, a, a);
            this.trackGrey.Value = a;
             */
        }

        private void trackGrey2_Scroll(object sender, EventArgs e)
        {
            this.labelGreyW.BackColor = Color.FromArgb(trackGreyW.Value, trackGreyW.Value, trackGreyW.Value);
            textGreyW.Text = trackGreyW.Value.ToString();
        }

        private void buttonWybierzMWlasna_Click(object sender, EventArgs e)
        {
            int rozmiar = Convert.ToInt32(this.maskaNR.Text);
            if (rozmiar <= 11 && rozmiar > 2)
            {              
                tab = new int[rozmiar, rozmiar];
                for (int i = 0; i < rozmiar; i++)
                {
                    for (int j = 0; j < rozmiar; j++)
                    {
                        try
                        {
                            tab[i, j] = Convert.ToInt32(dataGridGrey.Rows[i].Cells[j].Value.ToString());
                        }
                        catch (FormatException)
                        {
                            tab[i, j] = 0;
                        }
                        catch (NullReferenceException)
                        {
                            tab[i, j] = 0;
                        }
                    }
                }                    
            }
        

            if (this.radioBrzegiIgnor2.Checked)
            {   
                tryb = -1;           
            }
            if (this.radioBrzegiCopy2.Checked)
            {
                tryb = this.trackGreyW.Value;
            }
            if (this.radioBrzegiSzary2.Checked)
            {
                tryb = -2;
            }
        }

        private void maskaNR_TextChanged_1(object sender, EventArgs e)
        {

          int rozmiar = 3;
            if (maskaNR.Text != "")
            {
                try
                {
                    rozmiar = Convert.ToInt32(maskaNR.Text);
                    if (rozmiar <= 9 && rozmiar > 2)
                    {
                        dataGridW.ColumnCount = rozmiar;
                        dataGridW.RowCount = rozmiar;
                        dataGridW.EditMode = DataGridViewEditMode.EditOnEnter;
                    }
                    else
                    {
                        MessageBox.Show("Podany rozmiar maski jest nieprawidłowy (podaj wartość od 3 do 9)", "APO_BB_DK_v012013 - filtry...", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                        maskaNR.Text = "3";
                    }
                }
                catch (FormatException)
                {
                    maskaNR.Text = "3";
                    MessageBox.Show("Podaj poprawny rozmiar maski!", "APO_BB_DK_v012013 - filtry...", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
            }
        }

        private void button_green_Click_1(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(1);
        }

        private void button_blue_Click_1(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(2);
        }

        private void button_wszystkie_Click_1(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(0);
        }

        private void button8_Click_1(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(1);
        }

        private void button5_Click_1(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(3);
        }

        private void radioBrzegiSzary_CheckedChanged(object sender, EventArgs e)
        {
            if (radioBrzegSzary.Checked)
            {
                tryb = -1;       
                groupGrey.Visible = true;
            }
            else
                groupGrey.Visible = false;                                                                                                        
          }

        private void radioBrzegiSzary2_CheckedChanged(object sender, EventArgs e)
        {
             if (radioBrzegiSzary2.Checked)
            {
                tryb = -1;       
                tabWlasnaRGB.Visible = true;
            }
            else
                 tabWlasnaRGB.Visible = false;                                                                                                        
        }

        private void labelGrey_Click(object sender, EventArgs e)
        {

        }

        private void textGrey_TextChanged(object sender, EventArgs e)
        {
            /*
            int a;
            int pom = this.trackGrey.Value;
            try
            {
                a = Convert.ToInt32(this.trackGrey.Text);
            }
            catch (FormatException)
            {
                a = pom;
            }
            if (a < 0)
                a = 0;
            else if (a > 255)
                a = 255;
            trackGrey.Text = a.ToString();
            this.labelGrey.BackColor = Color.FromArgb(a, a, a);
            trackGrey.Value = a;
             */
        }

        private void trackRed_Scroll(object sender, EventArgs e)
        {

        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            if (this.radioBrzegRGB.Checked)
            {
                tryb = -1;   
                this.tabFiltryRGB.Visible = true;
            }
            else
                this.tabFiltryRGB.Visible = false;                                                                                                      
          }

        private void radioButton3_CheckedChanged(object sender, EventArgs e)
        {
        
        }

        private void trackBlue_Scroll(object sender, EventArgs e)
        {
               this.labelBlue.BackColor = Color.Blue;
            this.textBlue.Text = this.trackBlue.Value.ToString();
        }

        private void trackRed_Scroll_1(object sender, EventArgs e)
        {
             this.labelRed.BackColor = Color.Red;
            this.textRed.Text = this.trackRed.Value.ToString();
        }

        private void trackGreen_Scroll(object sender, EventArgs e)
        {
             this.labelGreen.BackColor = Color.Green;
            this.textGreen.Text = this.trackGreen.Value.ToString();
        }

        private void textBox2_TextChanged(object sender, EventArgs e)
        {

        }

        private void textBox3_TextChanged(object sender, EventArgs e)
        {

        }

        private void textGrey2_TextChanged(object sender, EventArgs e)
        {

        }

        private void button2_Click(object sender, EventArgs e)
        {
            labelBrzegRGB.BackColor = Color.FromArgb(trackRed.Value, trackGreen.Value, trackBlue.Value);
        }

        private void label14_Click(object sender, EventArgs e)
        {

        }

        private void trackRedW_Scroll(object sender, EventArgs e)
        {
            this.labelRedW.BackColor = Color.Red;
            this.textRedW.Text = this.trackRedW.Value.ToString();
        }

        private void trackGreenW_Scroll(object sender, EventArgs e)
        {
            this.labelGreenW.BackColor = Color.Green;
            this.textGreenW.Text = this.trackGreenW.Value.ToString();
        }

        private void trackBlueW_Scroll(object sender, EventArgs e)
        {
            this.labelBlueW.BackColor = Color.Blue;
            this.textBlueW.Text = this.trackBlueW.Value.ToString();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            labelBrzegRGBW.BackColor = Color.FromArgb(trackRedW.Value, trackGreenW.Value, trackBlueW.Value);
        }

        private void dataGridView1_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }
  
    
    }     
  }      
