﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Windows.Forms.DataVisualization.Charting;
using System.Drawing.Imaging;
using APO_BB_DK_v012013.Operacje;
using BitmapProcessing;
using System.Reflection;


namespace APO_BB_DK_v012013
{
    public partial class ObrazFDME : Form
    {
        private TrackBar suwak1;
        private OpenFileDialog open;
        public PictureBox pictureFGLwynik;
        public Bitmap bitmap;
        private Bitmap originalBitmap = null;
        private Bitmap previewBitmap = null;
        private Bitmap resultBitmap = null;
     //   private int _id = -1;
        private int[] histogram_values = new int[256];
        private int[] histogram_hsv_values = new int[256];
        private int[,] histogram_kolory_values;
        
        public bool HSV
        {   get { return _HSV; }
            set { _HSV = value; this.label3.Text = "Obraz (HSV)"; this.HistogramRGB.Visible = false; button_blue.Visible = false; button_green.Visible = false; buttpn_red.Visible = false; label3.Visible = false; button_wszystkie.Visible = false; button1.Visible = false; button3.Visible = false; label3.Visible = true; label2.Text = "1.0"; }
        }
        private bool _HSV = false;
      
        public ObrazFDME()
        {
            InitializeComponent();
            open = new OpenFileDialog();
            suwak1 = new System.Windows.Forms.TrackBar();
            this.pictureFGL.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureFGLwynik.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureObrazFL1.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureObrazFL2.SizeMode = PictureBoxSizeMode.StretchImage;
            comboBoxFGL.Items.Add("Filtry Wygładzające (FD) - Mediana");       
            comboBoxFGL.SelectedIndex = 0;        
        }
              
        private void buttonObrazFL_Click_1(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Title = "Select the source Image";
            ofd.Filter = "Image Files(*.BMP;*.JPG;*.PNG)|*.BMP;*.JPG;*.PNG|All files (*.*)|*.*";

            if (ofd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                StreamReader streamReader = new StreamReader(ofd.FileName);
                originalBitmap = (Bitmap)Bitmap.FromStream(streamReader.BaseStream);
                streamReader.Close();
                previewBitmap = originalBitmap.CopyToSquareCanvas(pictureFGL.Width);
                this.pictureFGL.Image = previewBitmap;
                this.pictureObrazFL1.Image = originalBitmap;
              }
        }           
           
        private void buttonWidok_Click(object sender, EventArgs e)
        {
            this.pictureFGL.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureFGLwynik.SizeMode = PictureBoxSizeMode.StretchImage;

            if (this.radioNaturalny.Checked)
            {           
                this.pictureFGLwynik.SizeMode = PictureBoxSizeMode.Normal;
                this.pictureFGL.SizeMode = PictureBoxSizeMode.Normal;
            }

            if (this.radioAutoSize.Checked)
            {
                this.pictureFGL.SizeMode = PictureBoxSizeMode.CenterImage;
                this.pictureFGLwynik.SizeMode = PictureBoxSizeMode.CenterImage;
            }
            if (this.radioDopasowany.Checked)
            {
                this.pictureFGL.SizeMode = PictureBoxSizeMode.StretchImage;
                this.pictureFGLwynik.SizeMode = PictureBoxSizeMode.StretchImage;
            }
            this.pictureFGL.Refresh();
            this.pictureFGLwynik.Refresh();
        }

        private void ApplyFilter(bool preview)
        {
            if (previewBitmap == null || comboBoxFGL.SelectedIndex == -1)
            {   return;   }

            Bitmap selectedSource = null;
            Bitmap bitmapResult = null;

            if (preview == true)
            {   selectedSource = previewBitmap;  }
            else
            {   selectedSource = originalBitmap;  }

            if (selectedSource != null)
            {
                if (comboBoxFGL.SelectedItem.ToString() == "None")
                {
                    bitmapResult = selectedSource;
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Operacja Medianowa 3x3")
                {
                    bitmapResult = selectedSource.MedianFilter(3);                 
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Operacja Medianowa 5x5")
                {
                    bitmapResult = selectedSource.MedianFilter(5);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Operacja Medianowa 7x7")
                {
                    bitmapResult = selectedSource.MedianFilter(7);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Operacja Medianowa 9x9")
                {
                    bitmapResult = selectedSource.MedianFilter(9);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Operacja Medianowa 11x11")
                {
                    bitmapResult = selectedSource.MedianFilter(11);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Operacja Medianowa 13x13")
                {
                    bitmapResult = selectedSource.MedianFilter(13);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Operacja Medianowa 15x15")
                {
                    bitmapResult = selectedSource.MedianFilter(15);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Operacja Medianowa 17x17")
                {
                    bitmapResult = selectedSource.MedianFilter(17);
                }
                // oBRAZ RGB
                else if (comboBoxFGL.SelectedItem.ToString() == "Operacja Medianowa 3x3 RGB")
                {
                    bitmapResult = selectedSource.MedianFilter(3);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Operacja Medianowa 5x5 RGB")
                {
                    bitmapResult = selectedSource.MedianFilter(5);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Operacja Medianowa 7x7 RGB")
                {
                    bitmapResult = selectedSource.MedianFilter(7);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Operacja Medianowa 9x9 RGB")
                {
                    bitmapResult = selectedSource.MedianFilter(9);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Operacja Medianowa 11x11 RGB")
                {
                    bitmapResult = selectedSource.MedianFilter(11);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Operacja Medianowa 13x13 RGB")
                {
                    bitmapResult = selectedSource.MedianFilter(13);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Operacja Medianowa 15x15 RGB")
                {
                    bitmapResult = selectedSource.MedianFilter(15);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Operacja Medianowa 17x17 RGB")
                {
                    bitmapResult = selectedSource.MedianFilter(17);
                }
                //OBRAZ HSV
                else if (comboBoxFGL.SelectedItem.ToString() == "Operacja Medianowa 3x3 HSV")
                {
                    bitmapResult = selectedSource.MedianFilter(3);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Operacja Medianowa 5x5 HSV")
                {
                    bitmapResult = selectedSource.MedianFilter(5);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Operacja Medianowa 7x7 HSV")
                {
                    bitmapResult = selectedSource.MedianFilter(7);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Operacja Medianowa 9x9 HSV")
                {
                    bitmapResult = selectedSource.MedianFilter(9);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Operacja Medianowa 11x11 HSV")
                {
                    bitmapResult = selectedSource.MedianFilter(11);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Operacja Medianowa 13x13 HSV")
                {
                    bitmapResult = selectedSource.MedianFilter(13);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Operacja Medianowa 15x15 HSV")
                {
                    bitmapResult = selectedSource.MedianFilter(15);
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Operacja Medianowa 17x17 HSV")
                {
                    bitmapResult = selectedSource.MedianFilter(17);
                }
            }      

            if (bitmapResult != null)
            {
                if (preview == true)
                {
                    pictureFGLwynik.Image = bitmapResult;
                }
                else
                {
                    resultBitmap = bitmapResult;
                }
            }
        }

        private void comboBoxFL_SelectedIndexChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void buttonKolor_Click(object sender, EventArgs e)
        {
            FunkcjeJednoarg fn = new FunkcjeJednoarg();
            comboBoxFGL.Items.Clear();
            comboBoxFGL.Items.Add ("Filtry Wygładzające (FD) - Mediana");
            comboBoxFGL.SelectedIndex = 0;
        
            if (this.radioSzary.Checked)
            {
                comboBoxFGL.Items.Add("Operacja Medianowa 3x3");
                comboBoxFGL.Items.Add("Operacja Medianowa 3x5");
                comboBoxFGL.Items.Add("Operacja Medianowa 5x5");
                comboBoxFGL.Items.Add("Operacja Medianowa 7x7");
                comboBoxFGL.Items.Add("Operacja Medianowa 9x9");
                comboBoxFGL.Items.Add("Operacja Medianowa 11x11");
                comboBoxFGL.Items.Add("Operacja Medianowa 13x13");
                comboBoxFGL.Items.Add("peracja Medianowa 15x15");
                comboBoxFGL.Items.Add("Operacja Medianowa 17x17"); 
                comboBoxFGL.SelectedIndex = 0; 
              
                this.label1.Text = "Obraz wynikowy w odcieniach szarości";
                Bitmap bmpFL = new Bitmap(this.pictureObrazFL1.Image);
                this.pictureObrazFL2.Image = bmpFL;
                bmpFL = fn.Skalaszarosci(bmpFL);
                this.pictureFGLwynik.Image = bmpFL;
                this.pictureFGL.Image = bmpFL;
                this.pictureFGLwynik.Image = bmpFL.CopyToSquareCanvas(pictureFGLwynik.Width);
                this.comboBoxFGL.Visible = true;
                this.pictureFGLwynik.Visible = true;
                previewBitmap = bmpFL.CopyToSquareCanvas(this.pictureFGL.Width);
                this.pictureFGLwynik.Image = previewBitmap;
            }

            if (this.radioKolorHVS.Checked)
            {
                comboBoxFGL.Items.Add("Operacja Medianowa 3x3 HSV");
                comboBoxFGL.Items.Add("Operacja Medianowa 3x5 HSV");
                comboBoxFGL.Items.Add("Operacja Medianowa 5x5 HSV");
                comboBoxFGL.Items.Add("Operacja Medianowa 7x7 HSV");
                comboBoxFGL.Items.Add("Operacja Medianowa 9x9 HSV");
                comboBoxFGL.Items.Add("Operacja Medianowa 11x11 HSV");
                comboBoxFGL.Items.Add("Operacja Medianowa 13x13 HSV");
                comboBoxFGL.Items.Add("peracja Medianowa 15x15 HSV");
                comboBoxFGL.Items.Add("Operacja Medianowa 17x17 HSV"); 
                comboBoxFGL.SelectedIndex = 0; 
                
                this.label1.Text = "Obraz wynikowy kolorowy HSV";
                Bitmap bmpFLkol = new Bitmap(this.pictureObrazFL1.Image);            
                this.comboBoxFGL.Visible = true;
                this.pictureFGL.Image = bmpFLkol;
                this.pictureFGLwynik.Image = bmpFLkol;
                this.pictureFGLwynik.Visible = true;
                previewBitmap = bmpFLkol.CopyToSquareCanvas(this.pictureFGL.Width);
                this.pictureFGLwynik.Image = previewBitmap; 
            }

            if (this.radioKolorRGB.Checked)
            {
                comboBoxFGL.Items.Add("Operacja Medianowa 3x3 RGB");
                comboBoxFGL.Items.Add("Operacja Medianowa 3x5 RGB");
                comboBoxFGL.Items.Add("Operacja Medianowa 5x5 RGB");
                comboBoxFGL.Items.Add("Operacja Medianowa 7x7 RGB");
                comboBoxFGL.Items.Add("Operacja Medianowa 9x9 RGB");
                comboBoxFGL.Items.Add("Operacja Medianowa 11x11 RGB");
                comboBoxFGL.Items.Add("Operacja Medianowa 13x13 RGB");
                comboBoxFGL.Items.Add("peracja Medianowa 15x15 RGB");
                comboBoxFGL.Items.Add("Operacja Medianowa 17x17 RGB");  
                comboBoxFGL.SelectedIndex = 0; 

                this.label1.Text = "Obraz wynikowy kolorowy RGB";
                Bitmap bmpFLkol = new Bitmap(this.pictureObrazFL1.Image);            
                this.comboBoxFGL.Visible = true;
                this.pictureFGL.Image = bmpFLkol;
                this.pictureFGLwynik.Image = bmpFLkol;
                this.pictureFGLwynik.Visible = true;
                previewBitmap = bmpFLkol.CopyToSquareCanvas(this.pictureFGL.Width);
                this.pictureFGLwynik.Image = previewBitmap;   
            }
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
             this.pictureFGLwynik.Image = resultBitmap;
            ApplyFilter(false);
            if (resultBitmap != null)
            {
                SaveFileDialog sfd = new SaveFileDialog();
                sfd.Title = "Specify a file name and file path";
                sfd.Filter = "Png Images(*.png)|*.png|Jpeg Images(*.jpg)|*.jpg";
                sfd.Filter += "|Bitmap Images(*.bmp)|*.bmp";

                if (sfd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                {
                    string fileExtension = Path.GetExtension(sfd.FileName).ToUpper();
                    ImageFormat imgFormat = ImageFormat.Png;

                    if (fileExtension == "BMP")
                    {
                        imgFormat = ImageFormat.Bmp;
                    }
                    else if (fileExtension == "JPG")
                    {
                        imgFormat = ImageFormat.Jpeg;
                    }
                    StreamWriter streamWriter = new StreamWriter(sfd.FileName, false);
                    resultBitmap.Save(streamWriter.BaseStream, imgFormat);
                    streamWriter.Flush();
                    streamWriter.Close();
                    resultBitmap = null;
                }
            }
        }

        private void EnableDoubleBuffered(DataGridView dgv, bool setting)
        {
            Type dgvType = dgv.GetType();
            PropertyInfo pi = dgvType.GetProperty("DoubleBuffered", BindingFlags.Instance | BindingFlags.NonPublic);
            pi.SetValue(dgv, setting, null);
        }

         private Bitmap generuj_histogram(int k)
        {
            Bitmap obrazek_bitmapa = new Bitmap(this.pictureFGLwynik.Image);
            Bitmap histogram = null;
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(obrazek_bitmapa); 
           
            if (HSV)
            {
                int histogram_max=0;      
                double h, s, v;
                fobrazek_bitmapa.LockImage();
                for (int x = 0; x < obrazek_bitmapa.Width; x++)
                {
                    for (int y = 0; y < obrazek_bitmapa.Height; y++)
                    {
                        hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y), out h, out s, out v);
                        int temp_v = (int)(v * 255.0f);
                        histogram_hsv_values[temp_v]++;
                        if (histogram_hsv_values[temp_v] > histogram_max)
                            histogram_max = histogram_hsv_values[temp_v];
                    }
                }

                fobrazek_bitmapa.UnlockImage();
                double skala = (512.0f / (double)histogram_max) * ((double)pasek_skali.Value / 10.0f);
                histogram = new Bitmap(1024, 513);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_hsv_values[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Black);
                        }                       
                    }
                }

                fhistogram.UnlockImage();
            }
            else
            {
                int[] histogram_values_tmp;
                histogram_values_tmp = new int[256];
                int histogram_max = 0;
                fobrazek_bitmapa.LockImage();
                //Zliczanie wartości histogramu
                for (int x = 0; x < obrazek_bitmapa.Width; x++)
                {
                    for (int y = 0; y < obrazek_bitmapa.Height; y++)
                    {
                        if (k == 0 || k > 2)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R]++;
                            histogram_values[fobrazek_bitmapa.GetPixel(x, y).R]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R];
                        }
                        if (k == 1)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G];
                        }
                        if (k == 2)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B];
                        }
                        if (k == 3)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B];
                        }
                    }
                }
                fobrazek_bitmapa.UnlockImage();

                float skala = (512.0f / (float)histogram_max) * ((float)pasek_skali.Value / 10.0f);

               histogram = new Bitmap(1024, 513);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                Color slupki = Color.Black;
                if (k == 0)
                    slupki = Color.Red;
                if (k == 1)
                    slupki = Color.Green;
                if (k == 2)
                    slupki = Color.Blue;

                Color tlo = Color.White;

                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_values_tmp[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), slupki);
                        }
                        else
                        {
                            //fhistogram.SetPixel(4*x1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+2, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+3, (int)(256 - y1), tlo);
                        }
                    }
                }

                fhistogram.UnlockImage();
            }
            return histogram;
        }

        private Bitmap generuj_histogram_kolory(int k)
        {
            Bitmap obrazek_bitmapa = new Bitmap(this.pictureFGLwynik.Image);
            if (histogram_kolory_values == null)
                histogram_kolory_values = new int[256,3];
            int histogram_max = 0;
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(obrazek_bitmapa);
            fobrazek_bitmapa.LockImage();
            //Zliczanie wartości histogramu
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0];
                }
            }
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1];
                }
            }
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2];
                }
            }
            fobrazek_bitmapa.UnlockImage();
            float skala = (512.0f / (float)histogram_max) ;
            Bitmap histogram = new Bitmap(1024, 513);
            BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
            fhistogram.LockImage();
            for (int x1 = 0; x1 < 256; x1++)
            {
                int tmpr = (int)(histogram_kolory_values[x1,0] * skala);
                int tmpg = (int)(histogram_kolory_values[x1,1] * skala);
                int tmpb = (int)(histogram_kolory_values[x1,2] * skala);
                //0,1,2 nie 3
                if (k < 3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpr)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Red);
                        }
                    }
                }
                //0,1,3 nie 2
                if (k < 2 || k==3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpg)
                        {
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Green);
                        }
                    }
                }
                //0,2,3 nie 1
                if (k == 0 || k > 1)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpb)
                        {
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Blue);
                        }
                    }
                }
            }
            fhistogram.UnlockImage();
            return histogram;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (this.radioSzary.Checked)
            {
                this.generuj_histogram(0);
            }
            if (this.radioKolorRGB.Checked)
            {
                this.HistogramRGB.Image = generuj_histogram_kolory(0);
                this.label3.Text = "rgb";
            }
            if (this.radioKolorHVS.Checked)
            { 
            
            }           
            EnableDoubleBuffered(this.dataGridTablica, true);
            int cols_width = 40;         
            Bitmap bmpTab = (Bitmap)this.pictureFGLwynik.Image;

            if (dataGridTablica.Columns.Count != bmpTab.Width || dataGridTablica.Rows.Count != bmpTab.Height)
            {
                dataGridTablica.Rows.Clear();
                dataGridTablica.Columns.Clear();
                dataGridTablica.RowHeadersWidth = 60;
                for (int x = 0; x < bmpTab.Width; x++)
                {
                    dataGridTablica.Columns.Add(null, x.ToString());
                    dataGridTablica.Columns[x].Width = cols_width;
                    dataGridTablica.Columns[x].FillWeight = 0.0000001f;
                }
                dataGridTablica.Rows.Add(bmpTab.Height);
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    dataGridTablica.Rows[y].HeaderCell.Value = y.ToString();
                }
            }
            for (int x = 0; x < bmpTab.Width; x++)
            {
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    dataGridTablica[x, y].Value = bmpTab.GetPixel(x, y).R;
                }
            } 
        }

        private void pasek_skali_Scroll(object sender, EventArgs e)
        {
            wartosc_skali.Text = ((double)pasek_skali.Value / 10.0f).ToString();
            this.HistogramGrey.Image = generuj_histogram(4);
        }

        private void buttpn_red_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(0);
        }

        private void button_green_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(1);
        }

        private void button_blue_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(2);
        }

        private void button_wszystkie_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(0);
        }

        private void button8_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(1);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(2);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(3);
        }

        private void label1_Click(object sender, EventArgs e)
        {

        }

        private void button3_Click_1(object sender, EventArgs e)
        {

        }

        private void pictureFGLwynik_Click(object sender, EventArgs e)
        {

        }
       
  }      
}