﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Windows.Forms.DataVisualization.Charting;
using System.Drawing.Imaging;
using APO_BB_DK_v012013.Operacje;
using BitmapProcessing;
using System.Reflection;


namespace APO_BB_DK_v012013
{
    public partial class ObrazFGG : Form
    {
        #region deklaracja zmiennych
        private TrackBar suwak1;
        private OpenFileDialog open;
        public PictureBox pictureFGGwynik;
        public Bitmap bitmap;

        private Bitmap originalBitmap = null;
        private Bitmap previewBitmap = null;
        private Bitmap resultBitmap = null;

    //    private int _id = -1;
        private int[] histogram_values = new int[256];
        private int[] histogram_hsv_values = new int[256];
        private int[,] histogram_kolory_values;
        #endregion

        public bool HSV
        {
            get { return _HSV; }
            set { _HSV = value; this.label5.Text = "Obraz (HSV)"; this.HistogramRGB.Visible = false; button_blue.Visible = false; button_green.Visible = false; buttpn_red.Visible = false; label5.Visible = false; button_wszystkie.Visible = false; button1.Visible = false; button3.Visible = false; label5.Visible = true; label2.Text = "1.0"; }
        }
        private bool _HSV = false;
      
        public ObrazFGG()
        {
            InitializeComponent();
            open = new OpenFileDialog();
            suwak1 = new System.Windows.Forms.TrackBar();
            this.pictureFGG.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureFGGwynik.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureObrazFL1.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureObrazFL2.SizeMode = PictureBoxSizeMode.StretchImage;       
            comboBoxFGG.Items.Add("Filtry Wyostrzające (FG) - Gradientowa");           
            comboBoxFGG.SelectedIndex = 0;        
        }
        
        private void buttonObrazFL_Click_1(object sender, EventArgs e)
        {
            #region otwieranie obrazu z pliku
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Title = "Select the source Image";
            ofd.Filter = "Image Files(*.BMP;*.JPG;*.PNG)|*.BMP;*.JPG;*.PNG|All files (*.*)|*.*";

            if (ofd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                StreamReader streamReader = new StreamReader(ofd.FileName);
                originalBitmap = (Bitmap)Bitmap.FromStream(streamReader.BaseStream);
                streamReader.Close();
                previewBitmap = originalBitmap.CopyToSquareCanvas(pictureFGG.Width);
                this.pictureFGG.Image = previewBitmap;
                this.pictureObrazFL1.Image = originalBitmap;
            }
            #endregion
        }
        
        private void buttonWidok_Click(object sender, EventArgs e)
        {
            #region widok wczytanego obrazu
            this.pictureFGG.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureFGGwynik.SizeMode = PictureBoxSizeMode.StretchImage;

            if (this.radioNaturalny.Checked)
            {           
                this.pictureFGGwynik.SizeMode = PictureBoxSizeMode.Normal;
                this.pictureFGG.SizeMode = PictureBoxSizeMode.Normal;
            }

            if (this.radioAutoSize.Checked)
            {
                this.pictureFGG.SizeMode = PictureBoxSizeMode.CenterImage;
                this.pictureFGGwynik.SizeMode = PictureBoxSizeMode.CenterImage;
            }
            if (this.radioDopasowany.Checked)
            {
                this.pictureFGG.SizeMode = PictureBoxSizeMode.StretchImage;
                this.pictureFGGwynik.SizeMode = PictureBoxSizeMode.StretchImage;
            }
            this.pictureFGG.Refresh();
            this.pictureFGGwynik.Refresh();
            #endregion
        }

        //AKTYWACJA FILTRA - COMBOBOXA
        private void ApplyFilter(bool preview)
        {
            if (previewBitmap == null || comboBoxFGG.SelectedIndex == -1)
            {   return; }

            Bitmap selectedSource = null;
            Bitmap bitmapResult = null;

            if (preview == true)
            {  selectedSource = previewBitmap;   }
            else
            {   selectedSource = originalBitmap;  }

            if (selectedSource != null)
            {
                if (comboBoxFGG.SelectedItem.ToString() == "None")
                {
                    bitmapResult = selectedSource;
                    this.dataGridView1.Visible = false;
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Gradient Roberts")
                {
                    bitmapResult = selectedSource.Roberts_Filter();
                    groupBox3.Visible = true;
                    this.dataGridM1.Visible = true;
                    this.dataGridM2.Visible = true;
                    update_view1(Matrix.Roberts_1, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Roberts_1.Length))));
                    update_view2(Matrix.Roberts_2, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Roberts_2.Length))));
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Gradient Prewitta")
                {
                    bitmapResult = selectedSource.Roberts_Filter();
                    groupBox3.Visible = true;
                    this.dataGridM1.Visible = true;
                    this.dataGridM2.Visible = true;
                    update_view1(Matrix.Prewitta_1, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_1.Length))));
                    update_view2(Matrix.Prewitta_2, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_2.Length))));
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Gradient Prewitta RGB")
                {
                    bitmapResult = selectedSource.Roberts_Filter();
                    groupBox3.Visible = true;
                    this.dataGridM1.Visible = true;
                    this.dataGridM2.Visible = true;
                    update_view1(Matrix.Prewitta_1, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_1.Length))));
                    update_view2(Matrix.Prewitta_2, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_2.Length))));
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Gradient Prewitta HSV")
                {
                    bitmapResult = selectedSource.Roberts_Filter();
                    groupBox3.Visible = true;
                    this.dataGridM1.Visible = true;
                    this.dataGridM2.Visible = true;
                    update_view1(Matrix.Prewitta_1, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_1.Length))));
                    update_view2(Matrix.Prewitta_2, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_2.Length))));
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Gradient Sobel")
                {
                    bitmapResult = selectedSource.Sobel_Filter();
                    groupBox3.Visible = true;
                    this.dataGridM1.Visible = true;
                    this.dataGridM2.Visible = true;
                    update_view1(Matrix.Sobela_1, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Sobela_1.Length))));
                    update_view2(Matrix.Sobela_2, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Sobela_2.Length))));
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Gradient Sobel HSV")
                {
                    bitmapResult = selectedSource.Sobel_Filter();
                    groupBox3.Visible = true;
                    this.dataGridM1.Visible = true;
                    this.dataGridM2.Visible = true;
                    update_view1(Matrix.Sobela_1, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Sobela_1.Length))));
                    update_view2(Matrix.Sobela_2, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Sobela_2.Length))));
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Gradient Sobel RGB")
                {
                    bitmapResult = selectedSource.Sobel_Filter();
                    groupBox3.Visible = true;
                    this.dataGridM1.Visible = true;
                    this.dataGridM2.Visible = true;
                    update_view1(Matrix.Sobela_1, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Sobela_1.Length))));
                    update_view2(Matrix.Sobela_2, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Sobela_2.Length))));
                }

                // OBRAZY W ODCIENIACH SZAROŚCI
                else if (comboBoxFGG.SelectedItem.ToString() == "Sobel")
                {
                    bitmapResult = selectedSource.Sobel3x3Filter(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Sobel3x3Horizontal, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Sobel3x3Horizontal.Length))));
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Sobel Horizontal")
                {
                    bitmapResult = selectedSource.Sobel_H(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Sobel3x3Horizontal, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Sobel3x3Horizontal.Length))));
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Sobel Vertical")
                {
                    bitmapResult = selectedSource.Sobel_V(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Sobel3x3Vertical, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Sobel3x3Vertical.Length))));
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta")
                {
                    bitmapResult = selectedSource.PrewittFilter(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_N, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_N.Length))));
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta N")
                {
                    bitmapResult = selectedSource.Prewitta_N(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_N, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_N.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta NE")
                {
                    bitmapResult = selectedSource.Prewitta_NE(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_NE, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_NE.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta E")
                {
                    bitmapResult = selectedSource.Prewitta_E(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_E, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_E.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta SE")
                {
                    bitmapResult = selectedSource.Prewitta_SE(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_SE, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_SE.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta S")
                {
                    bitmapResult = selectedSource.Prewitta_S(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_S, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_S.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta SW")
                {
                    bitmapResult = selectedSource.Prewitta_SW(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_SW, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_SW.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta W")
                {
                    bitmapResult = selectedSource.Prewitta_W(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_W, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_W.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta NW")
                {
                    bitmapResult = selectedSource.Prewitta_NW(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_NW, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_NW.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha")
                {
                    bitmapResult = selectedSource.KirschFilter(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_N, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_N.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha N")
                {
                    bitmapResult = selectedSource.Kirscha_N(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_N, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_N.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha NE")
                {
                    bitmapResult = selectedSource.Kirscha_NE(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_NE, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_NE.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha E")
                {
                    bitmapResult = selectedSource.Kirscha_E(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_E, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_E.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha SE")
                {
                    bitmapResult = selectedSource.Kirscha_SE(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_SE, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_SE.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha S")
                {
                    bitmapResult = selectedSource.Kirscha_S(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_S, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_S.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha SW")
                {
                    bitmapResult = selectedSource.Kirscha_SW(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_SW, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_SW.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha W")
                {
                    bitmapResult = selectedSource.Kirscha_W(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_W, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_W.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha NW")
                {
                    bitmapResult = selectedSource.Kirscha_NW(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_NW, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_NW.Length))));
                }
                //OBRAZ - KOLOR RGB
                else if (comboBoxFGG.SelectedItem.ToString() == "Gradient Roberts RGB")
                {
                    bitmapResult = selectedSource.Roberts_Filter();
                    groupBox3.Visible = true;
                    this.dataGridM1.Visible = true;
                    this.dataGridM2.Visible = true;
                    update_view1(Matrix.Roberts_1, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Roberts_1.Length))));
                    update_view2(Matrix.Roberts_2, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Roberts_2.Length))));
                }
                
                else if (comboBoxFGG.SelectedItem.ToString() == "Sobel RGB")
                {
                    bitmapResult = selectedSource.Sobel3x3Filter(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Sobel3x3Horizontal, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Sobel3x3Horizontal.Length))));
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Sobel Horizontal RGB")
                {
                    bitmapResult = selectedSource.Sobel_H(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Sobel3x3Horizontal, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Sobel3x3Horizontal.Length))));
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Sobel Vertical RGB")
                {
                    bitmapResult = selectedSource.Sobel_V(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Sobel3x3Vertical, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Sobel3x3Vertical.Length))));
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta RGB")
                {
                    bitmapResult = selectedSource.PrewittFilter(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_N, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_N.Length))));
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta N RGB")
                {
                    bitmapResult = selectedSource.Prewitta_N(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_N, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_N.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta NE RGB")
                {
                    bitmapResult = selectedSource.Prewitta_NE(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_NE, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_NE.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta E RGB")
                {
                    bitmapResult = selectedSource.Prewitta_E(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_E, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_E.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta SE RGB")
                {
                    bitmapResult = selectedSource.Prewitta_SE(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_SE, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_SE.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta S RGB")
                {
                    bitmapResult = selectedSource.Prewitta_S(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_S, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_S.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta SW RGB")
                {
                    bitmapResult = selectedSource.Prewitta_SW(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_SW, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_SW.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta W RGB")
                {
                    bitmapResult = selectedSource.Prewitta_W(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_W, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_W.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta NW RGB")
                {
                    bitmapResult = selectedSource.Prewitta_NW(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_NW, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_NW.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha RGB")
                {
                    bitmapResult = selectedSource.KirschFilter(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_N, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_N.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha N RGB")
                {
                    bitmapResult = selectedSource.Kirscha_N(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_N, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_N.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha NE RGB")
                {
                    bitmapResult = selectedSource.Kirscha_NE(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_NE, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_NE.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha E RGB")
                {
                    bitmapResult = selectedSource.Kirscha_E(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_E, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_E.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha SE RGB")
                {
                    bitmapResult = selectedSource.Kirscha_SE(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_SE, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_SE.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha S RGB")
                {
                    bitmapResult = selectedSource.Kirscha_S(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_S, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_S.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha SW RGB")
                {
                    bitmapResult = selectedSource.Kirscha_SW(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_SW, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_SW.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha W RGB")
                {
                    bitmapResult = selectedSource.Kirscha_W(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_W, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_W.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha NW RGB")
                {
                    bitmapResult = selectedSource.Kirscha_NW(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_NW, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_NW.Length))));
                }
                //OBRAZY KOLOR HSV
                else if (comboBoxFGG.SelectedItem.ToString() == "Gradient Roberts HSV")
                {
                    bitmapResult = selectedSource.Roberts_Filter();
                    groupBox3.Visible = true;
                    this.dataGridM1.Visible = true;
                    this.dataGridM2.Visible = true;
                    update_view1(Matrix.Roberts_1, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Roberts_1.Length))));
                    update_view2(Matrix.Roberts_2, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Roberts_2.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Sobel HSV")
                {
                    bitmapResult = selectedSource.Sobel3x3Filter(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Sobel3x3Horizontal, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Sobel3x3Horizontal.Length))));
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Sobel Horizontal HSV ")
                {
                    bitmapResult = selectedSource.Sobel_H(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Sobel3x3Horizontal, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Sobel3x3Horizontal.Length))));
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Sobel Vertical HSV")
                {
                    bitmapResult = selectedSource.Sobel_V(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Sobel3x3Vertical, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Sobel3x3Vertical.Length))));
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta HSV")
                {
                    bitmapResult = selectedSource.PrewittFilter(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_N, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_N.Length))));
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta N HSV")
                {
                    bitmapResult = selectedSource.Prewitta_N(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_N, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_N.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta NE HSV")
                {
                    bitmapResult = selectedSource.Prewitta_NE(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_NE, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_NE.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta E HSV")
                {
                    bitmapResult = selectedSource.Prewitta_E(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_E, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_E.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta SE HSV")
                {
                    bitmapResult = selectedSource.Prewitta_SE(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_SE, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_SE.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta S HSV")
                {
                    bitmapResult = selectedSource.Prewitta_S(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_S, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_S.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta SW HSV")
                {
                    bitmapResult = selectedSource.Prewitta_SW(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_SW, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_SW.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta W HSV")
                {
                    bitmapResult = selectedSource.Prewitta_W(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_W, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_W.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Prewitta NW HSV")
                {
                    bitmapResult = selectedSource.Prewitta_NW(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Prewitta_NW, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Prewitta_NW.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha HSV")
                {
                    bitmapResult = selectedSource.KirschFilter(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_N, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_N.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha N HSV")
                {
                    bitmapResult = selectedSource.Kirscha_N(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_N, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_N.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha NE HSV")
                {
                    bitmapResult = selectedSource.Kirscha_NE(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_NE, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_NE.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha E HSV")
                {
                    bitmapResult = selectedSource.Kirscha_E(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_E, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_E.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha SE HSV")
                {
                    bitmapResult = selectedSource.Kirscha_SE(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_SE, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_SE.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha S HSV")
                {
                    bitmapResult = selectedSource.Kirscha_S(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_S, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_S.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha SW HSV")
                {
                    bitmapResult = selectedSource.Kirscha_SW(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_SW, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_SW.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha W HSV")
                {
                    bitmapResult = selectedSource.Kirscha_W(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_W, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_W.Length))));
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Kirscha NW HSV")
                {
                    bitmapResult = selectedSource.Kirscha_NW(false);
                    this.dataGridView1.Visible = true;
                    update_view(Matrix.Kirscha_NW, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Kirscha_NW.Length))));
                }
            }

            if (bitmapResult != null)
            {
                if (preview == true)
                {
                    pictureFGGwynik.Image = bitmapResult;
                }
                else
                {   resultBitmap = bitmapResult; }
            }
        }

        private void comboBoxFL_SelectedIndexChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        public void update_view(double[,] tabela, int wymiar)
        {
            #region update_view2 - wyswietlenie Maski
            int szer = wymiar;
            double[,] tablica = tabela;
            dataGridView1.ColumnCount = szer;
            dataGridView1.EditMode = DataGridViewEditMode.EditProgrammatically;
            dataGridView1.RowHeadersVisible = false;
            dataGridView1.ColumnHeadersVisible = false;
            dataGridView1.AutoSize = true;
            dataGridView1.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells;
            dataGridView1.AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.AllCells;

            string[] tab = new string[szer];
            dataGridView1.Rows.Clear();
            for (int i = 0; i < szer; i++)
            {
                for (int j = 0; j < szer; j++)
                {
                    tab[j] = tablica[i, j].ToString();
                }
                dataGridView1.Rows.Add(tab);
            }

            dataGridView1.Visible = true;
            #endregion
        }

        public void update_view2(double[,] tabela, int wymiar)
        {
            #region update_view2 - wyswietlenie Maski 2
            int szer = wymiar;
            double[,] tablica = tabela;
            dataGridM2.ColumnCount = szer;
            dataGridM2.EditMode = DataGridViewEditMode.EditProgrammatically;
            dataGridM2.RowHeadersVisible = false;
            dataGridM2.ColumnHeadersVisible = false;
            dataGridM2.AutoSize = true;
            dataGridM2.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells;
            dataGridM2.AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.AllCells;

            string[] tab = new string[szer];
            dataGridM2.Rows.Clear();
            for (int i = 0; i < szer; i++)
            {
                for (int j = 0; j < szer; j++)
                {
                    tab[j] = tablica[i, j].ToString();
                }
                dataGridM2.Rows.Add(tab);
            }
            dataGridM2.Visible = true;
            #endregion
        }

        public void update_view1(double[,] tabela, int wymiar)
        {
            #region update_view2 - wyswietlenie Maski 1
            int szer = wymiar;
            double[,] tablica = tabela;
            dataGridM1.ColumnCount = szer;
            dataGridM1.EditMode = DataGridViewEditMode.EditProgrammatically;
            dataGridM1.RowHeadersVisible = false;
            dataGridM1.ColumnHeadersVisible = false;
            dataGridM1.AutoSize = true;
            dataGridM1.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells;
            dataGridM1.AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.AllCells;

            string[] tab = new string[szer];
            dataGridM1.Rows.Clear();
            for (int i = 0; i < szer; i++)
            {
                for (int j = 0; j < szer; j++)
                {
                    tab[j] = tablica[i, j].ToString();
                }
                dataGridM1.Rows.Add(tab);
            }
            dataGridM1.Visible = true;
            #endregion
        } 



        private void buttonKolor_Click(object sender, EventArgs e)
        {
            FunkcjeJednoarg fn = new FunkcjeJednoarg();
            comboBoxFGG.Items.Clear();
            comboBoxFGG.Items.Add("Filtry Wyostrzające (FG) - Gradientowa");
            comboBoxFGG.SelectedIndex = 0;
        
            if (this.radioSzary.Checked)
            {
                #region obraz szary
                comboBoxFGG.Items.Add("Gradient Roberts");
                comboBoxFGG.Items.Add("Gradient Sobel");
                comboBoxFGG.Items.Add("Gradient Prewitta");
                comboBoxFGG.Items.Add("Sobel Horizontal");
                comboBoxFGG.Items.Add("Sobel Vertical");
                comboBoxFGG.Items.Add("Prewitta");
                comboBoxFGG.Items.Add("Prewitta N");
                comboBoxFGG.Items.Add("Prewitta NE");
                comboBoxFGG.Items.Add("Prewitta E");
                comboBoxFGG.Items.Add("Prewitta SE");
                comboBoxFGG.Items.Add("Prewitta S");
                comboBoxFGG.Items.Add("Prewitta SW");
                comboBoxFGG.Items.Add("Prewitta W");
                comboBoxFGG.Items.Add("Prewitta NW");
                comboBoxFGG.Items.Add("Kirscha");
                comboBoxFGG.Items.Add("Kirscha N");
                comboBoxFGG.Items.Add("Kirscha NE");
                comboBoxFGG.Items.Add("Kirscha E");
                comboBoxFGG.Items.Add("Kirscha SE");
                comboBoxFGG.Items.Add("Kirscha S");
                comboBoxFGG.Items.Add("Kirscha SW");
                comboBoxFGG.Items.Add("Kirscha W");
                comboBoxFGG.Items.Add("Kirscha NW");
                comboBoxFGG.SelectedIndex = 0; 
              
                this.label1.Text = "Obraz wynikowy w odcieniach szarości";
                Bitmap bmpFL = new Bitmap(this.pictureObrazFL1.Image);
                this.pictureObrazFL2.Image = bmpFL;
                bmpFL = fn.Skalaszarosci(bmpFL);
                this.pictureFGG.Image = bmpFL;
                this.pictureFGG.Image = bmpFL;
                this.pictureFGGwynik.Image = bmpFL.CopyToSquareCanvas(this.pictureFGGwynik.Width);
                this.comboBoxFGG.Visible = true;
                this.pictureFGGwynik.Visible = true;
                previewBitmap = bmpFL.CopyToSquareCanvas(this.pictureFGG.Width);
                this.pictureFGGwynik.Image = previewBitmap;
                #endregion
            }

            if (this.radioKolorHVS.Checked)
            {
                #region obraz HSV
                comboBoxFGG.Items.Add("Gradient RobertsHSV");
                comboBoxFGG.Items.Add("Gradient Sobel HSV");
                comboBoxFGG.Items.Add("Gradient Prewitta HSV");
                comboBoxFGG.Items.Add("Sobel HSV");
                comboBoxFGG.Items.Add("Sobel Horizontal HSV");
                comboBoxFGG.Items.Add("Sobel Vertical HSV");
                comboBoxFGG.Items.Add("Prewitta HSV");
                comboBoxFGG.Items.Add("Prewitta N HSV");
                comboBoxFGG.Items.Add("Prewitta NE HSV");
                comboBoxFGG.Items.Add("Prewitta E HSV");
                comboBoxFGG.Items.Add("Prewitta S HSVE");
                comboBoxFGG.Items.Add("Prewitta S HSV");
                comboBoxFGG.Items.Add("Prewitta SW HSV");
                comboBoxFGG.Items.Add("Prewitta W HSV");
                comboBoxFGG.Items.Add("Prewitta NW HSV");
                comboBoxFGG.Items.Add("Kirscha HSV");
                comboBoxFGG.Items.Add("Kirscha N HSV");
                comboBoxFGG.Items.Add("Kirscha NE HSV");
                comboBoxFGG.Items.Add("Kirscha E HSV");
                comboBoxFGG.Items.Add("Kirscha SE HSV");
                comboBoxFGG.Items.Add("Kirscha S HSV");
                comboBoxFGG.Items.Add("Kirscha SW HSV");
                comboBoxFGG.Items.Add("Kirscha W HSV");
                comboBoxFGG.Items.Add("Kirscha NW HSV");
                comboBoxFGG.SelectedIndex = 0; 
                
                this.label1.Text = "Obraz wynikowy kolorowy HSV";
                Bitmap bmpFLkol = new Bitmap(this.pictureObrazFL1.Image);            
                this.comboBoxFGG.Visible = true;
                this.pictureFGG.Image = bmpFLkol;
                this.pictureFGGwynik.Image = bmpFLkol;
                this.pictureFGGwynik.Visible = true;
                previewBitmap = bmpFLkol.CopyToSquareCanvas(this.pictureFGG.Width);
                this.pictureFGGwynik.Image = previewBitmap;
                #endregion
            }

            if (this.radioKolorRGB.Checked)
            {
                #region obraz RGB
                comboBoxFGG.Items.Add("Gradient Roberts RGB");
                comboBoxFGG.Items.Add("Gradient Sobel RGB");
                comboBoxFGG.Items.Add("Gradient Prewitta RGB");
                comboBoxFGG.Items.Add("Sobel RGB");
                comboBoxFGG.Items.Add("Sobel Horizontal RGB");
                comboBoxFGG.Items.Add("Sobel Vertical RGB");
                comboBoxFGG.Items.Add("Prewitta RHB");
                comboBoxFGG.Items.Add("Prewitta N RGB");
                comboBoxFGG.Items.Add("Prewitta NE RGB");
                comboBoxFGG.Items.Add("Prewitta E RGB");
                comboBoxFGG.Items.Add("Prewitta SE RGB");
                comboBoxFGG.Items.Add("Prewitta S RGB");
                comboBoxFGG.Items.Add("Prewitta SW RGB");
                comboBoxFGG.Items.Add("Prewitta W RGB");
                comboBoxFGG.Items.Add("Prewitta NW RGB");
                comboBoxFGG.Items.Add("Kirscha RGB");
                comboBoxFGG.Items.Add("Kirscha N RGB");
                comboBoxFGG.Items.Add("Kirscha NE RGB");
                comboBoxFGG.Items.Add("Kirscha E RGB");
                comboBoxFGG.Items.Add("Kirscha SE RGB");
                comboBoxFGG.Items.Add("Kirscha S RGB");
                comboBoxFGG.Items.Add("Kirscha SW RGB");
                comboBoxFGG.Items.Add("Kirscha W RGB");
                comboBoxFGG.Items.Add("Kirscha NW RGB");
                comboBoxFGG.SelectedIndex = 0;  
                
                this.label1.Text = "Obraz wynikowy kolorowy RGB";
                Bitmap bmpFLkol = new Bitmap(this.pictureObrazFL1.Image);            
                this.comboBoxFGG.Visible = true;
                this.pictureFGG.Image = bmpFLkol;
                this.pictureFGGwynik.Image = bmpFLkol;
                this.pictureFGGwynik.Visible = true;
                previewBitmap = bmpFLkol.CopyToSquareCanvas(this.pictureFGG.Width);
                this.pictureFGGwynik.Image = previewBitmap;
                #endregion
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            #region ZAPISYWANIE OBRAZU WYNIKOWEGO DO PLIKU
            this.pictureFGGwynik.Image = resultBitmap;
            ApplyFilter(false);
            if (resultBitmap != null)
            {
                SaveFileDialog sfd = new SaveFileDialog();
                sfd.Title = "Specify a file name and file path";
                sfd.Filter = "Png Images(*.png)|*.png|Jpeg Images(*.jpg)|*.jpg";
                sfd.Filter += "|Bitmap Images(*.bmp)|*.bmp";

                if (sfd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                {
                    string fileExtension = Path.GetExtension(sfd.FileName).ToUpper();
                    ImageFormat imgFormat = ImageFormat.Png;

                    if (fileExtension == "BMP")
                    {
                        imgFormat = ImageFormat.Bmp;
                    }
                    else if (fileExtension == "JPG")
                    {
                        imgFormat = ImageFormat.Jpeg;
                    }
                    StreamWriter streamWriter = new StreamWriter(sfd.FileName, false);
                    resultBitmap.Save(streamWriter.BaseStream, imgFormat);
                    streamWriter.Flush();
                    streamWriter.Close();
                    resultBitmap = null;
                }
            }
            #endregion
        }

        //AKTYWACJA I WYŚWIETLANIE HISTOGRAMU, WCZYTYWANIE TABLICY I RYSOWANIE PROFILE LINE
        private void button3_Click(object sender, EventArgs e)
        {
            #region wyświetlanie tablicy obrazu
            if (this.radioSzary.Checked)
            {
                this.generuj_histogram(0);
            }
            if (this.radioKolorRGB.Checked)
            {
                this.HistogramRGB.Image = generuj_histogram_kolory(0);
                this.label5.Text = "rgb";
            }
            if (this.radioKolorHVS.Checked)
            {

            }
            EnableDoubleBuffered(this.dataGridTablica, true);
            int cols_width = 40;
            Bitmap bmpTab = (Bitmap)this.pictureFGGwynik.Image;

            if (dataGridTablica.Columns.Count != bmpTab.Width || dataGridTablica.Rows.Count != bmpTab.Height)
            {
                dataGridTablica.Rows.Clear();
                dataGridTablica.Columns.Clear();
                dataGridTablica.RowHeadersWidth = 60;
                for (int x = 0; x < bmpTab.Width; x++)
                {
                    dataGridTablica.Columns.Add(null, x.ToString());
                    dataGridTablica.Columns[x].Width = cols_width;
                    dataGridTablica.Columns[x].FillWeight = 0.0000001f;
                }
                dataGridTablica.Rows.Add(bmpTab.Height);
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    dataGridTablica.Rows[y].HeaderCell.Value = y.ToString();
                }
            }
            for (int x = 0; x < bmpTab.Width; x++)
            {
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    dataGridTablica[x, y].Value = bmpTab.GetPixel(x, y).R;
                }
            }
            #endregion
        }

        private void EnableDoubleBuffered(DataGridView dgv, bool setting)
        {
            Type dgvType = dgv.GetType();
            PropertyInfo pi = dgvType.GetProperty("DoubleBuffered", BindingFlags.Instance | BindingFlags.NonPublic);
            pi.SetValue(dgv, setting, null);
        }

        private Bitmap generuj_histogram(int k)
        {
            #region generowanie histogramu
            Bitmap obrazek_bitmapa = new Bitmap(this.pictureFGGwynik.Image);
            Bitmap histogram = null;
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(obrazek_bitmapa);

            if (HSV)
            {
                int histogram_max = 0;
                double h, s, v;
                fobrazek_bitmapa.LockImage();
                for (int x = 0; x < obrazek_bitmapa.Width; x++)
                {
                    for (int y = 0; y < obrazek_bitmapa.Height; y++)
                    {
                        hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y), out h, out s, out v);
                        int temp_v = (int)(v * 255.0f);
                        histogram_hsv_values[temp_v]++;
                        if (histogram_hsv_values[temp_v] > histogram_max)
                            histogram_max = histogram_hsv_values[temp_v];
                    }
                }

                fobrazek_bitmapa.UnlockImage();
                double skala = (512.0f / (double)histogram_max) * ((double)pasek_skali.Value / 10.0f);
                histogram = new Bitmap(1024, 513);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_hsv_values[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Black);
                        }
                    }
                }

                fhistogram.UnlockImage();
            }
            else
            {
                int[] histogram_values_tmp;
                histogram_values_tmp = new int[256];
                int histogram_max = 0;
                fobrazek_bitmapa.LockImage();
                //Zliczanie wartości histogramu
                for (int x = 0; x < obrazek_bitmapa.Width; x++)
                {
                    for (int y = 0; y < obrazek_bitmapa.Height; y++)
                    {
                        if (k == 0 || k > 2)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R]++;
                            histogram_values[fobrazek_bitmapa.GetPixel(x, y).R]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R];
                        }
                        if (k == 1)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G];
                        }
                        if (k == 2)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B];
                        }
                        if (k == 3)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B];
                        }

                    }
                }
                fobrazek_bitmapa.UnlockImage();

                float skala = (512.0f / (float)histogram_max) * ((float)pasek_skali.Value / 10.0f);

                histogram = new Bitmap(1024, 513);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                Color slupki = Color.Black;
                if (k == 0)
                    slupki = Color.Red;
                if (k == 1)
                    slupki = Color.Green;
                if (k == 2)
                    slupki = Color.Blue;

                Color tlo = Color.White;

                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_values_tmp[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), slupki);

                        }
                        else
                        {
                            //fhistogram.SetPixel(4*x1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+2, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+3, (int)(256 - y1), tlo);
                        }
                    }
                }

                fhistogram.UnlockImage();
            }
            return histogram;
            #endregion
        }

        private Bitmap generuj_histogram_kolory(int k)
        {
            #region generuj_histogram_kolory
            Bitmap obrazek_bitmapa = new Bitmap(this.pictureFGGwynik.Image);
            if (histogram_kolory_values == null)
                histogram_kolory_values = new int[256, 3];
            int histogram_max = 0;
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(obrazek_bitmapa);
            fobrazek_bitmapa.LockImage();
            //Zliczanie wartości histogramu
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0];
                }
            }
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1];
                }
            }
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2];
                }
            }
            fobrazek_bitmapa.UnlockImage();
            float skala = (512.0f / (float)histogram_max);
            Bitmap histogram = new Bitmap(1024, 513);
            BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
            fhistogram.LockImage();
            for (int x1 = 0; x1 < 256; x1++)
            {
                int tmpr = (int)(histogram_kolory_values[x1, 0] * skala);
                int tmpg = (int)(histogram_kolory_values[x1, 1] * skala);
                int tmpb = (int)(histogram_kolory_values[x1, 2] * skala);
                //0,1,2 nie 3
                if (k < 3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpr)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Red);
                        }
                    }
                }
                //0,1,3 nie 2
                if (k < 2 || k == 3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpg)
                        {
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Green);
                        }
                    }
                }
                //0,2,3 nie 1
                if (k == 0 || k > 1)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpb)
                        {
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Blue);
                        }
                    }
                }
            }
            fhistogram.UnlockImage();
            return histogram;
            #endregion
        }

        private void buttpn_red_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(0);
        }

        private void button_green_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(1);
        }

        private void button_blue_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(2);
        }

        private void button_wszystkie_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(0);
        }

        private void button8_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(1);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(2);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(3);
        }

        private void pasek_skali_Scroll(object sender, EventArgs e)
        {
            wartosc_skali.Text = ((double)pasek_skali.Value / 10.0f).ToString();
            this.HistogramGrey.Image = generuj_histogram(4);
        }            
    }
}