﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Windows.Forms.DataVisualization.Charting;
using System.Drawing.Imaging;
using APO_BB_DK_v012013.Operacje;
using BitmapProcessing;
using System.Reflection;


namespace APO_BB_DK_v012013
{
    public partial class ObrazFGL : Form
    {
        private TrackBar suwak1;
        private OpenFileDialog open;
        public PictureBox pictureFGLwynik;
        public Bitmap bitmap;
        private Bitmap originalBitmap = null;
        private Bitmap previewBitmap = null;
        private Bitmap resultBitmap = null;

   //     private int _id = -1;
        private int[] histogram_values = new int[256];
        private int[] histogram_hsv_values = new int[256];

        private int[,] histogram_kolory_values;
        public bool HSV
        {
            get { return _HSV; }
            set { _HSV = value; this.label5.Text = "Obraz (HSV)"; this.HistogramRGB.Visible = false; button_blue.Visible = false; button_green.Visible = false; buttpn_red.Visible = false; label5.Visible = false; button_wszystkie.Visible = false; button1.Visible = false; button3.Visible = false; label5.Visible = true; label2.Text = "1.0"; }
        }
        private bool _HSV = false;
      
        public ObrazFGL()
        {
            InitializeComponent();
            open = new OpenFileDialog();
            suwak1 = new System.Windows.Forms.TrackBar();
            this.pictureFGL.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureFGLwynik.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureObrazFL1.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureObrazFL2.SizeMode = PictureBoxSizeMode.StretchImage;

            this.groupBox2.Visible = true;
            this.label3.Visible = false;
            this.label4.Visible = false;
            this.dataGridView1.Visible = true;
            this.dataGridView2.Visible = false;
          
            comboBoxFGL.Items.Add ("Filtry Wyostrzające (FG) - Laplasjanowe");
            comboBoxFGL.Items.Add("Laplasian 3x3");
            comboBoxFGL.Items.Add("Laplasian 3x3 L1");
            comboBoxFGL.Items.Add("Laplasian 3x3 L2");
            comboBoxFGL.Items.Add("Laplasian 3x3 L3");
            comboBoxFGL.Items.Add("Laplasian 3x3 L4");
            comboBoxFGL.Items.Add("Laplasian 3x3 L5");
            comboBoxFGL.Items.Add("Laplasian 3x3 Poziomy");
            comboBoxFGL.Items.Add("Laplasian 3x3 Pionowy");
            comboBoxFGL.Items.Add("Laplasian 3x3 Ukosny");
            comboBoxFGL.Items.Add("Laplasian 5x5");
            comboBoxFGL.Items.Add("Laplasian of Gaussian");
            comboBoxFGL.Items.Add("Laplasian 3x3 of Gaussian 3x3");
            comboBoxFGL.Items.Add("Laplasian 3x3 of Gaussian 5x5 - 1");
            comboBoxFGL.Items.Add("Laplasian 3x3 of Gaussian 5x5 - 2");
            comboBoxFGL.Items.Add("Laplasian 5x5 of Gaussian 3x3");
            comboBoxFGL.Items.Add("Laplasian 5x5 of Gaussian 5x5 - 1");
            comboBoxFGL.Items.Add("Laplasian 5x5 of Gaussian 5x5 - 2");          
            comboBoxFGL.SelectedIndex = 0;        
        }
              
        private void buttonObrazFL_Click_1(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Title = "Select the source Image";
            ofd.Filter = "Image Files(*.BMP;*.JPG;*.PNG)|*.BMP;*.JPG;*.PNG|All files (*.*)|*.*";

            if (ofd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                StreamReader streamReader = new StreamReader(ofd.FileName);
                originalBitmap = (Bitmap)Bitmap.FromStream(streamReader.BaseStream);
                streamReader.Close();
                previewBitmap = originalBitmap.CopyToSquareCanvas(pictureFGL.Width);
                this.pictureFGL.Image = previewBitmap;
                this.pictureObrazFL1.Image = originalBitmap;
              }
        }

        public void update_view(double [,] tabela, int wymiar)
        {
            int szer = wymiar;   
            double [,] tablica = tabela;
            dataGridView1.ColumnCount = szer;
            dataGridView1.EditMode = DataGridViewEditMode.EditProgrammatically;
            dataGridView1.RowHeadersVisible = false;
            dataGridView1.ColumnHeadersVisible = false;
            dataGridView1.AutoSize = true;
            dataGridView1.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells;
            dataGridView1.AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.AllCells;
        
            string[] tab = new string[szer];
            dataGridView1.Rows.Clear();
            for (int i = 0; i < szer; i++)
            {
                for (int j = 0; j < szer; j++)
                {
                    tab[j] = tablica[i, j].ToString();
                }
                dataGridView1.Rows.Add(tab);
            }

            dataGridView1.Visible = true;
        }

        public void update_view2 (double[,] tabela, int wymiar)
        {
            int szer = wymiar;
            double[,] tablica = tabela;
            dataGridView2.ColumnCount = szer;
            dataGridView2.EditMode = DataGridViewEditMode.EditProgrammatically;
            dataGridView2.RowHeadersVisible = false;
            dataGridView2.ColumnHeadersVisible = false;
            dataGridView2.AutoSize = true;
            dataGridView2.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells;
            dataGridView2.AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.AllCells;

            string[] tab = new string[szer];
            dataGridView2.Rows.Clear();
            for (int i = 0; i < szer; i++)
            {
                for (int j = 0; j < szer; j++)
                {
                    tab[j] = tablica[i, j].ToString();
                }
                dataGridView2.Rows.Add(tab);
            }
            dataGridView2.Visible = true;
        }  
           
           
        private void buttonWidok_Click(object sender, EventArgs e)
        {
            this.pictureFGL.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureFGLwynik.SizeMode = PictureBoxSizeMode.StretchImage;

            if (this.radioNaturalny.Checked)
            {           
                this.pictureFGLwynik.SizeMode = PictureBoxSizeMode.Normal;
                this.pictureFGL.SizeMode = PictureBoxSizeMode.Normal;
            }

            if (this.radioAutoSize.Checked)
            {
                this.pictureFGL.SizeMode = PictureBoxSizeMode.CenterImage;
                this.pictureFGLwynik.SizeMode = PictureBoxSizeMode.CenterImage;
            }
            if (this.radioDopasowany.Checked)
            {
                this.pictureFGL.SizeMode = PictureBoxSizeMode.StretchImage;
                this.pictureFGLwynik.SizeMode = PictureBoxSizeMode.StretchImage;
            }
            this.pictureFGL.Refresh();
            this.pictureFGLwynik.Refresh();
        }

        private void ApplyFilter(bool preview)
        {
            if (previewBitmap == null || comboBoxFGL.SelectedIndex == -1)
            {
                return;
            }

            Bitmap selectedSource = null;
            Bitmap bitmapResult = null;

            if (preview == true)
            {
                selectedSource = previewBitmap;
            }
            else
            {
                selectedSource = originalBitmap;
            }

            if (selectedSource != null)
            {
                if (comboBoxFGL.SelectedItem.ToString() == "None")
                {
                    bitmapResult = selectedSource;
                    this.dataGridView1.Visible = false;
                    this.dataGridView2.Visible = false;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                }
                // WYKRYWANIE KRAWEDZI DLA OBRAZU W ODCIENIACH SZAROŚCI
                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3")
                {
                    bitmapResult = selectedSource.Laplacian3x3Filter(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian3x3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian3x3.Length))));
                }

                  else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 L1")
                {
                    bitmapResult = selectedSource.Laplacian3x3_L1(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian_L1, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian_L1.Length))));
                }

                  else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 L2")
                {
                    bitmapResult = selectedSource.Laplacian3x3_L2(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian_L2, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian_L2.Length))));
                }

                   else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 L3")
                {
                    bitmapResult = selectedSource.Laplacian3x3_L3(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian_L3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian_L3.Length))));
                }

                  else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 L4")
                {
                    bitmapResult = selectedSource.Laplacian3x3_L4(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian_L4, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian_L4.Length))));
                }

                   else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 L5")
                {
                    bitmapResult = selectedSource.Laplacian3x3_L5(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian_L5, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian_L5.Length))));
                }

                  else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 Poziomy")
                {
                    bitmapResult = selectedSource.Laplacian3x3_Horizontal(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian_Horizontal, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian_Horizontal.Length))));
                }

                   else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 Pionowy")
                {
                    bitmapResult = selectedSource.Laplacian3x3_Vertical(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian_Vertical, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian_Vertical.Length))));
                }

                   else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 Ukosny")
                {
                    bitmapResult = selectedSource.Laplacian3x3_Ukosny(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian_Ukosny, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian_Ukosny.Length))));
                }

                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 Grayscale")
                {
                    bitmapResult = selectedSource.Laplacian3x3Filter(true);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian3x3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian3x3.Length))));
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 5x5")
                {
                    bitmapResult = selectedSource.Laplacian5x5Filter(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian5x5, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian5x5.Length))));
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian of Gaussian")
                {
                    bitmapResult = selectedSource.LaplacianOfGaussianFilter();
                    this.groupBox2.Visible = true;
                    this.label3.Visible = true;
                    this.label4.Visible = true;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = true;
                    update_view(Matrix.LaplacianOfGaussian, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.LaplacianOfGaussian.Length))));
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 of Gaussian 3x3")
                {
                    bitmapResult = selectedSource.Laplacian3x3OfGaussian3x3Filter();
                    this.groupBox2.Visible = true;
                    this.label3.Visible = true;
                    this.label4.Visible = true;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = true;
                    update_view (Matrix.Laplacian3x3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian3x3.Length))));
                    update_view2 (Matrix.Gaussian3x3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Gaussian3x3.Length))));
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 of Gaussian 5x5 - 1")
                {
                    bitmapResult = selectedSource.Laplacian3x3OfGaussian5x5Filter1();
                    this.groupBox2.Visible = true;
                    this.label3.Visible = true;
                    this.label4.Visible = true;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = true;
                    update_view (Matrix.Laplacian3x3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian3x3.Length))));
                    update_view2 (Matrix.Gaussian5x5Type1, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Gaussian5x5Type1.Length))));
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 of Gaussian 5x5 - 2")
                {
                    bitmapResult = selectedSource.Laplacian3x3OfGaussian5x5Filter2();
                    this.groupBox2.Visible = true;
                    this.label3.Visible = true;
                    this.label4.Visible = true;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = true;
                    update_view(Matrix.Laplacian3x3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian3x3.Length))));
                    update_view2(Matrix.Gaussian5x5Type2, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Gaussian5x5Type2.Length))));
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 5x5 of Gaussian 3x3")
                {
                    bitmapResult = selectedSource.Laplacian5x5OfGaussian3x3Filter();
                    this.groupBox2.Visible = true;
                    this.label3.Visible = true;
                    this.label4.Visible = true;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = true;
                    update_view(Matrix.Laplacian5x5, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian5x5.Length))));
                    update_view2(Matrix.Gaussian3x3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Gaussian3x3.Length))));
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 5x5 of Gaussian 5x5 - 1")
                {
                    bitmapResult = selectedSource.Laplacian5x5OfGaussian5x5Filter1();
                    this.groupBox2.Visible = true;
                    this.label3.Visible = true;
                    this.label4.Visible = true;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = true;
                    update_view(Matrix.Laplacian5x5, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian5x5.Length))));

                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 5x5 of Gaussian 5x5 - 2")
                {
                    bitmapResult = selectedSource.Laplacian5x5OfGaussian5x5Filter2();
                    this.groupBox2.Visible = true;
                    this.label3.Visible = true;
                    this.label4.Visible = true;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = true;
                    update_view(Matrix.Laplacian5x5, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian5x5.Length))));
                    update_view2(Matrix.Gaussian5x5Type2, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Gaussian5x5Type2.Length))));
                    update_view2(Matrix.Gaussian5x5Type1, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Gaussian5x5Type1.Length))));
                }
                // WYKRYWANIE KRAWEDZI DLA OBRAZU RGB
                 else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 RGB")
                {
                    bitmapResult = selectedSource.Laplacian3x3Filter(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian3x3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian3x3.Length))));
                }

                  else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 L1 RGB")
                {
                    bitmapResult = selectedSource.Laplacian3x3_L1(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian_L1, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian_L1.Length))));
                }

                  else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 L2 RGB")
                {
                    bitmapResult = selectedSource.Laplacian3x3_L2(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian_L2, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian_L2.Length))));
                }

                   else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 L3 RGB")
                {
                    bitmapResult = selectedSource.Laplacian3x3_L3(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian_L3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian_L3.Length))));
                }

                  else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 L4 RGB")
                {
                    bitmapResult = selectedSource.Laplacian3x3_L4(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian_L4, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian_L4.Length))));
                }

                   else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 L5 RGB")
                {
                    bitmapResult = selectedSource.Laplacian3x3_L5(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian_L5, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian_L5.Length))));
                }

                  else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 Poziomy RGB")
                {
                    bitmapResult = selectedSource.Laplacian3x3_Horizontal(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian_Horizontal, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian_Horizontal.Length))));
                }

                   else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 Pionowy RGB")
                {
                    bitmapResult = selectedSource.Laplacian3x3_Vertical(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian_Vertical, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian_Vertical.Length))));
                }

                   else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 Ukosny RGB")
                {
                    bitmapResult = selectedSource.Laplacian3x3_Ukosny(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian_Ukosny, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian_Ukosny.Length))));
                }

                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 Grayscale RGB")
                {
                    bitmapResult = selectedSource.Laplacian3x3Filter(true);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian3x3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian3x3.Length))));
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Laplacian 5x5 RGB")
                {
                    bitmapResult = selectedSource.Laplacian5x5Filter(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian5x5, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian5x5.Length))));
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian of Gaussian RGB")
                {
                    bitmapResult = selectedSource.LaplacianOfGaussianFilter();
                    this.groupBox2.Visible = true;
                    this.label3.Visible = true;
                    this.label4.Visible = true;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = true;
                    update_view(Matrix.LaplacianOfGaussian, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.LaplacianOfGaussian.Length))));
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 of Gaussian 3x3 RGB")
                {
                    bitmapResult = selectedSource.Laplacian3x3OfGaussian3x3Filter();
                    this.groupBox2.Visible = true;
                    this.label3.Visible = true;
                    this.label4.Visible = true;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = true;
                    update_view (Matrix.Laplacian3x3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian3x3.Length))));
                    update_view2 (Matrix.Gaussian3x3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Gaussian3x3.Length))));
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 of Gaussian 5x5 - 1 RGB")
                {
                    bitmapResult = selectedSource.Laplacian3x3OfGaussian5x5Filter1();
                    this.groupBox2.Visible = true;
                    this.label3.Visible = true;
                    this.label4.Visible = true;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = true;
                    update_view (Matrix.Laplacian3x3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian3x3.Length))));
                    update_view2 (Matrix.Gaussian5x5Type1, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Gaussian5x5Type1.Length))));
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 of Gaussian 5x5 - 2 RGB")
                {
                    bitmapResult = selectedSource.Laplacian3x3OfGaussian5x5Filter2();
                    this.groupBox2.Visible = true;
                    this.label3.Visible = true;
                    this.label4.Visible = true;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = true;
                    update_view(Matrix.Laplacian3x3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian3x3.Length))));
                    update_view2(Matrix.Gaussian5x5Type2, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Gaussian5x5Type2.Length))));
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 5x5 of Gaussian 3x3 RGB")
                {
                    bitmapResult = selectedSource.Laplacian5x5OfGaussian3x3Filter();
                    this.groupBox2.Visible = true;
                    this.label3.Visible = true;
                    this.label4.Visible = true;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = true;
                    update_view(Matrix.Laplacian5x5, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian5x5.Length))));
                    update_view2(Matrix.Gaussian3x3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Gaussian3x3.Length))));
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 5x5 of Gaussian 5x5 - 1 RGB")
                {
                    bitmapResult = selectedSource.Laplacian5x5OfGaussian5x5Filter1();
                    this.groupBox2.Visible = true;
                    this.label3.Visible = true;
                    this.label4.Visible = true;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = true;
                    update_view(Matrix.Laplacian5x5, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian5x5.Length))));

                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 5x5 of Gaussian 5x5 - 2 RGB")
                {
                    bitmapResult = selectedSource.Laplacian5x5OfGaussian5x5Filter2();
                    this.groupBox2.Visible = true;
                    this.label3.Visible = true;
                    this.label4.Visible = true;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = true;
                    update_view(Matrix.Laplacian5x5, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian5x5.Length))));
                    update_view2(Matrix.Gaussian5x5Type2, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Gaussian5x5Type2.Length))));
                    update_view2(Matrix.Gaussian5x5Type1, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Gaussian5x5Type1.Length))));
                }    
              // WYKRYWANIE KRAWEDZI DLA OBRAZU HSV
                 else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 HSV")
                {
                    bitmapResult = selectedSource.Laplacian3x3Filter(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian3x3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian3x3.Length))));
                }

                  else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 L1 HSV")
                {
                    bitmapResult = selectedSource.Laplacian3x3_L1(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian_L1, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian_L1.Length))));
                }

                  else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 L2 HSV")
                {
                    bitmapResult = selectedSource.Laplacian3x3_L2(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian_L2, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian_L2.Length))));
                }

                   else if (comboBoxFGL.SelectedItem.ToString() == "Laplscian 3x3 L3 HSV")
                {
                    bitmapResult = selectedSource.Laplacian3x3_L3(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian_L3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian_L3.Length))));
                }

                  else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 L4 HSV")
                {
                    bitmapResult = selectedSource.Laplacian3x3_L4(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian_L4, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian_L4.Length))));
                }

                   else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 L5 HSV")
                {
                    bitmapResult = selectedSource.Laplacian3x3_L5(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian_L5, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian_L5.Length))));
                }

                  else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 Poziomy HSV")
                {
                    bitmapResult = selectedSource.Laplacian3x3_Horizontal(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian_Horizontal, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian_Horizontal.Length))));
                }

                   else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 Pionowy HSV")
                {
                    bitmapResult = selectedSource.Laplacian3x3_Vertical(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian_Vertical, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian_Vertical.Length))));
                }

                   else if (comboBoxFGL.SelectedItem.ToString() == "Laplacian 3x3 Ukosny HSV")
                {
                    bitmapResult = selectedSource.Laplacian3x3_Ukosny(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian_Ukosny, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian_Ukosny.Length))));
                }

                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 Grayscale HSV")
                {
                    bitmapResult = selectedSource.Laplacian3x3Filter(true);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian3x3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian3x3.Length))));
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 5x5 HSV")
                {
                    bitmapResult = selectedSource.Laplacian5x5Filter(false);
                    this.groupBox2.Visible = true;
                    this.label3.Visible = false;
                    this.label4.Visible = false;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = false;
                    update_view(Matrix.Laplacian5x5, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian5x5.Length))));
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian of Gaussian HSV")
                {
                    bitmapResult = selectedSource.LaplacianOfGaussianFilter();
                    this.groupBox2.Visible = true;
                    this.label3.Visible = true;
                    this.label4.Visible = true;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = true;
                    update_view(Matrix.LaplacianOfGaussian, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.LaplacianOfGaussian.Length))));
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 of Gaussian 3x3 HSV")
                {
                    bitmapResult = selectedSource.Laplacian3x3OfGaussian3x3Filter();
                    this.groupBox2.Visible = true;
                    this.label3.Visible = true;
                    this.label4.Visible = true;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = true;
                    update_view (Matrix.Laplacian3x3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian3x3.Length))));
                    update_view2 (Matrix.Gaussian3x3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Gaussian3x3.Length))));
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 of Gaussian 5x5 - 1 HSV")
                {
                    bitmapResult = selectedSource.Laplacian3x3OfGaussian5x5Filter1();
                    this.groupBox2.Visible = true;
                    this.label3.Visible = true;
                    this.label4.Visible = true;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = true;
                    update_view (Matrix.Laplacian3x3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian3x3.Length))));
                    update_view2 (Matrix.Gaussian5x5Type1, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Gaussian5x5Type1.Length))));
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 3x3 of Gaussian 5x5 - 2 HSV")
                {
                    bitmapResult = selectedSource.Laplacian3x3OfGaussian5x5Filter2();
                    this.groupBox2.Visible = true;
                    this.label3.Visible = true;
                    this.label4.Visible = true;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = true;
                    update_view(Matrix.Laplacian3x3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian3x3.Length))));
                    update_view2(Matrix.Gaussian5x5Type2, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Gaussian5x5Type2.Length))));
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 5x5 of Gaussian 3x3 HSV")
                {
                    bitmapResult = selectedSource.Laplacian5x5OfGaussian3x3Filter();
                    this.groupBox2.Visible = true;
                    this.label3.Visible = true;
                    this.label4.Visible = true;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = true;
                    update_view(Matrix.Laplacian5x5, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian5x5.Length))));
                    update_view2(Matrix.Gaussian3x3, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Gaussian3x3.Length))));
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 5x5 of Gaussian 5x5 - 1 HSV")
                {
                    bitmapResult = selectedSource.Laplacian5x5OfGaussian5x5Filter1();
                    this.groupBox2.Visible = true;
                    this.label3.Visible = true;
                    this.label4.Visible = true;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = true;
                    update_view(Matrix.Laplacian5x5, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian5x5.Length))));

                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Laplasian 5x5 of Gaussian 5x5 - 2 HSV")
                {
                    bitmapResult = selectedSource.Laplacian5x5OfGaussian5x5Filter2();
                    this.groupBox2.Visible = true;
                    this.label3.Visible = true;
                    this.label4.Visible = true;
                    this.dataGridView1.Visible = true;
                    this.dataGridView2.Visible = true;
                    update_view(Matrix.Laplacian5x5, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Laplacian5x5.Length))));
                    update_view2(Matrix.Gaussian5x5Type2, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Gaussian5x5Type2.Length))));
                    update_view2(Matrix.Gaussian5x5Type1, Convert.ToInt32(Math.Sqrt(Convert.ToDouble(Matrix.Gaussian5x5Type1.Length))));
                }                  
            }      

            if (bitmapResult != null)
            {
                if (preview == true)
                {  pictureFGLwynik.Image = bitmapResult; }
                else
                {  resultBitmap = bitmapResult;  }
            }
        }

        private void comboBoxFL_SelectedIndexChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void buttonKolor_Click(object sender, EventArgs e)
        {
            FunkcjeJednoarg fn = new FunkcjeJednoarg();
            comboBoxFGL.Items.Clear();
            comboBoxFGL.Items.Add ("Filtry Wyostrzające (FG) - Laplasjanowe");
            comboBoxFGL.SelectedIndex = 0;
        
            if (this.radioSzary.Checked)
            {              
                comboBoxFGL.Items.Add("Laplasian 3x3");
                comboBoxFGL.Items.Add("Laplasian 3x3 L1");
                comboBoxFGL.Items.Add("Laplasian 3x3 L2");
                comboBoxFGL.Items.Add("Laplasian 3x3 L3");
                comboBoxFGL.Items.Add("Laplasian 3x3 L4");
                comboBoxFGL.Items.Add("Laplasian 3x3 L5");
                comboBoxFGL.Items.Add("Laplasian 3x3 Poziomy");
                comboBoxFGL.Items.Add("Laplasian 3x3 Pionowy");
                comboBoxFGL.Items.Add("Laplasian 3x3 Ukosny");
                comboBoxFGL.Items.Add("Laplasian 5x5");
                comboBoxFGL.Items.Add("Laplasian of Gaussian");
                comboBoxFGL.Items.Add("Laplasian 3x3 of Gaussian 3x3");
                comboBoxFGL.Items.Add("Laplasian 3x3 of Gaussian 5x5 - 1");
                comboBoxFGL.Items.Add("Laplasian 3x3 of Gaussian 5x5 - 2");
                comboBoxFGL.Items.Add("Laplasian 5x5 of Gaussian 3x3");
                comboBoxFGL.Items.Add("Laplasian 5x5 of Gaussian 5x5 - 1");
                comboBoxFGL.Items.Add("Laplasian 5x5 of Gaussian 5x5 - 2"); 
                comboBoxFGL.SelectedIndex = 0; 
              
                this.label1.Text = "Obraz wynikowy w odcieniach szarości";
                Bitmap bmpFL = new Bitmap(this.pictureObrazFL1.Image);
                this.pictureObrazFL2.Image = bmpFL;
                bmpFL = fn.Skalaszarosci(bmpFL);
                this.pictureFGLwynik.Image = bmpFL;
                this.pictureFGL.Image = bmpFL;
                this.pictureFGLwynik.Image = bmpFL.CopyToSquareCanvas(pictureFGLwynik.Width);
                this.comboBoxFGL.Visible = true;
                this.pictureFGLwynik.Visible = true;
                previewBitmap = bmpFL.CopyToSquareCanvas(this.pictureFGL.Width);
                this.pictureFGLwynik.Image = previewBitmap;
            }

            if (this.radioKolorHVS.Checked)
            {
                comboBoxFGL.Items.Add("Laplasian 3x3 HSV");
                comboBoxFGL.Items.Add("Laplasian 3x3 L1 HSV");
                comboBoxFGL.Items.Add("Laplasian 3x3 L2 HSV");
                comboBoxFGL.Items.Add("Laplasian 3x3 L3 HSV");
                comboBoxFGL.Items.Add("Laplasian 3x3 L4 HSV");
                comboBoxFGL.Items.Add("Laplasian 3x3 L5 HSV");
                comboBoxFGL.Items.Add("Laplasian 3x3 Poziomy HSV");
                comboBoxFGL.Items.Add("Laplasian 3x3 Pionowy HSV");
                comboBoxFGL.Items.Add("Laplasian 3x3 Ukosny HSV");
                comboBoxFGL.Items.Add("Laplasian 5x5 HSV");
                comboBoxFGL.Items.Add("Laplasian of Gaussian HSV");
                comboBoxFGL.Items.Add("Laplasian 3x3 of Gaussian 3x3 HSV");
                comboBoxFGL.Items.Add("Laplasian 3x3 of Gaussian 5x5 - 1 HSV");
                comboBoxFGL.Items.Add("Laplasian 3x3 of Gaussian 5x5 - 2 HSV");
                comboBoxFGL.Items.Add("Laplasian 5x5 of Gaussian 3x3 HSV");
                comboBoxFGL.Items.Add("Laplasian 5x5 of Gaussian 5x5 - 1 HSV");
                comboBoxFGL.Items.Add("Laplasian 5x5 of Gaussian 5x5 - 2HSV"); 
                comboBoxFGL.SelectedIndex = 0; 
                
                this.label1.Text = "Obraz wynikowy kolorowy HSV";
                Bitmap bmpFLkol = new Bitmap(this.pictureObrazFL1.Image);            
                this.comboBoxFGL.Visible = true;
                this.pictureFGL.Image = bmpFLkol;
                this.pictureFGLwynik.Image = bmpFLkol;
                this.pictureFGLwynik.Visible = true;
                previewBitmap = bmpFLkol.CopyToSquareCanvas(this.pictureFGL.Width);
                this.pictureFGLwynik.Image = previewBitmap; 
            }

            if (this.radioKolorRGB.Checked)
            {
                comboBoxFGL.Items.Add("Laplasian 3x3 RGB");
                comboBoxFGL.Items.Add("Laplasian 3x3 L1 RGB");
                comboBoxFGL.Items.Add("Laplasian 3x3 L2 RGB");
                comboBoxFGL.Items.Add("Laplasian 3x3 L3 RGB");
                comboBoxFGL.Items.Add("Laplasian 3x3 L4 RGB");
                comboBoxFGL.Items.Add("Laplasian 3x3 L5 RGB");
                comboBoxFGL.Items.Add("Laplasian 3x3 Poziomy RGB");
                comboBoxFGL.Items.Add("Laplasian 3x3 Pionowy RGB");
                comboBoxFGL.Items.Add("Laplasian 3x3 Ukosny RGB");
                comboBoxFGL.Items.Add("Laplasian 5x5 RGB");
                comboBoxFGL.Items.Add("Laplasian of Gaussian RGB");
                comboBoxFGL.Items.Add("Laplasian 3x3 of Gaussian 3x3 RGB");
                comboBoxFGL.Items.Add("Laplasian 3x3 of Gaussian 5x5 - 1 RGB");
                comboBoxFGL.Items.Add("Laplasian 3x3 of Gaussian 5x5 - 2 RGB");
                comboBoxFGL.Items.Add("Laplasian 5x5 of Gaussian 3x3 RGB");
                comboBoxFGL.Items.Add("Laplasian 5x5 of Gaussian 5x5 - 1 RGB");
                comboBoxFGL.Items.Add("Laplasian 5x5 of Gaussian 5x5 - 2 RGB"); 
                comboBoxFGL.SelectedIndex = 0; 

                this.label1.Text = "Obraz wynikowy kolorowy RGB";
                Bitmap bmpFLkol = new Bitmap(this.pictureObrazFL1.Image);            
                this.comboBoxFGL.Visible = true;
                this.pictureFGL.Image = bmpFLkol;
                this.pictureFGLwynik.Image = bmpFLkol;
                this.pictureFGLwynik.Visible = true;
                previewBitmap = bmpFLkol.CopyToSquareCanvas(this.pictureFGL.Width);
                this.pictureFGLwynik.Image = previewBitmap;   
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {

        }

        private void button1_Click_1(object sender, EventArgs e)
        {
             this.pictureFGLwynik.Image = resultBitmap;
            ApplyFilter(false);
            if (resultBitmap != null)
            {
                SaveFileDialog sfd = new SaveFileDialog();
                sfd.Title = "Specify a file name and file path";
                sfd.Filter = "Png Images(*.png)|*.png|Jpeg Images(*.jpg)|*.jpg";
                sfd.Filter += "|Bitmap Images(*.bmp)|*.bmp";

                if (sfd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                {
                    string fileExtension = Path.GetExtension(sfd.FileName).ToUpper();
                    ImageFormat imgFormat = ImageFormat.Png;

                    if (fileExtension == "BMP")
                    {
                        imgFormat = ImageFormat.Bmp;
                    }
                    else if (fileExtension == "JPG")
                    {
                        imgFormat = ImageFormat.Jpeg;
                    }
                    StreamWriter streamWriter = new StreamWriter(sfd.FileName, false);
                    resultBitmap.Save(streamWriter.BaseStream, imgFormat);
                    streamWriter.Flush();
                    streamWriter.Close();
                    resultBitmap = null;
                }
            }
        }

        private void EnableDoubleBuffered(DataGridView dgv, bool setting)
        {
            Type dgvType = dgv.GetType();
            PropertyInfo pi = dgvType.GetProperty("DoubleBuffered", BindingFlags.Instance | BindingFlags.NonPublic);
            pi.SetValue(dgv, setting, null);
        }

               private Bitmap generuj_histogram(int k)
        {
            Bitmap obrazek_bitmapa = new Bitmap(this.pictureFGLwynik.Image);
            Bitmap histogram = null;
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(obrazek_bitmapa);
            
           
            if (HSV)
            {
                int histogram_max=0;
                
                double h, s, v;
                fobrazek_bitmapa.LockImage();
                for (int x = 0; x < obrazek_bitmapa.Width; x++)
                {
                    for (int y = 0; y < obrazek_bitmapa.Height; y++)
                    {
                        hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y), out h, out s, out v);
                        int temp_v = (int)(v * 255.0f);
                        histogram_hsv_values[temp_v]++;
                        if (histogram_hsv_values[temp_v] > histogram_max)
                            histogram_max = histogram_hsv_values[temp_v];
                    }

                }

                fobrazek_bitmapa.UnlockImage();

                double skala = (512.0f / (double)histogram_max) * ((double)pasek_skali.Value / 10.0f);
                histogram = new Bitmap(1024, 513);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_hsv_values[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Black);

                        }
                        
                    }
                }

                fhistogram.UnlockImage();
            }
            else
            {
                int[] histogram_values_tmp;
                histogram_values_tmp = new int[256];
                int histogram_max = 0;
                fobrazek_bitmapa.LockImage();
                //Zliczanie wartości histogramu
                for (int x = 0; x < obrazek_bitmapa.Width; x++)
                {
                    for (int y = 0; y < obrazek_bitmapa.Height; y++)
                    {
                        if (k == 0 || k > 2)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R]++;
                            histogram_values[fobrazek_bitmapa.GetPixel(x, y).R]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R];
                        }
                        if (k == 1)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G];
                        }
                        if (k == 2)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B];
                        }
                        if (k == 3)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B];
                        }

                    }
                }
                fobrazek_bitmapa.UnlockImage();

                float skala = (512.0f / (float)histogram_max) * ((float)pasek_skali.Value / 10.0f);

               histogram = new Bitmap(1024, 513);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                Color slupki = Color.Black;
                if (k == 0)
                    slupki = Color.Red;
                if (k == 1)
                    slupki = Color.Green;
                if (k == 2)
                    slupki = Color.Blue;

                Color tlo = Color.White;

                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_values_tmp[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), slupki);

                        }
                        else
                        {
                            //fhistogram.SetPixel(4*x1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+2, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+3, (int)(256 - y1), tlo);
                        }
                    }
                }

                fhistogram.UnlockImage();
            }
            return histogram;
        }

        private Bitmap generuj_histogram_kolory(int k)
        {
            Bitmap obrazek_bitmapa = new Bitmap(this.pictureFGLwynik.Image);
            if (histogram_kolory_values == null)
                histogram_kolory_values = new int[256,3];
            int histogram_max = 0;
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(obrazek_bitmapa);
            fobrazek_bitmapa.LockImage();
            //Zliczanie wartości histogramu
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0];
                }
            }
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1];
                }
            }
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2];
                }
            }
            fobrazek_bitmapa.UnlockImage();
            float skala = (512.0f / (float)histogram_max) ;
            Bitmap histogram = new Bitmap(1024, 513);
            BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
            fhistogram.LockImage();
            for (int x1 = 0; x1 < 256; x1++)
            {
                int tmpr = (int)(histogram_kolory_values[x1,0] * skala);
                int tmpg = (int)(histogram_kolory_values[x1,1] * skala);
                int tmpb = (int)(histogram_kolory_values[x1,2] * skala);
                //0,1,2 nie 3
                if (k < 3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpr)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Red);
                        }
                    }
                }
                //0,1,3 nie 2
                if (k < 2 || k==3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpg)
                        {
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Green);
                        }
                    }
                }
                //0,2,3 nie 1
                if (k == 0 || k > 1)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpb)
                        {
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Blue);
                        }
                    }
                }
            }
            fhistogram.UnlockImage();
            return histogram;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (this.radioSzary.Checked)
            {
            //    this.tab_histogram_Enter(this.pictureWynikHist.Image);
                this.generuj_histogram(0);
              //  this.groupHistogram.Visible = true;
            }
            if (this.radioKolorRGB.Checked)
            {
                this.HistogramRGB.Image = generuj_histogram_kolory(0);
                this.label5.Text = "rgb";
            }
            if (this.radioKolorHVS.Checked)
            { 
            
            }           
            EnableDoubleBuffered(this.dataGridTablica, true);
            int cols_width = 40;         
            Bitmap bmpTab = (Bitmap)this.pictureFGLwynik.Image;

            if (dataGridTablica.Columns.Count != bmpTab.Width || dataGridTablica.Rows.Count != bmpTab.Height)
            {
                dataGridTablica.Rows.Clear();
                dataGridTablica.Columns.Clear();
                dataGridTablica.RowHeadersWidth = 60;
                for (int x = 0; x < bmpTab.Width; x++)
                {
                    dataGridTablica.Columns.Add(null, x.ToString());
                    dataGridTablica.Columns[x].Width = cols_width;
                    dataGridTablica.Columns[x].FillWeight = 0.0000001f;
                }
                dataGridTablica.Rows.Add(bmpTab.Height);
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    dataGridTablica.Rows[y].HeaderCell.Value = y.ToString();
                }
            }
            for (int x = 0; x < bmpTab.Width; x++)
            {
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    dataGridTablica[x, y].Value = bmpTab.GetPixel(x, y).R;
                }
            } 
        }

        private void pasek_skali_Scroll(object sender, EventArgs e)
        {
            wartosc_skali.Text = ((double)pasek_skali.Value / 10.0f).ToString();
            this.HistogramGrey.Image = generuj_histogram(4);
        }

        private void buttpn_red_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(0);
        }

        private void button_green_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(1);
        }

        private void button_blue_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(2);
        }

        private void button_wszystkie_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(0);
        }

        private void button8_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(1);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(2);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(3);
        }

        private void dataGridView2_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }
       
  }      
}