﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Windows.Forms.DataVisualization.Charting;
using System.Drawing.Imaging;


namespace APO_BB_DK_v012013
{
    public partial class ObrazFM: Form
    {
     //   private OperatorOPJ processingOPJ;
        private TrackBar suwak1;
        private OpenFileDialog open;
        public PictureBox pictureHistogramOPJ;
        public PictureBox pictureFLW;
        public Bitmap bitmap;

        private Bitmap originalBitmap = null;
        private Bitmap previewBitmap = null;
        private Bitmap resultBitmap = null;
      
        public ObrazFM()
        {
            InitializeComponent();
            //processingOPJ = new OperatorOPJ();
            open = new OpenFileDialog();
            suwak1 = new System.Windows.Forms.TrackBar();
            this.pictureFL.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureFLW.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureObrazFL1.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureObrazFL2.SizeMode = PictureBoxSizeMode.StretchImage;
          
            comboBoxFL.Items.Add ("Operacje Sąsiedztwa");
            comboBoxFL.Items.Add("Operacja Medianowa 3x3");
            comboBoxFL.Items.Add("Operacja Medianowa 3x5");
            comboBoxFL.Items.Add("Operacja Medianowa 5x5");
            comboBoxFL.Items.Add("Operacja Medianowa 7x7");
            comboBoxFL.Items.Add("Operacja Medianowa 9x9");
            comboBoxFL.Items.Add("Operacja Medianowa 11x11");
            comboBoxFL.Items.Add("Operacja Medianowa 13x13");
            comboBoxFL.Items.Add("Operacja Medianowa 15x15");
            comboBoxFL.Items.Add("Operacja Medianowa 17x17");
           
            comboBoxFL.SelectedIndex = 0;        
        }
        
        private void buttonHistogramOPJ_Click(object sender, EventArgs e)
        {
            Bitmap bmpG = (Bitmap)this.pictureFLW.Image;
            Bitmap hs = new HistogramRysuj(bmpG).draw();
            this.pictureHistogramOPJ.Image = hs;
            this.pictureHistogramOPJ.Visible = true; 
            /*
            this.pictureHistogramOPJ.Visible = true;
            Bitmap bmpHistogOPJ = (Bitmap)pictureFLW.Image;
            this.processingOPJ.setImage(new Bitmap(this.pictureFLW.Image));
        //    this.processingOPJ.calcHisto(this);
            this.Invalidate();
             */
        }


        private void button1_Click(object sender, EventArgs e)
        {         
            FunkcjeJednoarg fn = new FunkcjeJednoarg();
 
            if (this.radioSzaryFL.Checked)
            {
                this.label1.Text = "Obraz wynikowy w odcieniach szarości";
                Bitmap bmpFL = new Bitmap(this.pictureObrazFL1.Image);
                this.pictureObrazFL2.Image = bmpFL;
                bmpFL = fn.Skalaszarosci(bmpFL);
                this.pictureFLW.Image = bmpFL;
                this.pictureFL.Image = bmpFL;
                this.pictureFLW.Image = bmpFL.CopyToSquareCanvas(pictureFLW.Width);
                this.comboBoxFL.Visible = true;
                this.pictureFLW.Visible = true;
                this.groupHistogramFL.Visible = true;
                previewBitmap = bmpFL.CopyToSquareCanvas(this.pictureFL.Width);
                this.pictureFLW.Image = previewBitmap;
            }

            else
            {
                this.label1.Text = "Obraz wynikowy kolorowy";
                Bitmap bmpFLkol = new Bitmap(this.pictureObrazFL1.Image);            
                this.comboBoxFL.Visible = true;
                this.pictureFL.Image = bmpFLkol;
                this.pictureFLW.Image = bmpFLkol;
                this.pictureFLW.Visible = true;
                this.groupHistogramFL.Visible = true;
                previewBitmap = bmpFLkol.CopyToSquareCanvas(this.pictureFL.Width);
                this.pictureFLW.Image = previewBitmap;
            }
            this.comboBoxFL.Refresh();
        }

        private void buttonObrazFL_Click_1(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Title = "Select the source Image";
            ofd.Filter = "Image Files(*.BMP;*.JPG;*.PNG)|*.BMP;*.JPG;*.PNG|All files (*.*)|*.*";

            if (ofd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                StreamReader streamReader = new StreamReader(ofd.FileName);
                originalBitmap = (Bitmap)Bitmap.FromStream(streamReader.BaseStream);
                streamReader.Close();
                previewBitmap = originalBitmap.CopyToSquareCanvas(pictureFL.Width);
                this.pictureFL.Image = previewBitmap;
                this.pictureObrazFL1.Image = originalBitmap;
              }
        }
        

           
        private void buttonWidok_Click(object sender, EventArgs e)
        {
            this.pictureFL.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureFLW.SizeMode = PictureBoxSizeMode.StretchImage;

            if (this.radioNaturalny.Checked)
            {
               
                this.pictureFLW.SizeMode = PictureBoxSizeMode.Normal;
                this.pictureFL.SizeMode = PictureBoxSizeMode.Normal;
            }

            if (this.radioAutoSize.Checked)
            {
                this.pictureFL.SizeMode = PictureBoxSizeMode.CenterImage;
                this.pictureFLW.SizeMode = PictureBoxSizeMode.CenterImage;
            }
            if (this.radioDopasowany.Checked)
            {
                this.pictureFL.SizeMode = PictureBoxSizeMode.StretchImage;
                this.pictureFLW.SizeMode = PictureBoxSizeMode.StretchImage;
            }
            this.pictureFL.Refresh();
            this.pictureFLW.Refresh();
        }

        private void ApplyFilter(bool preview)
        {
            if (previewBitmap == null || comboBoxFL.SelectedIndex == -1)
            {
                return;
            }

            Bitmap selectedSource = null;
            Bitmap bitmapResult = null;

            if (preview == true)
            {
                selectedSource = previewBitmap;
            }
            else
            {
                selectedSource = originalBitmap;
            }

            if (selectedSource != null)
            {
                if (comboBoxFL.SelectedItem.ToString() == "None")
                {
                    bitmapResult = selectedSource;
                }
                else if (comboBoxFL.SelectedItem.ToString() == "Operacja Medianowa 3x3")
                {
                    bitmapResult = selectedSource.MedianFilter(3);
                }
                else if (comboBoxFL.SelectedItem.ToString() == "Operacja Medianowa 3x5")
                {
                    bitmapResult = selectedSource.MedianFilter(3);
                    bitmapResult = selectedSource.MedianFilter(5);
                }
                else if (comboBoxFL.SelectedItem.ToString() == "Operacja Medianowa 5x5")
                {
                    bitmapResult = selectedSource.MedianFilter(5);
                }
                else if (comboBoxFL.SelectedItem.ToString() == "Operacja Medianowa 7x7")
                {
                    bitmapResult = selectedSource.MedianFilter(7);
                }
                else if (comboBoxFL.SelectedItem.ToString() == "Operacja Medianowa 9x9")
                {
                    bitmapResult = selectedSource.MedianFilter(9);
                }
                else if (comboBoxFL.SelectedItem.ToString() == "Operacja Medianowa 11x11")
                {
                    bitmapResult = selectedSource.MedianFilter(11);
                }
                else if (comboBoxFL.SelectedItem.ToString() == "Operacja Medianowa 13x13")
                {
                    bitmapResult = selectedSource.MedianFilter(13);
                }
                else if (comboBoxFL.SelectedItem.ToString() == "Operacja Medianowa 15x15")
                {
                    bitmapResult = selectedSource.MedianFilter(15);
                }
                else if (comboBoxFL.SelectedItem.ToString() == "Operacja Medianowa 17x17")
                {
                    bitmapResult = selectedSource.MedianFilter(17);
                }
            }

            if (bitmapResult != null)
            {
                if (preview == true)
                {
                    pictureFLW.Image = bitmapResult;
                }
                else
                {
                    resultBitmap = bitmapResult;
                }
            }
        }

        private void comboBoxFL_SelectedIndexChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }              
    }
}