﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Windows.Forms.DataVisualization.Charting;
using System.Drawing.Imaging;
using BitmapProcessing;
using System.Reflection;
using APO_BB_DK_v012013.Operacje;
using System.Runtime.InteropServices;
using System.Drawing.Drawing2D;

namespace APO_BB_DK_v012013
{
    public partial class ObrazHSV_JP : Form
    {
        #region deklaracja zmiennych
     //   private OperatorOPJ processingOPJ;
        private TrackBar suwak1;
        private OpenFileDialog open;
        public PictureBox pictureHistogramOPJ;
        public PictureBox pictureWtornyOPJ;
        public PictureBox picturePierwotnyOPJ;
        public Bitmap bitmap;
        public int w;



        private Bitmap originalBitmap = null;
        private Bitmap previewBitmap = null;
        private Bitmap resultBitmap = null;
    //    Bitmap bmpHSV;
    //    private TrackBar wartosc;
        public Label t;
     //   private int kanalRGB;
     //   private ColorDialog cld;
    //    private Panel tmp;

    //    private int _id = -1;
        private int[] histogram_values = new int[256];
        private int[] histogram_hsv_values = new int[256];
        private int[,] histogram_kolory_values;

        private int[] histogram_values2 = new int[256];
        private int[] histogram_hsv_values2 = new int[256];
        private int[,] histogram_kolory_values2;
        private bool _HSV = false;
        #endregion

        public bool HSV
        {
            #region HSV
            get { return _HSV; }
            set { _HSV = value; this.label2.Text = "Obraz (HSV)"; this.HistogramRGB.Visible = false; button_blue.Visible = false; button_green.Visible = false; buttpn_red.Visible = false; label2.Visible = false; button_wszystkie.Visible = false; button1.Visible = false; button3.Visible = false; label2.Visible = true; label2.Text = "1.0"; }
            #endregion
        }

        public Bitmap get_image
        {
            #region get_image
            get { return new Bitmap(this.pictureWtornyOPJ.Image); }
            set { }
            #endregion
        }
        public Bitmap get_histogram
        {
            #region get_histogram
            get
            {
                if (this.HistogramGrey.Image == null)
                    return null;
                return new Bitmap(HistogramGrey.Image);
            }
            set { }
            #endregion
        }
        public Bitmap get_histogram_kolory
        {
            #region get_histogram_kolory
            get
            {
                if (this.HistogramRGB.Image == null)
                    return null;
                return new Bitmap(this.HistogramRGB.Image);
            }
            set { }
            #endregion
        }

        private void EnableDoubleBuffered(DataGridView dgv, bool setting)
        {
            #region EnableDoubleBuffered
            Type dgvType = dgv.GetType();
            PropertyInfo pi = dgvType.GetProperty("DoubleBuffered", BindingFlags.Instance | BindingFlags.NonPublic);
            pi.SetValue(dgv, setting, null);
            #endregion
        }

        private Bitmap generuj_histogram(int k)
        {
            #region generuj_histogram
            Bitmap obrazek_bitmapa = new Bitmap(this.pictureWtornyOPJ.Image);
            Bitmap histogram = null;
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(obrazek_bitmapa);

            if (HSV)
            {
                int histogram_max = 0;
                double h, s, v;
                fobrazek_bitmapa.LockImage();
                for (int x = 0; x < obrazek_bitmapa.Width; x++)
                {
                    for (int y = 0; y < obrazek_bitmapa.Height; y++)
                    {
                        hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y), out h, out s, out v);
                        int temp_v = (int)(v * 255.0f);
                        histogram_hsv_values[temp_v]++;
                        if (histogram_hsv_values[temp_v] > histogram_max)
                            histogram_max = histogram_hsv_values[temp_v];
                    }
                }
                fobrazek_bitmapa.UnlockImage();
                double skala = (512.0f / (double)histogram_max) * ((double)pasek_skali.Value / 10.0f);
                histogram = new Bitmap(1024, 513);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_hsv_values[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Black);
                        }
                    }
                }

                fhistogram.UnlockImage();
            }
            else
            {
                int[] histogram_values_tmp;
                histogram_values_tmp = new int[256];
                int histogram_max = 0;
                fobrazek_bitmapa.LockImage();
                //Zliczanie wartości histogramu
                for (int x = 0; x < obrazek_bitmapa.Width; x++)
                {
                    for (int y = 0; y < obrazek_bitmapa.Height; y++)
                    {
                        if (k == 0 || k > 2)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R]++;
                            histogram_values[fobrazek_bitmapa.GetPixel(x, y).R]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R];
                        }
                        if (k == 1)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G];
                        }
                        if (k == 2)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B];
                        }
                        if (k == 3)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B];
                        }

                    }
                }
                fobrazek_bitmapa.UnlockImage();
                float skala = (512.0f / (float)histogram_max) * ((float)pasek_skali.Value / 10.0f);
                histogram = new Bitmap(1024, 513);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                Color slupki = Color.Black;
                if (k == 0)
                    slupki = Color.Red;
                if (k == 1)
                    slupki = Color.Green;
                if (k == 2)
                    slupki = Color.Blue;
                Color tlo = Color.White;
                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_values_tmp[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), slupki);
                        }
                        else
                        {
                            //fhistogram.SetPixel(4*x1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+2, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+3, (int)(256 - y1), tlo);
                        }
                    }
                }
                fhistogram.UnlockImage();
            }
            return histogram;
            #endregion
        }

        private Bitmap generuj_histogram2(int k)
        {
            #region generuj_histogram2
            Bitmap bmp = new Bitmap(this.picturePierwotnyOPJ.Image);
            Bitmap histogram = null;
            BitmapProcessing.FastBitmap fbmp = new BitmapProcessing.FastBitmap(bmp);

            if (HSV)
            {
                int histogram_max = 0;
                double h, s, v;
                fbmp.LockImage();
                for (int x = 0; x < bmp.Width; x++)
                {
                    for (int y = 0; y < bmp.Height; y++)
                    {
                        hsv.ColorToHSV(fbmp.GetPixel(x, y), out h, out s, out v);
                        int temp_v = (int)(v * 255.0f);
                        histogram_hsv_values2[temp_v]++;
                        if (histogram_hsv_values2[temp_v] > histogram_max)
                            histogram_max = histogram_hsv_values2[temp_v];
                    }
                }
                fbmp.UnlockImage();
                double skala = (512.0f / (double)histogram_max) * ((double)pasek_skali.Value / 10.0f);
                histogram = new Bitmap(1024, 513);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_hsv_values2[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Black);
                        }
                    }
                }

                fhistogram.UnlockImage();
            }
            else
            {
                int[] histogram_values_tmp;
                histogram_values_tmp = new int[256];
                int histogram_max = 0;
                fbmp.LockImage();
                //Zliczanie wartości histogramu
                for (int x = 0; x < bmp.Width; x++)
                {
                    for (int y = 0; y < bmp.Height; y++)
                    {
                        if (k == 0 || k > 2)
                        {
                            histogram_values_tmp[fbmp.GetPixel(x, y).R]++;
                            histogram_values2[fbmp.GetPixel(x, y).R]++;
                            if (histogram_values_tmp[fbmp.GetPixel(x, y).R] > histogram_max)
                                histogram_max = histogram_values_tmp[fbmp.GetPixel(x, y).R];
                        }
                        if (k == 1)
                        {
                            histogram_values_tmp[fbmp.GetPixel(x, y).G]++;
                            if (histogram_values_tmp[fbmp.GetPixel(x, y).G] > histogram_max)
                                histogram_max = histogram_values_tmp[fbmp.GetPixel(x, y).G];
                        }
                        if (k == 2)
                        {
                            histogram_values_tmp[fbmp.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fbmp.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fbmp.GetPixel(x, y).B];
                        }
                        if (k == 3)
                        {
                            histogram_values_tmp[fbmp.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fbmp.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fbmp.GetPixel(x, y).B];
                        }

                    }
                }
                fbmp.UnlockImage();
                float skala = (512.0f / (float)histogram_max) * ((float)pasek_skali.Value / 10.0f);
                histogram = new Bitmap(1024, 513);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                Color slupki = Color.Black;
                if (k == 0)
                    slupki = Color.Red;
                if (k == 1)
                    slupki = Color.Green;
                if (k == 2)
                    slupki = Color.Blue;
                Color tlo = Color.White;
                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_values_tmp[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), slupki);
                        }
                        else
                        {
                            //fhistogram.SetPixel(4*x1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+2, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+3, (int)(256 - y1), tlo);
                        }
                    }
                }
                fhistogram.UnlockImage();
            }
            return histogram;
            #endregion
        }

        private Bitmap generuj_histogram_kolory2(int k)
        {
            #region generuj_histogram_kolory2
            Bitmap bmp = new Bitmap(this.picturePierwotnyOPJ.Image);
            if (histogram_kolory_values2 == null)
                histogram_kolory_values2 = new int[256, 3];
            int histogram_max = 0;
            BitmapProcessing.FastBitmap fbmp = new BitmapProcessing.FastBitmap(bmp);
            fbmp.LockImage();
            //Zliczanie wartości histogramu
            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    histogram_kolory_values2[fbmp.GetPixel(x, y).R, 0]++;
                    if (histogram_kolory_values2[fbmp.GetPixel(x, y).R, 0] > histogram_max)
                        histogram_max = histogram_kolory_values2[fbmp.GetPixel(x, y).R, 0];
                }
            }
            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    histogram_kolory_values2[fbmp.GetPixel(x, y).G, 1]++;
                    if (histogram_kolory_values2[fbmp.GetPixel(x, y).G, 1] > histogram_max)
                        histogram_max = histogram_kolory_values2[fbmp.GetPixel(x, y).G, 1];
                }
            }
            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    histogram_kolory_values2[fbmp.GetPixel(x, y).B, 2]++;
                    if (histogram_kolory_values2[fbmp.GetPixel(x, y).B, 2] > histogram_max)
                        histogram_max = histogram_kolory_values2[fbmp.GetPixel(x, y).B, 2];
                }
            }
            fbmp.UnlockImage();
            float skala = (512.0f / (float)histogram_max);
            Bitmap histogram = new Bitmap(1024, 513);
            BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
            fhistogram.LockImage();
            for (int x1 = 0; x1 < 256; x1++)
            {
                int tmpr = (int)(histogram_kolory_values2[x1, 0] * skala);
                int tmpg = (int)(histogram_kolory_values2[x1, 1] * skala);
                int tmpb = (int)(histogram_kolory_values2[x1, 2] * skala);
                //0,1,2 nie 3
                if (k < 3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpr)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Red);
                        }
                    }
                }
                //0,1,3 nie 2
                if (k < 2 || k == 3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpg)
                        {
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Green);
                        }
                    }
                }
                //0,2,3 nie 1
                if (k == 0 || k > 1)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpb)
                        {
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Blue);
                        }
                    }
                }
            }
            fhistogram.UnlockImage();
            return histogram;
            #endregion
        }

        private Bitmap generuj_histogram_kolory(int k)
        {
            # region generuj_histogram_kolory
            Bitmap obrazek_bitmapa = new Bitmap(this.pictureWtornyOPJ.Image);
            if (histogram_kolory_values == null)
                histogram_kolory_values = new int[256, 3];
            int histogram_max = 0;
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(obrazek_bitmapa);
            fobrazek_bitmapa.LockImage();
            //Zliczanie wartości histogramu
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0];
                }
            }
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1];
                }
            }
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2];
                }
            }
            fobrazek_bitmapa.UnlockImage();
            float skala = (512.0f / (float)histogram_max);
            Bitmap histogram = new Bitmap(1024, 513);
            BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
            fhistogram.LockImage();
            for (int x1 = 0; x1 < 256; x1++)
            {
                int tmpr = (int)(histogram_kolory_values[x1, 0] * skala);
                int tmpg = (int)(histogram_kolory_values[x1, 1] * skala);
                int tmpb = (int)(histogram_kolory_values[x1, 2] * skala);
                //0,1,2 nie 3
                if (k < 3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpr)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Red);
                        }
                    }
                }
                //0,1,3 nie 2
                if (k < 2 || k == 3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpg)
                        {
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Green);
                        }
                    }
                }
                //0,2,3 nie 1
                if (k == 0 || k > 1)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpb)
                        {
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Blue);
                        }
                    }
                }
            }
            fhistogram.UnlockImage();
            return histogram;
            #endregion
        }

        public ObrazHSV_JP()
        {
            #region ObrazHSV_JP()
            InitializeComponent();
            //processingOPJ = new OperatorOPJ();
            open = new OpenFileDialog();
            suwak1 = new System.Windows.Forms.TrackBar();
            comboBoxFGG.Items.Add("Operacje jednopunktowe");
            comboBoxFGG.SelectedIndex = 0; 
            tabJP.TabPages.Clear();
            w = 2;
            #endregion
        }

        private void buttonObrazPierwotnyOPJ_Click(object sender, EventArgs e)
        {
            #region OTWIERANIE OBRAZ Z PLIKU
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Title = "Select the source Image";
            ofd.Filter = "Image Files(*.BMP;*.JPG;*.PNG)|*.BMP;*.JPG;*.PNG|All files (*.*)|*.*";

            if (ofd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                StreamReader streamReader = new StreamReader(ofd.FileName);
                originalBitmap = (Bitmap)Bitmap.FromStream(streamReader.BaseStream);
                streamReader.Close();
                label28.Text = ofd.FileName;
                previewBitmap = originalBitmap.CopyToSquareCanvas(this.picturePierwotnyOPJ.Width);
                this.picturePierwotnyOPJ.Image = previewBitmap;
                this.pictureObrazFL1.Image = originalBitmap;
            }
            #endregion
        }

        private void buttonKolor_Click(object sender, EventArgs e)
        {
            #region wybór obrazu
            FunkcjeJednoarg fn = new FunkcjeJednoarg();
            comboBoxFGG.Items.Clear();
            comboBoxFGG.Items.Add("Operacje jednopunktowe");
            comboBoxFGG.SelectedIndex = 0;
            #endregion

            if (this.radioSzary.Checked)
            {
                #region obraz w odcieniach szarości
                comboBoxFGG.Items.Add("Identyczność");
                comboBoxFGG.Items.Add("Negacja");
                comboBoxFGG.Items.Add("Kontrast");
                comboBoxFGG.Items.Add("Jasność");
                comboBoxFGG.Items.Add("Bineryzacja");
                comboBoxFGG.Items.Add("Progowanie odwrotne");
                comboBoxFGG.Items.Add("Progowanie przedziałami");
                comboBoxFGG.Items.Add("Progowanie z poziomem szarości");
                comboBoxFGG.Items.Add("Rozciąganie");
                comboBoxFGG.Items.Add("Korekcja Gamma");
                comboBoxFGG.Items.Add("Redukcja poziomów szarości");
                comboBoxFGG.Items.Add("Sepia");
                comboBoxFGG.Items.Add("Transparentny");
                comboBoxFGG.SelectedIndex = 0;

                this.label1.Text = "Obraz wynikowy w odcieniach szarości";
                Bitmap bmpGrey = new Bitmap(this.pictureObrazFL1.Image);
                bmpGrey = pictureObrazFL1.Image.DrawAsGrayscale();
                //    bmpGrey = fn.Skalaszarosci(bmpGrey);
                this.pictureObrazFL2.Image = bmpGrey;
                picturePierwotnyOPJ.Image = bmpGrey;
                pictureWtornyOPJ.Image = bmpGrey;
                previewBitmap = bmpGrey;
                //      previewBitmap = bmpGrey.CopyAsGrayscale();
                //        previewBitmap = bmpGrey.CopyToSquareCanvas(this.picturePierwotnyOPJ.Width);
                this.pictureWtornyOPJ.Image = previewBitmap;
                tabJP.TabPages.Clear();
                #endregion
            }

            if (this.radioKolorHVS.Checked)
            {
                #region obraz HSV
                comboBoxFGG.Items.Add("Identyczność HSV");
                comboBoxFGG.Items.Add("Negacja HSV");
                comboBoxFGG.Items.Add("Kontrast HSV");
                comboBoxFGG.Items.Add("Jasność HSV");
                comboBoxFGG.Items.Add("Rozciąganie HSV");
                comboBoxFGG.Items.Add("Bineryzacja HSV");
                comboBoxFGG.Items.Add("Korekcja Gamma HSV");
                comboBoxFGG.Items.Add("Odcienie HSV");
                comboBoxFGG.Items.Add("Redukcja poziomów jasności HSV");
                comboBoxFGG.Items.Add("Sepia HSV");
                comboBoxFGG.Items.Add("Transparentny HSV");
                comboBoxFGG.SelectedIndex = 0;

                this.label1.Text = "Obraz wtórny kolorowy HVS";
                Bitmap bmpHVS = new Bitmap(this.pictureObrazFL1.Image);
                picturePierwotnyOPJ.Image = bmpHVS;
                pictureWtornyOPJ.Image = bmpHVS;
                previewBitmap = bmpHVS.CopyToSquareCanvas(this.picturePierwotnyOPJ.Width);
                this.pictureWtornyOPJ.Image = previewBitmap;
                #endregion
            }

            if (this.radioKolorRGB.Checked)
            {
                #region obraz RGB
                comboBoxFGG.Items.Add("Identyczność RGB");
                comboBoxFGG.Items.Add("Negacja RGB");
                comboBoxFGG.Items.Add("Kontrast RGB");
                comboBoxFGG.Items.Add("Jasność RGB");
                comboBoxFGG.Items.Add("Rozciąganie RGB");
                comboBoxFGG.Items.Add("Bineryzacja RGB");
                comboBoxFGG.Items.Add("Progowanie odwrotne RGB");
                comboBoxFGG.Items.Add("Progowanie przedziałami RGB");
                comboBoxFGG.Items.Add("Progowanie z poziomem szarości RGB");
                comboBoxFGG.Items.Add("Korekcja Gamma RGB");
                comboBoxFGG.Items.Add("Odcień RGB");
                comboBoxFGG.Items.Add("Redukcja poziomów jasności RGB");
                comboBoxFGG.Items.Add("Sepia RGB");
                comboBoxFGG.Items.Add("Transparentny RGB");
                comboBoxFGG.SelectedIndex = 0;

                this.label1.Text = "Obraz wtórny kolorowy RGB";
                Bitmap bmpRGB = new Bitmap(this.pictureObrazFL1.Image);
                picturePierwotnyOPJ.Image = bmpRGB;
                pictureWtornyOPJ.Image = bmpRGB;
           //     previewBitmap = bmpRGB.CopyToSquareCanvas(this.picturePierwotnyOPJ.Width);
                previewBitmap = bmpRGB;
                this.pictureWtornyOPJ.Image = previewBitmap;
                #endregion
            }
        }

        private void buttonHistogramOPJ_Click(object sender, EventArgs e)
        {
            #region Histogram mały - testowy
            Bitmap bmpG = (Bitmap)this.pictureWtornyOPJ.Image;
            Bitmap hs = new HistogramRysuj(bmpG).draw();
            this.pictureHistogramOPJ.Image = hs;
            this.pictureHistogramOPJ.Visible = true;

            /*
            this.pictureHistogramOPJ.Visible = true;
            Bitmap bmpHistogOPJ = (Bitmap)pictureWtornyOPJ.Image;
            this.processingOPJ.setImage(new Bitmap(this.pictureWtornyOPJ.Image));
            this.processingOPJ.calcHisto(this);
            this.Invalidate();
            */
            #endregion
        }

        private void trackBarJasnosc(Bitmap bmp, int b)
        {
            #region Tabkica LUT - JASNOŚĆ
            //Przygotuj tablice LUT i pokaz ja na wykresie
            wykres.Series[0].Points.Clear();
            byte[] LUT = new byte[256];
            wykres.Titles[0].Text = "Tablica LUT, p1 = " + b;
            for (int i = 0; i < 256; i++)
            {
                if ((b + i) > 255)
                {
                    LUT[i] = 255;
                }
                else if ((b + i) < 0)
                {
                    LUT[i] = 0;
                }
                else
                {
                    LUT[i] = (byte)(b + i);
                }
                wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
            }
            //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
            if (bmp == null)
            {
                return;
            }
            Bitmap bitmap = (Bitmap)this.picturePierwotnyOPJ.Image.Clone();
            this.pictureWtornyOPJ.Image = bitmap;
            //Pobierz wartosc wszystkich punktow obrazu
            BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
            byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
            System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);
            //Zmien jasnosc kazdego punktu zgodnie z tablica LUT
            for (int i = 0; i < pixelValues.Length; i++)
            {
                pixelValues[i] = LUT[pixelValues[i]];
            }
            //Ustaw wartosc wszystkich punktow obrazu
            System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
            bitmap.UnlockBits(bmpData);
            #endregion
        }

        private void trackGamma(object sender, EventArgs e)
        {
            #region Tabkica LUT - KOREKCJA GAMMA
            //Przygotuj tablice LUT i pokaz ja na wykresie
            wykres.Series[0].Points.Clear();
            byte[] LUT = new byte[256];
            double gamma ;
            if (radioKolorRGB.Checked)
            {
                gamma = tracKGammaRGB.Value / 100.0;
            }
            else
            {
                gamma = trackKorekcjaGammaS.Value / 100.0;
            }
            wykres.Titles[0].Text = "Tablica LUT, gamma = " + gamma;
            for (int i = 0; i < 256; i++)
            {
                if ((255 * Math.Pow(i / 255.0, 1 / gamma)) > 255)
                {
                    LUT[i] = 255;
                }
                else
                {
                    LUT[i] = (byte)(255 * Math.Pow(i / 255.0, 1 / gamma));
                }
                wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
            }
            //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
            if (picturePierwotnyOPJ.Image == null)
            {
                return;
            }
            Bitmap bitmap = (Bitmap)this.picturePierwotnyOPJ.Image.Clone();
            this.pictureWtornyOPJ.Image = bitmap;
            //Pobierz wartosc wszystkich punktow obrazu
            BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
            byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
            System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);
            for (int i = 0; i < pixelValues.Length; i++)
            {
                pixelValues[i] = LUT[pixelValues[i]];
            }
            System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
            bitmap.UnlockBits(bmpData);
            #endregion
        }

        private void trackBarGamma(Bitmap bmp, int b)
        {
            #region Tabkica LUT - KOREKCJA GAMMA
            //Przygotuj tablice LUT i pokaz ja na wykresie
            wykres.Series[0].Points.Clear();
            byte[] LUT = new byte[256];
            double gamma = b / 100.0;
            wykres.Titles[0].Text = "Tablica LUT, gamma = " + gamma;
            for (int i = 0; i < 256; i++)
            {
                if ((255 * Math.Pow(i / 255.0, 1 / gamma)) > 255)
                {
                    LUT[i] = 255;
                }
                else
                {
                    LUT[i] = (byte)(255 * Math.Pow(i / 255.0, 1 / gamma));
                }
                wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
            }
            //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
            if (bmp == null)
            {
                return;
            }
            Bitmap bitmap = (Bitmap)this.picturePierwotnyOPJ.Image.Clone();
            this.pictureWtornyOPJ.Image = bitmap;
            //Pobierz wartosc wszystkich punktow obrazu
            BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
            byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
            System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);
            for (int i = 0; i < pixelValues.Length; i++)
            {
                pixelValues[i] = LUT[pixelValues[i]];
            }
            System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
            bitmap.UnlockBits(bmpData);
            #endregion
        }

        private void trackBarKontrast(Bitmap bmp, int b)
        {
            #region Tabkica LUT - KONTRAST
            //Przygotuj tablice LUT i pokaz ja na wykresie
            wykres.Series[0].Points.Clear();
            byte[] LUT = new byte[256];
            double a;
            if (b <= 0)
            {
                a = 1.0 + (b / 256.0);
            }
            else
            {
                a = 256.0 / Math.Pow(2, Math.Log(257 - b, 2));
            }
            wykres.Titles[0].Text = "Tablica LUT, p1 = " + a;
            for (int i = 0; i < 256; i++)
            {
                if ((a * (i - 127) + 127) > 255)
                {
                    LUT[i] = 255;
                }
                else if ((a * (i - 127) + 127) < 0)
                {
                    LUT[i] = 0;
                }
                else
                {
                    LUT[i] = (byte)(a * (i - 127) + 127);
                }
                wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
            }
            //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
            if (bmp == null)
            {
                return;
            }
            //Kopiuj obrazek zrodlowy        
            Bitmap bitmap = (Bitmap)this.picturePierwotnyOPJ.Image.Clone();
            //    Bitmap bitmap1 = (Bitmap)this.picturePierwotnySzary.Image.Clone();
            this.pictureWtornyOPJ.Image = bitmap;
            //Pobierz wartosc wszystkich punktow obrazu
            BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
            byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
            System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);
            //Zmien kontrast kazdego punktu zgodnie z tablica LUT
            for (int i = 0; i < pixelValues.Length; i++)
            {
                pixelValues[i] = LUT[pixelValues[i]];
            }
            //Ustaw wartosc wszystkich punktow obrazu
            System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
            bitmap.UnlockBits(bmpData);
            #endregion
        }

        private void trackBarBineryzacja2(Bitmap bmp, int b)
        {
            #region Tabkica LUT - BINERYZACJA 2
            //Przygotuj tablice LUT i pokaz ja na wykresie
            wykres.Series[0].Points.Clear();
            byte[] LUT = new byte[256];
            int a = b / 3;
            //   int b = this.trackBarOPJ.Value;
            //  int b = this.trackBar1.Value;
            wykres.Titles[0].Text = "Tablica LUT, p1 = " + a;
            for (int i = 0; i < 256; i++)
            {
                if ((a + i) > 255)
                {
                    LUT[i] = 255;
                }
                else if ((a + i) < 0)
                {
                    LUT[i] = 0;
                }
                else
                {
                    LUT[i] = (byte)(a + i);
                }
                wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
            }
            //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
            if (bmp == null)
            {
                return;
            }
            Bitmap bitmap = (Bitmap)this.picturePierwotnyOPJ.Image.Clone();
            this.pictureWtornyOPJ.Image = bitmap;
            //Pobierz wartosc wszystkich punktow obrazu
            BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
            byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
            System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);
            //Korekcja gamma dla kazdego punktu zgodnie z tablica LUT
            for (int i = 0; i < pixelValues.Length; i++)
            {
                pixelValues[i] = LUT[pixelValues[i]];
            }
            //Ustaw wartosc wszystkich punktow obrazu
            System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
            bitmap.UnlockBits(bmpData);
            #endregion
        }

        private void trackBarBineryzacjaOdwrotna(Bitmap bmp, int b)
        {
            #region Tabkica LUT - BINERYZACJA ODWROTNA
            //Przygotuj tablice LUT i pokaz ja na wykresie
            wykres.Series[0].Points.Clear();
            byte[] LUT = new byte[256];
            //   int b = this.trackBarOPJ.Value;
            //  int b = this.trackBar1.Value;
            int a = b/3 ;
            wykres.Titles[0].Text = "Tablica LUT, p1 = " + a.ToString("0");
            for (int i = 0; i < 256; i++)
            {
                if (i <= a)
                {
                    LUT[i] = 255;
                }
                else LUT[i] = 0;

                wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
            }

            //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
            if (bmp == null)
            {
                return;
            }
            Bitmap bitmap = (Bitmap)this.picturePierwotnyOPJ.Image.Clone();
            this.pictureWtornyOPJ.Image = bitmap;
            //Pobierz wartosc wszystkich punktow obrazu
            BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
            byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
            System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);
            //Korekcja gamma dla kazdego punktu zgodnie z tablica LUT
            for (int i = 0; i < pixelValues.Length; i++)
            {
                pixelValues[i] = LUT[pixelValues[i]];
            }
            //Ustaw wartosc wszystkich punktow obrazu
            System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
            bitmap.UnlockBits(bmpData);
            #endregion
        }

        private void trackBarBineryzacja(Bitmap bmp, int b)
        {
            #region Tabkica LUT - BINERYZACJA
            //Przygotuj tablice LUT i pokaz ja na wykresie
            wykres.Series[0].Points.Clear();
            byte[] LUT = new byte[256];
            int a = b/3;
            wykres.Titles[0].Text = "Tablica LUT, p1 = " + a.ToString("0");
            for (int i = 0; i < 256; i++)
            {
                if (i <= a)
                {
                     LUT[i] = 0;
                }
                else LUT[i] = 255;
                
                wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
            }
            //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
            if (bmp == null)
            {
                return;
            }
            Bitmap bitmap = (Bitmap)this.picturePierwotnyOPJ.Image.Clone();
            this.pictureWtornyOPJ.Image = bitmap;
            //Pobierz wartosc wszystkich punktow obrazu
            BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
            byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
            System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);
            //Korekcja gamma dla kazdego punktu zgodnie z tablica LUT
            for (int i = 0; i < pixelValues.Length; i++)
            {
                pixelValues[i] = LUT[pixelValues[i]];
            }
            //Ustaw wartosc wszystkich punktow obrazu
            System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
            bitmap.UnlockBits(bmpData);
            #endregion
        }

        private void trackBarBineryzacjaZProgami2(Bitmap bmp, int a, int b)
        {
            #region Tabkica LUT - BINERYZACJA Z DWOMA PROGAMI P1 I P2
            //Przygotuj tablice LUT i pokaz ja na wykresie
            wykres.Series[0].Points.Clear();
            byte[] LUT = new byte[256];
            wykres.Titles[0].Text = "Tablica LUT, p1 = " + a + " p2 = " + b;

            for (int i = 0; i < 256; i++)
            {
               if (a < b)
               {
                  if (i < a)
                  {
                      LUT[i] = 0;
                  }
                  else if (i >= b)
                  {
                        LUT[i] = 0;
                  }
                  else LUT[i] = 255;
               }
               if (b < a)
               {
                  if (i < b)
                  {
                      LUT[i] = 0;
                  }
                  else if (i >= a)
                  {
                        LUT[i] = 0;
                  }
                  else LUT[i] = 255;
                }

                wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
            }
            //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
            if (bmp == null)
            {
                return;
            }
            Bitmap bitmap = (Bitmap)this.picturePierwotnyOPJ.Image.Clone();
            this.pictureWtornyOPJ.Image = bitmap;
            //Pobierz wartosc wszystkich punktow obrazu
            BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
            byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
            System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);
            //Korekcja gamma dla kazdego punktu zgodnie z tablica LUT
            for (int i = 0; i < pixelValues.Length; i++)
            {
                pixelValues[i] = LUT[pixelValues[i]];
            }
            //Ustaw wartosc wszystkich punktow obrazu
            System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
            bitmap.UnlockBits(bmpData);
            #endregion
        }

        private void trackBarIdentyczny(Bitmap bmp)
        {
            #region Tabkica LUT - IDENTYCZNOŚĆ
            //Przygotuj tablice LUT i pokaz ja na wykresie
            wykres.Series[0].Points.Clear();
            byte[] LUT = new byte[256];
            //   int b = this.trackBarOPJ.Value;
            //  int b = this.trackBar1.Value;
            wykres.Titles[0].Text = "Tablica LUT";
            for (int i = 0; i < 256; i++)
            {
                if (i > 255)
                {
                    LUT[i] = 255;
                }
                else if (i < 0)
                {
                    LUT[i] = 0;
                }
                else
                {
                    LUT[i] = (byte)i;
                }
                wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
            }
            //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
            if (bmp == null)
            {
                return;
            }
            Bitmap bitmap = (Bitmap)picturePierwotnyOPJ.Image.Clone();
            pictureWtornyOPJ.Image = bitmap;
            //Pobierz wartosc wszystkich punktow obrazu
            BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
            byte[] byteBuffer = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
            System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, byteBuffer, 0, byteBuffer.Length);

            for (int i = 0; i < byteBuffer.Length; i++)
            {
                byteBuffer[i] = LUT[byteBuffer[i]];
            }
            //Ustaw wartosc wszystkich punktow obrazu
            System.Runtime.InteropServices.Marshal.Copy(byteBuffer, 0, bmpData.Scan0, byteBuffer.Length);
            bitmap.UnlockBits(bmpData);
            #endregion
        }

        private void trackBarNegaCJA(Bitmap bmp)
        {
            #region Tabkica LUT - NEGACJA
            //Przygotuj tablice LUT i pokaz ja na wykresie
            wykres.Series[0].Points.Clear();
            byte[] LUT = new byte[256];
            //   int b = this.trackBarOPJ.Value;
            //  int b = this.trackBar1.Value;
            wykres.Titles[0].Text = "Tablica LUT";
            for (int i = 0; i < 256; i++)
            {
                if (i > 255)
                {
                    LUT[i] = 255;
                }
                else if (i < 0)
                {
                    LUT[i] = 0;
                }
                else
                {
                    LUT[i] = (byte)(255 - i);
                }
                wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
            }
            //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
            if (bmp == null)
            {
                return;
            }
            Bitmap bitmap = (Bitmap)picturePierwotnyOPJ.Image.Clone();
            pictureWtornyOPJ.Image = bitmap;
            //Pobierz wartosc wszystkich punktow obrazu
            BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
            byte[] byteBuffer = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
            System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, byteBuffer, 0, byteBuffer.Length);

            for (int i = 0; i < byteBuffer.Length; i++)
            {
                byteBuffer[i] = LUT[byteBuffer[i]];
            }
            //Ustaw wartosc wszystkich punktow obrazu
            System.Runtime.InteropServices.Marshal.Copy(byteBuffer, 0, bmpData.Scan0, byteBuffer.Length);
            bitmap.UnlockBits(bmpData);
            #endregion
        }

          private void trackBarRozciaganie(Bitmap bmp, int a, int b)
        {
            #region Tabkica LUT - ROZCIĄGANIE RGB
            //Przygotuj tablice LUT i pokaz ja na wykresie
            wykres.Series[0].Points.Clear();
            byte[] LUT = new byte[256];
            //   int b = this.trackBarOPJ.Value;
            //  int b = this.trackBar1.Value;
            wykres.Titles[0].Text = "Tablica LUT, p1 = " + a+ " p2 = " + b;

            for (int i = 0; i < 256; ++i)
            {
                if ((a - b) <= 0 || (b - a) <= 0)
                {
                    LUT[i] = 255;
                }
                if (a > b)        // a - high, b low
                {
                    float p = 255.0f / (a - b);
                    if (i < b)
                        LUT[i] = 0;
                    else if (i >= a)
                        LUT[i] = 0;
                    else
                        LUT[i] = (byte)((i - b) * p);
                }

                if (a < b)        // b - high, a low
                {
                    float p = 255.0f / (b - a);
                    if (i < a)
                        LUT[i] = 0;
                    else if (i >= b)
                        LUT[i] = 0;
                    else
                        LUT[i] = (byte)((i - a) * p);
                }
                wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
            }
            //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
            if (bmp == null)
            {
                return;
            }
            Bitmap bitmap = (Bitmap)this.picturePierwotnyOPJ.Image.Clone();
            this.pictureWtornyOPJ.Image = bitmap;
            //Pobierz wartosc wszystkich punktow obrazu
            BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
            byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
            System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);
            //Korekcja gamma dla kazdego punktu zgodnie z tablica LUT
            for (int i = 0; i < pixelValues.Length; i++)
            {
                pixelValues[i] = LUT[pixelValues[i]];
            }
            //Ustaw wartosc wszystkich punktow obrazu
            System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
            bitmap.UnlockBits(bmpData);
            #endregion
        }

          private void trackBarBineryzacjaPrzedzialem(Bitmap bmp, int a, int b)
          {
              #region Tabkica LUT - BINERYZACJA Z PRZEDZIAŁAMI P1 i p2
              //Przygotuj tablice LUT i pokaz ja na wykresie
              wykres.Series[0].Points.Clear();
              byte[] LUT = new byte[256];
            //  int b2 = b / 3;
              //   int b = this.trackBarOPJ.Value;
              //  int b = this.trackBar1.Value;
              wykres.Titles[0].Text = "Tablica LUT, p1 = " + a + " p2 = " + b;
              for (int i = 0; i < 256; i++)
              {
                  if ((a + i) > 255)
                  {
                      LUT[i] = 255;
                  }
                  else if ((a + i) < 0)
                  {
                      LUT[i] = 0;
                  }
                  else
                  {
                      LUT[i] = (byte)(a + i);
                  }
                  wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
              }
              //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
              if (bmp == null)
              {
                  return;
              }
              Bitmap bitmap = (Bitmap)this.picturePierwotnyOPJ.Image.Clone();
              this.pictureWtornyOPJ.Image = bitmap;
              //Pobierz wartosc wszystkich punktow obrazu
              BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
              byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
              System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);
              //Korekcja gamma dla kazdego punktu zgodnie z tablica LUT
              for (int i = 0; i < pixelValues.Length; i++)
              {
                  pixelValues[i] = LUT[pixelValues[i]];
              }
              //Ustaw wartosc wszystkich punktow obrazu
              System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
              bitmap.UnlockBits(bmpData);
              #endregion
          }

          private void trackBarBineryzacjaZProgamiOdw(Bitmap bmp, int a, int b)
          {
              #region Tabkica LUT - BINERYZACJA Z PRZEDZIAŁAMI ODWROTNE P1 i p2
              //Przygotuj tablice LUT i pokaz ja na wykresie
              wykres.Series[0].Points.Clear();
              byte[] LUT = new byte[256];
              wykres.Titles[0].Text = "Tablica LUT, p1 = " + a + " p2 = " + b;

              for (int i = 0; i < 256; i++)
              {
                  if (a < b)
                  {
                      if (i < a)
                      {
                          LUT[i] = 255;
                      }
                      else if (i >= b)
                      {
                          LUT[i] = 255;
                      }
                      else LUT[i] = 0;
                  }
                  if (b < a)
                  {
                      if (i < b)
                      {
                          LUT[i] = 255;
                      }
                      else if (i >= a)
                      {
                          LUT[i] = 255;
                      }
                      else LUT[i] = 0;
                  }
                  wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
              }
              //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
              if (bmp == null)
              {
                  return;
              }
              Bitmap bitmap = (Bitmap)this.picturePierwotnyOPJ.Image.Clone();
              this.pictureWtornyOPJ.Image = bitmap;
              //Pobierz wartosc wszystkich punktow obrazu
              BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
              byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
              System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);
              //Korekcja gamma dla kazdego punktu zgodnie z tablica LUT
              for (int i = 0; i < pixelValues.Length; i++)
              {
                  pixelValues[i] = LUT[pixelValues[i]];
              }
              //Ustaw wartosc wszystkich punktow obrazu
              System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
              bitmap.UnlockBits(bmpData);
              #endregion
          }

          private void trackBarBineryzacjaZPoziomemSzarosci(Bitmap bmp, int a, int b)
          {
              #region Tabkica LUT -  BINERYZACJA Z ZACHOWANIEM POZIOMÓW SZAROŚCI
              //Przygotuj tablice LUT i pokaz ja na wykresie
              wykres.Series[0].Points.Clear();
              byte[] LUT = new byte[256];
              wykres.Titles[0].Text = "Tablica LUT, p1 = " + a + " p2 = " + b;

              for (int i = 0; i < 256; i++)
              {
                  if (a < b)
                  {
                      if (i < a)
                      {
                          LUT[i] = 0;
                      }
                      else if (i > b)
                      {
                          LUT[i] = 0;
                      }
                      else LUT[i] = (byte)i;
                  }
                  if (b < a)
                  {
                      if (i < b)
                      {
                          LUT[i] = 0;
                      }
                      else if (i > a)
                      {
                          LUT[i] = 0;
                      }
                      else LUT[i] = (byte)i;
                  }

                  wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
              }
              //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
              if (bmp == null)
              {
                  return;
              }
              Bitmap bitmap = (Bitmap)this.picturePierwotnyOPJ.Image.Clone();
              this.pictureWtornyOPJ.Image = bitmap;
              //Pobierz wartosc wszystkich punktow obrazu
              BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
              byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
              System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);
              //Korekcja gamma dla kazdego punktu zgodnie z tablica LUT
              for (int i = 0; i < pixelValues.Length; i++)
              {
                  pixelValues[i] = LUT[pixelValues[i]];
              }
              //Ustaw wartosc wszystkich punktow obrazu
              System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
              bitmap.UnlockBits(bmpData);
              #endregion
          }

          private void trackBarBineryzacjaZPoziomemSzarosciOdwr(Bitmap bmp, int a, int b)
          {
              #region Tabkica LUT - BINERYZACJA Z ZACHOWANIEM POZIOMÓW SZAROŚCI ODWROTNA
              //Przygotuj tablice LUT i pokaz ja na wykresie
              wykres.Series[0].Points.Clear();
              byte[] LUT = new byte[256];
              wykres.Titles[0].Text = "Tablica LUT, p1 = " + a + " p2 = " + b;

              for (int i = 0; i < 256; i++)
              {
                  if (a < b)
                  {
                      if (i < a)
                      {
                          LUT[i] = 0;
                      }
                      else if (i > b)
                      {
                          LUT[i] = 0;
                      }
                      else LUT[i] = (byte)(255-i);
                  }
                  if (b < a)
                  {
                      if (i < b)
                      {
                          LUT[i] = 0;
                      }
                      else if (i > a)
                      {
                          LUT[i] = 0;
                      }
                      else LUT[i] = (byte)(255 - i);
                  }

                  wykres.Series[0].Points.Add(new DataPoint(i, LUT[i]));
              }
              //Nie rob nic wiecej jezeli obraz jest jeszcze niewczytany
              if (bmp == null)
              {
                  return;
              }
              Bitmap bitmap = (Bitmap)this.picturePierwotnyOPJ.Image.Clone();
              this.pictureWtornyOPJ.Image = bitmap;
              //Pobierz wartosc wszystkich punktow obrazu
              BitmapData bmpData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height), ImageLockMode.ReadWrite, bitmap.PixelFormat);
              byte[] pixelValues = new byte[Math.Abs(bmpData.Stride) * bitmap.Height];
              System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, pixelValues, 0, pixelValues.Length);
              //Korekcja gamma dla kazdego punktu zgodnie z tablica LUT
              for (int i = 0; i < pixelValues.Length; i++)
              {
                  pixelValues[i] = LUT[pixelValues[i]];
              }
              //Ustaw wartosc wszystkich punktow obrazu
              System.Runtime.InteropServices.Marshal.Copy(pixelValues, 0, bmpData.Scan0, pixelValues.Length);
              bitmap.UnlockBits(bmpData);
              #endregion
          }
     


        private void ApplyFilter(bool preview)
        {
            if (previewBitmap == null || comboBoxFGG.SelectedIndex == -1)
            {
                return;
            }

            Bitmap selectedSource = null;
            Bitmap bitmapResult = null;

            if (preview == true)
            {
                selectedSource = previewBitmap;
            }
            else
            {
                selectedSource = originalBitmap;
            }

            if (selectedSource != null)
            {
                if (comboBoxFGG.SelectedItem.ToString() == "None")
                {
                    bitmapResult = selectedSource;
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Identyczność")
                {
                    #region Identyczność - w odcieniach szarości
                    ustawieniaS();
                 //   tabJP.TabPages.Clear();
                 //   this.groupBoxTablicaLUT.Visible = true;
                    Bitmap bmp1 = new Bitmap(this.pictureWtornyOPJ.Image);
                    trackBarIdentyczny(bmp1);
                    this.label1.Text = "Obraz wynikowy - Identyczność";
                    bitmapResult = selectedSource;
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Identyczność RGB")
                {
                    # region Identyczność RGB
                    tabJP.TabPages.Clear();
                    tabJP.TabPages.Add(tabIdentycznosc);
                    this.groupBoxTablicaLUT.Visible = true;
                    Bitmap bmp1 = new Bitmap(this.pictureWtornyOPJ.Image);
                    trackBarIdentyczny(bmp1);
                    this.label1.Text = "Obraz wynikowy - Identyczność RGB";

                    if (radioKanal_Kolor.Checked)
                    {
                        if (radioKanal_Red.Checked)
                        {
                            bitmapResult = selectedSource.DrawAsGrayscale_Red();
                            this.label1.Text = "Obraz wynikowy - Identyczność RGB - Kanał Czerwony";
                        }
                        else if (radioKanal_Green.Checked)
                        {
                            this.label1.Text = "Obraz wynikowy - Identyczność RGB - Kanał Zielony";
                            bitmapResult = selectedSource.DrawAsGrayscale_Green();
                        }
                        else if (radioKanal_Blue.Checked)
                        {
                            this.label1.Text = "Obraz wynikowy - Identyczność RGB - Kanał Niebieski";
                            bitmapResult = selectedSource.DrawAsGrayscale_Blue();
                        }
                    }
                    else
                    {
                        Bitmap bmp = new Bitmap(this.picturePierwotnyOPJ.Image);
                        this.label1.Text = "Obraz wynikowy - Identyczność RGB";
                        bmp = selectedSource;
                        bitmapResult = selectedSource.ModelRGB();
                    }
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Identyczność HSV")
                {
                    #region Identyczność HSV
                    ustawieniaHSV();            
                    tabJP.TabPages.Add(tabIdentycznosc);
                    this.groupBoxTablicaLUT.Visible = true;
                    Bitmap bmp1 = new Bitmap(this.pictureWtornyOPJ.Image);
                    trackBarIdentyczny(bmp1);
                    this.label1.Text = "Obraz wynikowy - Identyczność";
                    selectedSource = (Bitmap)picturePierwotnyOPJ.Image;
                    bitmapResult = selectedSource;                  
                   #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Negacja")
                {
                    #region Negacja - w odcieniach szarości
                    ustawieniaS();
                  //  tabJP.TabPages.Clear();
                  //  this.groupBoxTablicaLUT.Visible = true;
                    Bitmap bmp1 = new Bitmap(this.pictureWtornyOPJ.Image);
                    this.trackBarNegaCJA(bmp1);
                    this.label1.Text = "Obraz wynikowy - Negacja";
                    bitmapResult = selectedSource.NegacjaRGB();
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Negacja RGB")
                {
                    #region Negacja RGB
                    tabJP.TabPages.Clear();
                    tabJP.TabPages.Add(tabNegacja);
                    this.groupBoxTablicaLUT.Visible = true;
                    Bitmap bmp1 = new Bitmap(this.pictureWtornyOPJ.Image);
                    this.trackBarNegaCJA(bmp1);
                    this.label1.Text = "Obraz wynikowy - Negacja RGB";
                    bitmapResult = selectedSource.DrawNegatywRGB();
                    if (radioNegacja.Checked)
                    {
                        if (radioNegacjaR.Checked)
                        {
                            Bitmap bmpR = new Bitmap(this.picturePierwotnyOPJ.Image);
                            bmpR = selectedSource.DrawNegatywRGB();
                            bitmapResult = bmpR.DrawAsGrayscale_Red();
                            this.label1.Text = "Obraz wynikowy - Negacja RGB - Kanał Czerwony";
                        }
                        else if (radioNegacjaG.Checked)
                        {
                            Bitmap bmpG = new Bitmap(this.picturePierwotnyOPJ.Image);
                            bmpG = selectedSource.DrawNegatywRGB();
                            bitmapResult = bmpG.DrawAsGrayscale_Green();
                            this.label1.Text = "Obraz wynikowy - Negacja RGB - Kanał Zielony";
                        }
                        else if (radioNegacjaB.Checked)
                        {
                            Bitmap bmpB = new Bitmap(this.picturePierwotnyOPJ.Image);
                            bmpB = selectedSource.DrawNegatywRGB();
                            bitmapResult = bmpB.DrawAsGrayscale_Blue();
                            this.label1.Text = "Obraz wynikowy - Negacja RGB - Kanał Niebieski";
                        }
                    }
                    else
                    {
                        Bitmap bmp = new Bitmap(this.picturePierwotnyOPJ.Image);
                        this.label1.Text = "Obraz wynikowy - Negacja RGB";
                        bitmapResult = bmp.DrawNegatywRGB();
                    }
                    //    bitmapResult = selectedSource.DrawAsGrayscale_Blue();
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Negacja HSV")
                {
                    #region Negacja HSV
                    ustawieniaHSV();          
                    tabJP.TabPages.Add(tabNegacja);
                    this.groupBoxTablicaLUT.Visible = true;
                    Bitmap bmp1 = new Bitmap(this.picturePierwotnyOPJ.Image);
                    this.trackBarNegaCJA(bmp1);
                    this.label1.Text = "Obraz wynikowy - Negacja HSV";
                    selectedSource = bmp1;
                    bitmapResult = selectedSource.NegacjaHSV();
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Kontrast")
                {
                    #region Kontrast w odcieniach szarości
                    ustawieniaS();
                    tabJP.TabPages.Add(tabKontrast);
                    this.label1.Text = "Obraz wynikowy - Kontrast";
                    Bitmap bmp = new Bitmap(this.picturePierwotnyOPJ.Image);                    
                    trackBarKontrast(bmp, track_Kontrast.Value);
                    bitmapResult = selectedSource.Contrast(track_Kontrast.Value);
                    //   this.trackBarOPJ.ValueChanged += new System.EventHandler(trackBarKontrast);
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Kontrast RGB")
                {
                    #region Kontrast RGB
                    ustawienia1();                 
                    tabJP.TabPages.Add(tabKontrast);
                    this.label1.Text = "Obraz wynikowy - Kontrast RGB";
                    Bitmap bmp1 = new Bitmap(this.picturePierwotnyOPJ.Image);
                    trackBarKontrast(bmp1, track_Kontrast.Value);
                    bitmapResult = selectedSource.Contrast(track_Kontrast.Value);
                    if (radioKontrast.Checked)
                    {
                        if (radioKontrastR.Checked)
                        {                        
                            Bitmap bmpR = new Bitmap(this.picturePierwotnyOPJ.Image);
                            bmpR = selectedSource.Contrast(track_Kontrast.Value);
                            bitmapResult = bmpR.DrawAsGrayscale_Red();
                            this.label1.Text = "Obraz wynikowy - Kontrast RGB - Kanał Czerwony";      
                        }
                        else if (radioKontrastG.Checked)
                        {
                            Bitmap bmpG = new Bitmap(this.picturePierwotnyOPJ.Image);
                            bmpG = selectedSource.Contrast(track_Kontrast.Value);
                            bitmapResult = bmpG.DrawAsGrayscale_Green();
                            this.label1.Text = "Obraz wynikowy - Kontrast RGB - Kanał Zielony";
                        }
                        else if (radioKontrastB.Checked)
                        {
                            Bitmap bmpB = new Bitmap(this.picturePierwotnyOPJ.Image);
                            bmpB = selectedSource.Contrast(track_Kontrast.Value);
                            bitmapResult = bmpB.DrawAsGrayscale_Blue();
                            this.label1.Text = "Obraz wynikowy - Kontrast RGB - Kanał Niebieski";
                        }
                        else
                        {
                            Bitmap bmp = new Bitmap(this.picturePierwotnyOPJ.Image);
                            this.label1.Text = "Obraz wynikowy - Kontrast RGB";
                            bmp = selectedSource;
                            bitmapResult = selectedSource.Contrast(track_Kontrast.Value);
                        }
                    }
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Kontrast HSV")
                {
                    #region Kontrast HSV
                    ustawieniaHSV();
                    tabJP.TabPages.Add(tabKontrast);
                    this.label1.Text = "Obraz wynikowy - Kontrast HSV";
                    Bitmap bmpHSV = new Bitmap(this.pictureWtornyOPJ.Image);
                    trackBarKontrast(bmpHSV, track_Kontrast.Value);
                    //     trackBarBineryzacja(bmpHSV, trackBar1.Value);
                    bitmapResult = selectedSource.Contrast(track_Kontrast.Value);
                    #endregion

                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Jasność")
                {
                    #region Jasność w odcieniac szarości
                    ustawieniaS();
                    tabJP.TabPages.Add(tabJasnosc);
                    this.label1.Text = "Obraz wynikowy - Jasność";
                    //   this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarJasnosc);
                    Bitmap bmp3 = new Bitmap(this.pictureWtornyOPJ.Image);
                    trackBarJasnosc(bmp3, track_Jasnosc.Value);
                    bitmapResult = selectedSource.JasnoscRGB2(track_Jasnosc.Value);
                    //  FunkcjeJednoarg fj = new FunkcjeJednoarg();
                    //   bitmapResult = fj.JasnoscRGB(bmp3, trackBar2.Value);
                    // bitmapResult = selectedSource.Jasnosc(trackBar2.Value);
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Jasność RGB")
                {
                    #region Jasność RGB
                    ustawienia1();
                    tabJP.TabPages.Add(tabJasnosc);
                    this.label1.Text = "Obraz wynikowy - Jasność RGB";
                    Bitmap bmp3 = new Bitmap(this.pictureWtornyOPJ.Image);
                    trackBarJasnosc(bmp3, track_Jasnosc.Value);
                    bitmapResult = selectedSource.JasnoscRGB2(track_Jasnosc.Value);
                    if (radioJasnosc.Checked)
                    {
                        if (radioJasnoscR.Checked)
                        {
                            Bitmap bmpR = new Bitmap(this.picturePierwotnyOPJ.Image);
                            bmpR = selectedSource.JasnoscRGB2(track_Jasnosc.Value);
                            bitmapResult = bmpR.DrawAsGrayscale_Red();
                            this.label1.Text = "Obraz wynikowy - Jasność RGB - Kanał Czerwony";
                        }
                        else if (radioJasnoscG.Checked)
                        {
                            Bitmap bmpG = new Bitmap(this.picturePierwotnyOPJ.Image);
                            bmpG = selectedSource.JasnoscRGB2(track_Jasnosc.Value);
                            bitmapResult = bmpG.DrawAsGrayscale_Green();
                            this.label1.Text = "Obraz wynikowy - Jasność RGB - Kanał Zielony";
                        }
                        else if (radioJasnoscB.Checked)
                        {
                            Bitmap bmpB = new Bitmap(this.picturePierwotnyOPJ.Image);
                            bmpB = selectedSource.JasnoscRGB2(track_Jasnosc.Value);
                            bitmapResult = bmpB.DrawAsGrayscale_Blue();
                            this.label1.Text = "Obraz wynikowy - Jasność RGB - Kanał Niebieski";
                        }
                        else
                        {
                            Bitmap bmp = new Bitmap(this.picturePierwotnyOPJ.Image);
                            this.label1.Text = "Obraz wynikowy - Jasność RGB";
                            bmp = selectedSource;
                            bitmapResult = selectedSource.JasnoscRGB2(track_Jasnosc.Value);
                        }
                    }
                    //     bitmapResult = selectedSource.Jasnosc(trackBar2.Value);
                    //      this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarJasnosc);
                    // bitmapResult = selectedSource.JasnoscRGB2(track_Jasnosc.Value);
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Jasność HSV")
                {
                    #region Jasność HSV
                    ustawieniaHSV();
                    tabJP.TabPages.Add(tabJasnoscHSV);
                    Bitmap bmp3 = new Bitmap(this.pictureWtornyOPJ.Image);
                    float wartosc = (float)track_Jasnosc.Value;
                    trackBarJasnosc(bmp3, (int)wartosc);
                    this.label1.Text = "Obraz wynikowy - Jasność HSV";
                    wynik((Bitmap)this.picturePierwotnyOPJ.Image);                   
                    bitmapResult = functions.regulacja_jasnoscia_hsv(src1, trackJasnoscHSV.Value);                                  
                    #endregion
                }

              
                    
                    /*
                else if (comboBoxFGG.SelectedItem.ToString() == "Bineryzacja")
                {
                    this.groupBoxTablicaLUT.Visible = true;
                    this.label1.Text = "Obraz wynikowy - Bineryzacja";
                    this.trackBarOPJ.Maximum = 255;
                    this.trackBarOPJ.Minimum = 0;
                    // this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarBineryzacja);
                    Bitmap bmpHSV;
                    bmpHSV = (Bitmap)this.pictureWtornyOPJ.Image;
                    bmpHSV = FunkcjeJednoarg.Bineryzacja(bmpHSV, this.trackBarOPJ.Value);
                    pictureWtornyOPJ.Refresh();
                    bitmapResult = bmpHSV;
                }
                */

                else if (comboBoxFGG.SelectedItem.ToString() == "Bineryzacja")
                {
                    #region Progowanie w odcieniach szarości
                    ustawieniaS();
                    tabJP.TabPages.Add(tabProgowanie);
                    tabJP_prog.TabPages.Add(tabSzaryP);
                    label1.Text = "Obraz wynikowy - Bineryzacja";
                    Bitmap bmp = new Bitmap(pictureWtornyOPJ.Image);
                    trackBarBineryzacja(bmp, trackBineryzacjaS.Value);
                    bitmapResult = selectedSource.Progowanie(trackBineryzacjaS.Value / 3);
                //    trackBarBineryzacja(bmp, track_Progowanie.Value);
                //    bitmapResult = selectedSource.Progowanie(track_Progowanie.Value);                                
                    // bitmapResult = selectedSource.JasnoscRGB2(track_Progowanie.Value);
                    // bmp = FunkcjeJednoarg.ProgowanieRGB(bmp, track_Progowanie.Value);
                    //   bitmapResult = bmp; 
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Bineryzacja RGB")
                {
                    #region Progowanie RGB
                    ustawienia1();
                    tabJP.TabPages.Add(tabProgowanie);
                    tabJP_prog.TabPages.Add(tabKolorP);
                    this.label1.Text = "Obraz wynikowy - Bineryzacja RGB";
                    Bitmap bmpRGB;
                    bmpRGB = (Bitmap)picturePierwotnyOPJ.Image;          
                    trackBarBineryzacja(bmpRGB, trcThreshold2.Value);
                    //            bitmapResult = selectedSource.Progowanie(track_Progowanie.Value);
                    bitmapResult = selectedSource.Bitonal(pnlDarkColour.BackColor, pnlLightColour.BackColor, trcThreshold2.Value);

                    //    bmpRGB = FunkcjeJednoarg.ProgowanieRGB(bmpRGB, track_Progowanie.Value);
                    //    bitmapResult = bmpHSV;
                    //bmpRGB.ModelRGB_Red();
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Bineryzacja HSV")
                {
                    #region Progowanie HSV
                    ustawieniaHSV();
                    tabJP.TabPages.Add(tabProgowanieHSV);
                    label1.Text = "Obraz wynikowy - Bineryzacja HSV";
                    bitmapResult = functions.progowanie_hsv(new Bitmap(picturePierwotnyOPJ.Image), trackProgowanieHSV.Value);
                   #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Progowanie odwrotne")
                {
                    #region Progowanie odwrotne w odcieniach szarości
                    ustawieniaS();
                    tabJP.TabPages.Add(tabProgowanie2);
                    tabProg.TabPages.Add(tabProgO1);
                    label1.Text = "Obraz wynikowy - Progowanie odwrotne";
                    Bitmap bmp = new Bitmap(pictureWtornyOPJ.Image);
                    this.trackBarBineryzacjaOdwrotna(bmp, track_ProgowanieOdw.Value);
                    bitmapResult = selectedSource.ProgowanieOdwrotne(track_ProgowanieOdw.Value/3);
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Progowanie odwrotne RGB")
                {
                    #region Progowanie odwrotne RGB
                    ustawienia1();
                    tabJP.TabPages.Add(tabProgowanie2);
                    tabProg.TabPages.Add(tabProgO2);
                    label1.Text = "Obraz wynikowy - Progowanie odwrotne RGB";
                    Bitmap bmp = new Bitmap(pictureWtornyOPJ.Image);
                    this.trackBarBineryzacjaOdwrotna(bmp, trackProgOdw.Value);
                    bitmapResult = selectedSource.BitonalOdwrot(pnlDarkColour2.BackColor, pnlLightColour2.BackColor, trackProgOdw.Value);
              //      bitmapResult = selectedSource.ProgowanieOdwrotne(trackProgOdw.Value);
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Progowanie przedziałami")
                {
                    #region Progowanie odwrotne w odcieniach szarości
                    ustawieniaS();
                    tabJP.TabPages.Add(tabProgowanie4);
                    label1.Text = "Obraz wynikowy - Progowanie przedziałami";
                    Bitmap bmp = new Bitmap(pictureWtornyOPJ.Image);
                    if (this.radioProgPrzedz1.Checked)
                    {
                        this.trackBarBineryzacjaZProgami2(bmp, trackProgowanieZP1.Value, trackProgowanieZP2.Value);
                        bitmapResult = selectedSource.ProgowanieZprzedzialem(trackProgowanieZP1.Value, trackProgowanieZP2.Value);
                        //    bitmapResult = selectedSource.ProgowanieZprzedzialemK(pnlDarkColour2.BackColor, pnlLightColour2.BackColor, trackProgowanieZP1.Value, trackProgowanieZP2.Value);
                    }
                    else
                    {
                        this.trackBarBineryzacjaZProgamiOdw(bmp, trackProgowanieZP1.Value, trackProgowanieZP2.Value);
                        bitmapResult = selectedSource.ProgowanieZprzedzOdwrotne(trackProgowanieZP1.Value, trackProgowanieZP2.Value);
                        //    bitmapResult = selectedSource.ProgowanieZprzedzialemK(pnlDarkColour2.BackColor, pnlLightColour2.BackColor, trackProgowanieZP1.Value, trackProgowanieZP2.Value);
                    }
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Progowanie przedziałami RGB")
                {
                    #region Progowanie odwrotne RGB
                    ustawienia1();
                    tabJP.TabPages.Add(tabProgowanie4);
                    label1.Text = "Obraz wynikowy - Progowanie przedziałami RGB";                 

                    Bitmap bmp = new Bitmap(pictureWtornyOPJ.Image);
                    if (this.radioProgPrzedz1.Checked)
                    {
                        this.trackBarBineryzacjaZProgami2(bmp, trackProgowanieZP1.Value, trackProgowanieZP2.Value);
                        bitmapResult = selectedSource.ProgowanieZprzedzialem(trackProgowanieZP1.Value, trackProgowanieZP2.Value);
                    //    bitmapResult = selectedSource.ProgowanieZprzedzialemK(pnlDarkColour2.BackColor, pnlLightColour2.BackColor, trackProgowanieZP1.Value, trackProgowanieZP2.Value);
                    }
                    else
                    {
                        this.trackBarBineryzacjaZProgamiOdw(bmp, trackProgowanieZP1.Value, trackProgowanieZP2.Value);
                        bitmapResult = selectedSource.ProgowanieZprzedzOdwrotne(trackProgowanieZP1.Value, trackProgowanieZP2.Value);
                     //    bitmapResult = selectedSource.ProgowanieZprzedzialemK(pnlDarkColour2.BackColor, pnlLightColour2.BackColor, trackProgowanieZP1.Value, trackProgowanieZP2.Value);
                    }
                    
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Progowanie z poziomem szarości")
                {
                    #region  Progowanie z zachowaniem poziomów szarości
                    ustawieniaS();
                    tabJP.TabPages.Add(tabProgowanie3);            
                    label1.Text = "Obraz wynikowy - Progowanie  z zachowaniem poziomów szarości";
                    Bitmap bmp = new Bitmap(pictureWtornyOPJ.Image);
                    if (this.radioProgowaniePS1.Checked)
                    {
                        trackBarBineryzacjaZPoziomemSzarosci(bmp, track_Progowanie3.Value, track_Progowanie4.Value);
                        bitmapResult = selectedSource.Progowanie2(track_Progowanie3.Value, track_Progowanie4.Value);
                    }
                    else
                    {
                        this.trackBarBineryzacjaZPoziomemSzarosciOdwr(bmp, track_Progowanie3.Value, track_Progowanie4.Value);
                        bitmapResult = selectedSource.Progowanie2Odwrot(track_Progowanie3.Value, track_Progowanie4.Value);
                    }
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Progowanie z poziomem szarości RGB")
                {
                    #region Progowanie  z zachowaniem poziomów szarości RGB
                    ustawienia1();
                    tabJP.TabPages.Add(tabProgowanie3);  
                    label1.Text = "Obraz wynikowy - Progowanie  z zachowaniem poziomów szarości RGB";
                    Bitmap bmp = new Bitmap(pictureWtornyOPJ.Image);
                    if (this.radioProgowaniePS1.Checked)
                    {
                        trackBarBineryzacjaZPoziomemSzarosci(bmp, track_Progowanie3.Value, track_Progowanie4.Value);
                        bitmapResult = selectedSource.Progowanie2(track_Progowanie3.Value, track_Progowanie4.Value);
                    }
                    else
                    {
                        this.trackBarBineryzacjaZPoziomemSzarosciOdwr(bmp, track_Progowanie3.Value, track_Progowanie4.Value);
                        bitmapResult = selectedSource.Progowanie2Odwrot(track_Progowanie3.Value, track_Progowanie4.Value);
                    }
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Rozciąganie")
                {
                    #region Rozciąganie - w odcieniach szarości
                    ustawieniaS();
                    tabJP.TabPages.Add(tabRozciaganie);             
                    Bitmap bmp = (Bitmap)picturePierwotnyOPJ.Image;
                    this.trackBarRozciaganie(bmp, trackRozciaganie_v1.Value, trackRozciaganie_v2.Value);                            
                    this.label1.Text = "Obraz wynikowy - Rozciąganie";
                    bitmapResult = selectedSource.Rozciagnie(trackRozciaganie_v1.Value, trackRozciaganie_v2.Value);
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Rozciąganie RGB")
                {
                    #region Rozciąganie RGB
                    this.groupBoxTablicaLUT.Visible = true;
                    this.label1.Text = "Obraz wynikowy - Rozciąganie RGB";
                    ustawienia1();
                    this.groupBoxTablicaLUT.Visible = true;
                    Bitmap bmp = (Bitmap)picturePierwotnyOPJ.Image;
                    this.trackBarRozciaganie(bmp, trackRozciaganie_v1.Value, trackRozciaganie_v2.Value);  
                    tabJP.TabPages.Add(tabRozciaganie);
                    bitmapResult = selectedSource.Rozciagnie(trackRozciaganie_v1.Value, trackRozciaganie_v2.Value);
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Rozciąganie HSV")
                {
                    #region Rozciąganie HSV
                    ustawieniaHSV();
                    tabJP.TabPages.Add(tabRozciaganieHSV); 
                    this.groupBoxTablicaLUT.Visible = true;
                    this.label1.Text = "Obraz wynikowy - Rozciąganie HSV";
                    Bitmap bmp = (Bitmap)picturePierwotnyOPJ.Image;
                    this.trackBarRozciaganie(bmp, this.trackRozHSV_v1.Value, this.trackRozHSV_v2.Value);  
                    //wynik((Bitmap)pictureWtornyOPJ.Image);
                    bmp = new Bitmap(selectedSource);
                    selectedSource = functions.RozciagnieHSV2(new Bitmap(picturePierwotnyOPJ.Image), trackRozHSV_v1.Value, trackRozHSV_v2.Value);
                    bitmapResult = selectedSource;
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Korekcja Gamma")
                {
                    #region Korekcja Gamma - w odcieniach szarości
                    ustawieniaS();
                    tabJP.TabPages.Add(this.tabKorekcjaGamma);                 
                    tabKG.TabPages.Add(tabKGammaS);
                    this.label1.Text = "Obraz wynikowy - Korekcja Gamma";
                    trackKorekcjaGammaS.ValueChanged += new System.EventHandler(this.trackGamma);
                    Bitmap bmp = new Bitmap(this.pictureWtornyOPJ.Image);
                    trackBarGamma(bmp, trackKorekcjaGammaS.Value);
                  //    trackKorekcjaGammaS.ValueChanged += new System.EventHandler(this.trackGamma);
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Korekcja Gamma RGB")
                {
                    #region Korekcja Gamma RGB
                    ustawienia1();
                    tabJP.TabPages.Clear();
                    tabJP.TabPages.Add(this.tabKorekcjaGamma);
                    tabKG.TabPages.Clear();
                    tabKG.TabPages.Add(tabKGammaRGB);
                    this.groupBoxTablicaLUT.Visible = true;
                    Bitmap bmp = new Bitmap(this.pictureWtornyOPJ.Image);
                    trackBarGamma(bmp, tracKGammaRGB.Value);
                    this.label1.Text = "Obraz wynikowy - Korekcja Gamma RGB";
             //       this.tracKGammaRGB.ValueChanged += new System.EventHandler(this.trackGamma);
                    if (this.radioKGamma.Checked)
                    {
                        if (radioKGammaR.Checked)
                        {
                            this.label1.Text = "Obraz wynikowy - Korekcja Gamma RGB - Kanał Czerwony";
                            this.tracKGammaRGB.ValueChanged += new System.EventHandler(this.trackGamma);
                            Bitmap bmpR = new Bitmap(this.picturePierwotnyOPJ.Image);
                            bitmapResult = bmpR.DrawAsGrayscale_Red();
                        }
                        else if (radioKGammaG.Checked)
                        {
                            this.label1.Text = "Obraz wynikowy - Korekcja Gamma RGB - Kanał Zielony";
                            this.tracKGammaRGB.ValueChanged += new System.EventHandler(this.trackGamma);
                            Bitmap bmpG = new Bitmap(this.picturePierwotnyOPJ.Image);
                            bitmapResult = bmpG.DrawAsGrayscale_Green();
                        }
                        else if (radioKGammaB.Checked)
                        {
                            this.label1.Text = "Obraz wynikowy - Korekcja Gamma RGB - Kanał Niebieski";
                            this.tracKGammaRGB.ValueChanged += new System.EventHandler(this.trackGamma);
                            Bitmap bmpB = new Bitmap(this.picturePierwotnyOPJ.Image);
                            bitmapResult = bmpB.DrawAsGrayscale_Blue();
                        }
                        else
                        {
                            Bitmap bmpRGB = new Bitmap(this.picturePierwotnyOPJ.Image);
                            this.tracKGammaRGB.ValueChanged += new System.EventHandler(this.trackGamma);
                            bitmapResult = bmpRGB.DrawRGB();
                        }
                    }
                   // tabJP.TabPages.Add(tabKorekcjaGamma); 
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Korekcja Gamma HSV")
                {
                    #region Korekcja Gamma HSV
                    ustawieniaHSV();
                    tabKG.TabPages.Clear();
                    tabJP.TabPages.Add(this.tabKorekcjaGamma);
                    tabJP.TabPages.Add(tabKgammaHSV); 
                    this.groupBoxTablicaLUT.Visible = true;
                    this.label1.Text = "Obraz wynikowy - Korekcja Gamma HSV";
                  //  bitmapResult = selectedSource.KorekcjaGammaRGB((float)tracKGammaRGB.Value / 100);
                    //       this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarGamma);
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Odcień RGB")
                {
                    #region Odcienie RGB
                    ustawienia1();
                    groupBoxTablicaLUT.Visible = false;
                    tabJP.TabPages.Add(this.tabOdcienie);
                    float blue = this.tracOdcienRGB_R.Value / 100.0f;
                    float green = this.tracOdcienRGB_G.Value / 100.0f;
                    float red = this.tracOdcienRGB_B.Value / 100.0f;
                    if (this.radioOdcien.Checked)
                    {
                        if (this.radioOdcien_R.Checked)
                        {
                            Bitmap bmpR = new Bitmap(this.picturePierwotnyOPJ.Image);
                            bmpR = selectedSource.OdcienieRGB(blue, green, red);
                            bitmapResult = bmpR.DrawAsGrayscale_Red();
                            this.label1.Text = "Obraz wynikowy - Odcień RGB - Kanał Czerwony";
                        }
                        else if (this.radioOdcien_G.Checked)
                        {
                            Bitmap bmpG = new Bitmap(this.picturePierwotnyOPJ.Image);
                            bmpG = selectedSource.OdcienieRGB(blue, green, red);
                            bitmapResult = bmpG.DrawAsGrayscale_Green();
                            this.label1.Text = "Obraz wynikowy - Odcień RGB - Kanał Zielony";
                        }
                        else if (this.radioOdcien_B.Checked)
                        {
                            Bitmap bmpB = new Bitmap(this.picturePierwotnyOPJ.Image);
                            bmpB = selectedSource.OdcienieRGB(blue, green, red);
                            bitmapResult = bmpB.DrawAsGrayscale_Blue();
                            this.label1.Text = "Obraz wynikowy - Odcień RGB - Kanał Niebieski";
                        }
                    }
                        else
                        {
                            Bitmap bmp = new Bitmap(this.picturePierwotnyOPJ.Image);
                            this.label1.Text = "Obraz wynikowy - Odcień RGB";
                            bmp = selectedSource;
                            bitmapResult = selectedSource.OdcienieRGB(blue, green, red);
                        }
                   #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Redukcja poziomów szarości")
                {
                    #region Redukcja poziomów szarości
                    ustawieniaS();
                    this.groupBoxTablicaLUT.Visible = false;
                    tabJP.TabPages.Add(tabRedukcjaPoziomow);          
                    this.label1.Text = "Obraz wynikowy - Redukcja poziomów szarości";
                    Bitmap bmpRP = (Bitmap)this.pictureWtornyOPJ.Image;
                    bitmapResult = bmpRP.RedukcjaPoziomowSzarosci(this.trackRedukcjaPRGB.Value);
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Redukcja poziomów jasności RGB")
                {
                    #region Redukcja poziomów jasności RGB
                    ustawienia1();
                    tabJP.TabPages.Add(tabRedukcjaPozRGB2); 
                    this.groupBoxTablicaLUT.Visible = false;
                    this.label1.Text = "Obraz wynikowy - Redukcja poziomów jasności RGB";
                    Bitmap bmpRP = (Bitmap)pictureWtornyOPJ.Image;
                 //   bitmapResult = bmpRP.RedukcjaPoziomowSzarosci(this.trackRedukcjaPRGB.Value);
                    bitmapResult = functions.RedukcjaPoziomowRGB2(new Bitmap(picturePierwotnyOPJ.Image), trackRP_RGB.Value);  
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Redukcja poziomów jasności HSV")
                {
                    #region Redukcja poziomów jasności HSV
                    ustawieniaHSV();
                    tabJP.TabPages.Add(tabRedukcjaPHSV); 
                    this.groupBoxTablicaLUT.Visible = true;
                    this.label1.Text = "Obraz wynikowy - Redukcja poziomów jasności HSV";
                    bitmapResult = functions.RedukcjaPoziomowHSV2(new Bitmap(picturePierwotnyOPJ.Image), trackRedukcjaP_HSV.Value);     

                   
                    //bmpRP..SetPixel(x, y, hsv.ColorFromHSV(h,s,));
               //     Bitmap bmpRP;
              //      bmpRP = (Bitmap)this.pictureWtornyOPJ.Image;
                    //    bmpRP = FunkcjeHSV.PoziomySzarosciHSV2(bmpRP, this.trackBarOPJ.Value);
                    //   this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarBineryzacja);
              //      pictureWtornyOPJ.Refresh();
             //       bitmapResult = bmpRP;
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Sepia")
                {
                    #region Sepia - odcieniach szarości
                    ustawieniaS();
                    groupBoxTablicaLUT.Visible = false;
                    label1.Text = "Obraz wynikowy - Sepia";
                    bitmapResult = selectedSource.CopyAsSepiaTone();
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Sepia RGB")
                {
                    #region Sepia RGB
                    groupBoxTablicaLUT.Visible = false;
                    label1.Text = "Obraz wynikowy - Sepia RGB";
                    //  this.pictureWtornyOPJ.Image = pictureWtornyOPJ.Image.CopyAsSepiaTone();
                    bitmapResult = selectedSource.CopyAsSepiaTone();
                    #endregion
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Sepia HSV")
                {
                    #region Sepia HSV
                    ustawieniaHSV();
                    groupBoxTablicaLUT.Visible = false;
                    label1.Text = "Obraz wynikowy - Sepia HSV ";
                    //   this.pictureWtornyOPJ.Image = pictureWtornyOPJ.Image.CopyAsSepiaTone();
                    bitmapResult = selectedSource.CopyAsSepiaTone();
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Transparentny")
                {
                    #region Transparentny - w odcieniach szarości
                    ustawieniaS();
                    groupBoxTablicaLUT.Visible = false;
                    label1.Text = "Obraz wynikowy - Transparentny";
                    bitmapResult = selectedSource.CopyWithTransparency();
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Transparentny RGB")
                {
                    #region Transparentny RGB
                    groupBoxTablicaLUT.Visible = false;
                    label1.Text = "Obraz wynikowy - Transparentny RGB";
                    bitmapResult = selectedSource.CopyWithTransparency();
                    #endregion
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Transparentny HSV")
                {
                    #region Transparentny HSV
                    ustawieniaHSV();
                    groupBoxTablicaLUT.Visible = false;
                    label1.Text = "Obraz wynikowy - Transparentny HSV";
                    bitmapResult = selectedSource.CopyWithTransparency();
                    #endregion
                }
            }

            if (bitmapResult != null)
            {
                if (preview == true)
                {
                    this.pictureWtornyOPJ.Image = bitmapResult;
                }
                else
                {
                    resultBitmap = bitmapResult;
                }
            }
        }

        private void comboBoxFGG_SelectedIndexChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            #region Zapis obrazu wynikowego
            pictureWtornyOPJ.Image = resultBitmap;
            ApplyFilter(false);

            if (resultBitmap != null)
            {
                SaveFileDialog sfd = new SaveFileDialog();
                sfd.Title = "Specify a file name and file path";
                sfd.Filter = "Png Images(*.png)|*.png|Jpeg Images(*.jpg)|*.jpg";
                sfd.Filter += "|Bitmap Images(*.bmp)|*.bmp";

                if (sfd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                {
                    string fileExtension = Path.GetExtension(sfd.FileName).ToUpper();
                    ImageFormat imgFormat = ImageFormat.Png;

                    if (fileExtension == "BMP")
                    {
                        imgFormat = ImageFormat.Bmp;
                    }
                    else if (fileExtension == "JPG")
                    {
                        imgFormat = ImageFormat.Jpeg;
                    }

                    StreamWriter streamWriter = new StreamWriter(sfd.FileName, false);
                    resultBitmap.Save(streamWriter.BaseStream, imgFormat);
                    streamWriter.Flush();
                    streamWriter.Close();

                    resultBitmap = null;
                }
            }
            #endregion
        }

        private void buttonWidok_Click(object sender, EventArgs e)
        {
            #region Widok wczytanego obrazu
            picturePierwotnyOPJ.SizeMode = PictureBoxSizeMode.StretchImage;
            pictureWtornyOPJ.SizeMode = PictureBoxSizeMode.StretchImage;

            if (this.radioNaturalny.Checked)
            {
                this.picturePierwotnyOPJ.SizeMode = PictureBoxSizeMode.Normal;
                this.pictureWtornyOPJ.SizeMode = PictureBoxSizeMode.Normal;
            }

            if (this.radioAutoSize.Checked)
            {
                this.picturePierwotnyOPJ.SizeMode = PictureBoxSizeMode.CenterImage;
                this.pictureWtornyOPJ.SizeMode = PictureBoxSizeMode.CenterImage;
            }
            if (this.radioDopasowany.Checked)
            {
                this.picturePierwotnyOPJ.SizeMode = PictureBoxSizeMode.StretchImage;
                this.pictureWtornyOPJ.SizeMode = PictureBoxSizeMode.StretchImage;
            }
            this.picturePierwotnyOPJ.Refresh();
            this.pictureWtornyOPJ.Refresh();
            #endregion
        }

        private void ColourComponentValueChangedEventHandler(object sender, EventArgs e)
        {
            #region ColourComponentValueChangedEventHandler
            //     label3.Text = this.trackBarOPJ.Value.ToString();
            //     label6.Text = this.trackBarV2.Value.ToString();
            //     label9.Text = this.trackBarV3.Value.ToString();

            ApplyFilter(true);
            #endregion
        }

        private void button3_Click(object sender, EventArgs e)
        {
            #region Generowanie Tablicy obrazu wtórnego
            //this.TabWynikowy.Visible = true;
            if (this.radioSzary.Checked)
            {
                this.generuj_histogram(0);
                //  this.groupHistogram.Visible = true;
            }
            if (this.radioKolorRGB.Checked)
            {
                this.HistogramRGB.Image = generuj_histogram_kolory(0);
                // this.label5.Text = "rgb";
            }
            if (this.radioKolorHVS.Checked)
            {

            }
            EnableDoubleBuffered(this.dataGridTablica, true);
            int cols_width = 40;
            Bitmap bmpTab = (Bitmap)this.pictureWtornyOPJ.Image;

            if (dataGridTablica.Columns.Count != bmpTab.Width || dataGridTablica.Rows.Count != bmpTab.Height)
            {
                dataGridTablica.Rows.Clear();
                dataGridTablica.Columns.Clear();
                dataGridTablica.RowHeadersWidth = 60;
                for (int x = 0; x < bmpTab.Width; x++)
                {
                    dataGridTablica.Columns.Add(null, x.ToString());
                    dataGridTablica.Columns[x].Width = cols_width;
                    dataGridTablica.Columns[x].FillWeight = 0.0000001f;
                }
                dataGridTablica.Rows.Add(bmpTab.Height);
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    dataGridTablica.Rows[y].HeaderCell.Value = y.ToString();
                }
            }

            for (int x = 0; x < bmpTab.Width; x++)
            {
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    dataGridTablica[x, y].Value = bmpTab.GetPixel(x, y).R;
                }
            }
            #endregion
        }

        private void pasek_skali_Scroll(object sender, EventArgs e)
        {
            #region skaladla Histogramu w odcieniach szarości obrazu wynikowego
            wartosc_skali.Text = ((double)pasek_skali.Value / 10.0f).ToString();
            this.HistogramGrey.Image = generuj_histogram(4);
            #endregion
        }

        private void buttpn_red_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(0);
        }

        private void button_green_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(1);
        }

        private void button_blue_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(2);
        }

        private void button_wszystkie_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(0);
        }

        private void button8_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(1);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(2);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(3);
        }

        private void pasek_skali2_Scroll(object sender, EventArgs e)
        {
            #region skaladla Histogramu w odcieniach szarości obrazu pierwotnego
            wartosc_skali2.Text = ((double)pasek_skali2.Value / 10.0f).ToString();
            this.HistogramGrey2.Image = generuj_histogram2(4);
            #endregion
        }

        private void button2_Click(object sender, EventArgs e)
        {
            #region Generowanie Tablicy obrazu pierwotnego
            //this.TabPierwotny.Visible = true; 
            if (this.radioSzary.Checked)
            {
                //    Bitmap b = (Bitmap)this.picturePierwotny2.Image;
                this.generuj_histogram2(0);
            }
            if (this.radioKolorRGB.Checked)
            {
                this.HistogramRGB2.Image = generuj_histogram_kolory2(0);
                this.label2.Text = "rgb";
            }
            if (this.radioKolorHVS.Checked)
            {

            }
            EnableDoubleBuffered(this.TablicaLiczb2, true);
            int cols_width = 40;
            Bitmap bmpTab = (Bitmap)this.picturePierwotnyOPJ.Image;

            if (TablicaLiczb2.Columns.Count != bmpTab.Width || TablicaLiczb2.Rows.Count != bmpTab.Height)
            {
                TablicaLiczb2.Rows.Clear();
                TablicaLiczb2.Columns.Clear();
                TablicaLiczb2.RowHeadersWidth = 60;
                for (int x = 0; x < bmpTab.Width; x++)
                {
                    TablicaLiczb2.Columns.Add(null, x.ToString());
                    TablicaLiczb2.Columns[x].Width = cols_width;
                    TablicaLiczb2.Columns[x].FillWeight = 0.0000001f;
                }
                TablicaLiczb2.Rows.Add(bmpTab.Height);
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    TablicaLiczb2.Rows[y].HeaderCell.Value = y.ToString();
                }
            }

            for (int x = 0; x < bmpTab.Width; x++)
            {
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    TablicaLiczb2[x, y].Value = bmpTab.GetPixel(x, y).R;
                }
            }
            #endregion
        }

        private void button6_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram2(0);
        }

        private void button12_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram2(1);
        }

        private void button11_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram2(2);
        }

        private void button10_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram_kolory2(0);
        }

        private void button9_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram_kolory2(1);
        }

        private void button14_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram_kolory2(2);
        }

        private void button13_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram_kolory2(3);
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            label_Kv.Text = track_Kontrast.Value.ToString();
        }

        private void trackBar2_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            if (this.radioKolorHVS.Checked)
            {
                float wartosc = (float)track_Jasnosc.Value / 255;
                //       t.Text = decimal.Round((decimal)wartosc, 2);
                //       label_Jv.Text = t.Text;
                //t.text = ShowDecimalRound(wartosc,2);
                label_Jv.Text = ((double)wartosc / 255.0).ToString("0.00");
                //     label_Jv.Text = wartosc.ToString();  
            }
            else
                label_Jv.Text = track_Jasnosc.Value.ToString();
        }

        private void ustawienia1()
        {
            #region ustawienia obraz RGB
            tabJP.TabPages.Clear();
            tabJP_prog.TabPages.Clear();
            tabProg.TabPages.Clear();
            track_Kontrast.Maximum = 255;
            track_Kontrast.Minimum = -255;
            label_Kmin.Text = "-255";
            label_Kmax.Text = "255";

            track_Jasnosc.Maximum = 255;
            track_Jasnosc.Minimum = -255;
            label_Jmin.Text = "-255";
            label_Jmax.Text = "255";

            label_Pmax.Text = "255";
            label_Pmin.Text = "0";
            groupBoxTablicaLUT.Visible = true;
            groupIdentRGB_1.Visible = true;
            groupJasnoscRGB_1.Visible = true;
            groupKontrastRGB_1.Visible = true;
            #endregion
        }

        private void ustawieniaS()
        {
            #region ustawienia obrazu Szarego
            tabJP.TabPages.Clear();
            tabJP_prog.TabPages.Clear();
            tabProg.TabPages.Clear();
            tabKG.TabPages.Clear();

            track_Kontrast.Maximum = 255;
            track_Kontrast.Minimum = -255;
            label_Kmin.Text = "-255";
            label_Kmax.Text = "255";

            track_Jasnosc.Maximum = 255;
            track_Jasnosc.Minimum = -255;
            label_Jmin.Text = "-255";
            label_Jmax.Text = "255";

            label_Pmax.Text = "255";
            label_Pmin.Text = "0";

            groupBoxTablicaLUT.Visible = true;
            groupIdentRGB_1.Visible = false;
            groupJasnoscRGB_1.Visible = false;
            groupKontrastRGB_1.Visible = false;

            #endregion
        }

        private void ustawieniaHSV()
        {
            #region ustawieniaHSV()
            tabJP.TabPages.Clear();
            tabJP_prog.TabPages.Clear();
            tabProg.TabPages.Clear();
            this.track_Kontrast.Maximum = 255;
            this.track_Kontrast.Minimum = 0;
            this.label_Jv.Text = " ";
            this.label_Kmin.Text = "0";
            this.label_Kmax.Text = "255";
            //  TrackBar value; 
            //  float wartosc = (float)trackBar2.Value / 10.0f;
            //  is between 0.0 and 1.0
            // val = (double)trackBar2.Value / 100;
            //  valc = Convert.ToInt32(vol);
            track_Jasnosc.Maximum = 255;
            this.track_Jasnosc.Minimum = -255;
            this.label_Jmin.Text = "-1.0";
            this.label_Jmax.Text = "1.0";
            this.groupBoxTablicaLUT.Visible = true;
            #endregion
        }


        private void radioKanal_Grey_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
            //  kanalRGB = 1;  //kanały R+G+B
        }

        private void radioKanal_Kolor_CheckedChanged(object sender, EventArgs e)
        {
            #region Identyczność - ustawienie kanałów RGB
            ApplyFilter(true);
            if (this.radioKanal_Kolor.Checked)
            {
                this.groupRGB_Kolor.Visible = true;
            }
            else
            {
                this.groupRGB_Kolor.Visible = false;
            }
            #endregion
        }

        private void radioKanal_Red_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
       //     kanalRGB = 2;  //kanały R
        }

        private void radioKanal_Green_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
       //     kanalRGB = 3;  //kanały G
        }

        private void radioKanal_Blue_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
     //       kanalRGB = 4;  //kanały B
        }

        private void button18_Click(object sender, EventArgs e)
        {
            #region Histrogram w odcieniach szarości - powiększenie
            HistogramMax hRGB1 = new HistogramMax();
            hRGB1.pictureMax.Image = this.HistogramGrey.Image;
            hRGB1.Text = "Obraz Wynikiowy w odcieniach szarości";
            hRGB1.Show();
            #endregion
        }

        private void button19_Click(object sender, EventArgs e)
        {
            #region Identyczność RGB - wyświetlanie kanałów
            ObrazKanalyRGBMax kanal = new ObrazKanalyRGBMax();
            kanal = new ObrazKanalyRGBMax();
           // kanal.MdiParent = this;
            kanal.pictureMaxRGB.Image = this.picturePierwotnyOPJ.Image;
            Bitmap bmp = new Bitmap(picturePierwotnyOPJ.Image);
            kanal.pictureMaxR.Image = kanalRGB_red(bmp);
            kanal.pictureMaxG.Image = kanalRGB_green(bmp);
            kanal.pictureMaxB.Image = kanalRGB_blue(bmp);
            kanal.Text = "Obraz Wynikiowy dla poszczególnych kanałów RGB";
            kanal.Show();
            #endregion
        }

        private void button20_Click(object sender, EventArgs e)
        {
            #region Histrogram RGB - powiększenie
            HistogramMax hRGB1 = new HistogramMax();
            hRGB1.pictureMax.Image = this.HistogramRGB.Image;
            hRGB1.Text = "Obraz Wynikiowy RGB";
            hRGB1.Show();
            #endregion
        }

        public Bitmap kanalRGB_red(Bitmap bmp)
        {
            bmp = bmp.DrawAsGrayscale_Red();
            return bmp;
        }

        public Bitmap kanalRGB_green(Bitmap bmp)
        {
            bmp = bmp.DrawAsGrayscale_Green();
            return bmp;
        }

        public Bitmap kanalRGB_blue(Bitmap bmp)
        {
            bmp = bmp.DrawAsGrayscale_Blue();
            return bmp;
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            #region Kontrast - ustawienie kanałów RGB
            ApplyFilter(true);
            if (this.radioKontrast.Checked)
            {
                this.groupKontrastRGB.Visible = true;
            }
            else
            {
                this.groupKontrastRGB.Visible = false;
            }
            #endregion
        }

        private void radioKontrastRGB_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void radioKontrastR_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void radioKontrastG_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void radioKontrastB_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void button21_Click(object sender, EventArgs e)
        {
            #region Kontrast RGB - wyświetlanie kanałów
            ObrazKanalyRGBMax kanal = new ObrazKanalyRGBMax();
            kanal = new ObrazKanalyRGBMax();
           // kanal.MdiParent = this;
            Bitmap bmp = new Bitmap(this.picturePierwotnyOPJ.Image);
            bmp = bmp.Contrast(track_Kontrast.Value);
            kanal.pictureMaxRGB.Image = bmp;
            kanal.pictureMaxR.Image = kanalRGB_red(bmp);
            kanal.pictureMaxG.Image = kanalRGB_green(bmp);
            kanal.pictureMaxB.Image = kanalRGB_blue(bmp);
            kanal.Text = "Obraz Wynikiowy dla poszczególnych kanałów RGB";
            kanal.Show();
            #endregion
        }

        private void button22_Click(object sender, EventArgs e)
        {
            #region Jasność RGB - wyświetlanie kanałów
            ObrazKanalyRGBMax kanal = new ObrazKanalyRGBMax();
            kanal = new ObrazKanalyRGBMax();
           // kanal.MdiParent = this;
            Bitmap bmp = new Bitmap(this.picturePierwotnyOPJ.Image);
            bmp = bmp.JasnoscRGB2(track_Jasnosc.Value);
            kanal.pictureMaxRGB.Image = bmp;
            kanal.pictureMaxR.Image = kanalRGB_red(bmp);
            kanal.pictureMaxG.Image = kanalRGB_green(bmp);
            kanal.pictureMaxB.Image = kanalRGB_blue(bmp);
            kanal.Text = "Obraz Wynikiowy dla poszczególnych kanałów RGB";
            kanal.Show();
            #endregion
        }

        private void radioJasnoscRGB_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void radioJasnosc_CheckedChanged(object sender, EventArgs e)
        {
            #region Jasność - ustawienie kanałów RGB
            ApplyFilter(true);
            if (this.radioJasnosc.Checked)
            {
                this.groupJasnoscRGB.Visible = true;
            }
            else
            {
                this.groupJasnoscRGB.Visible = false;
            }
            #endregion
        }

        private void radioJasnoscR_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void radioJasnoscG_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void radioJasnoscB_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void radioNegacjaRGB_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void radioNegacja_CheckedChanged(object sender, EventArgs e)
        {
            #region Negacja - ustawienie kanałów RGB
            ApplyFilter(true);
            if (this.radioNegacja.Checked)
            {
                this.groupNegacjaRGB.Visible = true;
            }
            else
            {
                this.groupNegacjaRGB.Visible = false;
            }
            #endregion
        }

        private void radioNegacjaR_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void radioNegacjaG_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void radioNegacjaB_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void button23_Click(object sender, EventArgs e)
        {
            #region Negacja RGB - wyświetlanie kanałów
            ObrazKanalyRGBMax kanal = new ObrazKanalyRGBMax();
            kanal = new ObrazKanalyRGBMax();
            Bitmap bmp = new Bitmap(this.picturePierwotnyOPJ.Image);
            bmp = bmp.DrawNegatywRGB();
            kanal.pictureMaxRGB.Image = bmp;
            kanal.pictureMaxR.Image = kanalRGB_red(bmp);
            kanal.pictureMaxG.Image = kanalRGB_green(bmp);
            kanal.pictureMaxB.Image = kanalRGB_blue(bmp);
            kanal.Text = "Obraz Wynikiowy dla poszczególnych kanałów RGB";
            kanal.Show();
            #endregion
        }

        private void button24_Click(object sender, EventArgs e)
        {
            #region Obraz wynikowy powiekszony
            ApplyFilter(true);
            ObrazMax bmpMax = new ObrazMax();
            bmpMax = new ObrazMax();
        //    bmpMax.MdiParent = this;
       //     bmpMax.pictureMaxZoom.Image = bmpR;         
            bmpMax.pictureMaxZoom.Image = this.pictureWtornyOPJ.Image;
            bmpMax.Text = "Obraz Wynikiowy RGB " + label28.Text;
            bmpMax.Show();
            #endregion
        }

        private void button25_Click(object sender, EventArgs e)
        {
            #region Obraz pierwotny powiekszony
            ObrazMax bmpMax = new ObrazMax();
            bmpMax = new ObrazMax();
            
            bmpMax.pictureMaxZoom.Image = this.picturePierwotnyOPJ.Image;
            bmpMax.Text = "Obraz Pierwotny RGB " + label28.Text;
            bmpMax.Show();
            #endregion
        }

        private void button4_Click(object sender, EventArgs e)
        {
            #region Histrogram w odcieniach szarości - powiększenie dla obrazu pierwotnego
            HistogramMax hRGB2 = new HistogramMax();
            hRGB2.pictureMax.Image = this.HistogramGrey2.Image;
            hRGB2.Text = "Obraz Wynikiowy w odcieniach szarości";
            hRGB2.Show();
            #endregion
        }

        private void button15_Click(object sender, EventArgs e)
        {
            #region Histrogram RGB - powiększenie dla obrazu pierwotnego
            HistogramMax hRGB2 = new HistogramMax();
            hRGB2.pictureMax.Image = this.HistogramRGB2.Image;
            hRGB2.Text = "Obraz Wynikiowy RGB";
            hRGB2.Show();
            #endregion
        }

        private void track_Progowanie2_Scroll(object sender, EventArgs e)
        {
            
        }

        private void trackBar1_Scroll_1(object sender, EventArgs e)
        {
            ApplyFilter(true);
            label_PPv1.Text = this.track_Progowanie3.Value.ToString();
        }

        private void track_Progowanie4_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            label_PPv2.Text = this.track_Progowanie4.Value.ToString();
        }

        private void trcThreshold_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            int war = this.trcThreshold2.Value;
            this.labelProgKolor.Text = ((double)war/3).ToString("0");
        }

        private void button16_Click(object sender, EventArgs e)
        {
            kolor(pnlDarkColour);
        }

        private void button17_Click(object sender, EventArgs e)
        {
            kolor(pnlLightColour);
        }

        private void trackProgOdw_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            int war = trackProgOdw.Value;
            this.labelProgKolor2.Text = ((double)war / 3).ToString("0");
        }

        private void button27_Click(object sender, EventArgs e)
        {
            kolor(pnlDarkColour2);
        }


        private void kolor(Panel pn)
        {
            ColorDialog cld = new ColorDialog();
            Panel tmp = new Panel();
            cld.AllowFullOpen = true;
            cld.Color = tmp.BackColor;
            cld.FullOpen = true;

            if (cld.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                tmp.BackColor = cld.Color;
                pn.BackColor = cld.Color;
                ApplyFilter(true);
            }               
        }

        private void button26_Click(object sender, EventArgs e)
        {
            kolor(pnlLightColour2);
        }

        private void track_ProgowanieOdw_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            int war = track_ProgowanieOdw.Value;
            labelPO_v.Text = ((double)war / 3).ToString("0");
        }

        private void trackBar6_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            float w = (float)(trackKorekcjaGammaS.Value/100.0);
            labelKG_Sv.Text = w.ToString("0.00");
        }

        private void tracProgowanieHSV_Scroll(object sender, EventArgs e)
        {
            
          //  this.pictureWtornyOPJ.Image = picturePierwotnyOPJ.Image;
                //    int war = this.tracProgowanieHSV.Value;
                //   tracProgowanieHSV.Maximum = 100000;
                //   lab_ProgowanieHSV.Text = "1000000";
                //   double w = ((double)tracProgowanieHSV.Value / 100000.0f);
                double w = ((double)tracProgowanieHSV.Value / 100000.0f);
         //      tracProgowanieHSV.Value =  1 / 100000.0f;
                this.labelProgKolorHSV.Text = ((double)w).ToString();
                ApplyFilter(true);
            
            
        }

        private void tracKGammaRGB_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            float w = (float)(tracKGammaRGB.Value / 100.0);
            this.labelKGammaRGBv.Text = w.ToString("0.00");
        }

        private void radioKGammaRGB_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void radioKGamma_CheckedChanged(object sender, EventArgs e)
        {
            #region Korekcja Gamma - ustawienie kanałów RGB
            ApplyFilter(true);
            if (this.radioKGamma.Checked)
            {
                this.groupKGammaRGB.Visible = true;
            }
            else
            {
                this.groupKGammaRGB.Visible = false;
            }
            #endregion
        }

        private void radioKGammaR_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void radioKGammaG_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void radioKGammaB_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void buttonKGammaRGB_Click(object sender, EventArgs e)
        {
            #region Korekca Gamma RGB - wyświetlanie kanałów
            ObrazKanalyRGBMax kanal = new ObrazKanalyRGBMax();
            kanal = new ObrazKanalyRGBMax();
           // kanal.MdiParent = this;
           this.tracKGammaRGB.ValueChanged += new System.EventHandler(this.trackGamma);
            Bitmap bmp = new Bitmap(this.picturePierwotnyOPJ.Image);
           // bmp = bmp.Contrast(track_Kontrast.Value);
            kanal.pictureMaxRGB.Image = bmp;
            kanal.pictureMaxR.Image = kanalRGB_red(bmp);
            kanal.pictureMaxG.Image = kanalRGB_green(bmp);
            kanal.pictureMaxB.Image = kanalRGB_blue(bmp);
            kanal.Text = "Obraz Wynikiowy dla poszczególnych kanałów RGB";
            kanal.Show();
            #endregion
        }

        private void trackBar1_Scroll_3(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelOdcienRGB_vR.Text = this.tracOdcienRGB_R.Value.ToString();
        }

        private void trackBar6_Scroll_1(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelOdcienRGB_vG.Text = this.tracOdcienRGB_G.Value.ToString();
        }

        private void trackBar7_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelOdcienRGB_vB.Text = this.tracOdcienRGB_B.Value.ToString();
        }

        private void radioButton6_CheckedChanged(object sender, EventArgs e)
        {
            #region Odcienie - ustawienie kanałów RGB
            ApplyFilter(true);
            if (this.radioOdcien.Checked)
            {
                this.groupOdcienKanaly.Visible = true;
            }
            else
            {
                this.groupOdcienKanaly.Visible = false;
            }
            #endregion
        }

        private void radioOdcien_RGB_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void radioOdcien_R_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void radioOdcien_G_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void radioOdcien_B_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void button29_Click(object sender, EventArgs e)
        {
            #region Odcień RGB - wyświetlanie kanałów
            ObrazKanalyRGBMax kanal = new ObrazKanalyRGBMax();
            kanal = new ObrazKanalyRGBMax();
          //  kanal.MdiParent = this;
            Bitmap bmp = new Bitmap(this.picturePierwotnyOPJ.Image);
            float blue = this.tracOdcienRGB_R.Value / 100.0f;
            float green = this.tracOdcienRGB_G.Value / 100.0f;
            float red = this.tracOdcienRGB_B.Value / 100.0f;
            bmp = bmp.OdcienieRGB(blue, green, red);
            kanal.pictureMaxRGB.Image = bmp;
            kanal.pictureMaxR.Image = kanalRGB_red(bmp);
            kanal.pictureMaxG.Image = kanalRGB_green(bmp);
            kanal.pictureMaxB.Image = kanalRGB_blue(bmp);
            kanal.Text = "Obraz Wynikiowy dla poszczególnych kanałów RGB";
            kanal.Show();
            #endregion
        }

        private void trackBar6_Scroll_2(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelRozciaganie_v1.Text = this.trackRozciaganie_v1.Value.ToString();
        }

        private void trackBar1_Scroll_4(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelRozciaganie_v2.Text = this.trackRozciaganie_v2.Value.ToString();

        }

        private void tabJP_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void groupBox6_Enter(object sender, EventArgs e)
        {

        }

        private void tabProgowanie4_Click(object sender, EventArgs e)
        {

        }

        private void trackProgowanieZP1_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelProg_v1.Text = this.trackProgowanieZP1.Value.ToString();
        }

        private void trackProgowanieZP2_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            this.labelProg_v2.Text = this.trackProgowanieZP2.Value.ToString();
        }

        private void radioButton7_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void radioButton6_CheckedChanged_1(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void label63_Click(object sender, EventArgs e)
        {

        }

        private void button32_Click(object sender, EventArgs e)
        {
            
        }

        private void button31_Click(object sender, EventArgs e)
        {
            
        }

        private void radioButton7_CheckedChanged_1(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void radioButton6_CheckedChanged_2(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void trackBineryzacjaS_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            int war1 = trackBineryzacjaS.Value;
            label_Pv.Text = ((double)war1 / 3).ToString("0");
        }

        private void button28_Click(object sender, EventArgs e)
        {

        }

        private void button30_Click(object sender, EventArgs e)
        {
            #region Rozciąganie RGB - wyświetlanie kanałów
            ObrazKanalyRGBMax kanal = new ObrazKanalyRGBMax();
            kanal = new ObrazKanalyRGBMax();
           // kanal.MdiParent = this;
            Bitmap bmp = new Bitmap(this.picturePierwotnyOPJ.Image);
            bmp = bmp.Rozciagnie(trackRozciaganie_v1.Value, trackRozciaganie_v2.Value);
            kanal.pictureMaxRGB.Image = bmp;
            kanal.pictureMaxR.Image = kanalRGB_red(bmp);
            kanal.pictureMaxG.Image = kanalRGB_green(bmp);
            kanal.pictureMaxB.Image = kanalRGB_blue(bmp);
            kanal.Text = "Obraz Wynikiowy dla poszczególnych kanałów RGB";
            kanal.Show();
            #endregion
        }

        private void radioButton9_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void radioRozciaganieRGB_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void radioRozciaganie_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void radioRozciaganieR_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void radioRozciaganieG_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void groupObrazPJ_Enter(object sender, EventArgs e)
        {

        }


        private void button31_Click_1(object sender, EventArgs e)
        {
            ApplyFilter(true);
            w = 2;
            this.prog.Text = "2";
        }

        private void button32_Click_1(object sender, EventArgs e)
        {
            ApplyFilter(true);
            w = 4;
            this.prog.Text = "4";
        }

        private void p6_Click(object sender, EventArgs e)
        {
            ApplyFilter(true);
            w = 6;
            this.prog.Text = "6";
        }

        private void p8_Click(object sender, EventArgs e)
        {
            ApplyFilter(true);
            w = 8;
            this.prog.Text = "8";
        }

        private void p16_Click(object sender, EventArgs e)
        {
            ApplyFilter(true);
            w = 16;
            this.prog.Text = "16";
        }

        private void trackBar3_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            double x = ((double)(this.trackRedukcjaPRGB.Value));
            this.labelRedukcjaPRGBv.Text = x.ToString("0.00");
        }

        private Bitmap src1;

        private void wynik(Bitmap src)
        {
            src = new Bitmap(this.picturePierwotnyOPJ.Image);
            int h = (int)pictureWtornyOPJ.Height;
            int w = (int)pictureWtornyOPJ.Width;
            while (h > 300 || w > 300)
            {
                h = (int)(pictureWtornyOPJ.Height / 1.05f);
                w = (int)(pictureWtornyOPJ.Width / 1.05f);
            }
            if (src != null)
            {
                src1 = new Bitmap(src.GetThumbnailImage(w, h, null, System.IntPtr.Zero));
                pictureWtornyOPJ.Image = src.GetThumbnailImage(w, h, null, System.IntPtr.Zero);
            }        
        }

        private void trackJasnoscHSV_Scroll_1(object sender, EventArgs e)
        {
            ApplyFilter(true);
        //    wynik((Bitmap)pictureWtornyOPJ.Image);
            labelJasnscHSVv.Text = (((double)this.trackJasnoscHSV.Value) / 255).ToString();
         //   pictureWtornyOPJ.Image  = functions.regulacja_jasnoscia_hsv(src1, trackJasnoscHSV.Value);
//
        }

        private void trackBar1_Scroll_2(object sender, EventArgs e)
        {
            ApplyFilter(true);
            double x = ((double)(trackProgowanieHSV.Value)/100000.0f);
            labelProgowanieHSV_v.Text = x.ToString("0.0");
        }

        private void trackProgHSV_1_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            double x = ((double)(this.trackRozHSV_v1.Value)/255);
            labelRozHSV_v1.Text = x.ToString("0.00");
        }

        private void trackProgHSV_2_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            double x = ((double)(this.trackRozHSV_v2.Value)/255);
            labelRozHSV_v2.Text = x.ToString("0.00");
        }

        private void trackRedukcjaP_HSV_Scroll(object sender, EventArgs e)
        {
            ApplyFilter(true);
            double x = ((double)(this.trackRedukcjaP_HSV.Value));
            this.labelRedukcjaP_HSVv.Text = x.ToString("0.00");
        }

        private void trackBar1_Scroll_5(object sender, EventArgs e)
        {
            ApplyFilter(true);
            double x = ((double)(this.trackRP_RGB.Value));
            this.labelRP_RGBv.Text = x.ToString("0.00");
        }
    }

}