﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Windows.Forms.DataVisualization.Charting;
using System.Drawing.Imaging;


namespace APO_BB_DK_v012013
{
    public partial class ObrazOAW : Form
    {
      //  private OperatorOPJ processingOPJ;
        private TrackBar suwak1;
        private OpenFileDialog open;
        public PictureBox pictureHistogramOPJ;
        public PictureBox pictureFLW;
        public Bitmap bitmap;
        public int x1, y1, x2, y2;
        private ArytmetykaObrazu arytmObrazu;
 //       private ArytmetykaObrazu arytmObrazuT;
        public TextBox textArytmetyka;
  

        private Bitmap originalBitmap = null;
        private Bitmap previewBitmap = null;
        private Bitmap resultBitmap = null;
      
        public ObrazOAW()
        {
            InitializeComponent();

            x1 = x2 = y1 = y2 = 0;
            //processingOPJ = new OperatorOPJ();
            open = new OpenFileDialog();
            suwak1 = new System.Windows.Forms.TrackBar();
            this.pictureFL.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureFLW.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureObrazFL1.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureObrazFL2.SizeMode = PictureBoxSizeMode.StretchImage;

            comboBoxFGL.Items.Add("Wybierz algorytm wyznaczania składowych wektora cech obiektu binarnego");
            comboBoxFGL.Items.Add ("Współczynniki kształtu");
            comboBoxFGL.Items.Add("Momentów");  
            comboBoxFGL.Items.Add("Momentu centralnego");
            comboBoxFGL.Items.Add("Środka masy i ukierunkowania");
            comboBoxFGL.Items.Add("Wszystkie cechy obiektu binarnego");
            comboBoxFGL.SelectedIndex = 0;        
        }
        
        private void buttonHistogramOPJ_Click(object sender, EventArgs e)
        {
            Bitmap bmpG = (Bitmap)this.pictureFLW.Image;
            Bitmap hs = new HistogramRysuj(bmpG).draw();
            this.pictureHistogramOPJ.Image = hs;
            this.pictureHistogramOPJ.Visible = true;             
            /*
            this.pictureHistogramOPJ.Visible = true;
            Bitmap bmpHistogOPJ = (Bitmap)pictureFLW.Image;
            this.processingOPJ.setImage(new Bitmap(this.pictureFLW.Image));
        //    this.processingOPJ.calcHisto(this);
            this.Invalidate();
             */
        }

        public int X1
        {
            get { return Math.Min(x1, x2); }
        }

        public int X2
        {
            get { return Math.Max(x1, x2); }
        }


        private void button1_Click(object sender, EventArgs e)
        {         
            FunkcjeJednoarg fn = new FunkcjeJednoarg();
 
            if (this.radioSzaryFL.Checked)
            {
                this.label1.Text = "Obraz wynikowy w odcieniach szarości";
                Bitmap bmpFL = new Bitmap(this.pictureObrazFL1.Image);
                this.pictureObrazFL2.Image = bmpFL;
                bmpFL = fn.Skalaszarosci(bmpFL);
                this.pictureFLW.Image = bmpFL;
                this.pictureFL.Image = bmpFL;
                this.pictureFLW.Image = bmpFL.CopyToSquareCanvas(pictureFLW.Width);
                this.comboBoxFGL.Visible = true;
                this.pictureFLW.Visible = true;
                this.groupHistogramFL.Visible = true;
                previewBitmap = bmpFL.CopyToSquareCanvas(this.pictureFL.Width);
                this.pictureFLW.Image = previewBitmap;
            }

            else
            {
                this.label1.Text = "Obraz wynikowy kolorowy";
                Bitmap bmpFLkol = new Bitmap(this.pictureObrazFL1.Image);            
                this.comboBoxFGL.Visible = true;
                this.pictureFL.Image = bmpFLkol;
                this.pictureFLW.Image = bmpFLkol;
                this.pictureFLW.Visible = true;
                this.groupHistogramFL.Visible = true;
                previewBitmap = bmpFLkol.CopyToSquareCanvas(this.pictureFL.Width);
                this.pictureFLW.Image = previewBitmap;
            }
            this.comboBoxFGL.Refresh();
        }

        private void buttonObrazFL_Click_1(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Title = "Select the source Image";
            ofd.Filter = "Image Files(*.BMP;*.JPG;*.PNG)|*.BMP;*.JPG;*.PNG|All files (*.*)|*.*";

            if (ofd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                StreamReader streamReader = new StreamReader(ofd.FileName);
                originalBitmap = (Bitmap)Bitmap.FromStream(streamReader.BaseStream);
                streamReader.Close();
                previewBitmap = originalBitmap.CopyToSquareCanvas(pictureFL.Width);
                this.pictureFL.Image = previewBitmap;
                this.pictureObrazFL1.Image = originalBitmap;
              }
        }
        

           
        private void buttonWidok_Click(object sender, EventArgs e)
        {
            this.pictureFL.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureFLW.SizeMode = PictureBoxSizeMode.StretchImage;

            if (this.radioNaturalny.Checked)
            {
               
                this.pictureFLW.SizeMode = PictureBoxSizeMode.Normal;
                this.pictureFL.SizeMode = PictureBoxSizeMode.Normal;
            }

            if (this.radioAutoSize.Checked)
            {
                this.pictureFL.SizeMode = PictureBoxSizeMode.CenterImage;
                this.pictureFLW.SizeMode = PictureBoxSizeMode.CenterImage;
            }
            if (this.radioDopasowany.Checked)
            {
                this.pictureFL.SizeMode = PictureBoxSizeMode.StretchImage;
                this.pictureFLW.SizeMode = PictureBoxSizeMode.StretchImage;
            }
            this.pictureFL.Refresh();
            this.pictureFLW.Refresh();
        }

        private void ApplyFilter(bool preview)
        {
            if (previewBitmap == null || comboBoxFGL.SelectedIndex == -1)
            {
                return;
            }

            Bitmap selectedSource = null;
            Bitmap bitmapResult = null;

            if (preview == true)
            {
                selectedSource = previewBitmap;
            }
            else
            {
                selectedSource = originalBitmap;
            }

            if (selectedSource != null)
            {
                if (comboBoxFGL.SelectedItem.ToString() == "Wybierz algorytm wyznaczania składowych wektora cech obiektu binarnego")
                {
                    bitmapResult = selectedSource;
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Współczynniki kształtu")
                {
                    bitmapResult = selectedSource;          
                    Bitmap bmp1 = (Bitmap)this.pictureFLW.Image;
                    arytmObrazu = new ArytmetykaObrazu(bmp1);
                  //  arytmObrazuT = new ArytmetykaObrazu
                    textArytmetyka.Text = arytmObrazu.ArytmetykaObrazuT();
        
                    label1.Text = "Obraz wynikowy - Algorytm wyznaczania składowych wektora cech obiektu binarnego";
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Momentów")
                {
                    bitmapResult = selectedSource.AlgorytmZolw2(128,128);
                    label1.Text = "Obraz wynikowy - Algorytm wyznaczania składowych wektora cech obiektu binarnego";
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Środka masy i ukierunkowania")
                {
                    bitmapResult = selectedSource.AlgorytmZolw2(128, 128);
                    label1.Text = "Obraz wynikowy - Algorytm wyznaczania składowych wektora cech obiektu binarnego";
                }
                else if (comboBoxFGL.SelectedItem.ToString() == "Wszystkie cechy obiektu binarnego")
                {
                    bitmapResult = selectedSource.AlgorytmZolw2(128, 128);
                    label1.Text = "Obraz wynikowy - Algorytm wyznaczania składowych wektora cech obiektu binarnego";
                }

            }

            if (bitmapResult != null)
            {
                if (preview == true)
                {
                    pictureFLW.Image = bitmapResult;
                }
                else
                {
                    resultBitmap = bitmapResult;
                }
            }
        }

        private void comboBoxFL_SelectedIndexChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void pictureFLW_Click(object sender, EventArgs e)
        {

        }

        private void groupBox2_Enter(object sender, EventArgs e)
        {

        }



        private void dataGridView1_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }

 
       

           
    }
}