﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Windows.Forms.DataVisualization.Charting;
using System.Drawing.Imaging;


namespace APO_BB_DK_v012013
{
    public partial class ObrazSAS : Form
    {
     //   private OperatorOPJ processingOPJ;
        private TrackBar suwak1;
        private OpenFileDialog open;
        public PictureBox pictureHistogramOPJ;
        public PictureBox pictureWtornyOPJ;
        public PictureBox picturePierwotnyOPJ;
        public Bitmap bitmap;
        private Bitmap originalBitmap = null;
        private Bitmap previewBitmap = null;
        private Bitmap resultBitmap = null;
        private ArytmetykaObrazu arytmObrazu;
     //   Bitmap bmpHSV;
    //    private FunkcjeHSV fHSV;
        

        public ObrazSAS()
        {
            InitializeComponent();
         //   processingOPJ = new OperatorOPJ();
            open = new OpenFileDialog();
            suwak1 = new System.Windows.Forms.TrackBar();
            comboBoxFGG.Items.Add("Operacje jednopunktowe");
            comboBoxFGG.SelectedIndex = 0;
            groupV1.Visible = false;
            groupV2.Visible = false;
            trackBarOPJ.Visible = true; 
        }

        private void buttonObrazPierwotnyOPJ_Click(object sender, EventArgs e)
        {
           OpenFileDialog ofd = new OpenFileDialog();
           ofd.Title = "Select the source Image";
           ofd.Filter = "Image Files(*.BMP;*.JPG;*.PNG)|*.BMP;*.JPG;*.PNG|All files (*.*)|*.*";

            if (ofd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                StreamReader streamReader = new StreamReader(ofd.FileName);
                originalBitmap = (Bitmap)Bitmap.FromStream(streamReader.BaseStream);
                streamReader.Close();
                previewBitmap = originalBitmap.CopyToSquareCanvas(this.picturePierwotnyOPJ.Width);
                this.picturePierwotnyOPJ.Image = previewBitmap;
                this.pictureObrazFL1.Image = originalBitmap;
              }
        }


        private void buttonKolor_Click(object sender, EventArgs e)
        {
            FunkcjeJednoarg fn = new FunkcjeJednoarg();
            comboBoxFGG.Items.Clear();
            comboBoxFGG.Items.Add("Operacje segmentacji obrazów");
            comboBoxFGG.SelectedIndex = 0;
            this.label10.Text = "";
        
            if (this.radioSzary.Checked)
            {
                comboBoxFGG.Items.Add("Progowanie");
                comboBoxFGG.Items.Add("Rozrost obszaru");
                comboBoxFGG.Items.Add("Dołączania");
                comboBoxFGG.Items.Add("Podziału");
                comboBoxFGG.Items.Add("Podziału i dołączania");
                comboBoxFGG.Items.Add("Segmentacja oparta na opisie tekstury");
                comboBoxFGG.Items.Add("Współczynniki kształtu");
                comboBoxFGG.SelectedIndex = 0;
                this.label1.Text = "Obraz wynikowy operacji segmentacji obrazów";
                Bitmap bmpGrey = new Bitmap(this.pictureObrazFL1.Image);
                bmpGrey = fn.Skalaszarosci(bmpGrey);
                this.pictureObrazFL2.Image = bmpGrey;
                picturePierwotnyOPJ.Image = bmpGrey;
                pictureWtornyOPJ.Image = bmpGrey;      
                previewBitmap = bmpGrey.CopyToSquareCanvas(this.picturePierwotnyOPJ.Width);
                this.pictureWtornyOPJ.Image = previewBitmap;
            }

            if (this.radioKolorHVS.Checked)
            {
                comboBoxFGG.Items.Add("Progowanie HSV");
                comboBoxFGG.Items.Add("Rozrost obszaru HSV");
                comboBoxFGG.Items.Add("Dołączania HSV");
                comboBoxFGG.Items.Add("Podziału HSV");
                comboBoxFGG.Items.Add("Podziału i dołączania HSV");
                comboBoxFGG.Items.Add("Segmentacja oparta na opisie tekstury HSV");
                comboBoxFGG.Items.Add("Współczynniki kształtu");
                comboBoxFGG.SelectedIndex = 0;
                this.label1.Text = "Obraz wynikowy operacji segmentacji obrazów HSV";
                Bitmap bmpHVS = new Bitmap(this.pictureObrazFL1.Image);
                picturePierwotnyOPJ.Image = bmpHVS;
                pictureWtornyOPJ.Image = bmpHVS;
                previewBitmap = bmpHVS.CopyToSquareCanvas(this.picturePierwotnyOPJ.Width);
                this.pictureWtornyOPJ.Image = previewBitmap;
            }

            if (this.radioKolorRGB.Checked)
            {
                comboBoxFGG.Items.Add("Progowanie RGB");
                comboBoxFGG.Items.Add("Rozrost obszaru RGB");
                comboBoxFGG.Items.Add("Dołączania RGB");
                comboBoxFGG.Items.Add("Podziału RGB");
                comboBoxFGG.Items.Add("Podziału i dołączania RGB");
                comboBoxFGG.Items.Add("Segmentacja oparta na opisie tekstury RGB");
                comboBoxFGG.Items.Add("Współczynniki kształtu");
                comboBoxFGG.SelectedIndex = 0;
                this.label1.Text = "Obraz wynikowy operacji segmentacji obrazów RGB";
                Bitmap bmpRGB = new Bitmap(this.pictureObrazFL1.Image);
                picturePierwotnyOPJ.Image = bmpRGB;
                pictureWtornyOPJ.Image = bmpRGB;
                previewBitmap = bmpRGB.CopyToSquareCanvas(this.picturePierwotnyOPJ.Width);
                this.pictureWtornyOPJ.Image = previewBitmap;    
            }
        }

        private void buttonHistogramOPJ_Click(object sender, EventArgs e)
        {
            Bitmap bmpG = (Bitmap)this.pictureWtornyOPJ.Image;
            Bitmap hs = new HistogramRysuj(bmpG).draw();
            this.pictureHistogramOPJ.Image = hs;
            this.pictureHistogramOPJ.Visible = true; 
        }

              
        private void trackBarOPJ_Scroll(object sender, EventArgs e)
        {
            label_value.Text = trackBarOPJ.Value.ToString();
            pictureWtornyOPJ.Refresh();
            ApplyFilter(true);
        }

        private void ApplyFilter(bool preview)
        {
            if (previewBitmap == null || comboBoxFGG.SelectedIndex == -1)
            { return; }

            Bitmap selectedSource = null;
            Bitmap bitmapResult = null;

            if (preview == true)
            {  selectedSource = previewBitmap; }
            else
            { selectedSource = originalBitmap; }

            if (selectedSource != null)
            {
                if (comboBoxFGG.SelectedItem.ToString() == "None")
                {
                    bitmapResult = selectedSource;
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Progowanie")
                {
                    this.groupV1.Visible = true;
                    this.groupV2.Visible = false;
                    this.trackBarOPJ.Maximum = 255;
                    this.trackBarOPJ.Minimum = 0;
                //    this.trackBarOPJ.Value = 50;
                    this.label2.Text = "0";
                    this.label3.Text = "255";
                    this.label1.Text = "Obraz wynikowy - operacje segmentacji obrazów - Progowanie";
                    Bitmap bmpHSV;
                    bmpHSV = (Bitmap)this.pictureWtornyOPJ.Image;
                    bmpHSV = FunkcjeJednoarg.Bineryzacja(bmpHSV, this.trackBarOPJ.Value);
                    bitmapResult = bmpHSV;
                    bitmapResult = selectedSource.AlgorytmZolw2(h, h);
                    pictureWtornyOPJ.Refresh();
                }
                else if (comboBoxFGG.SelectedItem.ToString() == "Progowanie RGB")
                {
                    this.groupV1.Visible = true;
                    this.groupV2.Visible = false;
                    this.trackBarOPJ.Maximum = 255;
                    this.trackBarOPJ.Minimum = 0;
                 //   this.trackBarOPJ.Value = 50;
                    this.label2.Text = "0";
                    this.label3.Text = "255";
                    this.label1.Text = "Obraz wynikowy - operacje segmentacji obrazów - Progowanie RGB";
                    Bitmap bmpHSV;
                    bmpHSV = (Bitmap)this.pictureWtornyOPJ.Image;
                    bmpHSV = FunkcjeJednoarg.Bineryzacja(bmpHSV, this.trackBarOPJ.Value);
                    pictureWtornyOPJ.Refresh();
                    bitmapResult = bmpHSV;
                    bitmapResult = selectedSource.AlgorytmZolw2(128, 128);
                    pictureWtornyOPJ.Refresh();
                     if (label10.ToString() == "Segmentacja")
                    {    bitmapResult = selectedSource.AlgorytmZolw2(128, 128);
                    pictureWtornyOPJ.Refresh();
                     }

                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Progowanie HSV")
                {
                    this.groupV1.Visible = true;
                    this.groupV2.Visible = false;
                    this.trackBarOPJ.Maximum = 100000;
                    this.trackBarOPJ.Minimum = 0;
                  //  this.trackBarOPJ.Value = 50;
                    this.label2.Text = "0";
                    this.label3.Text = "100000";
                    this.label1.Text = "Obraz wynikowy - operacje segmentacji obrazów - Progowanie HSV";                  
                    Bitmap bmpHSV;
                    bmpHSV = (Bitmap)this.pictureWtornyOPJ.Image; 
                    bmpHSV = functions.progowanie_hsv(bmpHSV, this.trackBarOPJ.Value);
                    pictureWtornyOPJ.Refresh();
                    bitmapResult = bmpHSV;         
                }

                else if (comboBoxFGG.SelectedItem.ToString() == "Współczynniki kształtu")
                {
                    bitmapResult = selectedSource;
                    Bitmap bmp1 = (Bitmap)this.pictureWtornyOPJ.Image;
                    arytmObrazu = new ArytmetykaObrazu(bmp1);
                    //  arytmObrazuT = new ArytmetykaObrazu
                    textArytmetyka.Text = arytmObrazu.ArytmetykaObrazuT();

                    label1.Text = "Obraz wynikowy - Algorytm wyznaczania składowych wektora cech obiektu binarnego";
                }
         

                else if (comboBoxFGG.SelectedItem.ToString() == "Odcienie RGB")
                {
                    float blue = trackBarOPJ.Value / 100.0f;
                    float green = trackBarV2.Value / 100.0f;
                    float red = trackBarV3.Value / 100.0f;
                    
                    this.groupV1.Visible = true;
                    this.groupV2.Visible = true;
                    this.groupV3.Visible = true;
                    this.trackBarOPJ.Minimum = 0;
                    this.trackBarOPJ.Maximum = 100;
                    this.trackBarV2.Minimum = 0;
                    this.trackBarV2.Maximum = 100;
                    this.trackBarV3.Minimum = 0;
                    this.trackBarV3.Maximum = 100;
      
                    this.label2.Text = "NIEBIESKI";
                    this.label5.Text = "ZIELONY";
                    this.label8.Text = "CZERWONY";
                    this.label3.Text = "100";
                    this.label6.Text = "100";
                    this.label9.Text = "100";
                    //this.trackBarOPJ.ValueChanged += new System.EventHandler(this.trackBarGamma);
                    bitmapResult = selectedSource.OdcienieRGB(blue, green, red);
                }              
              }

            if (bitmapResult != null)
            {
                if (preview == true)
                {
                    this.pictureWtornyOPJ.Image = bitmapResult;
                }
                else
                {
                    resultBitmap = bitmapResult;
                }
            }

        }

        public int h
        {
            get {return (int)this.fwidth.Value;}
            set {}
        }

        private void comboBoxFGG_SelectedIndexChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.pictureWtornyOPJ.Image = resultBitmap;
            ApplyFilter(false);
            if (resultBitmap != null)
            {
                SaveFileDialog sfd = new SaveFileDialog();
                sfd.Title = "Specify a file name and file path";
                sfd.Filter = "Png Images(*.png)|*.png|Jpeg Images(*.jpg)|*.jpg";
                sfd.Filter += "|Bitmap Images(*.bmp)|*.bmp";

                if (sfd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                {
                    string fileExtension = Path.GetExtension(sfd.FileName).ToUpper();
                    ImageFormat imgFormat = ImageFormat.Png;

                    if (fileExtension == "BMP")
                    {
                        imgFormat = ImageFormat.Bmp;
                    }
                    else if (fileExtension == "JPG")
                    {
                        imgFormat = ImageFormat.Jpeg;
                    }
                    StreamWriter streamWriter = new StreamWriter(sfd.FileName, false);
                    resultBitmap.Save(streamWriter.BaseStream, imgFormat);
                    streamWriter.Flush();
                    streamWriter.Close();
                    resultBitmap = null;
                }

            }
        }

        private void trackBarV2_Scroll(object sender, EventArgs e)
        {
            this.label4.Text = trackBarOPJ.Value.ToString();
            ApplyFilter(true);
        }

        private void buttonWidok_Click(object sender, EventArgs e)
        {
            this.picturePierwotnyOPJ.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureWtornyOPJ.SizeMode = PictureBoxSizeMode.StretchImage;

            if (this.radioNaturalny.Checked)
            {
                this.picturePierwotnyOPJ.SizeMode = PictureBoxSizeMode.Normal;
                this.pictureWtornyOPJ.SizeMode = PictureBoxSizeMode.Normal;
            }

            if (this.radioAutoSize.Checked)
            {
                this.picturePierwotnyOPJ.SizeMode = PictureBoxSizeMode.CenterImage;
                this.pictureWtornyOPJ.SizeMode = PictureBoxSizeMode.CenterImage;
            }
            if (this.radioDopasowany.Checked)
            {
                this.picturePierwotnyOPJ.SizeMode = PictureBoxSizeMode.StretchImage;
                this.pictureWtornyOPJ.SizeMode = PictureBoxSizeMode.StretchImage;
            }
            this.picturePierwotnyOPJ.Refresh();
            this.pictureWtornyOPJ.Refresh();
        }

        private void ColourComponentValueChangedEventHandler(object sender, EventArgs e)
        {
            label3.Text = this.trackBarOPJ.Value.ToString();
            label6.Text = this.trackBarV2.Value.ToString();
            label9.Text = this.trackBarV3.Value.ToString();

            ApplyFilter(true);
        }

        private void trackBarV3_Scroll(object sender, EventArgs e)
        {
            label7.Text = trackBarOPJ.Value.ToString();
            ApplyFilter(true);
        }

         private void ProgowanieSAS(Bitmap bmpSAS)
        {          
            int new_height = bmpSAS.Height;
            int new_width = bmpSAS.Width;
            while (new_height > 300 || new_width > 400)
            {
                new_height = (int)(new_height / 1.05f);
                new_width = (int)(new_width / 1.05f);
            }
         }
           /*
             if (bmpSAS != null)
            {
                src_thumbnail = new Bitmap(src.GetThumbnailImage(new_width, new_height, null, System.IntPtr.Zero));
                preview.Image = src.GetThumbnailImage(new_width, new_height, null, System.IntPtr.Zero);
            }
            */
        
     
      
    

        /*
        private void trackBarOPJel10._Scroll(object sender, EventArgs e)
        {
            label_value.Text = this.trackBarOPJ.Value.ToString();
            Bitmap bmp = new Bitmap(bmpASA1);
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(bmp);
            fobrazek_bitmapa.LockImage();
            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    if (fobrazek_bitmapa.GetPixel(x, y).R > this.trackBarOPJ.Value)
                    {
                        fobrazek_bitmapa.SetPixel(x, y, Color.FromArgb(255, 255, 255));
                    }
                    else
                    {
                        fobrazek_bitmapa.SetPixel(x, y, Color.FromArgb(0, 0, 0));
                    }
                }
            }
            fobrazek_bitmapa.UnlockImage();
            this.pictureWtornyOPJ.Image = bmp;
        }      */
    
    }
}