﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Drawing.Imaging;
using System.Windows.Forms.DataVisualization.Charting;
using BitmapProcessing;
using System.Reflection;
using APO_BB_DK_v012013.Operacje;
using System.Runtime.InteropServices;
using System.Drawing.Drawing2D;

namespace APO_BB_DK_v012013
{
    public partial class ObrazWAA_RGB : Form
    {
        private Bitmap sourceBitmap = null;
        private Bitmap blendBitmap = null;
        private Bitmap resultBitmap = null;

    //    private int _id = -1;
        private int[] histogram_values = new int[256];
        private int[] histogram_hsv_values = new int[256];
        private int[,] histogram_kolory_values;

        private int[] histogram_values2 = new int[256];
        private int[] histogram_hsv_values2 = new int[256];
        private int[,] histogram_kolory_values2;
        private bool _HSV = false;

        public ObrazWAA_RGB()
        {
            InitializeComponent();
            #region zmienne ComboBoxów
            cmbR.Items.Add(ExtBitmap.BitwiseBlendType.None);
            cmbR.Items.Add(ExtBitmap.BitwiseBlendType.AND);
            cmbR.Items.Add(ExtBitmap.BitwiseBlendType.OR);
            cmbR.Items.Add(ExtBitmap.BitwiseBlendType.XOR);
            cmbR.Items.Add(ExtBitmap.BitwiseBlendType.XNOR);
            cmbR.SelectedIndex = 0;

            cmbG.Items.Add(ExtBitmap.BitwiseBlendType.None);
            cmbG.Items.Add(ExtBitmap.BitwiseBlendType.AND);
            cmbG.Items.Add(ExtBitmap.BitwiseBlendType.OR);
            cmbG.Items.Add(ExtBitmap.BitwiseBlendType.XOR);
            cmbG.Items.Add(ExtBitmap.BitwiseBlendType.XNOR);
            cmbG.SelectedIndex = 0;

            cmbB.Items.Add(ExtBitmap.BitwiseBlendType.None);
            cmbB.Items.Add(ExtBitmap.BitwiseBlendType.AND);
            cmbB.Items.Add(ExtBitmap.BitwiseBlendType.OR);
            cmbB.Items.Add(ExtBitmap.BitwiseBlendType.XOR);
            cmbB.Items.Add(ExtBitmap.BitwiseBlendType.XNOR);
            cmbB.SelectedIndex = 0;

            cmbWAA_S.Items.Add("Wybierz");
            cmbWAA_S.Items.Add(FunkcjeWieloarg.FunkcjeWieloargumentoweTyp.AND);
            cmbWAA_S.Items.Add(FunkcjeWieloarg.FunkcjeWieloargumentoweTyp.OR);
            cmbWAA_S.Items.Add(FunkcjeWieloarg.FunkcjeWieloargumentoweTyp.XOR);
            cmbWAA_S.Items.Add(FunkcjeWieloarg.FunkcjeWieloargumentoweTyp.XNOR);
            cmbWAA_S.SelectedIndex = 0;

            cmbRGB.Items.Add("Wybierz");
            cmbRGB.Items.Add(FunkcjeWieloarg.FunkcjeWieloargumentoweTyp.AND);
            cmbRGB.Items.Add(FunkcjeWieloarg.FunkcjeWieloargumentoweTyp.OR);
            cmbRGB.Items.Add(FunkcjeWieloarg.FunkcjeWieloargumentoweTyp.XOR);
            cmbRGB.Items.Add(FunkcjeWieloarg.FunkcjeWieloargumentoweTyp.XNOR);
            cmbRGB.SelectedIndex = 0;

            cmbH.Items.Add(ExtBitmap.BitwiseBlendType.None);
            cmbH.Items.Add(ExtBitmap.BitwiseBlendType.AND);
            cmbH.Items.Add(ExtBitmap.BitwiseBlendType.OR);
            cmbH.Items.Add(ExtBitmap.BitwiseBlendType.XOR);
            cmbH.Items.Add(ExtBitmap.BitwiseBlendType.XNOR);
            cmbH.SelectedIndex = 0;

            cmbS.Items.Add(ExtBitmap.BitwiseBlendType.None);
            cmbS.Items.Add(ExtBitmap.BitwiseBlendType.AND);
            cmbS.Items.Add(ExtBitmap.BitwiseBlendType.OR);
            cmbS.Items.Add(ExtBitmap.BitwiseBlendType.XOR);
            cmbS.Items.Add(ExtBitmap.BitwiseBlendType.XNOR);
            cmbS.SelectedIndex = 0;

            cmbV.Items.Add(ExtBitmap.BitwiseBlendType.None);
            cmbV.Items.Add(ExtBitmap.BitwiseBlendType.AND);
            cmbV.Items.Add(ExtBitmap.BitwiseBlendType.OR);
            cmbV.Items.Add(ExtBitmap.BitwiseBlendType.XOR);
            cmbV.Items.Add(ExtBitmap.BitwiseBlendType.XNOR);
            cmbV.SelectedIndex = 0;
                        
          //  cmbSz.TabPages.Clear();

            cmbSz.Visible = false;
            this.groupBox4.Visible = false;
            cmbSz.TabPages.Clear();
            cmbSz.TabPages.Add(tabInfo);
            #endregion
        }

        public bool HSV
        {
            #region HSV
            get { return _HSV; }
            set { _HSV = value; this.label2.Text = "Obraz (HSV)"; this.HistogramRGB.Visible = false; button_blue.Visible = false; button_green.Visible = false; buttpn_red.Visible = false; label2.Visible = false; button_wszystkie.Visible = false; button1.Visible = false; button3.Visible = false; label2.Visible = true; label2.Text = "1.0"; }
            #endregion
        }

        public Bitmap get_image
        {
            #region get_image
            get { return new Bitmap(pictureObraz12OL.Image); }
            set { }
            #endregion
        }
        public Bitmap get_histogram
        {
            #region get_histogram
            get
            {
                if (this.HistogramGrey.Image == null)
                    return null;
                return new Bitmap(HistogramGrey.Image);
            }
            set { }
            #endregion
        }

        public Bitmap get_histogram_kolory
        {
            #region get_histogram_kolory
            get
            {
                if (this.HistogramRGB.Image == null)
                    return null;
                return new Bitmap(this.HistogramRGB.Image);
            }
            set { }
            #endregion
        }

        private void ApplyFilter(bool preview)
        {
            #region ApplyFilter
            if (sourceBitmap == null || blendBitmap == null || pictureOb_WAA_1.Image == null || pictureOb_WAA_2.Image == null)
            {
                return;
            }

            if (preview == true)
            {
                Bitmap sourcePreview = (Bitmap)pictureOb_WAA_1.Image;
                tabyWstemp();

                   pictureObraz12OL.Image = sourcePreview.BitwiseBlend((Bitmap)pictureOb_WAA_2.Image, (ExtBitmap.BitwiseBlendType)cmbB.SelectedItem, (ExtBitmap.BitwiseBlendType)cmbG.SelectedItem, (ExtBitmap.BitwiseBlendType)cmbR.SelectedItem);
                    resultBitmap = (Bitmap)pictureObraz12OL.Image;            
                    this.label1.Text = "Obraz wynikowy ";
            }
            else
            {
                resultBitmap = sourceBitmap.BitwiseBlend(blendBitmap, (ExtBitmap.BitwiseBlendType)cmbB.SelectedItem, (ExtBitmap.BitwiseBlendType)cmbG.SelectedItem, (ExtBitmap.BitwiseBlendType)cmbR.SelectedItem);
                this.label1.Text = "Obraz wynikowy";
            }
            #endregion
        }
                             
        private void ApplyFilter2(bool preview)
        {
            #region ApplyFilter2
            if (sourceBitmap == null || blendBitmap == null || pictureOb_WAA_1.Image == null || pictureOb_WAA_2.Image == null)
            {
                return;
            }

            else if (preview == true)
            {
                tabyWstemp();

                if (radioSzary.Checked)
                {
                    Bitmap sourcePreview = (Bitmap)pictureOb_WAA_1.Image;
                    pictureObraz12OL.Image = sourcePreview.ArithmeticBlend((Bitmap)pictureOb_WAA_2.Image, (FunkcjeWieloarg.FunkcjeWieloargumentoweTyp)cmbWAA_S.SelectedItem);
                    resultBitmap = (Bitmap)pictureObraz12OL.Image;
                }
                else
                {
                    Bitmap sourcePreview = (Bitmap)pictureOb_WAA_1.Image;
                    pictureObraz12OL.Image = sourcePreview.ArithmeticBlend((Bitmap)pictureOb_WAA_2.Image, (FunkcjeWieloarg.FunkcjeWieloargumentoweTyp)cmbRGB.SelectedItem);
                    resultBitmap = (Bitmap)pictureObraz12OL.Image;
                }
            }
            #endregion
        }

        private void ApplyFilter3(bool preview)
        {
            #region ApplyFilter3
            if (sourceBitmap == null || blendBitmap == null || pictureOb_WAA_1.Image == null || pictureOb_WAA_2.Image == null)
            {
                return;
            }

            if (preview == true)
            {
                Bitmap sourcePreview3 = (Bitmap)pictureOb_WAA_1.Image;
          //      tabyWstemp();
                pictureObraz12OL.Image = sourcePreview3.BitwiseBlend((Bitmap)pictureOb_WAA_2.Image, (ExtBitmap.BitwiseBlendType)cmbV.SelectedItem, (ExtBitmap.BitwiseBlendType)cmbS.SelectedItem, (ExtBitmap.BitwiseBlendType)cmbH.SelectedItem);
                resultBitmap = (Bitmap)pictureObraz12OL.Image;
                this.label1.Text = "Obraz wynikowy HSV";
            }
            else
            {
                resultBitmap = sourceBitmap.BitwiseBlend(blendBitmap, (ExtBitmap.BitwiseBlendType)cmbV.SelectedItem, (ExtBitmap.BitwiseBlendType)cmbS.SelectedItem, (ExtBitmap.BitwiseBlendType)cmbH.SelectedItem);
                this.label1.Text = "Obraz wynikowy HSV";
            }
            #endregion
        }

        private void tabyWstemp()
        {
            #region tabyWstemp()
           
            cmbSz.Visible = true;

            #endregion
        }

        private void ClenTmp()
        {
            #region tabyWstemp()
            cmbSz.TabPages.Clear();
            cmbSz.TabPages.Add(tabInfo);
            #endregion
        }

        private void tabyWstempS()
        {
            #region tabyWstempS()
            groupBox4.Visible = true;
            cmbSz.Visible = true;
            cmbSz.TabPages.Clear();               
            TabWynikowy.TabPages.Clear();
            tabObrazy12.TabPages.Clear();
            TabPierwotny.TabPages.Clear();          
            TabPierwotny2.TabPages.Clear();

            cmbSz.TabPages.Add(tabSuwak_WAA_S);

            tabObrazy12.TabPages.Add(tabPage1);
            tabObrazy12.TabPages.Add(tabPage2);

            TabWynikowy.TabPages.Add(tabHistogramGrey); 
            TabPierwotny.TabPages.Add(tabHistogramGrey2);
            TabPierwotny2.TabPages.Add(tabHistogramGrey3);           
            #endregion
        }

        private void tabyWstempRGB()
        {
            #region tabyWstempRGB()
            groupBox4.Visible = true;
            cmbSz.Visible = true;
            cmbSz.TabPages.Clear();
            TabWynikowy.TabPages.Clear();
            tabObrazy12.TabPages.Clear();
            TabPierwotny.TabPages.Clear();
            TabPierwotny2.TabPages.Clear();

            cmbSz.TabPages.Add(tabSuwak_WAA_RGB);

            tabObrazy12.TabPages.Add(tabPage1);
            tabObrazy12.TabPages.Add(tabPage2);

            TabWynikowy.TabPages.Add(tabHistogramGrey);
            TabPierwotny.TabPages.Add(tabHistogramGrey2);
            TabPierwotny2.TabPages.Add(tabHistogramGrey3); 
           
            TabWynikowy.TabPages.Add(tabHistogramRGB);
            TabPierwotny.TabPages.Add(tabHistogramRGB2);
            TabPierwotny2.TabPages.Add(tabHistogramRGB3);
            #endregion
        }

        private void tabyWstempHSV()
        {
            #region tabyWstempHSV     
            groupBox4.Visible = true;
            cmbSz.Visible = true;
            cmbSz.TabPages.Clear();
            TabWynikowy.TabPages.Clear();
            tabObrazy12.TabPages.Clear();
            TabPierwotny.TabPages.Clear();
            TabPierwotny2.TabPages.Clear();

            cmbSz.TabPages.Add(tabSuwak_WAA_HSV); 

            tabObrazy12.TabPages.Add(tabPage1);
            tabObrazy12.TabPages.Add(tabPage2);

            TabWynikowy.TabPages.Add(tabHistogramGrey);
            TabPierwotny.TabPages.Add(tabHistogramGrey2);
            TabPierwotny2.TabPages.Add(tabHistogramGrey3);
            
            TabWynikowy.TabPages.Add(tabHistogramHSV);           
            TabPierwotny.TabPages.Add(tabHistogramHSV2);
            TabPierwotny2.TabPages.Add(tabHistogramHSV3);
            #endregion
        }

        private void buttonObraz1_Click(object sender, EventArgs e)
        {
            #region Wybór obrazu 1
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = "Image Files(*.BMP;*.JPG;*.PNG)|*.BMP;*.JPG;*.PNG|All files (*.*)|*.*";
            ofd.Title = "Select an image file.";
           // ofd.Filter = "Png Images(*.png)|*.png|Jpeg Images(*.jpg)|*.jpg";
           // ofd.Filter += "|Bitmap Images(*.bmp)|*.bmp";

            if (ofd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                if (sender == buttonObraz1)
                {
                    StreamReader streamReader = new StreamReader(ofd.FileName);
                    sourceBitmap = (Bitmap)Bitmap.FromStream(streamReader.BaseStream);
                    label4.Text = ofd.FileName;
                    streamReader.Close();
                    pictureOb_WAA_1.Image = sourceBitmap.CopyToSquareCanvas(pictureObraz12OL.Width);
                    pictureObrazWPA1.Image = sourceBitmap.CopyToSquareCanvas(pictureObraz12OL.Width);
                }
                ApplyFilter(true);
            }
            #endregion
        }

        private void cmbWAA_S_SelectedIndexChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void cmbR_SelectedIndexChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void cmbG_SelectedIndexChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void cmbB_SelectedIndexChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void cmbH_SelectedIndexChanged(object sender, EventArgs e)
        {
            ApplyFilter3(true);
        }

        private void cmbS_SelectedIndexChanged(object sender, EventArgs e)
        {
            ApplyFilter3(true);
        }

        private void cmbV_SelectedIndexChanged(object sender, EventArgs e)
        {
            ApplyFilter3(true);
        }

        private void button17_Click(object sender, EventArgs e)
        {
            #region zapis obrazu wynikowego
            ApplyFilter(false);

            if (resultBitmap != null)
            {
                SaveFileDialog sfd = new SaveFileDialog();
                sfd.Title = "Specify a file name and file path";
                sfd.Filter = "Png Images(*.png)|*.png|Jpeg Images(*.jpg)|*.jpg";
                sfd.Filter += "|Bitmap Images(*.bmp)|*.bmp";

                if (sfd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                {
                    string fileExtension = Path.GetExtension(sfd.FileName).ToUpper();
                    ImageFormat imgFormat = ImageFormat.Png;

                    if (fileExtension == "BMP")
                    {
                        imgFormat = ImageFormat.Bmp;
                    }
                    else if (fileExtension == "JPG")
                    {
                        imgFormat = ImageFormat.Jpeg;
                    }

                    StreamWriter streamWriter = new StreamWriter(sfd.FileName, false);
                    resultBitmap.Save(streamWriter.BaseStream, imgFormat);
                    streamWriter.Flush();
                    streamWriter.Close();

                    resultBitmap = null;
                }
            }
            #endregion
        }

        private void buttonObraz2_Click(object sender, EventArgs e)
        {
            #region Wybór obrazu 2
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = "Image Files(*.BMP;*.JPG;*.PNG)|*.BMP;*.JPG;*.PNG|All files (*.*)|*.*";
            ofd.Title = "Select an image file.";
           // ofd.Filter = "Png Images(*.png)|*.png|Jpeg Images(*.jpg)|*.jpg";
           // ofd.Filter += "|Bitmap Images(*.bmp)|*.bmp";

            if (ofd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                if (sender == buttonObraz2)
                {
                    StreamReader streamReader = new StreamReader(ofd.FileName);
                    blendBitmap = (Bitmap)Bitmap.FromStream(streamReader.BaseStream);
                    label32.Text = ofd.FileName;
                    streamReader.Close();
                    pictureOb_WAA_2.Image = blendBitmap.CopyToSquareCanvas(pictureObraz12OL.Width);
                    pictureObrazWPA2.Image = blendBitmap.CopyToSquareCanvas(pictureObraz12OL.Width);
                }

                ApplyFilter(true);
            }
            #endregion
        }

        private void button1_Click(object sender, EventArgs e)
        {
            #region kolor obrazu
            FunkcjeJednoarg fn = new FunkcjeJednoarg();
            Bitmap bmp1 = new Bitmap(pictureOb_WAA_1.Image);
            Bitmap bmp2 = new Bitmap(pictureOb_WAA_2.Image);
            pictureObraz12OL.Visible = true;
            tabyWstemp();

            if (this.radioSzary.Checked)
            {
                this.label1.Text = "Obraz wynikowy w odcieniach szarości";
                bmp1 = fn.Skalaszarosci(bmp1);
                bmp2 = fn.Skalaszarosci(bmp2);
                pictureOb_WAA_1.Image = bmp1;
                pictureOb_WAA_2.Image = bmp2;
                tabyWstempS();       
            }
            if (this.radioKolorRGB.Checked)
            {
                this.label1.Text = "Obraz wynikowy kolorowy RGB";
                Bitmap bmp3 = new Bitmap(this.pictureObrazWPA1.Image);
                Bitmap bmp4 = new Bitmap(this.pictureObrazWPA2.Image);
                pictureOb_WAA_1.Image = bmp3;
                pictureOb_WAA_2.Image = bmp4;
                tabyWstempRGB();                                 
            }
            if (this.radioKolorHVS.Checked)
            {
                this.label1.Text = "Obraz wynikowy kolorowy HSV";
                Bitmap bmp5 = new Bitmap(this.pictureObrazWPA1.Image);
                Bitmap bmp6 = new Bitmap(this.pictureObrazWPA2.Image);
                pictureOb_WAA_1.Image = bmp5;
                pictureOb_WAA_2.Image = bmp6;
                tabyWstempHSV();     
            }
            #endregion
        }

        private void cmbWAA_S_SelectedIndexChanged_1(object sender, EventArgs e)
        {
            ApplyFilter2(true);
        }

        private void buttonWidok_Click(object sender, EventArgs e)
        {
            #region dopasowanie obrazu
            if (radioNaturalny.Checked)
            {
                pictureOb_WAA_1.SizeMode = PictureBoxSizeMode.Normal;
                pictureOb_WAA_2.SizeMode = PictureBoxSizeMode.Normal;
                pictureObraz12OL.SizeMode = PictureBoxSizeMode.Normal;
                pictureOb_WAA_1.Refresh();
                pictureOb_WAA_2.Refresh();
                pictureObraz12OL.Refresh();
            }
             if (radioAutoSize.Checked)
             {
                 pictureOb_WAA_1.SizeMode = PictureBoxSizeMode.CenterImage;
                 pictureOb_WAA_2.SizeMode = PictureBoxSizeMode.CenterImage;
                 pictureObraz12OL.SizeMode = PictureBoxSizeMode.CenterImage;
                 pictureOb_WAA_1.Refresh();
                 pictureOb_WAA_2.Refresh();
                 pictureObraz12OL.Refresh();
             }
             if (radioDopasowany.Checked)
            {
                 pictureOb_WAA_1.SizeMode = PictureBoxSizeMode.StretchImage;
                 pictureOb_WAA_2.SizeMode = PictureBoxSizeMode.StretchImage;
                 pictureObraz12OL.SizeMode = PictureBoxSizeMode.StretchImage;
                 pictureOb_WAA_1.Refresh();
                 pictureOb_WAA_2.Refresh();
                 pictureObraz12OL.Refresh();
             }
            #endregion
        }

        private void button14_Click(object sender, EventArgs e)
        {
                #region Obraz pierwotny powiekszony
                ObrazMax bmpMax = new ObrazMax();
                bmpMax = new ObrazMax();
                bmpMax.pictureMaxZoom.Image = sourceBitmap;
                bmpMax.Text = "Obraz 1 Pierwotny " + label28.Text;
                bmpMax.Show();
                #endregion
        }

        private void button16_Click(object sender, EventArgs e)
        {
            #region Obraz pierwotny powiekszony
            ObrazMax bmpMax = new ObrazMax();
            bmpMax = new ObrazMax();
            bmpMax.pictureMaxZoom.Image = blendBitmap;
            bmpMax.Text = "Obraz 2 Pierwotny " + label28.Text;
            bmpMax.Show();
            #endregion
        }

        private void button2_Click(object sender, EventArgs e)
        {
            #region Obraz wynikowy powiekszony
            ObrazMax bmpMax = new ObrazMax();

            bmpMax.pictureMaxZoom.Image = pictureObraz12OL.Image;

    //        Rectangle rectangle = new Rectangle(bmpMax.pictureMaxZoom.Location, new Size(1024, 768));
     //       Graphics g = bmpMax.pictureMaxZoom.CreateGraphics();
      //      g.Clear(bmpMax.pictureMaxZoom.BackColor);
       //     g.DrawImage(bmpMax.pictureMaxZoom.Image, rectangle);

            bmpMax.pictureMaxZoom.SizeMode = PictureBoxSizeMode.Zoom;
            bmpMax.Text = "Obraz Wynikiowy " + label28.Text;

            bmpMax.Show();
            #endregion
        }

        public static Bitmap Resize(Bitmap value, int newWidth, int newHeight)
        {
            Bitmap resizedImage = new Bitmap(newWidth, newHeight);
            Graphics.FromImage((Image)resizedImage).DrawImage(value, 0, 0, newWidth, newHeight);
            return (resizedImage);
        }

        private void radioNegacjaRGB_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
            panel1.Visible = true;
        }

        private void radioNegacja_CheckedChanged(object sender, EventArgs e)
        {
            #region Ustawienie kanałów RGB
            ApplyFilter(true);
            panel1.Visible = false;
            #endregion
        }

        
        private void radioNegacjaR_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void radioNegacjaG_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void radioNegacjaB_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }
         
        public Bitmap kanalRGB_red(Bitmap bmp)
        {
            bmp = bmp.DrawAsGrayscale_Red();
            return bmp;
        }

        public Bitmap kanalRGB_green(Bitmap bmp)
        {
            bmp = bmp.DrawAsGrayscale_Green();
            return bmp;
        }

        public Bitmap kanalRGB_blue(Bitmap bmp)
        {
            bmp = bmp.DrawAsGrayscale_Blue();
            return bmp;
        }

        private void button23_Click(object sender, EventArgs e)
        {
           #region Wyświetlanie kanałów
            ObrazKanalyRGBMax kanal = new ObrazKanalyRGBMax();
            kanal = new ObrazKanalyRGBMax();
            Bitmap bmp = new Bitmap(pictureObraz12OL.Image);
            bmp =  resultBitmap;
            kanal.pictureMaxRGB.Image = bmp;
            kanal.pictureMaxR.Image = kanalRGB_red(bmp);
            kanal.pictureMaxG.Image = kanalRGB_green(bmp);
            kanal.pictureMaxB.Image = kanalRGB_blue(bmp);
            kanal.Text = "Obraz Wynikiowy dla poszczególnych kanałów RGB";
            kanal.Show();
            #endregion
        }

        private void comRGB_SelectedIndexChanged(object sender, EventArgs e)
        {
            ApplyFilter2(true);
        }

        private void checkR_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void checkG_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void checkB_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void button9_Click(object sender, EventArgs e)
        {
           #region Histrogram w odcieniach szarości - powiększenie
           HistogramMax hRGB1 = new HistogramMax();
           hRGB1.pictureMax.Image = this.HistogramGrey.Image;
           hRGB1.Text = "Obraz Wynikiowy w odcieniach szarości";
           hRGB1.Show();
           #endregion
        }

        private void button6_Click(object sender, EventArgs e)
        {
            #region Histrogram RGB - powiększenie
            HistogramMax hRGB1 = new HistogramMax();
            hRGB1.pictureMax.Image = this.HistogramRGB.Image;
            hRGB1.Text = "Obraz Wynikiowy RGB";
            hRGB1.Show();
            #endregion
        }

        private void buttpn_red_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(0);
        }

        private void button_green_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(1);
        }

        private void button_blue_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(2);
        }

        private void button8_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(1);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(2);
        }

        private void button_wszystkie_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(0);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(3);
        }

        private void EnableDoubleBuffered(DataGridView dgv, bool setting)
        {
            #region EnableDoubleBuffered
            Type dgvType = dgv.GetType();
            PropertyInfo pi = dgvType.GetProperty("DoubleBuffered", BindingFlags.Instance | BindingFlags.NonPublic);
            pi.SetValue(dgv, setting, null);
            #endregion
        }

        private void button3_Click(object sender, EventArgs e)
        {
            #region Generowanie Tablicy obrazu wtórnego       
            groupBox4.Visible = true;
            cmbSz.Visible = true;
            TabWynikowy.TabPages.Add(tabTablica);

            if (this.radioSzary.Checked)
            {
                this.generuj_histogram(0);
            }
            if (this.radioKolorRGB.Checked)
            {
                this.HistogramRGB.Image = generuj_histogram_kolory(0);
            }
            if (this.radioKolorHVS.Checked)
            {

            }
            EnableDoubleBuffered(this.dataGridTablica, true);
            int cols_width = 40;
            Bitmap bmpTab = (Bitmap)pictureObraz12OL.Image;

            if (dataGridTablica.Columns.Count != bmpTab.Width || dataGridTablica.Rows.Count != bmpTab.Height)
            {
                dataGridTablica.Rows.Clear();
                dataGridTablica.Columns.Clear();
                dataGridTablica.RowHeadersWidth = 60;
                for (int x = 0; x < bmpTab.Width; x++)
                {
                    dataGridTablica.Columns.Add(null, x.ToString());
                    dataGridTablica.Columns[x].Width = cols_width;
                    dataGridTablica.Columns[x].FillWeight = 0.0000001f;
                }
                dataGridTablica.Rows.Add(bmpTab.Height);
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    dataGridTablica.Rows[y].HeaderCell.Value = y.ToString();
                }
            }

            for (int x = 0; x < bmpTab.Width; x++)
            {
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    dataGridTablica[x, y].Value = bmpTab.GetPixel(x, y).R;
                }
            }
            #endregion
        }

        private Bitmap generuj_histogram(int k)
        {
            #region generuj_histogram
            Bitmap obrazek_bitmapa = new Bitmap(pictureObraz12OL.Image);
            Bitmap histogram = null;
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(obrazek_bitmapa);

            if (HSV)
            {
                int histogram_max = 0;
                double h, s, v;
                fobrazek_bitmapa.LockImage();
                for (int x = 0; x < obrazek_bitmapa.Width; x++)
                {
                    for (int y = 0; y < obrazek_bitmapa.Height; y++)
                    {
                        hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y), out h, out s, out v);
                        int temp_v = (int)(v * 255.0f);
                        histogram_hsv_values[temp_v]++;
                        if (histogram_hsv_values[temp_v] > histogram_max)
                            histogram_max = histogram_hsv_values[temp_v];
                    }
                }
                fobrazek_bitmapa.UnlockImage();
                double skala = (512.0f / (double)histogram_max) * ((double)pasek_skali.Value / 10.0f);
                histogram = new Bitmap(1024, 513);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_hsv_values[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Black);
                        }
                    }
                }

                fhistogram.UnlockImage();
            }
            else
            {
                int[] histogram_values_tmp;
                histogram_values_tmp = new int[256];
                int histogram_max = 0;
                fobrazek_bitmapa.LockImage();
                //Zliczanie wartości histogramu
                for (int x = 0; x < obrazek_bitmapa.Width; x++)
                {
                    for (int y = 0; y < obrazek_bitmapa.Height; y++)
                    {
                        if (k == 0 || k > 2)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R]++;
                            histogram_values[fobrazek_bitmapa.GetPixel(x, y).R]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R];
                        }
                        if (k == 1)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G];
                        }
                        if (k == 2)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B];
                        }
                        if (k == 3)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B];
                        }

                    }
                }
                fobrazek_bitmapa.UnlockImage();
                float skala = (512.0f / (float)histogram_max) * ((float)pasek_skali.Value / 10.0f);
                histogram = new Bitmap(1024, 513);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                Color slupki = Color.Black;
                if (k == 0)
                    slupki = Color.Red;
                if (k == 1)
                    slupki = Color.Green;
                if (k == 2)
                    slupki = Color.Blue;
                Color tlo = Color.White;
                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_values_tmp[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), slupki);
                        }
                        else
                        {
                            //fhistogram.SetPixel(4*x1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+2, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+3, (int)(256 - y1), tlo);
                        }
                    }
                }
                fhistogram.UnlockImage();
            }
            return histogram;
            #endregion
        }

        private Bitmap generuj_histogram_kolory(int k)
        {
            # region generuj_histogram_kolory
            Bitmap obrazek_bitmapa = new Bitmap(pictureObraz12OL.Image);
            if (histogram_kolory_values == null)
                histogram_kolory_values = new int[256, 3];
            int histogram_max = 0;
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(obrazek_bitmapa);
            fobrazek_bitmapa.LockImage();
            //Zliczanie wartości histogramu
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0];
                }
            }
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1];
                }
            }
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2];
                }
            }
            fobrazek_bitmapa.UnlockImage();
            float skala = (512.0f / (float)histogram_max);
            Bitmap histogram = new Bitmap(1024, 513);
            BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
            fhistogram.LockImage();
            for (int x1 = 0; x1 < 256; x1++)
            {
                int tmpr = (int)(histogram_kolory_values[x1, 0] * skala);
                int tmpg = (int)(histogram_kolory_values[x1, 1] * skala);
                int tmpb = (int)(histogram_kolory_values[x1, 2] * skala);
                //0,1,2 nie 3
                if (k < 3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpr)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Red);
                        }
                    }
                }
                //0,1,3 nie 2
                if (k < 2 || k == 3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpg)
                        {
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Green);
                        }
                    }
                }
                //0,2,3 nie 1
                if (k == 0 || k > 1)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpb)
                        {
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Blue);
                        }
                    }
                }
            }
            fhistogram.UnlockImage();
            return histogram;
            #endregion
        }

        private void pasek_skali_Scroll(object sender, EventArgs e)
        {
            #region skaladla Histogramu w odcieniach szarości obrazu wynikowego
            wartosc_skali.Text = ((double)pasek_skali.Value / 10.0f).ToString();
            this.HistogramGrey.Image = generuj_histogram(4);
            #endregion
        }

        private void button10_Click(object sender, EventArgs e)
        {
            #region Histrogram w odcieniach szarości - powiększenie dla obrazu pierwotnego
            HistogramMax hRGB2 = new HistogramMax();
            hRGB2.pictureMax.Image = this.HistogramGrey2.Image;
            hRGB2.Text = "Obraz Wynikiowy w odcieniach szarości";
            hRGB2.Show();
            #endregion
        }

        private void pasek_skali2_Scroll(object sender, EventArgs e)
        {
            #region skaladla Histogramu w odcieniach szarości obrazu pierwotnego
            Bitmap bmp2 = new Bitmap(this.pictureOb_WAA_1.Image);
            wartosc_skali2.Text = ((double)pasek_skali2.Value / 10.0f).ToString();
            this.HistogramGrey2.Image = generuj_histogramX(bmp2, 4, pasek_skali2.Value);
            #endregion
        }

        private void button11_Click(object sender, EventArgs e)
        {
            #region Histrogram RGB - powiększenie dla obrazu pierwotnego
            HistogramMax hRGB2 = new HistogramMax();
            hRGB2.pictureMax.Image = this.HistogramRGB2.Image;
            hRGB2.Text = "Obraz Wynikiowy RGB";
            hRGB2.Show();
            #endregion
        }

        private void buttonRED2_Click(object sender, EventArgs e)
        {
            Bitmap bmp2 = new Bitmap(this.pictureOb_WAA_1.Image);
            this.HistogramRGB2.Image = generuj_histogramX(bmp2, 0, pasek_skali2.Value);
        }

        private void buttonGREEN2_Click(object sender, EventArgs e)
        {
            Bitmap bmp2 = new Bitmap(this.pictureOb_WAA_1.Image);
            this.HistogramRGB2.Image = generuj_histogramX(bmp2, 1, pasek_skali2.Value);
        }

        private void buttonBLUE2_Click(object sender, EventArgs e)
        {
            Bitmap bmp2 = new Bitmap(this.pictureOb_WAA_1.Image);
            this.HistogramRGB2.Image = generuj_histogramX(bmp2, 2, pasek_skali2.Value);
        }

        private void buttonALL2_Click(object sender, EventArgs e)
        {
            Bitmap bmp2 = new Bitmap(this.pictureOb_WAA_1.Image);
            this.HistogramRGB2.Image = generuj_histogram_koloryX(bmp2, 0);
        }

        private void buttonRED_GREEN2_Click(object sender, EventArgs e)
        {
            Bitmap bmp2 = new Bitmap(this.pictureOb_WAA_1.Image);
            this.HistogramRGB2.Image = generuj_histogram_koloryX(bmp2, 1);
        }

        private void buttonRED_BLUE2_Click(object sender, EventArgs e)
        {
            Bitmap bmp2 = new Bitmap(this.pictureOb_WAA_1.Image);
            this.HistogramRGB2.Image = generuj_histogram_koloryX(bmp2, 2);
        }

        private void buttonGREEN_BLUE2_Click(object sender, EventArgs e)
        {
            Bitmap bmp2 = new Bitmap(this.pictureOb_WAA_1.Image);
            this.HistogramRGB2.Image = generuj_histogram_koloryX(bmp2, 3);
        }


        private Bitmap generuj_histogram_koloryX(Bitmap bmp, int k)
        {
            #region generuj_histogram_koloryX
            if (histogram_kolory_values2 == null)
                histogram_kolory_values2 = new int[256, 3];
            int histogram_max = 0;
            BitmapProcessing.FastBitmap fbmp = new BitmapProcessing.FastBitmap(bmp);
            fbmp.LockImage();
            //Zliczanie wartości histogramu
            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    histogram_kolory_values2[fbmp.GetPixel(x, y).R, 0]++;
                    if (histogram_kolory_values2[fbmp.GetPixel(x, y).R, 0] > histogram_max)
                        histogram_max = histogram_kolory_values2[fbmp.GetPixel(x, y).R, 0];
                }
            }
            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    histogram_kolory_values2[fbmp.GetPixel(x, y).G, 1]++;
                    if (histogram_kolory_values2[fbmp.GetPixel(x, y).G, 1] > histogram_max)
                        histogram_max = histogram_kolory_values2[fbmp.GetPixel(x, y).G, 1];
                }
            }
            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    histogram_kolory_values2[fbmp.GetPixel(x, y).B, 2]++;
                    if (histogram_kolory_values2[fbmp.GetPixel(x, y).B, 2] > histogram_max)
                        histogram_max = histogram_kolory_values2[fbmp.GetPixel(x, y).B, 2];
                }
            }
            fbmp.UnlockImage();
            float skala = (512.0f / (float)histogram_max);
            Bitmap histogram = new Bitmap(1024, 513);
            BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
            fhistogram.LockImage();
            for (int x1 = 0; x1 < 256; x1++)
            {
                int tmpr = (int)(histogram_kolory_values2[x1, 0] * skala);
                int tmpg = (int)(histogram_kolory_values2[x1, 1] * skala);
                int tmpb = (int)(histogram_kolory_values2[x1, 2] * skala);
                //0,1,2 nie 3
                if (k < 3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpr)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Red);
                        }
                    }
                }
                //0,1,3 nie 2
                if (k < 2 || k == 3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpg)
                        {
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Green);
                        }
                    }
                }
                //0,2,3 nie 1
                if (k == 0 || k > 1)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpb)
                        {
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Blue);
                        }
                    }
                }
            }
            fhistogram.UnlockImage();
            return histogram;
            #endregion
        }

        private Bitmap generuj_histogramX(Bitmap bmp, int k, int w)
        {
            #region generuj_histogramX
            Bitmap histogram = null;
            BitmapProcessing.FastBitmap fbmp = new BitmapProcessing.FastBitmap(bmp);

            if (HSV)
            {
                int histogram_max = 0;
                double h, s, v;
                fbmp.LockImage();
                for (int x = 0; x < bmp.Width; x++)
                {
                    for (int y = 0; y < bmp.Height; y++)
                    {
                        hsv.ColorToHSV(fbmp.GetPixel(x, y), out h, out s, out v);
                        int temp_v = (int)(v * 255.0f);
                        histogram_hsv_values2[temp_v]++;
                        if (histogram_hsv_values2[temp_v] > histogram_max)
                            histogram_max = histogram_hsv_values2[temp_v];
                    }
                }
                fbmp.UnlockImage();
                double skala = (512.0f / (double)histogram_max) * ((double)w / 10.0f);
                histogram = new Bitmap(1024, 513);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_hsv_values2[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Black);
                        }
                    }
                }

                fhistogram.UnlockImage();
            }
            else
            {
                int[] histogram_values_tmp;
                histogram_values_tmp = new int[256];
                int histogram_max = 0;
                fbmp.LockImage();
                //Zliczanie wartości histogramu
                for (int x = 0; x < bmp.Width; x++)
                {
                    for (int y = 0; y < bmp.Height; y++)
                    {
                        if (k == 0 || k > 2)
                        {
                            histogram_values_tmp[fbmp.GetPixel(x, y).R]++;
                            histogram_values2[fbmp.GetPixel(x, y).R]++;
                            if (histogram_values_tmp[fbmp.GetPixel(x, y).R] > histogram_max)
                                histogram_max = histogram_values_tmp[fbmp.GetPixel(x, y).R];
                        }
                        if (k == 1)
                        {
                            histogram_values_tmp[fbmp.GetPixel(x, y).G]++;
                            if (histogram_values_tmp[fbmp.GetPixel(x, y).G] > histogram_max)
                                histogram_max = histogram_values_tmp[fbmp.GetPixel(x, y).G];
                        }
                        if (k == 2)
                        {
                            histogram_values_tmp[fbmp.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fbmp.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fbmp.GetPixel(x, y).B];
                        }
                        if (k == 3)
                        {
                            histogram_values_tmp[fbmp.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fbmp.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fbmp.GetPixel(x, y).B];
                        }

                    }
                }
                fbmp.UnlockImage();
                float skala = (512.0f / (float)histogram_max) * ((float)w / 10.0f);
                histogram = new Bitmap(1024, 513);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                Color slupki = Color.Black;
                if (k == 0)
                    slupki = Color.Red;
                if (k == 1)
                    slupki = Color.Green;
                if (k == 2)
                    slupki = Color.Blue;
                Color tlo = Color.White;
                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_values_tmp[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), slupki);
                        }
                        else
                        {
                            //fhistogram.SetPixel(4*x1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+2, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+3, (int)(256 - y1), tlo);
                        }
                    }
                }
                fhistogram.UnlockImage();
            }
            return histogram;
            #endregion
        }

        private void buttonRED3_Click(object sender, EventArgs e)
        {
            Bitmap bmp2 = new Bitmap(this.pictureOb_WAA_2.Image);
            this.HistogramRGB3.Image = generuj_histogramX(bmp2, 0, pasek_skali3.Value);
        }

        private void buttonGREEN3_Click(object sender, EventArgs e)
        {
            Bitmap bmp2 = new Bitmap(this.pictureOb_WAA_2.Image);
            this.HistogramRGB3.Image = generuj_histogramX(bmp2, 1, pasek_skali3.Value);
        }

        private void buttonBLUE3_Click(object sender, EventArgs e)
        {
            Bitmap bmp2 = new Bitmap(this.pictureOb_WAA_2.Image);
            this.HistogramRGB3.Image = generuj_histogramX(bmp2, 2, pasek_skali3.Value);
        }

        private void buttonALL3_Click(object sender, EventArgs e)
        {
            Bitmap bmp2 = new Bitmap(this.pictureOb_WAA_2.Image);
            this.HistogramRGB3.Image = generuj_histogram_koloryX(bmp2, 0);
        }

        private void buttonRED_GREEN3_Click(object sender, EventArgs e)
        {
            Bitmap bmp2 = new Bitmap(this.pictureOb_WAA_2.Image);
            this.HistogramRGB3.Image = generuj_histogram_koloryX(bmp2, 1);
        }

        private void buttonRED_BLUE3_Click(object sender, EventArgs e)
        {
            Bitmap bmp2 = new Bitmap(this.pictureOb_WAA_2.Image);
            this.HistogramRGB3.Image = generuj_histogram_koloryX(bmp2, 2);
        }

        private void buttonGREEN_BLUE3_Click(object sender, EventArgs e)
        {
            Bitmap bmp2 = new Bitmap(this.pictureOb_WAA_2.Image);
            this.HistogramRGB3.Image = generuj_histogram_koloryX(bmp2, 3);
        }

        private void pasek_skali3_Scroll(object sender, EventArgs e)
        {
            #region skaladla Histogramu w odcieniach szarości obrazu pierwotnego
            Bitmap bmp2 = new Bitmap(this.pictureOb_WAA_2.Image);
            wartosc_skali3.Text = ((double)pasek_skali3.Value / 10.0f).ToString();
            this.HistogramGrey3.Image = generuj_histogramX(bmp2, 4, pasek_skali3.Value);
            #endregion
        }

        private void button12_Click(object sender, EventArgs e)
        {
            #region Histrogram w odcieniach szarości - powiększenie dla obrazu pierwotnego
            HistogramMax hRGB2 = new HistogramMax();
            hRGB2.pictureMax.Image = this.HistogramGrey3.Image;
            hRGB2.Text = "Obraz Wynikiowy w odcieniach szarości";
            hRGB2.Show();
            #endregion
        }

        private void button13_Click(object sender, EventArgs e)
        {
            #region Histrogram RGB - powiększenie dla obrazu pierwotnego
            HistogramMax hRGB2 = new HistogramMax();
            hRGB2.pictureMax.Image = this.HistogramRGB3.Image;
            hRGB2.Text = "Obraz Wynikiowy RGB";
            hRGB2.Show();
            #endregion
        }

        private void button18_Click(object sender, EventArgs e)
        {
            #region Wyświetlanie kanałów
            ObrazKanalyHSVMax kanal = new ObrazKanalyHSVMax();
            kanal = new ObrazKanalyHSVMax();
            Bitmap bmp = new Bitmap(pictureObraz12OL.Image);
            bmp = resultBitmap;
            kanal.pictureMaxHSV.Image = bmp;
            kanal.pictureMaxH.Image = kanalRGB_red(bmp);
            kanal.pictureMaxS.Image = kanalRGB_green(bmp);
            kanal.pictureMaxV.Image = kanalRGB_blue(bmp);
            kanal.Text = "Obraz Wynikiowy dla poszczególnych kanałów HSV";
            kanal.Show();
            #endregion
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            ApplyFilter3(true);
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            #region Ustawienie kanałów HSV
            ApplyFilter(true);
            #endregion
        }

        private void button19_Click(object sender, EventArgs e)
        {
            cmbSz.TabPages.Clear();
            cmbSz.TabPages.Add(tabInfo);
        }

        private void button20_Click(object sender, EventArgs e)
        {
            cmbSz.TabPages.Clear();
            cmbSz.TabPages.Add(tabInfo);
        }

        private void button21_Click(object sender, EventArgs e)
        {
            cmbSz.TabPages.Clear();
            cmbSz.TabPages.Add(tabInfo);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            #region Generowanie Tablicy obrazu 1    
            groupBox4.Visible = true;
            TabPierwotny.TabPages.Add(tabTablica2);

            EnableDoubleBuffered(TablicaLiczb2, true);
            int cols_width = 40;
            Bitmap bmpTab = (Bitmap)pictureOb_WAA_1.Image;

            if (TablicaLiczb2.Columns.Count != bmpTab.Width || TablicaLiczb2.Rows.Count != bmpTab.Height)
            {
                TablicaLiczb2.Rows.Clear();
                TablicaLiczb2.Columns.Clear();
                TablicaLiczb2.RowHeadersWidth = 60;
                for (int x = 0; x < bmpTab.Width; x++)
                {
                    TablicaLiczb2.Columns.Add(null, x.ToString());
                    TablicaLiczb2.Columns[x].Width = cols_width;
                    TablicaLiczb2.Columns[x].FillWeight = 0.0000001f;
                }
                TablicaLiczb2.Rows.Add(bmpTab.Height);
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    TablicaLiczb2.Rows[y].HeaderCell.Value = y.ToString();
                }
            }

            for (int x = 0; x < bmpTab.Width; x++)
            {
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    TablicaLiczb2[x, y].Value = bmpTab.GetPixel(x, y).R;
                }
            }
            #endregion
        }

        private void button15_Click(object sender, EventArgs e)
        {
            #region Tablica obrazu 2
            groupBox4.Visible = true;
            TabPierwotny2.TabPages.Add(tabHistogramTabl3);

            EnableDoubleBuffered(TablicaLiczb3, true);
            int cols_width = 40;
            Bitmap bmpTab = (Bitmap)pictureOb_WAA_2.Image;

            if (TablicaLiczb3.Columns.Count != bmpTab.Width || TablicaLiczb3.Rows.Count != bmpTab.Height)
            {
                TablicaLiczb3.Rows.Clear();
                TablicaLiczb3.Columns.Clear();
                TablicaLiczb3.RowHeadersWidth = 60;
                for (int x = 0; x < bmpTab.Width; x++)
                {
                    TablicaLiczb3.Columns.Add(null, x.ToString());
                    TablicaLiczb3.Columns[x].Width = cols_width;
                    TablicaLiczb3.Columns[x].FillWeight = 0.0000001f;
                }
                TablicaLiczb3.Rows.Add(bmpTab.Height);
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    TablicaLiczb3.Rows[y].HeaderCell.Value = y.ToString();
                }
            }

            for (int x = 0; x < bmpTab.Width; x++)
            {
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    TablicaLiczb3[x, y].Value = bmpTab.GetPixel(x, y).R;
                }
            }
            #endregion
        }

   
    
    }
}
