﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Windows.Forms.DataVisualization.Charting;
using System.Drawing.Imaging;
using System.IO;
using BitmapProcessing;
using System.Reflection;
using APO_BB_DK_v012013.Operacje;

namespace APO_BB_DK_v012013
{
    public partial class ObrazWPA : Form
    {
     //   private Image zrodlo;
    //    private Image zrodlo2;
        //  private OperatorWPA processingWPA;
    //    private TrackBar suwak1;

//        private Bitmap bmpOrg;
  //      private Bitmap bmpMod;
        private Bitmap blendBitmap1 = null;
        private Bitmap blendBitmap2 = null;
        private Bitmap resultBitmap = null;
        private Bitmap blendBitmapM = null;
        private Bitmap blendBitmap2M = null;

        public Panel panelPierowtny;
        public Panel panelWynikowy;

        public PictureBox pictureWynik1;
        public PictureBox pictureHistPierwotny;
        public PictureBox pictureHistWynikowy;
        public PictureBox pictureHistogramObraz12;
        public PictureBox pictureObraz12OL;

     //   private int _id = -1;
        private int[] histogram_values = new int[256];
        private int[] histogram_hsv_values = new int[256];
        private int[,] histogram_kolory_values;

        private int[] histogram_values2 = new int[256];
        private int[] histogram_hsv_values2 = new int[256];
        private int[,] histogram_kolory_values2;

        public bool HSV
        {
            get { return _HSV; }
            set { _HSV = value; this.label5.Text = "Obraz (HSV)"; this.HistogramRGB.Visible = false; button_blue.Visible = false; button_green.Visible = false; buttpn_red.Visible = false; label5.Visible = false; button_wszystkie.Visible = false; button1.Visible = false; button3.Visible = false; label5.Visible = true; label2.Text = "1.0"; }
        }
        private bool _HSV = false;
        public Bitmap get_image
        {
            get { return new Bitmap(this.pictureObraz12OL.Image); }
            set { }
        }
        public Bitmap get_histogram
        {
            get
            {
                if (this.HistogramGrey.Image == null)
                    return null;
                return new Bitmap(HistogramGrey.Image);
            }
            set { }
        }
        public Bitmap get_histogram_kolory
        {
            get
            {
                if (this.HistogramRGB.Image == null)
                    return null;
                return new Bitmap(this.HistogramRGB.Image);
            }
            set { }
        }

        private void EnableDoubleBuffered(DataGridView dgv, bool setting)
        {
            Type dgvType = dgv.GetType();
            PropertyInfo pi = dgvType.GetProperty("DoubleBuffered", BindingFlags.Instance | BindingFlags.NonPublic);
            pi.SetValue(dgv, setting, null);
        }


        public ObrazWPA()
        {
            InitializeComponent();
            //processingWPA = new OperatorWPA();
            this.cmbOA.Visible = false;
            this.groupBox2.Visible = false;
            //   this.groupHistogramOPJ.Visible = false;
            //   this.groupHistogramOPJKolor.Visible = false;

            this.pictureObraz1.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureObraz2.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureObraz12OL.SizeMode = PictureBoxSizeMode.StretchImage;


            //    cmbOA.Items.Add("Operacje Wieloargumentowe Arytmetyczne");   
            cmbOA.Items.Add(FunkcjeWieloarg.FunkcjeWieloargumentoweTyp.Dodawanie);
            cmbOA.Items.Add(FunkcjeWieloarg.FunkcjeWieloargumentoweTyp.OdchylenieStd);
            cmbOA.Items.Add(FunkcjeWieloarg.FunkcjeWieloargumentoweTyp.Srednia);
            cmbOA.Items.Add(FunkcjeWieloarg.FunkcjeWieloargumentoweTyp.Roznica);
            cmbOA.Items.Add(FunkcjeWieloarg.FunkcjeWieloargumentoweTyp.Maksimum);
            cmbOA.Items.Add(FunkcjeWieloarg.FunkcjeWieloargumentoweTyp.Minimum);
            cmbOA.Items.Add(FunkcjeWieloarg.FunkcjeWieloargumentoweTyp.Mnozenie);
            cmbOA.Items.Add(FunkcjeWieloarg.FunkcjeWieloargumentoweTyp.OdejmowanieLewe);
            cmbOA.Items.Add(FunkcjeWieloarg.FunkcjeWieloargumentoweTyp.OdejmowaniePrawe);
            cmbOA.SelectedIndex = 0;

        }

        private void ApplyFilter(bool preview)
        {
            if (blendBitmap1 == null || blendBitmap2 == null || pictureObraz2.Image == null || pictureObraz1.Image == null)
            {
                return;
            }

            if (preview == true)
            {
                Bitmap blendPreview = (Bitmap)pictureObraz1.Image;
                //    pictureOobraz12OL.Image = blendPreview.ArithmeticBlend((Bitmap)pictureObraz2.Image, (FunkcjeWieloarg.FunkcjeWieloargumentoweTyp)cmbOL.SelectedItem);
                pictureObraz12OL.Image = blendPreview.ArithmeticBlend((Bitmap)pictureObraz2.Image, (FunkcjeWieloarg.FunkcjeWieloargumentoweTyp)cmbOA.SelectedItem);
            }
            else
            {
                resultBitmap = blendBitmap1.ArithmeticBlend(blendBitmap2, (FunkcjeWieloarg.FunkcjeWieloargumentoweTyp)cmbOA.SelectedItem);
                //       resultBitmap = blendBitmap1.ArithmeticBlend(blendBitmap2, (FunkcjeWieloarg.FunkcjeWieloargumentoweTyp)cmbBlendType2.SelectedItem);
            }


        }

        private void buttonObraz1_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Title = "Select the source Image";
            ofd.Filter = "Image Files(*.BMP;*.JPG;*.PNG)|*.BMP;*.JPG;*.PNG|All files (*.*)|*.*";

            if (ofd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                if (sender == buttonObraz1)
                {
                    StreamReader streamReader = new StreamReader(ofd.FileName);
                    blendBitmap1 = (Bitmap)Bitmap.FromStream(streamReader.BaseStream);
                    blendBitmapM = (Bitmap)Bitmap.FromStream(streamReader.BaseStream);

                    label4.Text = ofd.FileName;
                    streamReader.Close();
                    pictureObraz1.Image = blendBitmap1.CopyToSquareCanvas(pictureObraz12OL.Width);
                    this.pictureObrazWPA1.Image = blendBitmap1.CopyToSquareCanvas(pictureObraz12OL.Width);
                }

                else if (sender == buttonObraz2)
                {
                    StreamReader streamReader = new StreamReader(ofd.FileName);
                    blendBitmap2 = (Bitmap)Bitmap.FromStream(streamReader.BaseStream);
                    blendBitmap2M = (Bitmap)Bitmap.FromStream(streamReader.BaseStream);
                    streamReader.Close();
                    pictureObraz2.Image = blendBitmap2.CopyToSquareCanvas(pictureObraz12OL.Width);
                    this.pictureObrazWPA2.Image = blendBitmap2.CopyToSquareCanvas(pictureObraz12OL.Width);
                }
                ApplyFilter(true);
            }
        }

        private void buttonObraz2_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Title = "Select the overlay Image";
            ofd.Filter = "Image Files(*.BMP;*.JPG;*.PNG)|*.BMP;*.JPG;*.PNG|All files (*.*)|*.*";

            if (ofd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                StreamReader streamReader = new StreamReader(ofd.FileName);
                blendBitmap2 = (Bitmap)Bitmap.FromStream(streamReader.BaseStream);
                blendBitmap2M = (Bitmap)Bitmap.FromStream(streamReader.BaseStream);
                this.label32.Text = ofd.FileName;
                streamReader.Close();
                pictureObraz2.Image = blendBitmap2.CopyToSquareCanvas(pictureObraz12OL.Width);
                this.pictureObrazWPA2.Image = blendBitmap2.CopyToSquareCanvas(pictureObraz12OL.Width);
            }
            ApplyFilter(true);
        }

        private void cmbOL_SelectedIndexChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void buttonHistogramOPJ_Click(object sender, EventArgs e)
        {

        }

        private void groupBoxDL_Enter(object sender, EventArgs e)
        {

        }

        private void buttonKolor_Click(object sender, EventArgs e)
        {
        }

        private void radioSzaryWPA_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void buttonWidok_Click(object sender, EventArgs e)
        {
            this.pictureObraz1.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureObraz2.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureObraz12OL.SizeMode = PictureBoxSizeMode.StretchImage;

            if (this.radioNaturalny.Checked)
            {
                this.pictureObraz1.SizeMode = PictureBoxSizeMode.Normal;
                this.pictureObraz2.SizeMode = PictureBoxSizeMode.Normal;
                this.pictureObraz12OL.SizeMode = PictureBoxSizeMode.Normal;
                this.pictureObraz1.Refresh();
                this.pictureObraz2.Refresh();
                this.pictureObraz12OL.Refresh();

            }
            if (this.radioAutoSize.Checked)
            {
                this.pictureObraz1.SizeMode = PictureBoxSizeMode.CenterImage;
                this.pictureObraz2.SizeMode = PictureBoxSizeMode.CenterImage;
                this.pictureObraz12OL.SizeMode = PictureBoxSizeMode.CenterImage;
                this.pictureObraz1.Refresh();
                this.pictureObraz2.Refresh();
                this.pictureObraz12OL.Refresh();
            }
            if (this.radioDopasowany.Checked)
            {
                this.pictureObraz1.SizeMode = PictureBoxSizeMode.StretchImage;
                this.pictureObraz2.SizeMode = PictureBoxSizeMode.StretchImage;
                this.pictureObraz12OL.SizeMode = PictureBoxSizeMode.StretchImage;
                this.pictureObraz1.Refresh();
                this.pictureObraz2.Refresh();
                this.pictureObraz12OL.Refresh();
            }
        }


        private void button1_Click(object sender, EventArgs e)
        {
            FunkcjeJednoarg fn = new FunkcjeJednoarg();
            Bitmap bmp1 = new Bitmap(this.pictureObraz1.Image);
            Bitmap bmp2 = new Bitmap(this.pictureObraz2.Image);
            this.groupBox2.Visible = false;
            //    this.generuj_histogram(0);

            if (this.radioSzary.Checked)
            {
                this.label1.Text = "Obraz wynikowy w odcieniach szarości";
                bmp1 = fn.Skalaszarosci(bmp1);
                bmp2 = fn.Skalaszarosci(bmp2);
                this.pictureObraz1.Image = bmp1;
                this.pictureObraz2.Image = bmp2;
                this.groupBox2.Visible = true;
                this.cmbOA.Visible = true;
                this.pictureObraz12OL.Visible = true;
            }
            if (this.radioKolorRGB.Checked)
            {
                this.label1.Text = "Obraz wynikowy kolorowy RGB";
                Bitmap bmp3 = new Bitmap(this.pictureObrazWPA1.Image);
                Bitmap bmp4 = new Bitmap(this.pictureObrazWPA2.Image);
                this.pictureObraz1.Image = bmp3;
                this.pictureObraz2.Image = bmp4;
                this.groupBox2.Visible = true;
                this.cmbOA.Visible = true;
                this.pictureObraz12OL.Visible = true;
            }
            if (this.radioKolorHVS.Checked)
            {
                this.label1.Text = "Obraz wynikowy kolorowy HSV";
                Bitmap bmp5 = new Bitmap(this.pictureObrazWPA1.Image);
                Bitmap bmp6 = new Bitmap(this.pictureObrazWPA2.Image);
                this.pictureObraz1.Image = bmp5;
                this.pictureObraz2.Image = bmp6;
                this.groupBox2.Visible = true;
                this.cmbOA.Visible = true;
                this.pictureObraz12OL.Visible = true;
                cmbOA.Items.Add("Dodawanie HSV");
            }
            //   this.cmbOA.Refresh();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            FunkcjeHSV fHSV = new FunkcjeHSV();
            Bitmap bmp1 = (Bitmap)pictureObraz1.Image;
            Bitmap bmp2 = (Bitmap)pictureObraz2.Image;
            Bitmap bmpHSV = (Bitmap)pictureObraz12OL.Image;
            Bitmap bmpHSV1;
            bmpHSV1 = fHSV.and_hsv(bmp1, bmp2);

            pictureObraz12OL.Image = bmpHSV1;

        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (this.radioSzary.Checked)
            {
                this.generuj_histogram(0);
            }
            if (this.radioKolorRGB.Checked)
            {
                this.HistogramRGB.Image = generuj_histogram_kolory(0);
            }
            if (this.radioKolorHVS.Checked)
            {
                this.HistogramRGB.Image = generuj_histogram_kolory(0);
            }
            EnableDoubleBuffered(this.dataGridTablica, true);
            int cols_width = 40;
            Bitmap bmpTab = (Bitmap)this.pictureObraz12OL.Image;

            if (dataGridTablica.Columns.Count != bmpTab.Width || dataGridTablica.Rows.Count != bmpTab.Height)
            {
                dataGridTablica.Rows.Clear();
                dataGridTablica.Columns.Clear();
                dataGridTablica.RowHeadersWidth = 60;
                for (int x = 0; x < bmpTab.Width; x++)
                {
                    dataGridTablica.Columns.Add(null, x.ToString());
                    dataGridTablica.Columns[x].Width = cols_width;
                    dataGridTablica.Columns[x].FillWeight = 0.0000001f;
                }
                dataGridTablica.Rows.Add(bmpTab.Height);
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    dataGridTablica.Rows[y].HeaderCell.Value = y.ToString();
                }
            }

            for (int x = 0; x < bmpTab.Width; x++)
            {
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    dataGridTablica[x, y].Value = bmpTab.GetPixel(x, y).R;
                }
            }
        }

        //RYSOWANIE HISTOGRAMÓW ----------------------------------------------------------
        private Bitmap generuj_histogram(int k)
        {
            Bitmap obrazek_bitmapa = new Bitmap(this.pictureObraz12OL.Image);
            Bitmap histogram = null;
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(obrazek_bitmapa);

            if (HSV)
            {
                int histogram_max = 0;
                double h, s, v;
                fobrazek_bitmapa.LockImage();
                for (int x = 0; x < obrazek_bitmapa.Width; x++)
                {
                    for (int y = 0; y < obrazek_bitmapa.Height; y++)
                    {
                        hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y), out h, out s, out v);
                        int temp_v = (int)(v * 255.0f);
                        histogram_hsv_values[temp_v]++;
                        if (histogram_hsv_values[temp_v] > histogram_max)
                            histogram_max = histogram_hsv_values[temp_v];
                    }
                }
                fobrazek_bitmapa.UnlockImage();
                double skala = (512.0f / (double)histogram_max) * ((double)pasek_skali.Value / 10.0f);
                histogram = new Bitmap(1024, 513);
                //    histogram = new Bitmap(490, 203);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_hsv_values[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Black);
                        }
                    }
                }

                fhistogram.UnlockImage();
            }
            else
            {
                int[] histogram_values_tmp;
                histogram_values_tmp = new int[256];
                int histogram_max = 0;
                fobrazek_bitmapa.LockImage();
                //Zliczanie wartości histogramu
                for (int x = 0; x < obrazek_bitmapa.Width; x++)
                {
                    for (int y = 0; y < obrazek_bitmapa.Height; y++)
                    {
                        if (k == 0 || k > 2)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R]++;
                            histogram_values[fobrazek_bitmapa.GetPixel(x, y).R]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).R];
                        }
                        if (k == 1)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).G];
                        }
                        if (k == 2)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B];
                        }
                        if (k == 3)
                        {
                            histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fobrazek_bitmapa.GetPixel(x, y).B];
                        }

                    }
                }
                fobrazek_bitmapa.UnlockImage();
                float skala = (512.0f / (float)histogram_max) * ((float)pasek_skali.Value / 10.0f);
                histogram = new Bitmap(1024, 513);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                Color slupki = Color.Black;
                if (k == 0)
                    slupki = Color.Red;
                if (k == 1)
                    slupki = Color.Green;
                if (k == 2)
                    slupki = Color.Blue;
                Color tlo = Color.White;
                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_values_tmp[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), slupki);
                        }
                        else
                        {
                            //fhistogram.SetPixel(4*x1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+2, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+3, (int)(256 - y1), tlo);
                        }
                    }
                }
                fhistogram.UnlockImage();
            }
            return histogram;
        }

        private Bitmap generuj_histogram2(Bitmap bmp, int k)
        {
            //   Bitmap bmp = new Bitmap(this.pictureObraz1.Image);
            Bitmap histogram = null;
            BitmapProcessing.FastBitmap fbmp = new BitmapProcessing.FastBitmap(bmp);

            if (HSV)
            {
                int histogram_max = 0;
                double h, s, v;
                fbmp.LockImage();
                for (int x = 0; x < bmp.Width; x++)
                {
                    for (int y = 0; y < bmp.Height; y++)
                    {
                        hsv.ColorToHSV(fbmp.GetPixel(x, y), out h, out s, out v);
                        int temp_v = (int)(v * 255.0f);
                        histogram_hsv_values2[temp_v]++;
                        if (histogram_hsv_values2[temp_v] > histogram_max)
                            histogram_max = histogram_hsv_values2[temp_v];
                    }
                }
                fbmp.UnlockImage();
                double skala = (512.0f / (double)histogram_max) * ((double)pasek_skali.Value / 10.0f);
                histogram = new Bitmap(1024, 513);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_hsv_values2[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Black);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Black);
                        }
                    }
                }

                fhistogram.UnlockImage();
            }
            else
            {
                int[] histogram_values_tmp;
                histogram_values_tmp = new int[256];
                int histogram_max = 0;
                fbmp.LockImage();
                //Zliczanie wartości histogramu
                for (int x = 0; x < bmp.Width; x++)
                {
                    for (int y = 0; y < bmp.Height; y++)
                    {
                        if (k == 0 || k > 2)
                        {
                            histogram_values_tmp[fbmp.GetPixel(x, y).R]++;
                            histogram_values2[fbmp.GetPixel(x, y).R]++;
                            if (histogram_values_tmp[fbmp.GetPixel(x, y).R] > histogram_max)
                                histogram_max = histogram_values_tmp[fbmp.GetPixel(x, y).R];
                        }
                        if (k == 1)
                        {
                            histogram_values_tmp[fbmp.GetPixel(x, y).G]++;
                            if (histogram_values_tmp[fbmp.GetPixel(x, y).G] > histogram_max)
                                histogram_max = histogram_values_tmp[fbmp.GetPixel(x, y).G];
                        }
                        if (k == 2)
                        {
                            histogram_values_tmp[fbmp.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fbmp.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fbmp.GetPixel(x, y).B];
                        }
                        if (k == 3)
                        {
                            histogram_values_tmp[fbmp.GetPixel(x, y).B]++;
                            if (histogram_values_tmp[fbmp.GetPixel(x, y).B] > histogram_max)
                                histogram_max = histogram_values_tmp[fbmp.GetPixel(x, y).B];
                        }

                    }
                }
                fbmp.UnlockImage();
                float skala = (512.0f / (float)histogram_max) * ((float)pasek_skali.Value / 10.0f);
                histogram = new Bitmap(1024, 513);
                BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
                Color slupki = Color.Black;
                if (k == 0)
                    slupki = Color.Red;
                if (k == 1)
                    slupki = Color.Green;
                if (k == 2)
                    slupki = Color.Blue;
                Color tlo = Color.White;
                fhistogram.LockImage();
                for (int x1 = 0; x1 < 256; x1++)
                {
                    int tmp = (int)(histogram_values_tmp[x1] * skala);
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmp)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), slupki);
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), slupki);
                        }
                        else
                        {
                            //fhistogram.SetPixel(4*x1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+1, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+2, (int)(256 - y1), tlo);
                            //fhistogram.SetPixel(4 * x1+3, (int)(256 - y1), tlo);
                        }
                    }
                }
                fhistogram.UnlockImage();
            }
            return histogram;
        }

        private Bitmap generuj_histogram_kolory2(Bitmap bmp, int k)
        {
            //  Bitmap bmp = new Bitmap(this.pictureObraz1.Image);
            if (histogram_kolory_values2 == null)
                histogram_kolory_values2 = new int[256, 3];
            int histogram_max = 0;
            BitmapProcessing.FastBitmap fbmp = new BitmapProcessing.FastBitmap(bmp);
            fbmp.LockImage();
            //Zliczanie wartości histogramu
            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    histogram_kolory_values2[fbmp.GetPixel(x, y).R, 0]++;
                    if (histogram_kolory_values2[fbmp.GetPixel(x, y).R, 0] > histogram_max)
                        histogram_max = histogram_kolory_values2[fbmp.GetPixel(x, y).R, 0];
                }
            }
            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    histogram_kolory_values2[fbmp.GetPixel(x, y).G, 1]++;
                    if (histogram_kolory_values2[fbmp.GetPixel(x, y).G, 1] > histogram_max)
                        histogram_max = histogram_kolory_values2[fbmp.GetPixel(x, y).G, 1];
                }
            }
            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    histogram_kolory_values2[fbmp.GetPixel(x, y).B, 2]++;
                    if (histogram_kolory_values2[fbmp.GetPixel(x, y).B, 2] > histogram_max)
                        histogram_max = histogram_kolory_values2[fbmp.GetPixel(x, y).B, 2];
                }
            }
            fbmp.UnlockImage();
            float skala = (512.0f / (float)histogram_max);
            Bitmap histogram = new Bitmap(1024, 513);
            BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
            fhistogram.LockImage();
            for (int x1 = 0; x1 < 256; x1++)
            {
                int tmpr = (int)(histogram_kolory_values2[x1, 0] * skala);
                int tmpg = (int)(histogram_kolory_values2[x1, 1] * skala);
                int tmpb = (int)(histogram_kolory_values2[x1, 2] * skala);
                //0,1,2 nie 3
                if (k < 3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpr)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Red);
                        }
                    }
                }
                //0,1,3 nie 2
                if (k < 2 || k == 3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpg)
                        {
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Green);
                        }
                    }
                }
                //0,2,3 nie 1
                if (k == 0 || k > 1)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpb)
                        {
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Blue);
                        }
                    }
                }
            }
            fhistogram.UnlockImage();
            return histogram;
        }

        private Bitmap generuj_histogram_kolory(int k)
        {
            Bitmap obrazek_bitmapa = new Bitmap(this.pictureObraz12OL.Image);
            if (histogram_kolory_values == null)
                histogram_kolory_values = new int[256, 3];
            int histogram_max = 0;
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(obrazek_bitmapa);
            fobrazek_bitmapa.LockImage();
            //Zliczanie wartości histogramu
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).R, 0];
                }
            }
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).G, 1];
                }
            }
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2]++;
                    if (histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2] > histogram_max)
                        histogram_max = histogram_kolory_values[fobrazek_bitmapa.GetPixel(x, y).B, 2];
                }
            }
            fobrazek_bitmapa.UnlockImage();
            float skala = (512.0f / (float)histogram_max);
            Bitmap histogram = new Bitmap(1024, 513);
            BitmapProcessing.FastBitmap fhistogram = new BitmapProcessing.FastBitmap(histogram);
            fhistogram.LockImage();
            for (int x1 = 0; x1 < 256; x1++)
            {
                int tmpr = (int)(histogram_kolory_values[x1, 0] * skala);
                int tmpg = (int)(histogram_kolory_values[x1, 1] * skala);
                int tmpb = (int)(histogram_kolory_values[x1, 2] * skala);
                //0,1,2 nie 3
                if (k < 3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpr)
                        {
                            fhistogram.SetPixel(4 * x1, (int)(512 - y1), Color.Red);
                        }
                    }
                }
                //0,1,3 nie 2
                if (k < 2 || k == 3)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpg)
                        {
                            fhistogram.SetPixel(4 * x1 + 1, (int)(512 - y1), Color.Green);
                        }
                    }
                }
                //0,2,3 nie 1
                if (k == 0 || k > 1)
                {
                    for (int y1 = 0; y1 < 512; y1++)
                    {
                        if (y1 < tmpb)
                        {
                            fhistogram.SetPixel(4 * x1 + 2, (int)(512 - y1), Color.Blue);
                        }
                    }
                }
            }
            fhistogram.UnlockImage();
            return histogram;
        }

        private void pasek_skali_Scroll(object sender, EventArgs e)
        {
            wartosc_skali.Text = ((double)pasek_skali.Value / 10.0f).ToString();
            this.HistogramGrey.Image = generuj_histogram(4);
        }

        private void buttpn_red_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(0);
        }

        private void button_green_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(1);
        }

        private void button_blue_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram(2);
        }

        private void button_wszystkie_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(0);
        }

        private void button8_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(1);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(2);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            this.HistogramRGB.Image = generuj_histogram_kolory(3);
        }

        private void button23_Click(object sender, EventArgs e)
        {

        }

        private void button4_Click(object sender, EventArgs e)
        {
            if (this.radioSzary.Checked)
            {
                this.generuj_histogram2((Bitmap)pictureObraz1.Image, 0);
            }
            if (this.radioKolorRGB.Checked)
            {
                this.HistogramRGB2.Image = generuj_histogram_kolory2((Bitmap)pictureObraz1.Image, 0);
            }
            if (this.radioKolorHVS.Checked)
            {
                this.HistogramRGB2.Image = generuj_histogram_kolory2((Bitmap)pictureObraz1.Image, 0);
            }

            EnableDoubleBuffered(TablicaLiczb2, true);
            int cols_width = 40;
            Bitmap bmpTab = (Bitmap)this.pictureObraz1.Image;

            if (TablicaLiczb2.Columns.Count != bmpTab.Width || TablicaLiczb2.Rows.Count != bmpTab.Height)
            {
                TablicaLiczb2.Rows.Clear();
                TablicaLiczb2.Columns.Clear();
                TablicaLiczb2.RowHeadersWidth = 60;
                for (int x = 0; x < bmpTab.Width; x++)
                {
                    TablicaLiczb2.Columns.Add(null, x.ToString());
                    TablicaLiczb2.Columns[x].Width = cols_width;
                    TablicaLiczb2.Columns[x].FillWeight = 0.0000001f;
                }
                TablicaLiczb2.Rows.Add(bmpTab.Height);
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    TablicaLiczb2.Rows[y].HeaderCell.Value = y.ToString();
                }
            }

            for (int x = 0; x < bmpTab.Width; x++)
            {
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    TablicaLiczb2[x, y].Value = bmpTab.GetPixel(x, y).R;
                }
            }
        }

        private void pasek_skali2_Scroll(object sender, EventArgs e)
        {
            wartosc_skali2.Text = ((double)pasek_skali2.Value / 10.0f).ToString();
            this.HistogramGrey2.Image = generuj_histogram2((Bitmap)pictureObraz1.Image, 4);
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            wartosc_skali3.Text = ((double)pasek_skali3.Value / 10.0f).ToString();
            this.HistogramGrey3.Image = generuj_histogram2((Bitmap)pictureObraz2.Image, 4);
        }

        private void buttonRED2_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram2((Bitmap)pictureObraz1.Image, 0);
        }

        private void button16_Click(object sender, EventArgs e)
        {
            this.HistogramRGB3.Image = generuj_histogram2((Bitmap)pictureObraz2.Image, 1);
        }

        private void button20_Click(object sender, EventArgs e)
        {
            this.HistogramRGB3.Image = generuj_histogram2((Bitmap)pictureObraz2.Image, 2);
        }

        private void buttonGREEN2_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram2((Bitmap)pictureObraz1.Image, 1);
        }

        private void buttonBLUE2_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram2((Bitmap)pictureObraz1.Image, 2);
        }

        private void buttonALL2_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram_kolory2((Bitmap)pictureObraz1.Image, 0);

        }

        private void buttonRED_GREEN2_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram_kolory2((Bitmap)pictureObraz1.Image, 1);
        }

        private void buttonRED_BLUE2_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram_kolory2((Bitmap)pictureObraz1.Image, 2);
        }

        private void buttonGREEN_BLUE2_Click(object sender, EventArgs e)
        {
            this.HistogramRGB2.Image = generuj_histogram_kolory2((Bitmap)pictureObraz1.Image, 3);
        }

        private void buttonALL3_Click(object sender, EventArgs e)
        {
            this.HistogramRGB3.Image = generuj_histogram_kolory2((Bitmap)pictureObraz2.Image, 0);
        }

        private void buttonRED_GREEN3_Click(object sender, EventArgs e)
        {
            this.HistogramRGB3.Image = generuj_histogram_kolory2((Bitmap)pictureObraz2.Image, 1);
        }

        private void buttonRED_BLUE3_Click(object sender, EventArgs e)
        {
            this.HistogramRGB3.Image = generuj_histogram_kolory2((Bitmap)pictureObraz2.Image, 2);
        }

        private void buttonGREEN_BLUE3_Click(object sender, EventArgs e)
        {
            this.HistogramRGB3.Image = generuj_histogram_kolory2((Bitmap)pictureObraz2.Image, 3);
        }

        private void buttonBLUE3_Click(object sender, EventArgs e)
        {
            this.HistogramRGB3.Image = generuj_histogram2((Bitmap)pictureObraz2.Image, 3);
        }

        private void button15_Click(object sender, EventArgs e)
        {
            if (this.radioSzary.Checked)
            {
                this.generuj_histogram(0);
            }
            if (this.radioKolorRGB.Checked)
            {
                this.HistogramRGB3.Image = generuj_histogram_kolory2((Bitmap)pictureObraz2.Image, 0);
            }
            if (this.radioKolorHVS.Checked)
            {
                this.HistogramRGB3.Image = generuj_histogram_kolory2((Bitmap)pictureObraz2.Image, 0);
            }

            EnableDoubleBuffered(TablicaLiczb2, true);
            int cols_width = 40;
            Bitmap bmpTab = (Bitmap)this.pictureObraz2.Image;

            if (TablicaLiczb3.Columns.Count != bmpTab.Width || TablicaLiczb3.Rows.Count != bmpTab.Height)
            {
                TablicaLiczb3.Rows.Clear();
                TablicaLiczb3.Columns.Clear();
                TablicaLiczb3.RowHeadersWidth = 60;
                for (int x = 0; x < bmpTab.Width; x++)
                {
                    TablicaLiczb3.Columns.Add(null, x.ToString());
                    TablicaLiczb3.Columns[x].Width = cols_width;
                    TablicaLiczb3.Columns[x].FillWeight = 0.0000001f;
                }
                TablicaLiczb3.Rows.Add(bmpTab.Height);
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    TablicaLiczb3.Rows[y].HeaderCell.Value = y.ToString();
                }
            }

            for (int x = 0; x < bmpTab.Width; x++)
            {
                for (int y = 0; y < bmpTab.Height; y++)
                {
                    TablicaLiczb3[x, y].Value = bmpTab.GetPixel(x, y).R;
                }
            }
        }

        private void HistogramGrey_Click(object sender, EventArgs e)
        {

        }

        private void groupBox5_Enter(object sender, EventArgs e)
        {

        }

        private void button6_Click(object sender, EventArgs e)
        {
            HistogramMax hMax = new HistogramMax();
            hMax.pictureMax.Image = this.HistogramRGB.Image;
            hMax.Text = "Obraz Wynikowy RGB";
            hMax.Show();
        }
       

        private void button9_Click(object sender, EventArgs e)
        {
            HistogramMax hMax = new HistogramMax();
            hMax.pictureMax.Image = this.HistogramGrey.Image;
            hMax.Text = "Obraz Wynikiowy w odcieniach szarości";
            hMax.Show();
        }

        private void button10_Click(object sender, EventArgs e)
        {
            HistogramMax hMax = new HistogramMax();
            hMax.pictureMax.Image = this.HistogramGrey2.Image;
            hMax.Text = "Obraz 1 Pierwotny RGB";
            hMax.Show();
        }

        private void button11_Click(object sender, EventArgs e)
        {
            HistogramMax hMax = new HistogramMax();
            hMax.pictureMax.Image = this.HistogramRGB2.Image;
            hMax.Text = "Obraz 1 Pierwotny RGB";
            hMax.Show();
        }

        private void button12_Click(object sender, EventArgs e)
        {
            HistogramMax hMax = new HistogramMax();
            hMax.pictureMax.Image = this.HistogramGrey3.Image;
            hMax.Text = "Obraz 2 Pierwotny w odcieniach szarości";
            hMax.Show();
        }

        private void button13_Click(object sender, EventArgs e)
        {
            HistogramMax hMax = new HistogramMax();
            hMax.pictureMax.Image = this.HistogramRGB3.Image;
            hMax.Text = "Obraz 2 Pierwotny RGB";
            hMax.Show();
        }

        private void pictureObraz1_Click(object sender, EventArgs e)
        {




            /*
            ObrazMax oMax = new ObrazMax();
            oMax.pictureMaxZoom.Image = blendBitmapM;
            Label x = new Label();
            x.Text = label4.Text;
            oMax.Text = "Obraz1 Pierwotny " + x.Text;
            oMax.Show();
          * /
        }
             

        private void pictureObraz2_Click(object sender, EventArgs e)
        {
            ObrazMax oMax = new ObrazMax();
            oMax.pictureMaxZoom.Image = blendBitmap2M;
            Label x = new Label();
            x.Text = label32.Text;
            oMax.Text = "Obraz 2 Pierwotny " + x.Text;
            oMax.Show();
        }

        private void pictureObraz12OL_Click(object sender, EventArgs e)
        {
            ObrazMax oMax = new ObrazMax();
            oMax.pictureMaxZoom.Image = pictureObraz12OL.Image;
        //    this.pictureObraz2.SizeMode = PictureBoxSizeMode.StretchImage;
            oMax.pictureMaxZoom.SizeMode = PictureBoxSizeMode.Zoom;
            Label x1 = new Label();
            x1.Text = label4.Text;
            Label x2 = new Label();
            x2.Text = label32.Text;
            oMax.Text = "Obraz Wynikowy " + x1.Text +  " , " + x2.Text;
            oMax.Show();
        }

        private void label4_Click(object sender, EventArgs e)
        {

        }

        //-------------------------------------------------------------------------------------------------------------

        
   }    
 }
    }
            */

        }

        private void label4_Click(object sender, EventArgs e)
        {

        }
    }
}