﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Windows.Forms.DataVisualization.Charting;
using System.Drawing.Imaging;
using System.IO;

namespace APO_BB_DK_v012013
{
    public partial class ObrazWPL : Form
    {
    //    private Image zrodlo;
    //    private Image zrodlo2;
     //   private OperatorWPL processingWPL;
     //   private System.Windows.Forms.TrackBar suwak1;
      //  private Bitmap bmpOrg;
     //   private Bitmap bmpMod;

        private Bitmap blendBitmap1 = null;
        private Bitmap blendBitmap2 = null;
        private Bitmap resultBitmap = null;

        public System.Windows.Forms.PictureBox pictureWynik1;
        public System.Windows.Forms.Panel panelPierowtny;
        public System.Windows.Forms.Panel panelWynikowy;
        public System.Windows.Forms.PictureBox pictureHistPierwotny;
        public System.Windows.Forms.PictureBox pictureHistWynikowy;
        public System.Windows.Forms.PictureBox pictureHistogramObraz12;
        public PictureBox pictureHistogramWPLRed;
        public PictureBox pictureHistogramWPLGreen;
        public PictureBox pictureHistogramWPLBlue;

        public ObrazWPL()
        {
            InitializeComponent();
            //processingWPL = new OperatorWPL();

            this.cmbOL.Visible = false;
            this.groupBox2.Visible = false;
            this.groupHistogramOPJ.Visible = false;
            this.pictureObraz1.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureObraz2.SizeMode = PictureBoxSizeMode.StretchImage;
            this.pictureObraz12OL.SizeMode = PictureBoxSizeMode.StretchImage;

            cmbOL.Items.Add(FunkcjeWieloarg.FunkcjeWieloargumentoweTyp.AND);
            cmbOL.Items.Add(FunkcjeWieloarg.FunkcjeWieloargumentoweTyp.OR);
            cmbOL.Items.Add(FunkcjeWieloarg.FunkcjeWieloargumentoweTyp.XOR);
            cmbOL.Items.Add(FunkcjeWieloarg.FunkcjeWieloargumentoweTyp.XNOR);
            cmbOL.SelectedIndex = 0;
        }

        private void ApplyFilter(bool preview)
        {
            if (blendBitmap1 == null || blendBitmap2 == null || pictureObraz2.Image == null || pictureObraz1.Image == null)
            {
                return;
            }

            if (preview == true)
            {
                Bitmap blendPreview = (Bitmap)pictureObraz1.Image;

            //    pictureOobraz12OL.Image = blendPreview.ArithmeticBlend((Bitmap)pictureObraz2.Image, (FunkcjeWieloarg.FunkcjeWieloargumentoweTyp)cmbOL.SelectedItem);
                pictureObraz12OL.Image = blendPreview.ArithmeticBlend((Bitmap)pictureObraz2.Image, (FunkcjeWieloarg.FunkcjeWieloargumentoweTyp)cmbOL.SelectedItem);
            }
            else
            {
                resultBitmap = blendBitmap1.ArithmeticBlend(blendBitmap2, (FunkcjeWieloarg.FunkcjeWieloargumentoweTyp)cmbOL.SelectedItem);
         //       resultBitmap = blendBitmap1.ArithmeticBlend(blendBitmap2, (FunkcjeWieloarg.FunkcjeWieloargumentoweTyp)cmbBlendType2.SelectedItem);
            }
        }

        private void buttonObraz1_Click(object sender, EventArgs e)
        {
             OpenFileDialog ofd = new OpenFileDialog();
            ofd.Title = "Select the source Image";
            ofd.Filter = "Image Files(*.BMP;*.JPG;*.PNG)|*.BMP;*.JPG;*.PNG|All files (*.*)|*.*";

            if (ofd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                if (sender == buttonObraz1)
                {
                    StreamReader streamReader = new StreamReader(ofd.FileName);
                    blendBitmap1 = (Bitmap)Bitmap.FromStream(streamReader.BaseStream);
                    streamReader.Close();

                    pictureObraz1.Image = blendBitmap1.CopyToSquareCanvas(pictureObraz12OL.Width);
                    this.pictureObrazWPL1.Image = blendBitmap1.CopyToSquareCanvas(pictureObraz12OL.Width);

                }

                else if (sender == buttonObraz2)
                {
                    StreamReader streamReader = new StreamReader(ofd.FileName);
                    blendBitmap2 = (Bitmap)Bitmap.FromStream(streamReader.BaseStream);
                    streamReader.Close();

                    pictureObraz2.Image = blendBitmap2.CopyToSquareCanvas(pictureObraz12OL.Width);
                    this.pictureObrazWPL2.Image = blendBitmap2.CopyToSquareCanvas(pictureObraz12OL.Width);
                }

                ApplyFilter(true);
            }
         

        }

        private void buttonObraz2_Click(object sender, EventArgs e)
        {
             OpenFileDialog ofd = new OpenFileDialog();
            ofd.Title = "Select the overlay Image";
            ofd.Filter = "Image Files(*.BMP;*.JPG;*.PNG)|*.BMP;*.JPG;*.PNG|All files (*.*)|*.*";

            if (ofd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                StreamReader streamReader = new StreamReader(ofd.FileName);
                blendBitmap2 = (Bitmap)Bitmap.FromStream(streamReader.BaseStream);
                streamReader.Close();

                pictureObraz2.Image = blendBitmap2.CopyToSquareCanvas(pictureObraz12OL.Width);
                this.pictureObrazWPL2.Image = blendBitmap2.CopyToSquareCanvas(pictureObraz12OL.Width);
            }
            ApplyFilter(true);
          }

        private void cmbOL_SelectedIndexChanged(object sender, EventArgs e)
        {
            ApplyFilter(true);
        }

        private void buttonHistogramOPJ_Click(object sender, EventArgs e)
        {
            Bitmap bmpS = (Bitmap)this.pictureObraz12OL.Image;
            Bitmap hs = new HistogramRysuj(bmpS).draw();
            this.pictureHistogramWP.Image = hs;
            this.pictureHistogramWP.Visible = true;            
           /* 
            this.pictureHistogramWP.Visible = true;
            Bitmap bmpHistogOPJ = (Bitmap)this.pictureObraz12OL.Image;
            this.processingWPL.setImage(new Bitmap(this.pictureObraz12OL.Image));
            this.processingWPL.calcHisto(this);
            this.Invalidate();
            */
        }

          

        private void buttonKolor_Click_1(object sender, EventArgs e)
        {
            FunkcjeJednoarg fn = new FunkcjeJednoarg();
            Bitmap bmp1 = new Bitmap(this.pictureObraz1.Image);
            Bitmap bmp2 = new Bitmap(this.pictureObraz2.Image);
            this.groupBox2.Visible = false;

            if (this.radioSzaryWPA.Checked)
            {
               this.label1.Text = "Obraz wynikowy w odcieniach szarości";
                bmp1 = fn.Skalaszarosci(bmp1);
                bmp2 = fn.Skalaszarosci(bmp2);
                this.pictureObraz1.Image = bmp1;
                this.pictureObraz2.Image = bmp2;
                this.groupBox2.Visible = true;
                this.cmbOL.Visible = true;
                this.pictureObraz12OL.Visible = true;
                this.groupHistogramOPJ.Visible = true;
                this.groupHistogramOPJKolor.Visible = false;
             }
            else
            {
               this.label1.Text = "Obraz wynikowy kolorowy";
               Bitmap bmp3 = new Bitmap(this.pictureObrazWPL1.Image);
               Bitmap bmp4 = new Bitmap(this.pictureObrazWPL2.Image);
               this.pictureObraz1.Image = bmp3;
               this.pictureObraz2.Image = bmp4;
               this.groupBox2.Visible = true;
               this.cmbOL.Visible = true;
               this.pictureObraz12OL.Visible = true;
               this.groupHistogramOPJ.Visible = false;
               this.groupHistogramOPJKolor.Visible = true;
            }
            this.cmbOL.Refresh();
         }
  

        private void buttonWidok_Click_1(object sender, EventArgs e)
        {
            if (this.radioNaturalny.Checked)
            {
                this.pictureObraz1.SizeMode = PictureBoxSizeMode.Normal;
                this.pictureObraz2.SizeMode = PictureBoxSizeMode.Normal;
                this.pictureObraz12OL.SizeMode = PictureBoxSizeMode.Normal;
                this.pictureObraz1.Refresh();
                this.pictureObraz2.Refresh();
                this.pictureObraz12OL.Refresh();
            }
             if (this.radioAutoSize.Checked)
             {
                 this.pictureObraz1.SizeMode = PictureBoxSizeMode.CenterImage;
                 this.pictureObraz2.SizeMode = PictureBoxSizeMode.CenterImage;
                 this.pictureObraz12OL.SizeMode = PictureBoxSizeMode.CenterImage;
                 this.pictureObraz1.Refresh();
                 this.pictureObraz2.Refresh();
                 this.pictureObraz12OL.Refresh();
             }
             if (this.radioDopasowany.Checked)
            {
                 this.pictureObraz1.SizeMode = PictureBoxSizeMode.StretchImage;
                 this.pictureObraz2.SizeMode = PictureBoxSizeMode.StretchImage;
                 this.pictureObraz12OL.SizeMode = PictureBoxSizeMode.StretchImage;
                 this.pictureObraz1.Refresh();
                 this.pictureObraz2.Refresh();
                 this.pictureObraz12OL.Refresh();
             }
        }

        private void buttonHistogramWPKolor_Click(object sender, EventArgs e)
        {      
            pictureHistogramWPLRed.Visible = true;
            pictureHistogramWPLBlue.Visible = true;
            pictureHistogramWPLGreen.Visible = true;

            //histogram RGB - CZERWONY / RED
            Bitmap bmpRed = (Bitmap)this.pictureObraz12OL.Image;
          //  Bitmap hsRed = new HistogramNew(bmpRed).
         //   this.pictureHistogramWPLRed.Image = hsRed;
            this.pictureHistogramWPLRed.Visible = true;


            Bitmap bmpR = (Bitmap)this.pictureObraz12OL.Image;
            Bitmap hsRed = new HistogramRysuj(bmpR).draw();
            this.pictureHistogramWPLRed.Image = hsRed;
            this.pictureHistogramWPLRed.Visible = true;

            //Histogram RGB - NIEBIESKI / BLUE
            Bitmap bmpB = (Bitmap)this.pictureObraz12OL.Image;
            Bitmap hsBlue = new HistogramRysuj(bmpB).draw();
            this.pictureHistogramWPLBlue.Image = hsBlue;
            this.pictureHistogramWPLBlue.Visible = true;

            //Histogram RGB - ZIELONY / GREEN
            Bitmap bmpG = (Bitmap)this.pictureObraz12OL.Image;
            Bitmap hsGreen = new HistogramRysuj(bmpG).draw();
            this.pictureHistogramWPLGreen.Image = hsGreen;
            this.pictureHistogramWPLGreen.Visible = true;

            
           /*
            Bitmap bmpHistogOP = (Bitmap)this.pictureObraz12OL.Image;
            this.processingWPL.setImage(new Bitmap(this.pictureObraz12OL.Image));
            this.processingWPL.calcHistoBlue(this);
            this.processingWPL.calcHistoGreen(this);
            this.processingWPL.calcHistoRed(this);
            */

        
            this.Invalidate();
        }
        

    }
}
