using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using BitmapProcessing;

namespace APO_BB_DK_v012013.Operacje
{
    public partial class _form_linia_profilu : Form
    {
        Bitmap lin;
        public _form_linia_profilu(Color [] values,bool is_hsv)
        {
            InitializeComponent();
            int max = 1;
            if (is_hsv)
            {
                this.Text = "Linia Profilu (HSV)";
                max = 500;
                label_max.Text = "Max:\n1.0";
            }
            else
            {
                for (int i = 0; i < values.Length; i++)
                {
                    if (values[i].R > max) max = values[i].R;
                    if (values[i].G > max) max = values[i].G;
                    if (values[i].B > max) max = values[i].B;
                }
                label_max.Text = "Max:\n" + max.ToString();
            }
            lin = new Bitmap(values.Length*4+2, 4*max+1+2);
            
            label_vals.Text = "Pikseli:" + values.Length.ToString();
            FastBitmap flin = new FastBitmap(lin);
            flin.LockImage();
            //Rysowanie ramki
            for (int i = 0; i < lin.Width; i++)
            {
                flin.SetPixel(i, 0, Color.Black);
                flin.SetPixel(i, lin.Height-1, Color.Black);
            }
            for (int i = 0; i < lin.Height; i++)
            {
                flin.SetPixel(0, i, Color.Black);
                flin.SetPixel(lin.Width-1, i, Color.Black);
            }
            if (!is_hsv)
            {
                for (int i = 0; i < values.Length; i++)
                {
                    flin.SetPixel(4 * i, 4 * values[i].R, Color.Red);
                    flin.SetPixel(4 * i, 4 * values[i].G, Color.Green);
                    flin.SetPixel(4 * i, 4 * values[i].B, Color.Blue);
                    flin.SetPixel(4 * i + 1, 4 * values[i].R, Color.Red);
                    flin.SetPixel(4 * i + 1, 4 * values[i].G, Color.Green);
                    flin.SetPixel(4 * i + 1, 4 * values[i].B, Color.Blue);
                    flin.SetPixel(4 * i + 2, 4 * values[i].R, Color.Red);
                    flin.SetPixel(4 * i + 2, 4 * values[i].G, Color.Green);
                    flin.SetPixel(4 * i + 2, 4 * values[i].B, Color.Blue);
                    //flin.SetPixel(4 * i + 3, values[i].R, Color.Red);
                    //flin.SetPixel(4 * i + 3, values[i].G, Color.Green);
                    //flin.SetPixel(4 * i + 3, values[i].B, Color.Blue);
                }
                for (int i = 0; i < values.Length - 1; i++)
                {
                    int diff = Math.Abs(4 * values[i].R - 4 * values[i + 1].R);
                    int min = Math.Min(4 * values[i].R, 4 * values[i + 1].R);
                    for (int j = 0; j < diff; j++)
                    {
                        flin.SetPixel(4 * i + 3, min + j, Color.Red);
                    }
                    diff = Math.Abs(4 * values[i].G - 4 * values[i + 1].G);
                    min = Math.Min(4 * values[i].G, 4 * values[i + 1].G);
                    for (int j = 0; j < diff; j++)
                    {
                        flin.SetPixel(4 * i + 3, min + j, Color.Green);
                    }
                    diff = Math.Abs(4 * values[i].B - 4 * values[i + 1].B);
                    min = Math.Min(4 * values[i].B, 4 * values[i + 1].B);
                    for (int j = 0; j < diff; j++)
                    {
                        flin.SetPixel(4 * i + 3, min + j, Color.Blue);
                    }
                }
            }
            else
            {
                for (int i = 0; i < values.Length; i++)
                {
                    double h,s,v;
                    hsv.ColorToHSV(values[i], out h, out s, out v);

                    flin.SetPixel(4 * i, (int) (2000.0f * v), Color.Black);
                    flin.SetPixel(4 * i + 1, (int)(2000.0f * v), Color.Black);
                    flin.SetPixel(4 * i + 2, (int)(2000.0f * v), Color.Black);
                   
                   
                }
                for (int i = 0; i < values.Length - 1; i++)
                {
                    double h, s, v,v1;
                    hsv.ColorToHSV(values[i], out h, out s, out v);
                    hsv.ColorToHSV(values[i+1], out h, out s, out v1);
                    int diff = (int) (Math.Abs(v - v1)*2000.0f);
                    double min = Math.Min(v, v1);
                    for (int j = 0; j < diff; j++)
                    {
                        flin.SetPixel(4 * i + 3, (int) (min*2000.0f) + j, Color.Black);
                    }
                }
            }
            flin.UnlockImage();
            linia.Image = lin;
        }

        private void linia_Click(object sender, EventArgs e)
        {

        }
    }
}