using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using BitmapProcessing;
using System.Reflection;

namespace APO_BB_DK_v012013.Operacje
{
    

    public partial class _form_tablica_liczb : Form
    {
        
        private void EnableDoubleBuffered(DataGridView dgv, bool setting)
        {
            Type dgvType = dgv.GetType();
            PropertyInfo pi = dgvType.GetProperty("DoubleBuffered",
                  BindingFlags.Instance | BindingFlags.NonPublic);
            pi.SetValue(dgv, setting, null);
        }
        public _form_tablica_liczb(Bitmap src)
        {
            InitializeComponent();
            obraz.Image = src;
            EnableDoubleBuffered(tablicaLiczb, true);
            int cols_width = 40;
            
            FastBitmap ftmp = new FastBitmap(src);

            ftmp.LockImage();
            if (tablicaLiczb.Columns.Count != src.Width || tablicaLiczb.Rows.Count != src.Height)
            {
                tablicaLiczb.Rows.Clear();
                tablicaLiczb.Columns.Clear();

                tablicaLiczb.RowHeadersWidth = 60;
                for (int x = 0; x < src.Width; x++)
                {

                    tablicaLiczb.Columns.Add(null, x.ToString());
                    tablicaLiczb.Columns[x].Width = cols_width;
                    tablicaLiczb.Columns[x].FillWeight = 0.0000001f;

                }
                tablicaLiczb.Rows.Add(src.Height);
                for (int y = 0; y < src.Height; y++)
                {
                    tablicaLiczb.Rows[y].HeaderCell.Value = y.ToString();
                }

            }
            
            for (int x = 0; x < src.Width; x++)
            {
                for (int y = 0; y < src.Height; y++)
                {
                    tablicaLiczb[x, y].Value = ftmp.GetPixel(x, y).R;
                }
            }
            
            ftmp.UnlockImage();
        }

        private void radio_11_CheckedChanged(object sender, EventArgs e)
        {
            obraz.Dock = DockStyle.Fill;
            obraz.SizeMode = PictureBoxSizeMode.AutoSize;
        }


        private void radio_zoom_CheckedChanged(object sender, EventArgs e)
        {
            obraz.Dock = DockStyle.Fill;
            obraz.SizeMode = PictureBoxSizeMode.Zoom;
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            obraz.Dock = DockStyle.None;
            obraz.Scale(new SizeF(1000, 1000));
        }

        private void button1_Click(object sender, EventArgs e)
        {
            obraz.Dock = DockStyle.None;
            
            obraz.Width += 200;
            obraz.Height += 200;
        }

        private void tablicaLiczb_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void obraz_Click(object sender, EventArgs e)
        {

        }

        
    }
}