using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace APO
{
    public partial class _form_lut_hsv : Form
    {
        private Bitmap src_thumbnail;
        private bool initialized = false;
        private bool regulacja_changes = false;
        public int [] vals
        {
            get
            {
                return regulacja1.vals;
            }
            set { }
        }
        public _form_lut_hsv(Bitmap src)
        {
            
            InitializeComponent();
            
            int new_height = src.Height;
            int new_width = src.Width;
            while (new_height > 448 || new_width > 640)
            {
                new_height = (int)(new_height / 1.05f);
                new_width = (int)(new_width / 1.05f);
            }
            if (src != null)
            {
                src_thumbnail = new Bitmap(src.GetThumbnailImage(new_width, new_height, null, System.IntPtr.Zero));
                preview.Image = src.GetThumbnailImage(new_width, new_height, null, System.IntPtr.Zero);
            }
            
            initialize_regulacja(src_thumbnail);
            dataGridView1.Rows.Add();
            update_grid();
            initialized = true;
            

        }
        private void initialize_regulacja(Bitmap src)
        {
            int histogram_max = 255;
            int [] values=new int[256];
            for (int x = 0; x < 256; x++)
            {
                values[x] = x;
            }
            regulacja1.init(values, histogram_max);
        }

        private void regulacja1_Load(object sender, EventArgs e)
        {

        }
        private void update_grid()
        {
            for (int x = 0; x < 256; x++)
            {
                dataGridView1.Rows[0].Cells[x].Value = regulacja1.vals[x];
            }
        }
        private void regulacja1_Zmiana(object sender)
        {
            preview.Image = functions.lut(new Bitmap(src_thumbnail), regulacja1.vals);
            regulacja_changes = true;
            update_grid();
            regulacja_changes = false;
            
        }

        private void _form_lut_Load(object sender, EventArgs e)
        {

        }

        private void dataGridView1_CellValueChanged(object sender, DataGridViewCellEventArgs e)
        {
            
            if (!regulacja_changes && initialized)
            {
                
                int val = -1;
                try
                {
                    val = int.Parse(dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Value.ToString());
                }
                catch
                {
                    val = -1;
                }
                if (val > 255)
                {
                    dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Value = 255;
                    val = 255;
                }
                if (val < 0)
                {
                    dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Value = 0;
                    val = 0;
                }
                regulacja1.vals[e.ColumnIndex] = val;
                regulacja1.update_curve_no_event();
                preview.Image = functions.lut(new Bitmap(src_thumbnail), regulacja1.vals);
            }
            
        }

        private void _button_default_Click(object sender, EventArgs e)
        {
            regulacja_changes = true;
            for (int x = 0; x < 256; x++)
            {
                regulacja1.vals[x] = x;
              
                    
            }
            update_grid();
            regulacja1.update_curve_no_event();
            preview.Image = functions.lut(new Bitmap(src_thumbnail), regulacja1.vals);
            regulacja_changes = false;
        }





    }
}