using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace APO
{
    public partial class _form_liniowa_hsv : Form
    {
        private Bitmap src_thumbnail;
        private TextBox[] vals;
        public _form_liniowa_hsv(Bitmap src)
        {
            
            InitializeComponent();
            init_textboxes();

            int new_height = src.Height;
            int new_width = src.Width;
            while (new_height > 300 || new_width > 400)
            {
                new_height = (int)(new_height / 1.05f);
                new_width = (int)(new_width / 1.05f);
            }
            if (src != null)
            {
                src_thumbnail = new Bitmap(src.GetThumbnailImage(new_width, new_height, null, System.IntPtr.Zero));
                preview.Image = src.GetThumbnailImage(new_width, new_height, null, System.IntPtr.Zero);
            }

        }
        public int[] values
        {
            get {
                int[] values2 = new int[9];
                for (int x = 0; x < 9; x++)
                {
                    try
                    {
                        values2[x] = int.Parse(vals[x].Text);
                    }
                    catch
                    {
                        values2[x] = 0;
                    }
                }
                return values2;
            }

            set { 
            }
        }
        public int dzielnik
        {
            get {
                if (fg)
                    return 1;
                int[] values2 = new int[9];
                for (int x = 0; x < 9; x++)
                {
                    try
                    {
                        values2[x] = int.Parse(vals[x].Text);
                    }
                    catch
                    {
                        values2[x] = 0;
                    }
                }
                
                int dzielnik = 0;
                foreach (int v in values2)
                {
                    dzielnik += v;
                }

                return dzielnik;
            }
            set { }
        }
        public int metoda
        {
            get { return _metoda; }
            set { }
        }
        private bool fg = false;
        private bool zmiana_reczna = false;
        private int _metoda = 3;
        
        private void update_preview()
        {
            //fg - true; fd = false
            int[] values = new int[9];
            for (int x = 0; x < 9; x++)
            {
                try
                {
                    values[x] = int.Parse(vals[x].Text);
                }
                catch
                {
                    values[x] = 0;
                }
            }
            int dzielnik = 0;
            foreach (int v in values)
            {
                dzielnik += v;
            }
            if(fg)
                preview.Image = functions.filtracja_liniowa_hsv(new Bitmap(src_thumbnail), values,1,_metoda);
            else
                preview.Image = functions.filtracja_liniowa_hsv(new Bitmap(src_thumbnail), values, dzielnik,_metoda);
        }
        #region textboxes
        private void init_textboxes()
        {
            int sx = 580;
            int sy = 90;
            int height = 30;
            int width = 30;

            vals = new TextBox[9];
            for (int x = 0; x < vals.Length; x++)
            {
                vals[x] = new TextBox();
                vals[x].Text = "1";
                vals[x].Width = width;
                vals[x].Height = height;
                vals[x].Font = new Font(FontFamily.GenericSansSerif, 12.0f);
                vals[x].TextAlign = HorizontalAlignment.Center;
                vals[x].TextChanged += new EventHandler(_form_liniowa_TextChanged);
                vals[x].Location = new Point(sx+(x%3)*(width+5), sy+(x/3)*height);
                vals[x].Enabled = false;
                this.Controls.Add(vals[x]);
            }
        }

        private void disable_textboxes()
        {
            zmiana_reczna = false;
            foreach (TextBox t in vals)
            {
                t.Enabled = false;
            }
            
        }
        private void enable_textboxes()
        {
            zmiana_reczna = true;
            foreach (TextBox t in vals)
            {
                t.Enabled = true;
            }
            
        }
        #endregion

        private void disable_skalowanie()
        {
            skalowanie.Enabled = false;
        }
        private void enable_skalowanie()
        {
            skalowanie.Enabled = true;
        }
        private void _form_liniowa_TextChanged(object sender, EventArgs e)
        {
            if (zmiana_reczna)
            {
                int val = 1;
                try
                {
                    val = int.Parse(((TextBox)sender).Text);
                }
                catch
                {
                    val = 1;
                }
                ((TextBox)sender).Text = val.ToString();
                update_preview();
            }
        }
        #region fdolno
        private void maska_fd_1_CheckedChanged(object sender, EventArgs e)
        {
            fg = false;
            disable_textboxes();
            disable_skalowanie();
            foreach (TextBox t in vals)
            {
                t.Text = "1";
            }
            update_preview();
        }
        private void maska_fd_2_CheckedChanged(object sender, EventArgs e)
        {
            fg = false;
            disable_textboxes();
            disable_skalowanie();
            for (int x = 0; x < vals.Length;x++ )
            {
                if (x == 4)
                    vals[x].Text = "2";
                else
                    vals[x].Text = "1";
            }
            update_preview();
        }
        private void maska_fd_3_CheckedChanged(object sender, EventArgs e)
        {
            fg = false;
            disable_textboxes();
            disable_skalowanie();
            for (int x = 0; x < vals.Length; x++)
            {
                if (x %2 ==1)
                    vals[x].Text = "2";
                else if(x==4)
                    vals[x].Text = "4";
                else
                    vals[x].Text = "1";
            }
            update_preview();
        }
        private void maska_fd_4_CheckedChanged(object sender, EventArgs e)
        {
            fg = false;
            disable_textboxes();
            disable_skalowanie();
            for (int x = 0; x < vals.Length; x++)
            {
                if (x == 4)
                    vals[x].Text = "0";
                else
                    vals[x].Text = "1";
            }
            update_preview();
        }
        private void maska_wlasna_fd_CheckedChanged(object sender, EventArgs e)
        {
            fg = false;
            enable_textboxes();
            disable_skalowanie();
            update_preview();
        }
#endregion
        #region fgrno
        private void maska_fg_1_CheckedChanged(object sender, EventArgs e)
        {
            fg = true;
            disable_textboxes();
            enable_skalowanie();
            vals[0].Text = "-1";
            vals[1].Text = "-2";
            vals[2].Text = "-1";
            for (int x = 3; x < 6; x++)
            {
                
                vals[x].Text = "0";
                
            }
            vals[6].Text = "1";
            vals[7].Text = "2";
            vals[8].Text = "1";
            update_preview();
        }
        private void maska_fg_2_CheckedChanged(object sender, EventArgs e)
        {
            fg = true;
            disable_textboxes();
            enable_skalowanie();
            for (int x = 0; x < vals.Length; x++)
            {
                if (x % 2 == 1)
                    vals[x].Text = "-2";
                else if (x == 4)
                    vals[x].Text = "5";
                else
                    vals[x].Text = "1";
            }
            update_preview();
        }
        private void maska_fg_3_CheckedChanged(object sender, EventArgs e)
        {
            fg = true;
            disable_textboxes();
            enable_skalowanie();
            for (int x = 0; x < vals.Length; x++)
            {
                
                if (x == 4)
                    vals[x].Text = "9";
                else
                    vals[x].Text = "-1";
            }
            update_preview();
        }
        private void maska_fg_4_CheckedChanged(object sender, EventArgs e)
        {
            fg = true;
            disable_textboxes();
            enable_skalowanie();
            for (int x = 0; x < vals.Length; x++)
            {
                if (x % 2 == 1)
                    vals[x].Text = "-1";
                else if (x == 4)
                    vals[x].Text = "5";
                else
                    vals[x].Text = "0";
            }
            update_preview();
        }
        
        private void maska_wlasna_CheckedChanged(object sender, EventArgs e)
        {
            fg = true;
            enable_textboxes();
            enable_skalowanie();
            update_preview();
        }

        #endregion

        private void skalowanie_rownomierne_CheckedChanged(object sender, EventArgs e)
        {
            _metoda = 1;
            update_preview();
        }

        private void skalowanie_trojwartosciowe_CheckedChanged(object sender, EventArgs e)
        {
            _metoda = 2;
            update_preview();
        }

        private void skalowanie_obcinajace_CheckedChanged(object sender, EventArgs e)
        {
            _metoda = 3;
            update_preview();
        }

        





        
    }
}