using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace APO
{
    public partial class _form_segmentacja_progowanie : Form
    {
        private Bitmap src_thumbnail;
        public _form_segmentacja_progowanie(Bitmap src)
        {
            
            InitializeComponent();
            
            int new_height = src.Height;
            int new_width = src.Width;
            while (new_height > 300 || new_width > 400)
            {
                new_height = (int)(new_height / 1.05f);
                new_width = (int)(new_width / 1.05f);
            }
            if (src != null)
            {
                src_thumbnail = new Bitmap(src.GetThumbnailImage(new_width, new_height, null, System.IntPtr.Zero));
                
                preview.Image = src.GetThumbnailImage(new_width, new_height, null, System.IntPtr.Zero);
            }
            ustaw_prog();
            update_preview();
            
        }
        
        public int prog
        {
            set{}
            get { 
                return value.Value;
            }
        }
        public void ustaw_prog()
        {
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(src_thumbnail);
            fobrazek_bitmapa.LockImage();
            int [] histogram_values = new int [256];
            int histogram_max = 0;
            int histogram_max_index = 0;
            for (int x = 0; x < src_thumbnail.Width; x++)
            {
                for (int y = 0; y < src_thumbnail.Height; y++)
                {
                    histogram_values[fobrazek_bitmapa.GetPixel(x, y).R]++;
                    if (histogram_values[fobrazek_bitmapa.GetPixel(x, y).R] > histogram_max)
                    {
                        histogram_max = histogram_values[fobrazek_bitmapa.GetPixel(x, y).R];
                        histogram_max_index = fobrazek_bitmapa.GetPixel(x, y).R;
                    }
                }
            }
            int prog=0;
            if (histogram_max > 0 && histogram_max_index>0)
            {
                for (int i = histogram_max_index; i >= 0; i--)
                {
                    if (histogram_values[i] < histogram_max / 100)
                    {
                        prog = i;
                        break;
                    }
                }
            }
            value.Value=prog;
            fobrazek_bitmapa.UnlockImage();

        }
        private void update_preview()
        {
            label_value.Text = value.Value.ToString();
            Bitmap obrazek_bitmapa = new Bitmap(src_thumbnail);
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(obrazek_bitmapa);
            fobrazek_bitmapa.LockImage();
            for (int x = 0; x < obrazek_bitmapa.Width; x++)
            {
                for (int y = 0; y < obrazek_bitmapa.Height; y++)
                {
                    if (fobrazek_bitmapa.GetPixel(x, y).R > value.Value)
                    {
                        fobrazek_bitmapa.SetPixel(x, y, Color.FromArgb(255, 255, 255));
                    }
                    else
                    {
                        fobrazek_bitmapa.SetPixel(x, y, Color.FromArgb(0, 0, 0));
                    }
                }
            }
            fobrazek_bitmapa.UnlockImage();
            preview.Image = obrazek_bitmapa;
        }
        private void value_Scroll(object sender, EventArgs e)
        {
            update_preview();
        }

        private void _form_segmentacja_progowanie_Load(object sender, EventArgs e)
        {

        }

        
    }
}