﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Drawing;
using System.Drawing.Imaging;

namespace APO_BB_DK_v012013
{
    class Skalowanie
    {
     //   protected int size;
    //    protected Edges edge;
        protected Bitmap tmp;


        public static byte Method1(int value)
        {
            if (value < 0) return 0;
            else if (value > 255) return 255;
            else return Convert.ToByte(value);
        }

        public static byte Method2(int value)
        {
            if (value < 0) return 0;
            else if (value > 255) return 255;
            else return 128;
        }

        public static byte Method3(int value, int max, int min)
        {
            return (byte)(((double)(value - min)) / ((double)(max - min)));
        }





        protected void Fill(Edges edge, int size, Bitmap oryginal)
        {
            int i;
            int j;
            int x_max = tmp.Width - size;
            int y_max = tmp.Height - size;
            switch (edge)
            {
                case Edges.CopyTmp:
                    // kopiuje gore
                    for (j = 0; j < size; j++)
                    {
                        for (i = size; i < x_max; i++)
                        {
                            tmp.SetPixel(i, j, tmp.GetPixel(i, size));
                        }
                    }

                    // kopiuje dol
                    for (j = y_max; j < tmp.Height; j++)
                    {
                        for (i = size; i < x_max; i++)
                        {
                            tmp.SetPixel(i, j, tmp.GetPixel(i, y_max - 1));
                        }
                    }

                    // kopiuje lewa
                    for (j = 0; j < size; j++)
                    {
                        for (i = 0; i < tmp.Height; i++)
                        {
                            tmp.SetPixel(j, i, tmp.GetPixel(size, i));
                        }
                    }

                    // kopiuje prawa
                    for (j = tmp.Width - size; j < tmp.Width; j++)
                    {
                        for (i = 0; i < tmp.Height; i++)
                        {
                            tmp.SetPixel(j, i, tmp.GetPixel(x_max - 1, i));
                        }
                    }
                    break;

                case Edges.Max:
                    // kopiuje gore
                    for (j = 0; j < size; j++)
                    {
                        for (i = size; i < x_max; i++)
                        {
                            tmp.SetPixel(i, j, Color.White);
                        }
                    }

                    // kopiuje dol
                    for (j = y_max; j < tmp.Height; j++)
                    {
                        for (i = size; i < x_max; i++)
                        {
                            tmp.SetPixel(i, j, Color.White);
                        }
                    }

                    // kopiuje lewa
                    for (j = 0; j < size; j++)
                    {
                        for (i = 0; i < tmp.Height; i++)
                        {
                            tmp.SetPixel(j, i, Color.White);
                        }
                    }

                    // kopiuje prawa
                    for (j = tmp.Width - size; j < tmp.Width; j++)
                    {
                        for (i = 0; i < tmp.Height; i++)
                        {
                            tmp.SetPixel(j, i, Color.White);
                        }
                    }
                    break;

                case Edges.Min:
                    // kopiuje gore
                    for (j = 0; j < size; j++)
                    {
                        for (i = size; i < x_max; i++)
                        {
                            tmp.SetPixel(i, j, Color.Black);
                        }
                    }

                    // kopiuje dol
                    for (j = y_max; j < tmp.Height; j++)
                    {
                        for (i = size; i < x_max; i++)
                        {
                            tmp.SetPixel(i, j, Color.Black);
                        }
                    }

                    // kopiuje lewa
                    for (j = 0; j < size; j++)
                    {
                        for (i = 0; i < tmp.Height; i++)
                        {
                            tmp.SetPixel(j, i, Color.Black);
                        }
                    }

                    // kopiuje prawa
                    for (j = tmp.Width - size; j < tmp.Width; j++)
                    {
                        for (i = 0; i < tmp.Height; i++)
                        {
                            tmp.SetPixel(j, i, Color.Black);
                        }
                    }
                    break;

                case Edges.Same:
                    // kopiuje gore
                    for (j = 0; j < size; j++)
                    {
                        for (i = size; i < x_max; i++)
                        {
                            tmp.SetPixel(i, j, oryginal.GetPixel(i, j));
                        }
                    }

                    // kopiuje dol
                    for (j = y_max; j < tmp.Height; j++)
                    {
                        for (i = size; i < x_max; i++)
                        {
                            tmp.SetPixel(i, j, oryginal.GetPixel(i, j));
                        }
                    }

                    // kopiuje lewa
                    for (j = 0; j < size; j++)
                    {
                        for (i = 0; i < tmp.Height; i++)
                        {
                            tmp.SetPixel(j, i, oryginal.GetPixel(j, i));
                        }
                    }

                    // kopiuje prawa
                    for (j = tmp.Width - size; j < tmp.Width; j++)
                    {
                        for (i = 0; i < tmp.Height; i++)
                        {
                            tmp.SetPixel(j, i, oryginal.GetPixel(j, i));
                        }
                    }
                    break;
            }
        }
    }

    class FLinear : Skalowanie, IMatrix
    {
        #region IMatrix Members

        public Bitmap execute(Bitmap b, short[,] matrix, int divisor, Edges edge, int size, Methods method)
        {
            tmp = (Bitmap)b.Clone();

            if (divisor == 0)
                divisor = 1;

            int begin = size;
            int x_max = tmp.Width - size;
            int y_max = tmp.Height - size;

            int maxwart = -10000;
            int minwart = 10000;

            int x, y;
            double c = 0.0;
            int col;

            int pp, qq;
            pp = -1 * size;
            qq = size + 1;

            int[,] obraz = new int[b.Width, b.Height];

            int i, j;
            for (x = begin; x < x_max; x++)
            {
                for (y = begin; y < y_max; y++)
                {
                    c = 0.0;
                    // pobieram otoczenie

                    for (i = pp; i < qq; i++)
                    {
                        for (j = pp; j < qq; j++)
                        {
                            col = b.GetPixel(x + i, y + j).R;
                            c += matrix[3 + i, 3 + j] * col;
                        }
                    }


                    obraz[x, y] = Convert.ToInt32(c / divisor);
                    if (obraz[x, y] > maxwart) maxwart = obraz[x, y];
                    if (obraz[x, y] < minwart) minwart = obraz[x, y];
                }
            }

                    //            if (col < 0)
                    //    col = 0;
                    //if (col > 255)
                    //    col = 255;
                    //tmp.SetPixel(x, y, Color.FromArgb(col, col, col));

            switch (method)
            {
                case Methods.Method1:
                    for (x = 0; x < tmp.Width; x++)
                        for (y = 0; y < tmp.Height; y++)
                            obraz[x, y] = Convert.ToInt32(255 * ( (double) (obraz[x,y] - minwart) / (maxwart - minwart) ));
                    break;

                case Methods.Method2:
                    for (x = 0; x < tmp.Width; x++)
                        for (y = 0; y < tmp.Height; y++)
                        {
                            if (obraz[x, y] < 0)
                                obraz[x, y] = 0;
                            else if (obraz[x, y] > 0)
                                obraz[x, y] = 255;
                            else
                                obraz[x, y] = 127;
                        }
                    break;

                case Methods.Method3:
                case Methods.DontCare:
                    for (x = 0; x < tmp.Width; x++)
                        for (y = 0; y < tmp.Height; y++)
                        {
                            if (obraz[x, y] < 0)
                                obraz[x, y] = 0;
                            else if (obraz[x, y] > 255)
                                obraz[x, y] = 255;
                        }
                    break;
            }

            for (x = begin; x < x_max; x++)
            {
                for (y = begin; y < y_max; y++)
                {
                    col = obraz[x, y];
                    tmp.SetPixel(x, y, Color.FromArgb(col, col, col));
                }
            }

            Fill(edge, size, b);

            return tmp;
        }

        #endregion
    }

    class FLogic : Skalowanie, IMatrix
    {
        #region IMatrix Members

        public Bitmap execute(Bitmap b, short[,] matrix, int divisor, Edges edge, int size, Methods method)
        {
            tmp = (Bitmap)b.Clone();
            int x, y, y_max = tmp.Height - 1, x_max = tmp.Width - 1;
            int c;
            for (x = 1; x < x_max; x++)
            {
                for (y = 1; y < y_max; y++)
                {
                    if ((c = tmp.GetPixel(x, y - 1).R) == tmp.GetPixel(x, y + 1).R)
                        tmp.SetPixel(x, y, Color.FromArgb(c, c, c));
                    else if ((c = tmp.GetPixel(x - 1, y).R) == tmp.GetPixel(x + 1, y).R)
                        tmp.SetPixel(x, y, Color.FromArgb(c, c, c));
                    else
                    {
                        c = tmp.GetPixel(x - 1, y).R;
                        if (c == tmp.GetPixel(x + 1, y).R && c == tmp.GetPixel(x, y + 1).R && c == tmp.GetPixel(x, y - 1).R)
                            tmp.SetPixel(x, y, Color.FromArgb(c, c, c));
                    }

                }
            }

            Fill(edge, 1, b);

            return tmp;
        }

        #endregion
    }

    class FMedian : Skalowanie, IMatrix
    {

        #region IMatrix Members

        public Bitmap execute(Bitmap b, short[,] matrix, int divisor, Edges edge, int size, Methods method)
        {
            short[,] m = {
                                 {0,0,0,0,0,0,0},
                                 {0,0,0,0,0,0,0},
                                 {0,0,1,1,1,0,0},
                                 {0,0,1,1,1,0,0},
                                 {0,0,1,1,1,0,0},
                                 {0,0,0,0,0,0,0},
                                 {0,0,0,0,0,0,0}
                             };
            FLinear fl = new FLinear();
            return fl.execute(b, m, 9, edge, 1, method);
        }

        #endregion
    }

    class FGrad : Skalowanie, IMatrix
    {
        private bool pixelIsValid(Size size, int x, int y)
        {
            if (x >= size.Width || x < 0) return false;
            if (y >= size.Height || y < 0) return false;
            return true;
        }

        #region IMatrix Members

        public Bitmap execute(Bitmap b, short[,] matrix, int divisor, Edges edge, int size, Methods method)
        {
            tmp = new Bitmap(b.Width, b.Height);
            int mask_size = 1;
            int suma = 1;
            int[,] maskaX = new int[3, 3] { { -1, 0, 1 }, { -2, 0, 2 }, { -1, 0, 1 } };
            int[,] maskaY = new int[3, 3] { { -1, -2, -1 }, { 0, 0, 0 }, { 1, 2, 1 } };
            float wynik = 0;
            int maxwart = -10000;
            int minwart = 10000;

            int[,] obraz = new int[b.Width, b.Height];
            int color;
            for (int x = 0; x < tmp.Width; x++)
            {
                for (int y = 0; y < tmp.Height; y++)
                {
                    int Gx = 0;
                    int Gy = 0;
                    float punkty = 0;
                    for (int i = -mask_size; i < mask_size + 1; i++)
                    {
                        for (int j = -mask_size; j < mask_size + 1; j++)
                        {
                            if (pixelIsValid(tmp.Size, x + i, y + j))
                            {
                                color = b.GetPixel(x+i, y+j).R;
                                Gx += maskaX[mask_size + i, mask_size + j] * color;
                                Gy += maskaY[mask_size + i, mask_size + j] * color;
                            }
                            else goto nastepny;
                        }
                    }

                    punkty = (float)Math.Sqrt(Math.Pow(Gx, 2) + Math.Pow(Gy, 2));
                    wynik = punkty / (float)suma;
                    if (wynik > maxwart) maxwart = (int)wynik;
                    if (wynik < minwart) minwart = (int)wynik;
                    obraz[x, y] = (int)wynik;

                nastepny: ;
                }
            }

            switch (method)
            {
                case Methods.Method1:
                    for (int x = 0; x < tmp.Width; x++)
                        for (int y = 0; y < tmp.Height; y++)
                            obraz[x, y] = (int)(((255) * (obraz[x, y] - minwart)) / ((float)maxwart - (float)minwart));
                    break;

                case Methods.Method2:
                    for (int x = 0; x < tmp.Width; x++)
                        for (int y = 0; y < tmp.Height; y++)
                        {
                            if (obraz[x, y] < 0)
                                obraz[x, y] = 0;
                            else if (obraz[x, y] > 0)
                                obraz[x, y] = 255;
                            else
                                obraz[x, y] = 127;
                        }
                    break;

                case Methods.Method3:
                    for (int x = 0; x < tmp.Width; x++)
                        for (int y = 0; y < tmp.Height; y++)
                        {
                            if (obraz[x, y] < 0)
                                obraz[x, y] = 0;
                            else if (obraz[x, y] > 255)
                                obraz[x, y] = 255;
                        }
                    break;
            }

            for (int x = 1; x < tmp.Width - 1; x++)
                for (int y = 1; y < tmp.Height - 1; y++)
                {
                    color = (byte)Math.Min(obraz[x, y], 255);
                    tmp.SetPixel(x, y, Color.FromArgb(color, color, color));
                }

            Fill(edge, 1, tmp);
            return tmp;
        }

        #endregion
    }
}
