﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Drawing;

namespace APO_BB_DK_v012013
{
    static class functions
    {
        private static int safety_check(int val)
        {
            if (val > 255)
                return 255;
            else if (val < 0)
                return 0;
            return val;
        }
        private static double safety_check_hsv(double val)
        {
            if (val > 1)
                return 1;
            else if (val < 0)
                return 0;
            return val;
        }
        public static Bitmap regulacja_jasnoscia(Bitmap src, int val)
        {
            
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(src);
            fobrazek_bitmapa.LockImage();
            
            for (int x = 0; x < src.Width; x++)
            {
                for (int y = 0; y < src.Height; y++)
                {
                    int red = safety_check(fobrazek_bitmapa.GetPixel(x, y).R + val);
                    int green = safety_check(fobrazek_bitmapa.GetPixel(x, y).G + val);
                    int blue = safety_check(fobrazek_bitmapa.GetPixel(x, y).B + val);

                    fobrazek_bitmapa.SetPixel(x, y, Color.FromArgb(red, green, blue));

                }
            }
            fobrazek_bitmapa.UnlockImage();
            return src;
        }
        public static Bitmap regulacja_jasnoscia_hsv(Bitmap src, int val)
        {

            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(src);
            fobrazek_bitmapa.LockImage();

            for (int x = 0; x < src.Width; x++)
            {
                for (int y = 0; y < src.Height; y++)
                {
                    double h, s, v;
                    hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y), out h, out s, out v);
                    v = v + ((double)val / 255);
                    if (v < 0) v = 0.0f;
                    if (v > 1) v = 1.0f;
                    fobrazek_bitmapa.SetPixel(x, y, hsv.ColorFromHSV(h,s,v));

                }
            }
            fobrazek_bitmapa.UnlockImage();
            return src;
        }
        public static Bitmap regulacja_kontrastem(Bitmap src, int val)
        {
            double multi = (100 + val) / 100;
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(src);
            fobrazek_bitmapa.LockImage();

            for (int x = 0; x < src.Width; x++)
            {
                for (int y = 0; y < src.Height; y++)
                {
                    double tmp = (fobrazek_bitmapa.GetPixel(x, y).R / 255) - 0.5;
                    tmp = tmp * multi + 0.5;
                    
                    //fobrazek_bitmapa.SetPixel(x, y, Color.FromArgb(tmp,tmp,tmp));

                }
            }
            fobrazek_bitmapa.UnlockImage();
            return src;
        }
        public static Bitmap lut(Bitmap src, int[] vals)
        {
            if (vals == null)
                return src;
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(src);
            fobrazek_bitmapa.LockImage();

            for (int x = 0; x < src.Width; x++)
            {
                for (int y = 0; y < src.Height; y++)
                {

                    fobrazek_bitmapa.SetPixel(x, y, Color.FromArgb(vals[fobrazek_bitmapa.GetPixel(x, y).R], vals[fobrazek_bitmapa.GetPixel(x, y).G], vals[fobrazek_bitmapa.GetPixel(x, y).B]));
                }
            }
            fobrazek_bitmapa.UnlockImage();
            return src;
        }
        public static Bitmap filtracja_liniowa(Bitmap src, int[] vals, int dzielnik,int metoda)
        {
            if (vals == null)
                return src;
            if(vals.Length!=9)
                return src;

            Bitmap result = new Bitmap(src);
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(src);
            BitmapProcessing.FastBitmap fresult = new BitmapProcessing.FastBitmap(result);
            fobrazek_bitmapa.LockImage();
            fresult.LockImage();
            int sum_vals = dzielnik;
            
            if (sum_vals == 0)
                sum_vals = 1;

            if (metoda == 1)
            {
                int rmax = 0, gmax = 0, bmax = 0,rmin=0,gmin=0,bmin=0;
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {
                        //RED
                        int[] r = new int[9];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            r[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).R;
                        if (y > 0)
                            r[1] = fobrazek_bitmapa.GetPixel(x, y - 1).R;
                        if (y > 0 && x < src.Width - 1)
                            r[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).R;
                        if (x > 0)
                            r[3] = fobrazek_bitmapa.GetPixel(x - 1, y).R;
                        r[4] = fobrazek_bitmapa.GetPixel(x, y).R;
                        if (x < src.Width - 1)
                            r[5] = fobrazek_bitmapa.GetPixel(x + 1, y).R;
                        if (x > 0 && y < src.Height - 1)
                            r[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).R;
                        if (y < src.Height - 1)
                            r[7] = fobrazek_bitmapa.GetPixel(x, y + 1).R;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            r[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).R;
                        int red = 0;
                        for (int z = 0; z < 9; z++)
                        {
                            red = red + vals[z] * r[z];
                        }
                        red = red / sum_vals;
                        if (red > rmax) rmax = red;
                        if (red < rmin) rmin = red;
                        //GREEN
                        int[] g = new int[9];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            g[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).G;
                        if (y > 0)
                            g[1] = fobrazek_bitmapa.GetPixel(x, y - 1).G;
                        if (y > 0 && x < src.Width - 1)
                            g[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).G;
                        if (x > 0)
                            g[3] = fobrazek_bitmapa.GetPixel(x - 1, y).G;
                        g[4] = fobrazek_bitmapa.GetPixel(x, y).G;
                        if (x < src.Width - 1)
                            g[5] = fobrazek_bitmapa.GetPixel(x + 1, y).G;
                        if (x > 0 && y < src.Height - 1)
                            g[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).G;
                        if (y < src.Height - 1)
                            g[7] = fobrazek_bitmapa.GetPixel(x, y + 1).G;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            g[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).G;
                        int green = 0;
                        for (int z = 0; z < 9; z++)
                        {
                            green = green + vals[z] * g[z];
                        }
                        green = green / sum_vals;
                        if (green > gmax) gmax = green;
                        if (green < gmin) gmin = green;
                        //BLUE
                        int[] b = new int[9];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            b[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).B;
                        if (y > 0)
                            b[1] = fobrazek_bitmapa.GetPixel(x, y - 1).B;
                        if (y > 0 && x < src.Width - 1)
                            b[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).B;
                        if (x > 0)
                            b[3] = fobrazek_bitmapa.GetPixel(x - 1, y).B;
                        b[4] = fobrazek_bitmapa.GetPixel(x, y).B;
                        if (x < src.Width - 1)
                            b[5] = fobrazek_bitmapa.GetPixel(x + 1, y).B;
                        if (x > 0 && y < src.Height - 1)
                            b[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).B;
                        if (y < src.Height - 1)
                            b[7] = fobrazek_bitmapa.GetPixel(x, y + 1).B;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            b[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).B;
                        int blue = 0;
                        for (int z = 0; z < 9; z++)
                        {
                            blue = blue + vals[z] * b[z];
                        }
                        blue = blue / sum_vals;
                        if (blue > bmax) bmax = blue;
                        if (blue < bmin) bmin = blue;
                    }
                }
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {
                        //RED
                        int[] r = new int[9];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            r[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).R;
                        if (y > 0)
                            r[1] = fobrazek_bitmapa.GetPixel(x, y - 1).R;
                        if (y > 0 && x < src.Width - 1)
                            r[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).R;
                        if (x > 0)
                            r[3] = fobrazek_bitmapa.GetPixel(x - 1, y).R;
                        r[4] = fobrazek_bitmapa.GetPixel(x, y).R;
                        if (x < src.Width - 1)
                            r[5] = fobrazek_bitmapa.GetPixel(x + 1, y).R;
                        if (x > 0 && y < src.Height - 1)
                            r[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).R;
                        if (y < src.Height - 1)
                            r[7] = fobrazek_bitmapa.GetPixel(x, y + 1).R;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            r[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).R;
                        int red = 0;
                        for (int z = 0; z < 9; z++)
                        {
                            red = red + vals[z] * r[z];
                        }
                        red = red / sum_vals;
                        red = (int) ((((double)red - (double)rmin) / ((double)rmax - (double)rmin)) * 256);
                        //GREEN
                        int[] g = new int[9];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            g[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).G;
                        if (y > 0)
                            g[1] = fobrazek_bitmapa.GetPixel(x, y - 1).G;
                        if (y > 0 && x < src.Width - 1)
                            g[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).G;
                        if (x > 0)
                            g[3] = fobrazek_bitmapa.GetPixel(x - 1, y).G;
                        g[4] = fobrazek_bitmapa.GetPixel(x, y).G;
                        if (x < src.Width - 1)
                            g[5] = fobrazek_bitmapa.GetPixel(x + 1, y).G;
                        if (x > 0 && y < src.Height - 1)
                            g[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).G;
                        if (y < src.Height - 1)
                            g[7] = fobrazek_bitmapa.GetPixel(x, y + 1).G;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            g[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).G;
                        int green = 0;
                        for (int z = 0; z < 9; z++)
                        {
                            green = green + vals[z] * g[z];
                        }
                        green = green / sum_vals;
                        green = (int)((((double)green - (double)gmin) / ((double)gmax - (double)gmin)) * 256);
                        //BLUE
                        int[] b = new int[9];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            b[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).B;
                        if (y > 0)
                            b[1] = fobrazek_bitmapa.GetPixel(x, y - 1).B;
                        if (y > 0 && x < src.Width - 1)
                            b[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).B;
                        if (x > 0)
                            b[3] = fobrazek_bitmapa.GetPixel(x - 1, y).B;
                        b[4] = fobrazek_bitmapa.GetPixel(x, y).B;
                        if (x < src.Width - 1)
                            b[5] = fobrazek_bitmapa.GetPixel(x + 1, y).B;
                        if (x > 0 && y < src.Height - 1)
                            b[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).B;
                        if (y < src.Height - 1)
                            b[7] = fobrazek_bitmapa.GetPixel(x, y + 1).B;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            b[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).B;
                        int blue = 0;
                        for (int z = 0; z < 9; z++)
                        {
                            blue = blue + vals[z] * b[z];
                        }
                        blue = blue / sum_vals;
                        blue=(int)((((double)blue - (double)bmin) / ((double)bmax - (double)bmin)) * 256);
                        fresult.SetPixel(x, y, Color.FromArgb(safety_check(red), safety_check(green), safety_check(blue)));
                    }
                }
            }
            else {
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {
                        //RED
                        int[] r = new int[9];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            r[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).R;
                        if (y > 0)
                            r[1] = fobrazek_bitmapa.GetPixel(x, y - 1).R;
                        if (y > 0 && x < src.Width - 1)
                            r[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).R;
                        if (x > 0)
                            r[3] = fobrazek_bitmapa.GetPixel(x - 1, y).R;
                        r[4] = fobrazek_bitmapa.GetPixel(x, y).R;
                        if (x < src.Width - 1)
                            r[5] = fobrazek_bitmapa.GetPixel(x + 1, y).R;
                        if (x > 0 && y < src.Height - 1)
                            r[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).R;
                        if (y < src.Height - 1)
                            r[7] = fobrazek_bitmapa.GetPixel(x, y + 1).R;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            r[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).R;
                        int red = 0;
                        for (int z = 0; z < 9; z++)
                        {
                            red = red + vals[z] * r[z];
                        }
                        red = red / sum_vals;
                        //GREEN
                        int[] g = new int[9];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            g[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).G;
                        if (y > 0)
                            g[1] = fobrazek_bitmapa.GetPixel(x, y - 1).G;
                        if (y > 0 && x < src.Width - 1)
                            g[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).G;
                        if (x > 0)
                            g[3] = fobrazek_bitmapa.GetPixel(x - 1, y).G;
                        g[4] = fobrazek_bitmapa.GetPixel(x, y).G;
                        if (x < src.Width - 1)
                            g[5] = fobrazek_bitmapa.GetPixel(x + 1, y).G;
                        if (x > 0 && y < src.Height - 1)
                            g[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).G;
                        if (y < src.Height - 1)
                            g[7] = fobrazek_bitmapa.GetPixel(x, y + 1).G;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            g[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).G;
                        int green = 0;
                        for (int z = 0; z < 9; z++)
                        {
                            green = green + vals[z] * g[z];
                        }
                        green = green / sum_vals;
                        //BLUE
                        int[] b = new int[9];
                        for (int z = 0; z < r.Length; z++) { r[z] = 0; }
                        if (x > 0 && y > 0)
                            b[0] = fobrazek_bitmapa.GetPixel(x - 1, y - 1).B;
                        if (y > 0)
                            b[1] = fobrazek_bitmapa.GetPixel(x, y - 1).B;
                        if (y > 0 && x < src.Width - 1)
                            b[2] = fobrazek_bitmapa.GetPixel(x + 1, y - 1).B;
                        if (x > 0)
                            b[3] = fobrazek_bitmapa.GetPixel(x - 1, y).B;
                        b[4] = fobrazek_bitmapa.GetPixel(x, y).B;
                        if (x < src.Width - 1)
                            b[5] = fobrazek_bitmapa.GetPixel(x + 1, y).B;
                        if (x > 0 && y < src.Height - 1)
                            b[6] = fobrazek_bitmapa.GetPixel(x - 1, y + 1).B;
                        if (y < src.Height - 1)
                            b[7] = fobrazek_bitmapa.GetPixel(x, y + 1).B;
                        if (y < src.Height - 1 && x < src.Width - 1)
                            b[8] = fobrazek_bitmapa.GetPixel(x + 1, y + 1).B;
                        int blue = 0;
                        for (int z = 0; z < 9; z++)
                        {
                            blue = blue + vals[z] * b[z];
                        }
                        blue = blue / sum_vals;
                        if (metoda == 2)
                        {
                            if (red > 0)
                            {
                                red = 255;
                            }
                            else if (red < 0)
                            {
                                red = 0;
                            }
                            else
                            {
                                red = 127;
                            }
                            if (green > 0)
                            {
                                green = 255;
                            }
                            else if (green < 0)
                            {
                                green = 0;
                            }
                            else
                            {
                                green = 127;
                            }
                            if (blue > 0)
                            {
                                blue = 255;
                            }
                            else if (blue < 0)
                            {
                                blue = 0;
                            }
                            else
                            {
                                blue = 127;
                            }

                        }
                        
                        fresult.SetPixel(x, y, Color.FromArgb(safety_check(red), safety_check(green), safety_check(blue)));
                    }
                }
            }
            fresult.UnlockImage();
            fobrazek_bitmapa.UnlockImage();
            return result;
        }
        public static Bitmap filtracja_liniowa_hsv(Bitmap src, int[] vals, int dzielnik, int metoda)
        {
            if (vals == null)
                return src;
            if (vals.Length != 9)
                return src;

            Bitmap result = new Bitmap(src);
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(src);
            BitmapProcessing.FastBitmap fresult = new BitmapProcessing.FastBitmap(result);
            fobrazek_bitmapa.LockImage();
            fresult.LockImage();
            int sum_vals = dzielnik;

            if (sum_vals == 0)
                sum_vals = 1;
            #region metoda1
            if (metoda == 1)
            {
                double vmax = 0, vmin = 0;
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {
                        double []  h = new double [9];
                        double [] s = new double[9];
                        double [] v = new double[9];
                        
                        for (int z = 0; z < v.Length; z++) { v[z] = 0; }
                        if (x > 0 && y > 0)
                        {
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x-1, y-1), out h[0], out s[0], out v[0]);
                        }
                        if (y > 0)
                        {
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y-1), out h[1], out s[1], out v[1]);
                        }
                        if (y > 0 && x < src.Width - 1)
                        {
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x+1, y-1), out h[2], out s[2], out v[2]);
                        }
                        if (x > 0)
                        {
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x-1, y), out h[3], out s[3], out v[3]);
                        }
                        hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y), out h[4], out s[4], out v[4]);
                        if (x < src.Width - 1)
                        {
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x+1, y), out h[5], out s[5], out v[5]);
                        }
                        if (x > 0 && y < src.Height - 1)
                        {
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x-1, y+1), out h[6], out s[6], out v[6]);
                        }
                        if (y < src.Height - 1)
                        {
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y+1), out h[7], out s[7], out v[7]);
                        }
                        if (y < src.Height - 1 && x < src.Width - 1)
                        {
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x+1, y+1), out h[8], out s[8], out v[8]);
                        }
                        double val = 0;
                        for (int z = 0; z < 9; z++)
                        {
                            val = val +((double) vals[z]) * v[z];
                        }
                        val = val / sum_vals;
                        if (val > vmax) vmax = val;
                        if (val < vmin) vmin = val;
                      
                    }
                }
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {
                        double[] h = new double[9];
                        double[] s = new double[9];
                        double[] v = new double[9];

                        for (int z = 0; z < v.Length; z++) { v[z] = 0; }
                        if (x > 0 && y > 0)
                        {
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x - 1, y - 1), out h[0], out s[0], out v[0]);
                        }
                        if (y > 0)
                        {
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y - 1), out h[1], out s[1], out v[1]);
                        }
                        if (y > 0 && x < src.Width - 1)
                        {
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x + 1, y - 1), out h[2], out s[2], out v[2]);
                        }
                        if (x > 0)
                        {
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x - 1, y), out h[3], out s[3], out v[3]);
                        }
                        hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y), out h[4], out s[4], out v[4]);
                        if (x < src.Width - 1)
                        {
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x + 1, y), out h[5], out s[5], out v[5]);
                        }
                        if (x > 0 && y < src.Height - 1)
                        {
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x - 1, y + 1), out h[6], out s[6], out v[6]);
                        }
                        if (y < src.Height - 1)
                        {
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y + 1), out h[7], out s[7], out v[7]);
                        }
                        if (y < src.Height - 1 && x < src.Width - 1)
                        {
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x + 1, y + 1), out h[8], out s[8], out v[8]);
                        }
                        double val = 0;
                        for (int z = 0; z < 9; z++)
                        {
                            val = val + ((double)vals[z]) * v[z];
                        }
                        val = val / sum_vals;
                        
                        val = ((((double)val - (double)vmin) / ((double)vmax - (double)vmin)));

                        fresult.SetPixel(x, y, hsv.ColorFromHSV(h[4],s[4],safety_check_hsv(val)));
                    }
                }
            }
            #endregion
            else
            {
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {
                        double[] h = new double[9];
                        double[] s = new double[9];
                        double[] v = new double[9];

                        for (int z = 0; z < v.Length; z++) { v[z] = 0; }
                        if (x > 0 && y > 0)
                        {
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x - 1, y - 1), out h[0], out s[0], out v[0]);
                        }
                        if (y > 0)
                        {
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y - 1), out h[1], out s[1], out v[1]);
                        }
                        if (y > 0 && x < src.Width - 1)
                        {
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x + 1, y - 1), out h[2], out s[2], out v[2]);
                        }
                        if (x > 0)
                        {
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x - 1, y), out h[3], out s[3], out v[3]);
                        }
                        hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y), out h[4], out s[4], out v[4]);
                        if (x < src.Width - 1)
                        {
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x + 1, y), out h[5], out s[5], out v[5]);
                        }
                        if (x > 0 && y < src.Height - 1)
                        {
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x - 1, y + 1), out h[6], out s[6], out v[6]);
                        }
                        if (y < src.Height - 1)
                        {
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y + 1), out h[7], out s[7], out v[7]);
                        }
                        if (y < src.Height - 1 && x < src.Width - 1)
                        {
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x + 1, y + 1), out h[8], out s[8], out v[8]);
                        }
                        double val = 0;
                        for (int z = 0; z < 9; z++)
                        {
                            val = val + ((double)vals[z]) * v[z];
                        }
                        val = val / sum_vals;
                        
                        
                        if (metoda == 2)
                        {
                            if (val > 0)
                            {
                                val = 1;
                            }
                            else if (val < 0)
                            {
                                val = 0;
                            }
                            else
                            {
                                val = 0.5f;
                            }
                            

                        }

                        fresult.SetPixel(x, y, hsv.ColorFromHSV(h[4],s[4],safety_check_hsv(val)));
                    }
                }
            }
            fresult.UnlockImage();
            fobrazek_bitmapa.UnlockImage();
            return result;
        }
        public static Bitmap dodawanie(Bitmap A, Bitmap B)
        {
            int min_width = Math.Min(A.Width, B.Width);
            int min_height = Math.Min(A.Height, B.Height);

            Bitmap C = new Bitmap(min_width, min_height);
            BitmapProcessing.FastBitmap fa = new BitmapProcessing.FastBitmap(A);
            BitmapProcessing.FastBitmap fb = new BitmapProcessing.FastBitmap(B);
            BitmapProcessing.FastBitmap fc = new BitmapProcessing.FastBitmap(C);
            fa.LockImage();
            fb.LockImage();
            fc.LockImage();

            for (int x = 0; x < C.Width; x++)
            {
                for (int y = 0; y < C.Height; y++)
                {
                    int red = safety_check((fa.GetPixel(x, y).R + fb.GetPixel(x, y).R));
                    int green = safety_check((fa.GetPixel(x, y).G + fb.GetPixel(x, y).G));
                    int blue = safety_check((fa.GetPixel(x, y).B + fb.GetPixel(x, y).B));
                    fc.SetPixel(x, y, Color.FromArgb(red, green, blue));
                }
            }

            fa.UnlockImage();
            fb.UnlockImage();
            fc.UnlockImage();
            return C;
        }
        public static Bitmap odejmowanie(Bitmap A, Bitmap B)
        {
            int min_width = Math.Min(A.Width, B.Width);
            int min_height = Math.Min(A.Height, B.Height);

            Bitmap C = new Bitmap(min_width, min_height);
            BitmapProcessing.FastBitmap fa = new BitmapProcessing.FastBitmap(A);
            BitmapProcessing.FastBitmap fb = new BitmapProcessing.FastBitmap(B);
            BitmapProcessing.FastBitmap fc = new BitmapProcessing.FastBitmap(C);
            fa.LockImage();
            fb.LockImage();
            fc.LockImage();

            for (int x = 0; x < C.Width; x++)
            {
                for (int y = 0; y < C.Height; y++)
                {
                    int red = safety_check((fa.GetPixel(x, y).R - fb.GetPixel(x, y).R));
                    int green = safety_check((fa.GetPixel(x, y).G - fb.GetPixel(x, y).G));
                    int blue = safety_check((fa.GetPixel(x, y).B - fb.GetPixel(x, y).B));
                    fc.SetPixel(x, y, Color.FromArgb(red, green, blue));
                }
            }

            fa.UnlockImage();
            fb.UnlockImage();
            fc.UnlockImage();
            return C;
        }
        public static Bitmap xor(Bitmap A, Bitmap B)
        {
            int min_width = Math.Min(A.Width, B.Width);
            int min_height = Math.Min(A.Height, B.Height);

            Bitmap C = new Bitmap(min_width, min_height);
            BitmapProcessing.FastBitmap fa = new BitmapProcessing.FastBitmap(A);
            BitmapProcessing.FastBitmap fb = new BitmapProcessing.FastBitmap(B);
            BitmapProcessing.FastBitmap fc = new BitmapProcessing.FastBitmap(C);
            fa.LockImage();
            fb.LockImage();
            fc.LockImage();

            for (int x = 0; x < C.Width; x++)
            {
                for (int y = 0; y < C.Height; y++)
                {
                    int red = safety_check((fa.GetPixel(x, y).R ^ fb.GetPixel(x, y).R));
                    int green = safety_check((fa.GetPixel(x, y).G ^ fb.GetPixel(x, y).G));
                    int blue = safety_check((fa.GetPixel(x, y).B ^ fb.GetPixel(x, y).B));
                    fc.SetPixel(x, y, Color.FromArgb(red, green, blue));
                }
            }

            fa.UnlockImage();
            fb.UnlockImage();
            fc.UnlockImage();
            return C;
        }
        public static Bitmap or(Bitmap A, Bitmap B)
        {
            int min_width = Math.Min(A.Width, B.Width);
            int min_height = Math.Min(A.Height, B.Height);

            Bitmap C = new Bitmap(min_width, min_height);
            BitmapProcessing.FastBitmap fa = new BitmapProcessing.FastBitmap(A);
            BitmapProcessing.FastBitmap fb = new BitmapProcessing.FastBitmap(B);
            BitmapProcessing.FastBitmap fc = new BitmapProcessing.FastBitmap(C);
            fa.LockImage();
            fb.LockImage();
            fc.LockImage();

            for (int x = 0; x < C.Width; x++)
            {
                for (int y = 0; y < C.Height; y++)
                {
                    int red = safety_check((fa.GetPixel(x, y).R | fb.GetPixel(x, y).R));
                    int green = safety_check((fa.GetPixel(x, y).G | fb.GetPixel(x, y).G));
                    int blue = safety_check((fa.GetPixel(x, y).B | fb.GetPixel(x, y).B));
                    fc.SetPixel(x, y, Color.FromArgb(red, green, blue));
                }
            }

            fa.UnlockImage();
            fb.UnlockImage();
            fc.UnlockImage();
            return C;
        }
        public static Bitmap and(Bitmap A, Bitmap B)
        {
            int min_width = Math.Min(A.Width, B.Width);
            int min_height = Math.Min(A.Height, B.Height);

            Bitmap C = new Bitmap(min_width, min_height);
            BitmapProcessing.FastBitmap fa = new BitmapProcessing.FastBitmap(A);
            BitmapProcessing.FastBitmap fb = new BitmapProcessing.FastBitmap(B);
            BitmapProcessing.FastBitmap fc = new BitmapProcessing.FastBitmap(C);
            fa.LockImage();
            fb.LockImage();
            fc.LockImage();

            for (int x = 0; x < C.Width; x++)
            {
                for (int y = 0; y < C.Height; y++)
                {
                    int red = safety_check((fa.GetPixel(x, y).R & fb.GetPixel(x, y).R));
                    int green = safety_check((fa.GetPixel(x, y).G & fb.GetPixel(x, y).G));
                    int blue = safety_check((fa.GetPixel(x, y).B & fb.GetPixel(x, y).B));
                    fc.SetPixel(x, y, Color.FromArgb(red, green, blue));
                }
            }

            fa.UnlockImage();
            fb.UnlockImage();
            fc.UnlockImage();
            return C;
        }


        public static Bitmap and_hsv(Bitmap A, Bitmap B)
        {
            int min_width = Math.Min(A.Width, B.Width);
            int min_height = Math.Min(A.Height, B.Height);

            Bitmap C = new Bitmap(min_width, min_height);
            BitmapProcessing.FastBitmap fa = new BitmapProcessing.FastBitmap(A);
            BitmapProcessing.FastBitmap fb = new BitmapProcessing.FastBitmap(B);
            BitmapProcessing.FastBitmap fc = new BitmapProcessing.FastBitmap(C);
            fa.LockImage();
            fb.LockImage();
            fc.LockImage();

            for (int x = 0; x < C.Width; x++)
            {
                for (int y = 0; y < C.Height; y++)
                {
                    double h, s, v;
                    hsv.ColorToHSV(fa.GetPixel(x, y), out h, out s, out v);
                    fc.SetPixel(x, y, hsv.ColorFromHSV(h,s,v));
                }
            }

            fa.UnlockImage();
            fb.UnlockImage();
            fc.UnlockImage();
            return C;
        }

        //PROGOWANIE DLA OBRAZU HSV
        public static Bitmap progowanie_hsv(Bitmap src,double prog)
        {     
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(src);
            fobrazek_bitmapa.LockImage();

            int new_height = src.Height;
            int new_width = src.Width;
            while (new_height > 300 || new_width > 300)
            {
                new_height = (int)(new_height / 1.05f);
                new_width = (int)(new_width / 1.05f);
            }

            prog = prog / 100000.0f;

            for (int x = 0; x < src.Width; x++)
            {
                for (int y = 0; y < src.Height; y++)
                {
                    double h, s, v;
                    hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y), out h, out s, out v);

                    if (v > prog)
                    {
                        fobrazek_bitmapa.SetPixel(x, y, hsv.ColorFromHSV(h, s, 0));
                    }
                    else
                    {
                        fobrazek_bitmapa.SetPixel(x, y, hsv.ColorFromHSV(h, s, 1));
                    }
                }
            }


            fobrazek_bitmapa.UnlockImage();
            return src;
        }


        public static Bitmap RozciagnieHSV2(Bitmap src, int threshold, int threshold2)
        {
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(src);
            fobrazek_bitmapa.LockImage();

            int hI = src.Height;
            int wI = src.Width;

            for (int x = 0; x < wI; x++)
            {
                for (int y = 0; y < hI; y++)
                {
                    double h, s, v;
                    hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y), out h, out s, out v);
                    double wartosc = v;
                    if (wartosc < ((double) threshold) /255)
                    {
                        fobrazek_bitmapa.SetPixel(x, y, hsv.ColorFromHSV(h,s,0));
                    }
                    else if (wartosc > ((double)threshold2) / 255)
                    {
                        fobrazek_bitmapa.SetPixel(x, y, hsv.ColorFromHSV(h,s,1));
                    }
                    else
                    {
                        double tmp = wartosc;
                        if (threshold2 != threshold)
                        {
                            tmp =(((wartosc - ((double)threshold / 255.0f)))) / (((float)(threshold2- threshold))/255.0f);
                        }

                        fobrazek_bitmapa.SetPixel(x, y, hsv.ColorFromHSV(h,s,tmp));
                    }
                }
            }
            fobrazek_bitmapa.UnlockImage();
           return src;
        }




        public static Bitmap RedukcjaPoziomowHSV2(Bitmap src, int threshold)
        {
            double krok = 1.0f / ((double)threshold);
           // float krok = 255 / threshold;
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(src);
            fobrazek_bitmapa.LockImage();

            int hI = src.Height;
            int wI = src.Width;

            for (int x = 0; x < wI; x++)
            {
                for (int y = 0; y < hI; y++)
                {
                    double h, s, v;
                    hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y), out h, out s, out v);
                    double wartosc_piksela = v;

                    int przedzial = (int)(wartosc_piksela / krok);

                    if (przedzial == threshold || przedzial == threshold - 1)
                    {
                        fobrazek_bitmapa.SetPixel(x, y, hsv.ColorFromHSV(h,s,1.0f));
                    }
                    else if (przedzial == 0)
                    {
                        fobrazek_bitmapa.SetPixel(x, y, hsv.ColorFromHSV(h,s,0));
                    }
                    else
                    {
                        double tmp = (((float)przedzial) * krok + krok / 2);
                        if (tmp > 1) tmp = 1;
                        fobrazek_bitmapa.SetPixel(x, y, hsv.ColorFromHSV(h,s,tmp));
                    }
                }
            }
            fobrazek_bitmapa.UnlockImage();
            return src;
        }


        public static Bitmap RedukcjaPoziomowRGB2(Bitmap src, int threshold)
        {
            float krok = 255 / threshold;
 //           Bitmap obrazek_bitmapa = new Bitmap(src_thumbnail);
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(src);
            fobrazek_bitmapa.LockImage();

            int hI = src.Height;
            int wI = src.Width;

            for (int x = 0; x < wI; x++)
            {
                for (int y = 0; y < hI; y++)
                {
                    int wartosc_piksela = fobrazek_bitmapa.GetPixel(x, y).R;

                    int przedzial = (int)(wartosc_piksela / krok);

                    if (przedzial == threshold || przedzial == threshold - 1)
                    {
                        fobrazek_bitmapa.SetPixel(x, y, Color.FromArgb(255, 255, 255));
                    }
                    else if (przedzial == 0)
                    {
                        fobrazek_bitmapa.SetPixel(x, y, Color.FromArgb(0, 0, 0));
                    }
                    else
                    {
                        int tmp = (int)(((float)przedzial) * krok + krok / 2);
                        if (tmp > 255)
                        {
                            tmp = 255;
                        }
                        else if(tmp <0)
                        {
                         tmp = 0;
                        }
                        else
                        fobrazek_bitmapa.SetPixel(x, y, Color.FromArgb(tmp, tmp, tmp));
                    }
                }
            }
            fobrazek_bitmapa.UnlockImage();
            return src;
        }




                
        public static Bitmap filtracja_medianowa(Bitmap src, int w, int h)
        {
            if (w < 3) w = 3;
            if (h < 3) h = 3;
            if (h % 2 == 0) h = 3;
            if (w % 2 == 0) w = 3;
            int[] sasiadujace = new int[w * h];
            Bitmap result = new Bitmap(src);
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(src);
            BitmapProcessing.FastBitmap fresult = new BitmapProcessing.FastBitmap(result);
            fobrazek_bitmapa.LockImage();
            fresult.LockImage();
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {
                        int i = 0;
                        for (int x1 = -w / 2; x1 <= w/2; x1++)
                        {
                            for (int y1 = -h / 2; y1 <= h / 2; y1++)
                            {
                                if (x+x1 >= 0 && y+y1 >= 0 && x+x1 < src.Width && y+y1 < src.Height)
                                {
                                    sasiadujace[i++] = fobrazek_bitmapa.GetPixel(x+x1, y+y1).R;
                                }
                            }
                        }
                        Array.Sort(sasiadujace,0,i);
                        if (i % 2 == 1)
                        {
                            fresult.SetPixel(x,y,Color.FromArgb(sasiadujace[i/2],sasiadujace[i/2],sasiadujace[i/2]));
                        }
                        else
                        {
                            int val = (sasiadujace[i/2]+sasiadujace[i/2+1])/2;
                            fresult.SetPixel(x,y,Color.FromArgb(val,val,val));
                        }
                    }
                }
            
            fresult.UnlockImage();
            fobrazek_bitmapa.UnlockImage();
            return result;
        }
        public static Bitmap filtracja_medianowa_hsv(Bitmap src, int w, int h)
        {
            if (w < 3) w = 3;
            if (h < 3) h = 3;
            if (h % 2 == 0) h = 3;
            if (w % 2 == 0) w = 3;
            double[] sasiadujace = new double[w * h];
            Bitmap result = new Bitmap(src);
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(src);
            BitmapProcessing.FastBitmap fresult = new BitmapProcessing.FastBitmap(result);
            fobrazek_bitmapa.LockImage();
            fresult.LockImage();
            for (int x = 0; x < src.Width; x++)
            {
                for (int y = 0; y < src.Height; y++)
                {
                    int i = 0;
                    double hue, sat, v;
                    for (int x1 = -w / 2; x1 <= w / 2; x1++)
                    {
                        for (int y1 = -h / 2; y1 <= h / 2; y1++)
                        {
                            if (x + x1 >= 0 && y + y1 >= 0 && x + x1 < src.Width && y + y1 < src.Height)
                            { 
                                hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x+x1, y+y1), out hue, out sat, out v);
                                sasiadujace[i++] = v;
                            }
                        }
                    }
                    Array.Sort(sasiadujace, 0, i);
                    hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y), out hue, out sat, out v);
                    if (i % 2 == 1)
                    {
                        fresult.SetPixel(x, y, hsv.ColorFromHSV(hue,sat, safety_check_hsv(sasiadujace[i / 2])));
                    }
                    else
                    {
                        double val = safety_check_hsv((sasiadujace[i / 2] + sasiadujace[i / 2 + 1]) / 2);
                        fresult.SetPixel(x, y, hsv.ColorFromHSV(hue,sat,val));
                    }
                }
            }

            fresult.UnlockImage();
            fobrazek_bitmapa.UnlockImage();
            return result;
        }

        public static Bitmap wygladzanie_logiczne(Bitmap src, int opcja)
        {
            Bitmap result = new Bitmap(src);
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(src);
            BitmapProcessing.FastBitmap fresult = new BitmapProcessing.FastBitmap(result);
            fobrazek_bitmapa.LockImage();
            fresult.LockImage();
            //Pionowo
            if (opcja == 1)
            {
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {

                        if (y > 0 && y < src.Height - 1)
                        {
                            if (fobrazek_bitmapa.GetPixel(x, y - 1).R == fobrazek_bitmapa.GetPixel(x, y + 1).R)
                            {
                                fresult.SetPixel(x,y,Color.FromArgb(fobrazek_bitmapa.GetPixel(x, y - 1).R,fobrazek_bitmapa.GetPixel(x, y - 1).R,fobrazek_bitmapa.GetPixel(x, y - 1).R));
                            }

                        }
                    }
                }
            }
                //Poziomo
            else if (opcja == 2)
            {
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {

                        if (x > 0 && x < src.Width - 1)
                        {
                            if (fobrazek_bitmapa.GetPixel(x-1, y).R == fobrazek_bitmapa.GetPixel(x+1, y).R)
                            {
                                fresult.SetPixel(x,y,Color.FromArgb(fobrazek_bitmapa.GetPixel(x+1, y).R,fobrazek_bitmapa.GetPixel(x+1, y).R,fobrazek_bitmapa.GetPixel(x+1, y).R));
                            }

                        }
                    }
                }
            }
            else if(opcja==3)
            {
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {

                        if (x > 0 && x < src.Width - 1&&y > 0 && y < src.Height - 1)
                        {
                            if (fobrazek_bitmapa.GetPixel(x - 1, y).R == fobrazek_bitmapa.GetPixel(x + 1, y).R && fobrazek_bitmapa.GetPixel(x, y - 1).R == fobrazek_bitmapa.GetPixel(x, y + 1).R && fobrazek_bitmapa.GetPixel(x, y - 1).R == fobrazek_bitmapa.GetPixel(x - 1, y).R)
                            {
                                fresult.SetPixel(x,y,Color.FromArgb(fobrazek_bitmapa.GetPixel(x, y - 1).R,fobrazek_bitmapa.GetPixel(x, y - 1).R,fobrazek_bitmapa.GetPixel(x, y - 1).R));
                            }

                        }
                    }
                }
            }

            fresult.UnlockImage();
            fobrazek_bitmapa.UnlockImage();
            return result;
        }

        public static Bitmap wygladzanie_logiczne_hsv(Bitmap src, int opcja)
        {
            Bitmap result = new Bitmap(src);
            BitmapProcessing.FastBitmap fobrazek_bitmapa = new BitmapProcessing.FastBitmap(src);
            BitmapProcessing.FastBitmap fresult = new BitmapProcessing.FastBitmap(result);
            fobrazek_bitmapa.LockImage();
            fresult.LockImage();
            //Pionowo
            if (opcja == 1)
            {
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {

                        if (y > 0 && y < src.Height - 1)
                        {
                            double h, s, v1,v2;
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y-1), out h, out s, out v1);
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y + 1), out h, out s, out v2);

                            if (v1==v2)
                            {
                                fresult.SetPixel(x, y, hsv.ColorFromHSV(h,s,v1));
                            }

                        }
                    }
                }
            }
            //Poziomo
            else if (opcja == 2)
            {
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {

                        if (x > 0 && x < src.Width - 1)
                        {
                            double h, s, v1,v2;
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x-1, y), out h, out s, out v1);
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x+1, y), out h, out s, out v2);

                            if (v1 == v2)
                            {
                                fresult.SetPixel(x, y, hsv.ColorFromHSV(h, s, v1));
                            }

                        }
                    }
                }
            }
            else if (opcja == 3)
            {
                for (int x = 0; x < src.Width; x++)
                {
                    for (int y = 0; y < src.Height; y++)
                    {
                        
                        if (x > 0 && x < src.Width - 1 && y > 0 && y < src.Height - 1)
                        {
                            double h, s, v1, v2, v3, v4;
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x - 1, y), out h, out s, out v1);
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x + 1, y), out h, out s, out v2);
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y - 1), out h, out s, out v3);
                            hsv.ColorToHSV(fobrazek_bitmapa.GetPixel(x, y + 1), out h, out s, out v4);

                            if (v1 == v2 && v3 == v4 && v2 == v4)
                            {
                                fresult.SetPixel(x, y, hsv.ColorFromHSV(h, s, v1));
                            }

                        }
                    }
                }
            }

            fresult.UnlockImage();
            fobrazek_bitmapa.UnlockImage();
            return result;
        }
        public static Bitmap zolw_obiekt(Bitmap src, int x, int y, int prog)
        {
            BitmapProcessing.FastBitmap fsrc = new BitmapProcessing.FastBitmap(src);
            Bitmap obraz = new Bitmap(src);
            BitmapProcessing.FastBitmap fobraz = new BitmapProcessing.FastBitmap(obraz);
            fsrc.LockImage();
            fobraz.LockImage();
            /*
             * Kierunki:
             *   0
             *  3 1
             *   2
             */
            //Zaczynamy idąc w prawo, będąc na pikselu w obiekcie
            int kierunek = 1;
            bool koniec = false;
            //szukanie 
            int sx = x, sy = y, i = 0;
            do
            {
                //w lewo, potem do przodu
                while (fsrc.GetPixel(x, y).R > prog)
                {
                    //obrot w lewo
                    if (kierunek == 0)
                    {
                        kierunek = 3;
                    }
                    else
                    {
                        kierunek--;
                    }
                    switch (kierunek)
                    {
                        case 0:
                            if (y == 0) { koniec = true; break; }
                            y--;
                            break;
                        case 1:
                            if (x == obraz.Width) { koniec = true; break; }
                            x++;
                            break;
                        case 2:
                            if (y == obraz.Height) { koniec = true; break; }
                            y++;
                            break;
                        case 3:
                            if (x == 0) { koniec = true; break; }
                            x--;
                            break;

                    }
                    if (koniec)
                    {
                        break;
                    }
                    fobraz.SetPixel(x, y, Color.FromArgb(0, 255, 0));
                }
                //w prawo, potem do przodu                  
                while (fsrc.GetPixel(x, y).R <= prog)
                {
                    //obrot w prawo
                    if (kierunek == 3)
                    {
                        kierunek = 0;
                    }
                    else
                    {
                        kierunek++;
                    }
                    switch (kierunek)
                    {
                        case 0:
                            if (y == 0) { koniec = true; break; }
                            y--;
                            break;
                        case 1:
                            if (x == obraz.Width) { koniec = true; break; }
                            x++;
                            break;
                        case 2:
                            if (y == obraz.Height) { koniec = true; break; }
                            y++;
                            break;
                        case 3:
                            if (x == 0) { koniec = true; break; }
                            x--;
                            break;


                    }
                    if (koniec)
                    {
                        break;
                    }
                    fobraz.SetPixel(x, y, Color.FromArgb(0, 255, 0));

                }
                i++;
            } while (sx != x || sy != y);
            fsrc.UnlockImage();
            fobraz.UnlockImage();
            return obraz;
        }
        public static Bitmap zolw(Bitmap src,int prog)
        {
            Bitmap obraz = new Bitmap(src);
            BitmapProcessing.FastBitmap fobraz = new BitmapProcessing.FastBitmap(obraz);
           
            fobraz.LockImage();
            int x = 0;
            int y = 0;
            bool koniec = false;
            for (; y < obraz.Height; y++)
            {
                for (x = 0; x < obraz.Width; x++)
                {

                    if (fobraz.GetPixel(x, y).R > prog)
                    {

                        koniec = true;
                        break;
                    }
                }
                if (koniec)
                {

                    break;
                }
            }
            //Sprawdzenie czy nie znaleziono żadnego obiektu
            if (x == obraz.Width && y == obraz.Height)
            {
                fobraz.UnlockImage();
              
                return src;
            }
            fobraz.UnlockImage();
            obraz = zolw_obiekt(src,x,y,prog);


           return obraz;
        }

        private class piksel
        {
            public int value;
            //public int id_obiektu;
            public piksel(int val)
            {
                value = val;
            }
        }
        public static Bitmap rozrost_obszaru(Bitmap A)
        {         
            BitmapProcessing.FastBitmap fa = new BitmapProcessing.FastBitmap(A);
            //int prog = 10;
            piksel[,] piksele = new piksel[A.Width,A.Height];

            fa.LockImage();

            //int id_obiektu = 0;
            for (int x = 0; x < A.Width; x++)
            {
                for (int y = 0; y < A.Height; y++)
                {
                    piksele[x,y] = new piksel(fa.GetPixel(x, y).R);
                    
                }
            }


            fa.UnlockImage();

            return A;
        }
    }
}

